/**
 * Class DataBaseIndexedDb : Application mobile Windows Phone 8 / tablette Windows 8 / Navigateur si demandé
 */
var DataBaseIndexedDb = {
	db: null,
	dbReady: false,
	init: function() {
		DataBase.dbReady = false;
		var req = window.indexedDB.open(DataBaseIndexedDb.name, DataBaseIndexedDb.version);
		req.onerror = function(event) {
			  Engine.alert("");
		};
		req.onsuccess = function (event) {
			Utils.log("Connecté à la BD IndexedDb");
			DataBase.db = this.result;
			DataBase.dbReady = true;
		};
     	req.onupgradeneeded  = function(event) {
     		DataBaseIndexedDb.createBase(event);
		};
	},
	createTable: function(name, attributId, autoIncremente, transaction) {
	    Utils.log("name " + name + " attributId " + attributId);
        if (DataBase.db.objectStoreNames.contains(name)) {
            return transaction.objectStore(name);
        } else {
            if (Utils.isNotNull(attributId)) {
                return DataBase.db.createObjectStore(name, { keyPath: attributId, autoIncrement: autoIncremente });
            } else {
                return DataBase.db.createObjectStore(name);
            }
        }
	},
	createIndex: function(objectStore, nom, champs, isUnique) {
	    try {
		    objectStore.createIndex(nom, champs, { unique: isUnique });
	    } catch(e) {
	    }
	},
	/* DEBUT Méthode Générique */
	findAllOld: function(table, callback, cbError) {
		var transaction = DataBase.db.transaction([table], "readwrite");
		var objectStore = transaction.objectStore(table);
		objectStore.onerror = function(event) {
			Utils.log("Erreur read " + table);
            Engine.hideLoader();
            if (typeof cbError === 'function') {
    			cbError(event);
    		}
		};
		objectStore.openCursor().onsuccess = function(event) {
            if (typeof callback === 'function') {
    			callback(event);
    		}
            Engine.hideLoader();
		};
	},
	nbMax: 10000000,
	findAll: function(table, callback) {
		return new Promise(function (resolve, reject) {
			var data = [];
			DataBase.findAllOld(table, function(event) {
				var cursor = event.target.result;
				if (cursor) {
					data.push(Utils.decryptData(table, cursor.value));
				    if(data.length > DataBase.nbMax - 1) {
	                    if (typeof callback === 'function') {
	                        callback && callback(data);
	                    }
	                    resolve(data);
				    } else {
	    			    cursor["continue"]();
				    }
				} else {
	                if (typeof callback === 'function') {
	                    callback && callback(data);
	                }
	                resolve(data);
				};
			}, function (event) {
				reject(event);
			});
		});
	},
	findById: function(table, id, callback) {
		var objectStore = DataBase.db.transaction([table], "readwrite").objectStore(table);
		var request = objectStore.get(parseInt(id, 10));
		request.onsuccess = function(event) {
			if (typeof callback === 'function') {
                callback(Utils.decryptData(table, event.target.result));
            }
            Engine.hideLoader();
		};
        request.onerror = function(event) {
            Engine.hideLoader();
        };
	},
	getChamps: function(champs) {
        var champsArray = champs;
        if(Object.prototype.toString.call(champs) !== '[object Array]' ) {
            champsArray = [champs];
        }
        var tokens = champs.split("And");
        for (var i in tokens) {
            champsArray[i] = tokens[i];
        }
        return champsArray;
	},
	findBy: function(table, champs, valeur, callback) {
        
		var champsArray = DataBase.getChamps(champs);
        var valeurArray = Utils.encryptData(table, valeur);
        if(Object.prototype.toString.call(valeur) !== '[object Array]') {
            valeurArray = [Utils.encryptData(table, valeur)];
        }
        var data = [];
		
		var transaction = DataBase.db.transaction([table], "readwrite");
		var objectStore = transaction.objectStore(table);
		var index = objectStore.index(champsArray[0]);
		
		index.openCursor(valeurArray[0]).onsuccess = function(event) {
			var cursor = event.target.result;
			if (cursor) {
			    var find = true;
			    if (champsArray.length > 1) {
			        for(var index in champsArray) {
			            if (cursor.value[champsArray[index]] !== valeurArray[index]) {
			                find = false;
			            }
			        }
			    }
			    if (find) {
                    data.push(Utils.decryptData(table, cursor.value));
                }
                cursor["continue"]();
			} else {
                if (typeof callback === 'function') {
                    callback(data);
                }
			}
            Engine.hideLoader();
		};
        index.onerror = function(event) {
            Engine.hideLoader();
        };
	},
	countBy: function(table, champs, valeur, callback) {
		var cpt = 0;
		var transaction = DataBase.db.transaction([table], "readwrite");
		var objectStore = transaction.objectStore(table);
		if (Utils.isNotBlank(champs)) {
    		var index = objectStore.index(champs);
    		index.openCursor(Utils.encryptData(table, valeur)).onsuccess = function(event) {
    			var cursor = event.target.result;
    			if (cursor) {
    				cpt++;
    			    cursor["continue"]();
    			} else {
    				if (typeof callback === 'function') {
                        callback(cpt);
                    }
    			}
                Engine.hideLoader();
    		};
            index.onerror = function(event) {
                Engine.hideLoader();
            };
        } else {
            objectStore.onerror = function(event) {
                Utils.log("Erreur read " + table);
                Engine.hideLoader();
            };
            objectStore.openCursor().onsuccess = function(event) {
                var cursor = event.target.result;
                if (cursor) {;
                    cpt++;
                    cursor["continue"]();
                } else {
                    if (typeof callback === 'function') {
                        callback(cpt);
                    }
                }
                Engine.hideLoader();
            };
        }
	},
	insert: function(table, data, callback) {
		var objectStore = DataBase.db.transaction([table], "readwrite").objectStore(table);
		var requestUpdate = objectStore.add(Utils.encryptData(table, data));
		requestUpdate.onsuccess = function(event) {
			if (typeof callback === 'function') {
                callback(event);
            }
            Engine.hideLoader();
		};
        requestUpdate.onerror = function(event) {
            Engine.hideLoader();
        };
	},
	updateData: function(table, data, callback) {
		var objectStore = DataBase.db.transaction([table], "readwrite").objectStore(table);
		var request = objectStore.get(parseInt(data.id, 10));
		request.onsuccess = function(event) {
			var requestUpdate = objectStore.put(Utils.encryptData(table, data));
			requestUpdate.onerror = function(event) {
                Engine.hideLoader();
			};
			requestUpdate.onsuccess = function(event) {
                if (typeof callback === 'function') {
    				callback(event);
    			}
                Engine.hideLoader();
			};
		};
        request.onerror = function(event) {
            Engine.hideLoader();
        };
	},
	update: function(table, id, champs, valeur, callback) {
		DataBase.findById(table, id, function(result) {
            result[champs] = valeur;
			DataBase.updateData(table, result, function(event) { 
                if (typeof callback === 'function') {
                    callback(event);
                }
			});
		});
	},
    updateJson: function(table, id, json, callback) {
        DataBase.findById(table, id, function(result) {
            for (var i in json) {
                result[i] = json[i];
            }
            DataBase.updateData(table, result, function(event) { 
                if (typeof callback === 'function') {
                    callback(event);
                }
            });
        });
    },
	deleteById: function(table, id, callback) {
		var request = DataBase.db.transaction([table], "readwrite").objectStore(table)["delete"](+id);
		request.onsuccess = function(event) {
            if (typeof callback === 'function') {
				callback(event);
			}
            Engine.hideLoader();
		};
		request.onerror = function(event) {
            Engine.hideLoader();
		};
	},
	removeDatabase: function () {
		window.indexedDB.deleteDatabase(DataBaseIndexedDb.name);
	}
	/* FIN Méthode Générique */
};