/**
 * Class APP DataBase.
 */
var DataBaseWeb = {
    init: function() {
        Utils.log("Mode temps réel");
        DataBase.dbReady = true;
    },
    findAll: function(table, callback) {
        var data = [];
        if (table=="TACTIQUE") {
            Engine.getDemande("D004", {"tactique" : "O", "ref" : "N", "ref_type" : ""}, function(json) {
                if (typeof callback === 'function') {
                    callback(json.tactiques);
                }
            });
        }
        else if (table=="MATCH") {
            if (Utils.isNotNull(Environnement.bouchonInfosFacultatives) && Environnement.bouchonInfosFacultatives) {
                callback(BouchonInfosFacultatives.matchs);
            } else {
                Engine.getDemande("D005", {"mode_web" : "O"}, function(json) {
                    for(var key in json.matchs) {
                        data.push(json.matchs[key]);
                    }
                    if (typeof callback === 'function') {
                        callback(data);
                    }
                });
            }
        } else {
            callback(data);
        }
    },
    findById: function(table, id, callback) {
        var data = [];
        if (typeof callback === 'function') {
            callback(json);
        }
        else if (table=="MATCH_FEUILLE_MEMBRE") {
            Engine.getDemande("D008", {}, function(json) {
                if (typeof callback === 'function') {
                    callback(json);
                }
            });
        }
    },
    findBy: function(table, champs, valeur, callback) {
        var data = [];
        if (table=="FMI_REF") {
            Engine.getDemande("D004", {"tactique" : "N", "ref" : "O", "ref_type" : valeur}, function(json) {
                if (typeof callback === 'function') {
                    callback(json);
                }
            });
        } else if (table=="CLUB_GROUPE") {
            Engine.getDemande("D013", {}, function(json) {
                if (typeof callback === 'function') {
                    callback(json);
                }
            });
        } else if (table=="EQUIPE_TYPE_INDIVIDU") {
            Engine.getDemande("D012", { cei_no: valeur[0] }, function(json) {
                if (typeof callback === 'function') {
                    var dataReturn = [];
                    for (var i in json.equipe_type) {
                        if (parseInt(json.equipe_type[i].cei_no, 10) === parseInt(valeur[0], 10) && parseInt(json.equipe_type[i].eq_cod, 10) === parseInt(valeur[1], 10) && json.equipe_type[i].lc_cod === valeur[2] && parseInt(json.equipe_type[i].cl_no, 10) === parseInt(valeur[3], 10)) {
                            Utils.log(json.equipe_type[i]);
                            for (var j in json.equipe_type[i].eq_typ_in) {
                                dataReturn.push({
                                    cfi_cl_no : json.equipe_type[i].cl_no,
                                    tq_no: json.equipe_type[i].tq_no,
                                    li_no : json.equipe_type[i].eq_typ_in[j].in_no,
                                    cfi_poste : json.equipe_type[i].eq_typ_in[j].cei_poste,
                                    cfi_ordre : json.equipe_type[i].eq_typ_in[j].cei_ordre,
                                    cfi_maillot : json.equipe_type[i].eq_typ_in[j].cei_maillot,
                                    cfi_capi : json.equipe_type[i].eq_typ_in[j].cei_capi,
                                    cfi_typ_role : json.equipe_type[i].eq_typ_in[j].cei_role,
                                    cfi_role : json.equipe_type[i].eq_typ_in[j].cei_role,
                                });
                            }
                        }
                    }
                    Utils.log(dataReturn);
                    callback(dataReturn);
                }
            });
        } else if (table=="MATCH_FEUILLE_COMPO") {
            Engine.getDemande("D009", { match: "" + valeur[0]}, function(json) {
                if (typeof callback === 'function') {
                    callback(json.compos);
                }
            });
        } else if (table=="SANCTION") {
            Engine.getDemande("D005", { match: valeur }, function(json) {
                if (typeof callback === 'function') {
                    callback(json.matchs[0].sanctions);
                }
            });
        } else if (table=="MATCH_FEUILLE") {
            Engine.getDemande("D010", { match: "" + valeur }, function(json) {
                if (typeof callback === 'function') {
                    callback(json.match_feuille);
                }
            });
        } else if (table=="MATCH_FEUILLE_EVENEMENT") {
            Engine.getDemande("D010", { match: "" + valeur }, function(json) {
                if (typeof callback === 'function') {
                    var ret = {
                        ma_no : json.match_feuille_evenement.ma_no,
                        cfm_no : json.match_feuille_evenement.cfm_no,
                        evenement : []
                    };
                    for (var i = 0; i < json.match_feuille_evenement.evenement.length; i++) {
                        if (json.match_feuille_evenement.evenement[i].cfe_typ == "BU") {
                            ret.evenement.push(json.match_feuille_evenement.evenement[i]);
                        }
                    }
                    callback(ret);
                }
            });
        } else if (table=="MATCH") {
            Engine.getDemande("D005", {mode_web: "O", match: valeur }, function(json) {
                if (typeof callback === 'function') {
                    callback(json.matchs[0]);
                }
            });
        } else if (table=="CLUB_LICENCE") {
            if(Utils.isNotNull(Environnement.bouchonInfosFacultatives) && Environnement.bouchonInfosFacultatives) {
                callback(BouchonInfosFacultatives.licences);
            } else {
                Engine.getDemande("D061", {mode_web: "O", lc_cod: null, groupe: null, perso: null, match: valeur}, function(json1) {
                    //
                    // 0036655 - Le Web services D61 doit être découpé en 2
                    //
                    // Engine.getDemande("D062", {mode_web: "O", lc_cod: null, groupe: null, perso: null, match: valeur}, function(json2) {
                    //     if (typeof callback === 'function') {
                    //         var licences = json1.licences.concat(json2.licences);
                    //         callback(licences);
                    //     }
                    // });
                    // 
                    // Supprimer les lignes ci-dessous pour réactiver la D062
                    // 
                    if (typeof callback === 'function') {
                        callback(json1.licences);
                    }
                    //
                    // Fin 0036655
                    //
                });
            }
        } else if (typeof callback === 'function') {
            callback(data);
        }
    },
    countBy: function(table, champs, valeur, callback) {
        if (typeof callback === 'function') {
            callback(0);
        }
    },
    insert: function(table, data, callback) {
        if(table == "EQUIPE_TYPE"){
            Engine.getDemande("T001", {"match_feuille_compo": null, "equipe_type": data}, function(json) {
                if (typeof callback === 'function') {
                    callback();
                }
            });
        } else if(table == "MATCH_FEUILLE_COMPO") {
            Utils.log(data);
            Engine.getDemande("T001", {"match_feuille_compo": data, "equipe_type": null}, function(json) {
                if (typeof callback === 'function') {
                    callback();
                }
            });
        } else if(table == "CGU") {
            delete data.cgu_version;
            Engine.getDemande("T004", {"cgu":[data]}, function(json) {
                if (typeof callback === 'function') {
                    callback();
                }
            });
        } else if(table == "MATCH_FEUILLE_EVENEMENT") {
            var datas = {
                "match_feuille":null,
                "match_feuille_evenement":{
                    "ma_no": parseInt(MatchDto.match.ma_no, 10),
                    "cfm_no": parseInt(MatchDto.match.cfm_no, 10),
                    "evenement": data
                },
                "match_feuille_compo" : null
            };
            Utils.log(datas);
            Engine.getDemande("T003", datas, function(json) {
                if (typeof callback === 'function') {
                    callback();
                }
            });
        } else if (typeof callback === 'function') {
            callback();
        }
    },
    update: function(table, id, champs, valeur, callback) {
        if (typeof callback === 'function') {
            callback();
        }
    },
    deleteById: function(table, id, callback) {
        if (typeof callback === 'function') {
            callback();
        }
    },
};
