/**
 * Class Utilitaire.
 */
var Utils = {

    wsValue: function (val) {
        if (Utils.isBlank(val) || val === "null") {
            return null;
        } else {
            return val;
        }
    },
	/**
	 * 
     * @param {Object} toFind
     * @param {Object} array
	 */
	containsInArray: function(toFind, array) {
		for (var element in array) {
			if (toFind.indexOf(array[element]) !== -1) {
				return true;
			}
		}
		return false;
	},
    /**
     *  
     * @param {Object} toFind
     * @param {Object} array
     */
    inArray: function(toFind, array) {
        return (jQuery.inArray(toFind, array) !== -1);
    },
	addUniqueInArray: function(erreur, value) {
	   if (!Utils.containsInArray(value, erreur)) {
	       erreur.push(value);
	   }
	},
	/**
	 *
     * @param {Object} table
     * @param {Object} value
	 */
	removeFromArrayId: function(table, value) {
	  return Utils.removeFromArray(table, "id", value);  
	},
	/**
	 * 
     * @param {Object} table
     * @param {Object} champ
     * @param {Object} value
	 */
	removeFromArray: function(table, champ, value) {
        var index = -1;
        for(var i in table) {
            if (table[i][champ] == value) {
                index = i;
                break;
            }
        }
        if (index != -1) {
            table.splice(index, 1);
        }
        return table;
	},
	/**
	 * 
	 */
	isIe: function() {
		var myNav = navigator.userAgent.toLowerCase();
		return (myNav.indexOf('msie')) ? parseInt(myNav.split('msie')[1], 10) : false;
	},
    /**
     * 
     */
    boolIsIe: function() {
        var myNav = navigator.userAgent.toLowerCase();
        return (myNav.indexOf('msie') != -1 || myNav.indexOf('Trident') != -1);
    },
	/**
	 * 
     * @param {Object} string
	 */
	capitalize: function(string) {
	    return string.charAt(0).toUpperCase() + string.slice(1);
	},
    /**
     * 
     * @param {Object} string
     */
    uncapitalize: function(string) {
        return string.charAt(0).toLowerCase() + string.slice(1);
    },
    setIndex: function(tab1, tab2, index) {
       if(Utils.isNotNull(tab2[index])){
           tab1[index] = tab2[index];
       }
   },
    /**
     * Préfixe une image en base 64 si besoin. Si le paramètre est vide, renvoie null ou l'image par défault si renseigné en paramètre
     * 
     * @param {Object} string l'image en base64
     * @param {Object} string l'image à retourner par défault
     */
    prepareBase64Image: function(b64Image, defaultImage) {
        if(Utils.isBlank(b64Image) || (b64Image === "img/person.png")){
            return defaultImage !== undefined ? defaultImage : null;
        }
        else {
            return (b64Image.indexOf("data:image/") == -1) ? "data:image/png;base64," + b64Image : b64Image;
        }
    },
    getStackTace: function(stack, index) {
        return stack.split("\n")[index].split("/")[stack.split("\n")[index].split("/").length - 1].split("?")[0];
    },
    getAllStackTace: function(message) {
        if (!Environnement.log) {
            return;
        }
        try {
            var fichier = "";
            var stack = new Error().stack;
            for (var i=1; i< 10; i++) {
                var stacktace = Utils.getStackTace(stack, i);
                if (stacktace == "") {
                    return;
                }
                fichier += stacktace + " ";
                
            }
            Utils.log(message + " - " + fichier);
        } catch(ex) { } 
    },
    getAllStackTace2: function() {
        if (!Environnement.log) {
            return "";
        }
        try {
            var fichier = "";
            var stack = new Error().stack;
            for (var i=1; i< 10; i++) {
                var stacktace = Utils.getStackTace(stack, i);
                if (stacktace == "") {
                    return fichier; 
                }
                fichier += stacktace + " - ";
                
            }
            return fichier;
        } catch(ex) { 
            return "";  
        } 
    },
	/**
	 * 
     * @param {Object} message
	 */
	log: function(message) {
	    if (!Environnement.log) {
	        return;
	    }
		/*var fichier = "";
		try {
			var stack = new Error().stack;
    	    fichier = Utils.getStackTace(stack, 2);
    	    if (fichier.indexOf("Utils.js") != -1) {
        	    fichier = Utils.getStackTace(stack, 2);
        	    fichier = fichier.substring(0, fichier.length - 3);
    	    }
    	} catch(ex) { } */
		
		/*try {
			var Today = new Date;*/
			/*if (typeof message === "object") {*/
                console.log(message);
            /*} else {
                console.log(Today.getHours() + ":" + Today.getMinutes() + ":" + Today.getSeconds() + " - " + message + " - " + fichier);
            }*/
		/*} catch (ex) {
		}*/
	},
    /**
     * 
     * @param {Object} message
     */
    error: function(message) {
        /*var fichier = "";
        try {
            var stack = new Error().stack;
            fichier = Utils.getStackTace(stack, 2);
            if (fichier.indexOf("Utils.js") != -1) {
                fichier = Utils.getStackTace(stack, 3);
                fichier = fichier.substring(0, fichier.length - 3);
            }
        } catch(ex) { } 
        
        try {
            var Today = new Date;
            fichier = Utils.getAllStackTace2();*/
            if (Environnement.log) {
                 console.error(message);
                /*console.error(Today.getHours() + ":" + Today.getMinutes() + ":" + Today.getSeconds() + " - " + message + " - " + fichier);*/
            }
        /*} catch (ex) {
            Engine.alert(ex);
        }*/
    },
    /**
     * Teste si un objet est null ou undefined
     * @param {Object} object
     */
    isNotNull: function(object) {
        return (typeof object != "undefined" && object != null && object !== "null");
    },
    isNull: function(object) {
        return !Utils.isNotNull(object);
    },
    /**
     * Teste si un objet est null ou undefined
     * @param {Object} object
     */
    isNotBlank: function(object) {
        return Utils.isNotNull(object) && object !== "";
    },
    isBlank: function(object) {
        return !Utils.isNotBlank(object);
    },
    /**
     * Teste si un objet est un entier ou non
     * @param {Object} object
     */
    isInteger: function(object) {
        return Utils.isNotNull(object) && Utils.isNotBlank(object) && Math.floor(object) == object;
    },
    /**
     * Teste si un objet est un entier positif ou non
     * @param {Object} object
     */
    isIntegerPositif : function (object) {
        return Utils.isInteger(object) &&  object >= 0;
    },
    /**
     * 
     * @param {Object} jqXHR
     * @param {Object} exception
     */
    formatErrorMessage: function(jqXHR, exception) {
        if (jqXHR.status === 0) {
            return ('Not connected.\nPlease verify your network connection.');
        } else if (jqXHR.status == 404) {
            return ('The requested page not found. [404]');
        } else if (jqXHR.status == 500) {
            return ('Internal Server Error [500].');
        } else if (exception === 'parsererror') {
            return ('Requested JSON parse failed.');
        } else if (exception === 'timeout') {
            return ('Time out error.');
        } else if (exception === 'abort') {
            return ('Ajax request aborted.');
        } 
        return ('Uncaught Error.\n' + jqXHR.responseText);
    },
    showLoader: function() {
        $(".ajax-loader").append("<div class='ajax-loader-img'></div>");
        $("#div-ajax-cacher").show();
    },
    hideLoader: function() {
        setTimeout(function() {
            $(".ajax-loader").find("div:first").remove();
            if ($.trim($(".ajax-loader").html()) == "") {
                $("#div-ajax-cacher").hide();
            }
        }, 1000);
    },
    xmlAjax: function(url, callback) {
//        Engine.showLoader();
        $.ajax({
            url: url,
            dataType: "xml",
            async: true,
            success: function(xml) {
                callback(xml);
                Engine.hideLoader();
            },
            error: function(xhr, err) {
                var responseTitle= $(xhr.responseText).filter('title').get(0);
                Utils.log($(responseTitle).text() + "\n" + Utils.formatErrorMessage(xhr, err) );
                Engine.hideLoader();
            },
            fail: function(xhr, err) { 
                var responseTitle= $(xhr.responseText).filter('title').get(0);
                Utils.log($(responseTitle).text() + "\n" + Utils.formatErrorMessage(xhr, err) );
                Engine.hideLoader();
            }
        });
    },
    jsonAjax: function(url, callback) {
//        Engine.showLoader();
        $.ajax({
            url: url,
            dataType: "json",
            async: true,
            success: function(json) {
                callback(json);
                Engine.hideLoader();
            },
            error: function(xhr, err) {
                var responseTitle= $(xhr.responseText).filter('title').get(0);
                Utils.log($(responseTitle).text() + "\n" + Utils.formatErrorMessage(xhr, err) );
                Engine.hideLoader();
            },
            fail: function(xhr, err) { 
                var responseTitle= $(xhr.responseText).filter('title').get(0);
                Utils.log($(responseTitle).text() + "\n" + Utils.formatErrorMessage(xhr, err) );
                Engine.hideLoader();
            }
        });
    },
    ajax: function(type, url, data, success, callbackError, isAfficherConnectionError) {
        isAfficherConnectionError = Utils.isNotBlank(isAfficherConnectionError) ? isAfficherConnectionError : true;
//        Engine.showLoader();
        
        if (Utils.isIe() <= 6 && window.XDomainRequest) {
            var xdr = new XDomainRequest();
            xdr.open(type, url, true);
            xdr.onsuccess = function() {
                var json = xdr.responseText;
                if (json.message=="KO") {
                    Utils.log("Erreur RESPONSE KO !");
                    Utils.log(JSON.stringify(json));
                    if (typeof callbackError === 'function') {
                        callbackError(json);
                    }
                } else {
                    success(json);
                }
                Engine.hideLoader();
            };
            xdr.onerror = function() {
                var error = xdr.responseText;
                Utils.log(JSON.stringify(error));
                if (isAfficherConnectionError && (error.status=="404" || error.status=="0")) {
                    Engine.alert(Lang.erreurConnectionInternet);
                } else {
                    if (typeof callbackError === 'function') {
                        callbackError(error);
                    } else {
                        Engine.alert("Une erreur s'est produit : " + error.status + " " + error.statusText);
                    }
                }
                Engine.hideLoader();
            }; 
            xdr.send(JSON.stringify(data));
        } else {
            $.support.cors = true;
            $.ajax({
                type: "post",
                timeout: 99999999999,
                url: url, 
                data: data,
                async: true,
                success: function(json) {
                    if (json.message=="KO") {
                        Utils.log("Erreur RESPONSE KO !");
                        Utils.log(JSON.stringify(json));
                        if (typeof callbackError === 'function') {
                            callbackError(json);
                        }
                    } else {
                        success(json);
                    }
                    Engine.hideLoader();
                },
                error: function(error) {
                    Utils.log(JSON.stringify(error));
                    if (isAfficherConnectionError && (error.status=="404" || error.status=="0")) {
//                        SynchronisationService.endWithError(Lang.erreurConnectionInternet);
                        Engine.alert(Lang.erreurConnectionInternet);
                    } else {
                        if (typeof callbackError === 'function') {
                            callbackError(error);
                        } else {
//                            SynchronisationService.endWithError("Une erreur s'est produit : " + error.status + " " + error.statusText);
                            Engine.alert("Une erreur s'est produit : " + error.status + " " + error.statusText);
                        }
                    }
                    Engine.hideLoader();
                }
            });
        }
    },
    /**
     * Retourne la date au format "jj/mm/aaaaa hh:mm:ss" 
     */
    getDate: function() {
        var dateJour = new Date();
        var jour = dateJour.getDate();
        if (parseInt(jour, 10) < 10) {
            jour = "0" + jour;
        }
        var mois = dateJour.getMonth() + 1;
        if (parseInt(mois, 10) < 10) {
            mois = "0" + mois;
        }
        var annee = dateJour.getFullYear();
        
        var heure = dateJour.getHours();
        if(parseInt(heure, 10) < 10) {
            heure = "0" + heure;
        }
        var minutes = dateJour.getMinutes();
        if(parseInt(minutes, 10) < 10) {
            minutes = "0" + minutes;
        }
        var secondes = dateJour.getSeconds();
        if(parseInt(secondes, 10) < 10) {
            secondes = "0" + secondes;
        }
        return jour + "/" + mois + "/" + annee + " " + heure + ":" + minutes + ":" + secondes;
    },
    // Engine.cleE
    encryptServiceData: function (data, cle) {
        if (Environnement.cryptWebService === false) {
            return JSON.stringify(data);
        } else {
            return Utils.encrypt(cle, JSON.stringify(data));
        }
    },
    // Engine.cleE
    decryptServiceData: function (data, cle) {
        if (Environnement.cryptWebService === false) {
            return JSON.parse(data);
        } else {
            return JSON.parse(Utils.decrypt(cle, data));
        }
    },
    encrypt: function(key, data) {
        var encryptedData = CryptoJS.AES.encrypt(data, CryptoJS.enc.Hex.parse(atob(key)), { iv: CryptoJS.enc.Base64.parse("") });
        return encryptedData.ciphertext.toString(CryptoJS.enc.Base64);
    },
    encryptSha1: function(data) {
        return CryptoJS.SHA1(data).toString();
    },
    decrypt: function(key, data) {
        return CryptoJS.enc.Utf8.stringify(CryptoJS.AES.decrypt({ciphertext: CryptoJS.enc.Base64.parse(data), salt: "" }, CryptoJS.enc.Hex.parse(atob(key)), { iv: CryptoJS.enc.Base64.parse("") } ));
    },
    desativeCryptageData: true,
    encryptData: function(table, data) {
        if (Environnement.cryptDatabase === false) {
            return data;
        }
        return Utils.encryptDecryptData(table, data, true);
    },
    decryptData: function(table, data) {
        if (Environnement.cryptDatabase === false) {
            return data;
        }
        return Utils.encryptDecryptData(table, data, false);
    },
    encryptDecryptData: function(table, data, encrypt) {
        if (table == "TABLETTE") {
            return data;
        }
        if (data==null) {
            return null;
        }
        if (data.constructor == Array || data.constructor == Object) {
            var dataNew = data.constructor == Array ? [] : {};
            for(var key in data) {
                if ((key != "id") && (key != "in_photo") && (key != "cr_cl_blason") && (key != "cv_cl_blason")){
                    if (encrypt) {
                        if (data[key] === null) {
                            dataNew[key] = null;
                        }else if (data[key] !== undefined) {
                            dataNew[key] = Utils.encrypt(Engine.cleB, data[key].toString());
                        }else {
                            dataNew[key] = "";
                        }
                        //dataNew[key] = (data[key]!=undefined) ? Utils.encrypt(Engine.cleB, data[key].toString()) : "";
                    } else {
                        try {
                            var decrypt = Utils.decrypt(Engine.cleB, data[key]);
                            dataNew[key] = decrypt;
                        } catch(e) {
                            dataNew[key] = data[key];
                        }
                    }
                } else {
                    dataNew[key] = data[key];
                }
            }
            return dataNew;
        } else {
            if (encrypt) {
                if (data === null) {
                    return null;
                }else if (data !== undefined) {
                    return Utils.encrypt(Engine.cleB, data.toString());
                }else {
                    return "";
                }
               //return (data!=undefined) ? Utils.encrypt(Engine.cleB, data.toString()) : "";
            } else {
                try {
                    return Utils.decrypt(Engine.cleB, data);
                } catch(e) {
                    return data;
                }
            }
        }
    },
    /**
     *Clone d'un TABLEAU ! 
     * @param {TABLEAU} source
     */
    cloneObject: function(source) {
        // var clone = [];
        var clone = source.constructor == Array ? [] : {};
        for (var i in source) {
            if (typeof source[i] == 'source') {
                clone = new Utils.cloneObject(source[i]);
            } else{
                clone[i] = source[i];
            }
        }
        return clone;
    },
    /**
     * Parse un tableau et change les strings en booleens ou int si possible
     * @param {Object} array le tableau à parser
     */
    parseIntBooleansInArray: function(data){
        var dataRetour = {};
        for(var i in data){
            if(Utils.isNotBlank(data[i])){
                if(data[i] === "true") {
                    dataRetour[i] = true;
                } else if(data[i] === "false") {
                    dataRetour[i] = false;
                } else if(!isNaN(data[i])) {
                    dataRetour[i] = parseInt(data[i], 10);
                } else {
                    dataRetour[i] = data[i];
                }
            } else {
                dataRetour[i] = data[i];
            }
        }
        return dataRetour;
    },
    
    convertArrayToArrayJson: function(data) {
        var dataTransmis = [];
        for (var k in data) {
            var json = {};
            for (var h in data[k]) {
                json[h] = data[k][h];
            }
            dataTransmis.push(json);
        }
        return dataTransmis;
    },
    convertDataParseInt: function(data) {
        for (var j in data) {
            delete data[j].id;
            for (var k in data[j]) {
                if (!Utils.isDate(data[j][k]) && !isNaN(parseInt(data[j][k], 10))) {
                    data[j][k] = parseInt(data[j][k], 10);
                }
            }
        }
    },
    convertDateFormatUs: function(date) {
        var day = date.substring(0, 2);
        var month = date.substring(3, 5);
        var year = date.substring(6, 10);
        return year + "-" + month + "-" + day;
    },
    parseInt: function(data) {
        if (Utils.isNotBlank(data) && !isNaN(parseInt(data, 10))) {
            return parseInt(data, 10);
        }
        return data;
    },
    /**
     * Vérifie si la signature n'est pas vide
     * @param {Object} id l'élément contenant la signature
     */
    isSignatureEmpty: function(id) {
        return $(id).jSignature('getData', 'native') == 0;    
    },
    /**
     * Tronque la string en ajoutant un point à la fin ou le parametre strFin si renseigné
     * @param {Object} string
     * @param {Object} nombreDeLettresMax
     * @param {string} strFin
     */
    truncateString: function(string, nombreDeLettresMax, strFin){
        strFin = strFin !== undefined ? strFin : ".";
        if (string.length > nombreDeLettresMax) {
            var returnString = string.substring(0, nombreDeLettresMax - strFin.length);
            returnString = returnString.trim();
            return returnString + strFin;
        }
        else {
            return string;
        }
    },

    /**
     * teste si le premier tableau contient au moins une des valeur du second tableau 
     */
    arrayContainsOneValue: function(tableau1, tableau2){
        for(var j in tableau2) {
            if(jQuery.inArray( tableau2[j], tableau1 ) != -1) {
                return true;
            }
        }
        return false;
    },
    switchRetourChariot: function(string) {
        return string.replace(new RegExp("\\n", 'g'), "<br/>");
    },
    /**
     * retourne la date sous forme d'objet date
     * 
     * @param {Object} sDate la date sous forme de string formatée en JJ/MM/AAAA
     */
    stringToDate: function(sDate, sHeure) {
        var dateTokens = sDate.split("/");
        var heureTokens;
        if (sHeure !== undefined) {
            heureTokens = sHeure.toLowerCase().split("h");
            if (heureTokens[1] === "") {
                heureTokens[1] = "0";
            }
        } else {
            heureTokens = ["0", "0"];
        }
        if (dateTokens.length === 3 && heureTokens.length === 2) {
            return new Date(parseInt(dateTokens[2],10), parseInt(dateTokens[1],10)-1, parseInt(dateTokens[0],10), parseInt(heureTokens[0],10), parseInt(heureTokens[1],10), 0);
        } else {
            return null;
        }
    },
    /**
     * Test si un string correspond à une date sous le format JJ/MM/AAAA
     * 
     * @param {String} sDate la date
     */
    isDate: function (date) {
        return /^(0?[1-9]|[12][0-9]|3[01])[\/\-](0?[1-9]|1[012])[\/\-]\d{4}$/.test(date);
    },
    /**
     * Calcule l'age actuel en fonction d'une date d'anniversaire
     * 
     * @param {Date} birthday la date d'anniversaire
     * @param {Date} refDate la date de référence à partir de laquel calculer l'age, par défault c'est la date actuelle
     */
    calculerAge: function (birthday, refDate) {
        var refDate = Utils.isNotNull(refDate) ? refDate : new Date();
        var age = refDate.getFullYear() - birthday.getFullYear();
        var m = refDate.getMonth() - birthday.getMonth();
        if (m < 0 || (m === 0 && refDate.getDate() < birthday.getDate())) {
            age--;
        }
        return age;
    },
    /**
     * Retourne un nombre entier dans un interval donné
     * @param {Object} min
     * @param {Object} max
     */
    randomInt: function (min, max) {
        return Math.floor(Math.random() * (max - min)) + min;
    }
};
