
function ScrollView(wrapperId, scrollHorizontal, scrollVertical) {

	
	var me = this;

	var _wrapper = $("#"+wrapperId);
	
	this.scroll = new IScroll("#" + wrapperId, { 
		bounce :false,
		click: true, 
		scrollX : scrollHorizontal, 
		scrollY : scrollVertical,
	});

	

	function _init() {
		// Initialisation de la ScrollView avec les bordures
		_prepare();  
		setTimeout(function () {
		 	_onScrollEvent();
		}, 50);
		
		// Mise à jour des bordure en fonction des positions du scroll
		me.scroll.on("scroll", _onScrollEvent);
		me.scroll.on("scrollEnd", _onScrollEvent);
		me.scroll.on("scrollStart", _onScrollEvent);
	}
	
	function _prepare() {

		// Supprimer les div s'ils sont déjà exsités
		if(!_wrapper.prev().is(".bounceDebut")) {
			var _scrollContainer = $("<div id='" + wrapperId + "-scroll-container' style='width: 100%; height: 100%;'></div>");
			_wrapper.wrap(_scrollContainer);
		} else {
			_wrapper.prev().remove();
			_wrapper.next().remove();
		}
		
			var divHeight = me.scroll.wrapper.offsetHeight;
			var divWidth = me.scroll.wrapper.offsetWidth;
			var divTop = _wrapper.position().top;
			var divLeft = _wrapper.position().left;
			var epaisseur = 20;
	
				if(scrollHorizontal) {
				var flouImgDebut = $("<img src='img/scroll_flou_gauche.png' style= 'height:"+ divHeight + "px; width:"+ epaisseur +"px;'/>");
				var flouImgFin = $("<img src='img/scroll_flou_droit.png' style= 'height:"+ divHeight + "px; width:"+ epaisseur +"px;' />");
				var divDebut = $("<div class='bounceDebut' style='opacity: 0.6; z-index: 1; position: absolute; width:" + epaisseur + "px; top:"+ (divTop) +"px; left: "+ divLeft + "px'></div>");
				var divFin = $("<div class='bounceEnd' style='opacity: 0.6; z-index: 1; position: absolute; width:" + epaisseur +"px; top:" + (divTop) + "px; left:" + (divLeft + divWidth - epaisseur) + "px' ></div>");
			} else if (scrollVertical) {
				var flouImgDebut = $("<img src='img/scroll_flou_haut.png' style= 'width:"+ divWidth + "px; height:"+ epaisseur +"px;' />");
				var flouImgFin = $("<img src='img/scroll_flou_bas.png' style = 'width:"+ divWidth + "px; height:"+ epaisseur +"px;'/>");
				var divDebut = $("<div class='bounceDebut' style='opacity: 0.6; z-index: 1; position: absolute; height: " + epaisseur + "px; top:"+ (divTop) +"px; left: "+ divLeft + "px'></div>");
				var divFin = $("<div class='bounceEnd' style='opacity: 0.6; z-index: 1; position: absolute; height:"+ epaisseur +"px; top:" + (divTop + divHeight - epaisseur) + "px; left:" + divLeft + "px' ></div>");
			}
			
			divDebut.html(flouImgDebut);
			divFin.html(flouImgFin);
	
			divDebut.hide();
			divFin.hide();
	
			_wrapper.before(divDebut);
			_wrapper.after(divFin);
	}

	// Fonction de mise à jour de la bordure
	function _update() {
		if (me.scroll.scroller.offsetHeight > me.scroll.wrapper.offsetHeight) {
			if (me.scroll.y <= me.scroll.maxScrollY) {
				_wrapper.next().fadeOut(200);
				_wrapper.prev().fadeIn(200);
			} else if (me.scroll.y >= 0) {
				_wrapper.prev().fadeOut(200);
				_wrapper.next().fadeIn(200);
			} else {
				_wrapper.prev().fadeIn(200);;
				_wrapper.next().fadeIn(200);;
			}
		} else if (me.scroll.scroller.offsetWidth > me.scroll.wrapper.offsetWidth) {
			if (me.scroll.x <= me.scroll.maxScrollX) {
				_wrapper.next().fadeOut(200);
				_wrapper.prev().fadeIn(200);
			} else if (me.scroll.x >= 0) {
				_wrapper.prev().fadeOut(200);
				_wrapper.next().fadeIn(200);
			} else {
				_wrapper.prev().fadeIn(200);
				_wrapper.next().fadeIn(200);
			}
		} else {
			_wrapper.prev().fadeOut(200);
			_wrapper.next().fadeOut(200);
		}
	}

	function _onScrollEvent() {
		// La fonction doit s'exécuter avec après un léger délai.
		setTimeout(function () {
		_update.apply(me);
		}, 0);
	}
	this.refresh = function() {
		_update.apply(me);
		me.scroll.refresh();
	} 

	this.destroy = function () {
		me.scroll.destroy();
	}

	this.scrollTop = function () {
		me.scroll.scrollTo(0,0);
	}

	this.scrollBot = function () {
		me.scroll.scrollTo(scrollX,scrollY);
	}

	_init();
}