(function($) {
   
    $.fn.uScroll = function(params) {
 
        // merge default and user parameters
        params = $.extend({
            thickness : 30,
            margin: 0,
            horizontal: false,
        }, params);
       
        var positionDebut = params.horizontal === true ? "gauche" : "haut";
        var positionFin = params.horizontal === true ? "droit" : "bas";
       
        var id = this.attr("id");
        if (id === undefined) {
            return;
        }
       
        var idDiv = "#" + id;
        var scrollDiv = $(idDiv);
        if (($(idDiv + "-flou-" + positionDebut).length > 0 && $(idDiv + "-flou-" + positionFin).length > 0) || scrollDiv.length === 0) {
            $(this).scroll();
            return;
        }
       
        // création d'un conteneur pour la div scrollable
        var container = $("<div id='" + id + "-scroll-container' style='width: 100%; height: 100%;'></div>");
        scrollDiv.wrap(container);
       
        // Fonction de calcul de la marge entre le flou du début et de fin
        var getFlouMargin = function () {
            if (params.horizontal === true) {
                return (params.margin !== 0 ? params.margin : scrollDiv.width()) - params.thickness;
            } else {
                return (params.margin !== 0 ? params.margin : scrollDiv.height()) - params.thickness;
            }
        };
       
        var widthFlou = scrollDiv.outerWidth();
        var heightFlou = scrollDiv.outerHeight();
       
        if (params.horizontal === true) {
            var flouDivDebut = $("<div id='"+ id + "-flou-" + positionDebut + "' style='position: absolute; margin-left: 0px; width: "+ params.thickness +"px; '></div>");
            var flouDivFin = $("<div id='"+ id + "-flou-" + positionFin + "' style='position: absolute; margin-left:" + getFlouMargin() + "px; width: "+ params.thickness +"px; '></div>");
            var flouImgDebut = $("<img src='img/scroll_flou_" + positionDebut + ".png' width='" + params.thickness + "' height='" + heightFlou + "' style='opacity: 0.4'/>");
            var flouImgFin = $("<img src='img/scroll_flou_"+ positionFin +".png' width='" + params.thickness + "' height='"+ heightFlou +"' style='opacity: 0.4'/>");
        } else {
            var flouDivDebut = $("<div id='"+ id + "-flou-" + positionDebut + "' style='position: absolute; margin-top: 0px; height: "+ params.thickness +"px; '></div>");
            var flouDivFin = $("<div id='"+ id + "-flou-" + positionFin + "' style='position: absolute; margin-top:" + getFlouMargin() + "px; height: "+ params.thickness +"px; '></div>");
            var flouImgDebut = $("<img src='img/scroll_flou_" + positionDebut + ".png' width='" + widthFlou + "' height='" + params.thickness + "' style='opacity: 0.4'/>");
            var flouImgFin = $("<img src='img/scroll_flou_"+ positionFin +".png' width='" + widthFlou + "' height='"+ params.thickness +"' style='opacity: 0.4'/>");
        }       
        
        flouDivDebut.hide();
        flouDivFin.hide();
       
        flouDivDebut.html(flouImgDebut);
        flouDivFin.html(flouImgFin);
       
        scrollDiv.before(flouDivDebut);
        scrollDiv.before(flouDivFin);
       
        var scroll = function() {
            if (params.horizontal === true) {
                flouDivFin.css("margin-left", getFlouMargin());
                flouImgDebut.attr("height", scrollDiv.outerHeight());
                flouImgDebut.attr("width", params.thickness);
                flouImgFin.attr("height", scrollDiv.outerHeight());
                flouImgFin.attr("width", params.thickness);
               
                if (scrollDiv.scrollLeft() + scrollDiv.outerWidth() < scrollDiv.get(0).scrollWidth) {
                    flouDivFin.show();
                } else {
                    flouDivFin.hide();
                }
               
                if (scrollDiv.scrollLeft() > 0) {
                    flouDivDebut.show();
                } else {
                    flouDivDebut.hide();
                }
            } else {
                flouDivFin.css("margin-top", getFlouMargin());
                flouImgDebut.attr("width", scrollDiv.outerWidth());
                flouImgDebut.attr("height", params.thickness);
                flouImgFin.attr("width", scrollDiv.outerWidth());
                flouImgFin.attr("height", params.thickness);
               
                if (scrollDiv.scrollTop() + scrollDiv.outerHeight() < scrollDiv.get(0).scrollHeight) {
                    flouDivFin.show();
                } else {
                    flouDivFin.hide();
                }
               
                if (scrollDiv.scrollTop() > 0) {
                    flouDivDebut.show();
                } else {
                    flouDivDebut.hide();
                }
            }       
        };
 
        $(this).scroll(function (event) {
            event.stopPropagation();
            scroll();
        });
       
        var async = new Async();
        async.timer = 1000;
        async.start(function() {
            scroll();
            async.stop();
        });
       
        return this;
    };
 
})(jQuery);