var AccueilController = MainController.extend({
    defaults : {
        name : ".AccueilController",
        click : Engine.eventClick,
        change : "change",
        dblclick : Engine.eventDblclick,
        pages : new Array("accueil/accueil.html"),
        files : new Array(
                    "accueil/js/accueilFr.js",
                    "accueil/css/accueil.css",
                    "accueil/js/accueilService.js",
                    "accueil/js/accueilDto.js",
                    "accueil/js/referentielDto.js",
                    "feuilleDeMatch/js/dto/matchDto.js",
                    "equipe/js/sanctionDto.js",
                    "equipe/js/equipeDto.js",
                    "feuilleDeMatch/js/dto/compositionsMatchDto.js",
                    "feuilleDeMatch/js/feuilleDeMatchService.js",
                    "synchronisation/js/service/synchronisationService.js")
    }
}, {
    init : function(element, options) {
        this._super(this, element, options);
    },
    load : function(page, data) {
        Engine.loadController(page, this.options.pages, this.options.files, this, function(controller) {
            controller.show(controller.element, null);
        });
    },
    show : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {

            var dtoList = ['MatchDto', 'AccueilDto', 'SanctionDto', 'ReferentielDto', 'CompositionsMatchDto', 'EquipeDto', 'SynchronisationDto', 'ReserveDto', 'ConnexionDto', 'FeuilleDeMatchDto', 'FaitsDeMatchHistoriqueDto']

            // Reset des Dto
            for (var i = 0; i < dtoList.length; i++) {
                var dto = window[dtoList[i]];
                if (typeof dto !== "undefined" && typeof dto.reset !== "undefined"){
                    dto.reset();
                }
            }
            AccueilDto.isSynchronizing = false;

// on cache les colonnes mobiles si on est en mode web, et inversement
            if ((!Engine.dbSiteWeb && !Engine.isCordova)) {
                $(".premiereColonneMatchs-mobile").hide();
                $(".deuxiemeColonneMatchs-mobile").hide();
                $(".troisiemeColonneMatchs-mobile").hide();
                $(".quatriemeColonneMatchs-mobile").hide();
                $(".cinquiemeColonneMatchs-mobile").hide();
            }
            else {
                $(".premiereColonneMatchs").hide();
                $(".deuxiemeColonneMatchs").hide();
                $(".troisiemeColonneMatchs").hide();
                $(".quatriemeColonneMatchs").hide();
            }

            Engine.headerController.setSynchroButton();
            Engine.headerController.showSynchroButton();
            
            Engine.headerController.showLogo(true);
            if (!Engine.isCordova && !Engine.dbSiteWeb) {
                $("#boutonRemplirFeuilleDeMatch").hide();
                $("#blocBoutonDemo").hide();
                $("#boutonInformationsFacultatives").show();
            }
            
            Engine.message("Chargement de l'accueil");
            if (Engine.dbActif) {
                var isDemonstration = "N";
                if(AccueilDto.isDemonstration) {
                    isDemonstration = "O";
                    if(!AccueilDto.isPurgeDemonstrationFaite) {
                        AccueilService.purgerDonneesMatchesDemo(function() {
                            AccueilService.insererFeuillesDeMatchDemo(function() {
                                AccueilDto.isPurgeDemonstrationFaite = true;
                                AccueilService.mettreAjourDateMatchesDemo(function() {
                                    AccueilService.getMatchUtilisateur(isDemonstration, AccueilService.afficherMatchs);
                                });
                            });
                        });
                    } else {
                        AccueilService.mettreAjourDateMatchesDemo(function() {
                            AccueilService.getMatchUtilisateur(isDemonstration, AccueilService.afficherMatchs);
                        });
                    }
                } else {
                    AccueilService.getMatchUtilisateur(isDemonstration, AccueilService.afficherMatchs);
                }
            } else {
                DataBase.findAll("MATCH", function(data) {
                    AccueilService.afficherMatchs(data);
                });
            }
        });
    },
    "{name} #boutonPreparerEquipe {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            SanctionDto.fromPreparer = false;
            SanctionDto.listSanctions = [];
            var rencontre = $(".ligneBody.selected");
            if (!element.hasClass("boutonInactif") || Project.debug) {
                if (rencontre.length > 0) {
                    Engine.message("Accès à la préparation");
                    var hiddenInfos = rencontre.children(".hiddenInfosMatch");
                    var cr_cl_no = parseInt(hiddenInfos.children(".cr_cl_no").text(), 10);
                    var cv_cl_no = parseInt(hiddenInfos.children(".cv_cl_no").text(), 10);
                    var visiteur;
                    if(AccueilDto.isDemonstration) {
                        visiteur = false;
                    } else {
                        visiteur = (cr_cl_no == Project.contexteUtilisateur.usr_equipe[0].cl_no) ? false : true;
                    }
                    var data = {
                        ma_id : parseInt(hiddenInfos.children(".id").text(), 10),
                        ma_no : parseInt(hiddenInfos.children(".ma_no").text(), 10),
                        ma_dat : hiddenInfos.children(".ma_dat").text(),
                        lc_cod : hiddenInfos.children(".lc_cod").text(),
                        li_no : hiddenInfos.children(".li_no").text(),
                        cl_nb_maxi_eqp_typ : parseInt(hiddenInfos.children( visiteur ? ".cv_cl_nb_maxi_eqp_typ" : ".cr_cl_nb_maxi_eqp_typ").text(), 10),
                        cl_eq_no : parseInt(hiddenInfos.children( visiteur ? ".cv_eq_cod" : ".cr_eq_cod").text(), 10),
                        cl_eq_cod : parseInt(hiddenInfos.children( visiteur ? ".cv_eq_cod" : ".cr_eq_cod").text(), 10),
                        cl_eq_nom : hiddenInfos.children( visiteur ? ".cv_cl_cod_nom" : ".cr_cl_cod_nom").text(),
                        sa_no : parseInt(hiddenInfos.children(".sa_no").text(), 10),
                        cfm_no : parseInt(hiddenInfos.children(".cfm_no").text(), 10),
                        cfm_statut : hiddenInfos.children(".cfm_statut").text(),
                        ph_tactiq : hiddenInfos.children(".ph_tactiq").text(),
                        ph_nb_jou_banc : hiddenInfos.children(".ph_nb_jou_banc").text(),
                        ph_nbmaxi_mut : hiddenInfos.children(".ph_nbmaxi_mut").text(),
                        ph_nb_maxi_etrg : hiddenInfos.children(".ph_nb_maxi_etrg").text(),
                        ph_nb_titul_mini : hiddenInfos.children(".ph_nb_titul_mini").text(),
                        ph_nb_titul : hiddenInfos.children(".ph_nb_titul").text(),
                        ph_num_maillot : hiddenInfos.children(".ph_num_maillot").text(),
                        ph_nb_med_banc : hiddenInfos.children(".ph_nb_med_banc").text(),
                        ph_nb_dir_banc : hiddenInfos.children(".ph_nb_dir_banc").text(),
                        ph_nb_edu_banc : hiddenInfos.children(".ph_nb_edu_banc").text(),
                        ph_nb_staff_banc : hiddenInfos.children(".ph_nb_staff_banc").text(),
                        ph_reglt_locaux : hiddenInfos.children(".ph_reglt_locaux").text(),
                        ph_info_but : hiddenInfos.children(".ph_info_but").text(),
                        ph_info_secu : hiddenInfos.children(".ph_info_secu").text(),
                        ph_info_orga : hiddenInfos.children(".ph_info_orga").text(),
                        tl_cod : hiddenInfos.children(".tl_cod").text(),
                    };
                    AccueilService.setHeaderDatas(hiddenInfos, visiteur);
                    Engine.gotoPage("equipe.html", {
                        match : data,
                        utilisateur : AccueilService.preparerContexte(data.cl_eq_cod)
                    });
                } else {
                    Engine.alert(Lang.accueil.erreurSelectionRencontre);
                }
            } else {
                Engine.alert(Lang.accueil.erreurEtatMatch);
            }
        });
    },
    "{name} #boutonRemplirFeuilleDeMatch {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var rencontre = $(".ligneBody.selected");
            
            var utilisateurActuelClNo = Project.contexteUtilisateur.cl_no;
            var equipeRecevanteMatchSelected = rencontre.find(".cr_cl_no").text();
            var visiteur = (equipeRecevanteMatchSelected == utilisateurActuelClNo) ? false : true;
            
            if (Engine.isBatteryOk()) {
                if (!element.hasClass("boutonInactif") || Project.debug) {
                    if (rencontre.length > 0) {
                        if (AccueilDto.isDemonstration || !visiteur || Environnement.debug) {
                            Engine.message("Accès à la feuille de match");
                            //vérification de la date du jour
                            var strMatchDate = element.find(".ma_dat").text();
                            //TODO réactive le contrôle sur la date du match
                            //if(AccueilService.checkDateMatch(strMatchDate))
                            {
                                var cr_cl_no = parseInt(rencontre.children(".hiddenInfosMatch").children(".cr_cl_no").text(), 10);
                                var cv_cl_no = parseInt(rencontre.children(".hiddenInfosMatch").children(".cv_cl_no").text(), 10);
                                if(AccueilDto.isDemonstration) {
                                    visiteur = false;
                                } else {
                                    visiteur = (cr_cl_no == Project.contexteUtilisateur.usr_equipe[0].cl_no) ? false : true;
                                }
                                var data = {
                                    cv_cl_blason : rencontre.children(".hiddenInfosMatch").children(".cv_cl_blason").text(),
                                    cr_cl_blason : rencontre.children(".hiddenInfosMatch").children(".cr_cl_blason").text(),
                                    ma_no : parseInt(rencontre.children(".hiddenInfosMatch").children(".ma_no").text(), 10),
                                    cv_eq_no : parseInt(rencontre.children(".hiddenInfosMatch").children(".cv_eq_no").text(), 10),
                                    cr_eq_no : parseInt(rencontre.children(".hiddenInfosMatch").children(".cr_eq_no").text(), 10),
                                    cfm_no : parseInt(rencontre.children(".hiddenInfosMatch").children(".cfm_no").text(), 10),
                                    ph_duree_prol : rencontre.children(".hiddenInfosMatch").children(".ph_duree_prol").text(),
                                    ph_tps_sup : rencontre.children(".hiddenInfosMatch").children(".ph_tps_sup").text(),
                                    ph_prol : rencontre.children(".hiddenInfosMatch").children(".ph_prol").text(),
                                    cr_cl_no : cr_cl_no,
                                    cv_cl_no : cv_cl_no,
                                    visiteur : visiteur,
                                    ph_nb_titul_mini : rencontre.children(".hiddenInfosMatch").children(".ph_nb_titul_mini").text(),
                                    ph_tir_but : rencontre.children(".hiddenInfosMatch").children(".ph_tir_but").text(),
                                    ma_huisclos : rencontre.children(".hiddenInfosMatch").children(".ma_huisclos").text(),
                                    ma_tv : rencontre.children(".hiddenInfosMatch").children(".ma_tv").text(),
                                    ph_duree_periode : rencontre.children(".hiddenInfosMatch").children(".ph_duree_periode").text(),
                                    cfm_statut : rencontre.children(".hiddenInfosMatch").children(".cfm_statut").text(),
                                    ph_tactiq : rencontre.children(".hiddenInfosMatch").children(".ph_tactiq").text(),
                                    ph_num_maillot : rencontre.children(".hiddenInfosMatch").children(".ph_num_maillot").text(),
                                    ph_reglt_locaux : rencontre.children(".hiddenInfosMatch").children(".ph_reglt_locaux").text(),
                                    ph_info_but : rencontre.children(".hiddenInfosMatch").children(".ph_info_but").text(),
                                    ph_info_secu : rencontre.children(".hiddenInfosMatch").children(".ph_info_secu").text(),
                                    ph_info_orga : rencontre.children(".hiddenInfosMatch").children(".ph_info_orga").text(),
                                    ph_carton_blanc : rencontre.children(".hiddenInfosMatch").children(".ph_carton_blanc").text(),
                                    ph_carton_vert : rencontre.children(".hiddenInfosMatch").children(".ph_carton_vert").text(),
                                    tl_cod : rencontre.children(".hiddenInfosMatch").children(".tl_cod").text(),
                                };
                                
                                var selected_ma_no = parseInt(rencontre.children(".hiddenInfosMatch").children(".ma_no").text(), 10);

                                DataBase.findBy("MATCH", "ma_no", selected_ma_no, function(dataReturn) {

                                    MatchDto.init(dataReturn[0]);

                                    // Vérifier si il existe un utilisateur pour le club visiteur du match dans la base de données de la tablette
                                    DataBase.findBy("UTILISATEUR_EQUIPE", "cl_noAndeq_codAndlc_codAndsa_no", [
                                        MatchDto.match.cv_cl_no, MatchDto.match.cv_eq_cod, MatchDto.match.lc_cod, MatchDto.match.sa_no
                                    ], function(res) {

                                        if (res.length === 0 && !AccueilDto.isDemonstration) {
                                            Engine.fermerPopup();
                                            return Engine.alert(Lang.accueil.utilisateurVisiteurManquant);
                                        }
                                        
                                        AccueilService.setHeaderDatas(rencontre.children(".hiddenInfosMatch"), visiteur);
                                        
                                        DataBase.findBy("MATCH_FEUILLE", "ma_no", parseInt(rencontre.children(".hiddenInfosMatch").children(".ma_no").text(), 10), function(dataReturn) {
                                           //récupère les joueurs de l'équipe recevante
                                            FeuilleDeMatchService.getJoueursFromCompo(data.ma_no, data.cr_cl_no, function(joueursRecevant) {
                                                //récupère les joueurs de l'équipe visiteur
                                                FeuilleDeMatchService.getJoueursFromCompo(data.ma_no, data.cv_cl_no, function(joueursVisiteur) {
                                                    CompositionsMatchDto.equipeRecevante = Utils.cloneObject(joueursRecevant);
                                                    CompositionsMatchDto.equipeVisiteur = Utils.cloneObject(joueursVisiteur);
                                                    
                                                    if (Environnement.debug) {
                                                        // Toujours ouvrir la feuille de match en mode debug
                                                        Engine.gotoPage("feuilleDeMatch.html", { match : data });
                                                    } else if(data.cfm_statut == 3 && (Utils.isNull(dataReturn[0].fdmValidee) || dataReturn[0].fdmValidee=="false")){
                                                        Engine.gotoPage("feuilleDeMatch.html", { match : data });
                                                    } else if(data.cfm_statut == 3 && (Utils.isNotNull(dataReturn[0].fdmValidee) && dataReturn[0].fdmValidee=="true")){
                                                        Engine.gotoPage("faitsDeMatch.html", { match : data });
                                                    } else if(data.cfm_statut == 4){
                                                        Engine.gotoPage("apresMatch.html", { match : data });
                                                    } else {
                                                        Engine.gotoPage("feuilleDeMatch.html", { match : data });
                                                    }
                                                });
                                            });
                                                                    
                                        });
                                    });
                                });
                            }
                            /*
                             else{
                             Engine.alert(Lang.accueil.erreurFeuilleDeMatchDate);
                             }
                             */
                        } else {
                            Engine.alert(Lang.accueil.equipeRecevanteUniquement);
                        }
                    } else {
                        Engine.alert(Lang.accueil.erreurSelectionRencontre);
                    }
                } else {
                    Engine.alert(Lang.accueil.erreurEtatMatch);
                }
            } else {
                Engine.alert(Lang.accueil.erreurNiveauBatterie);
            }

        });
    },
    "{name} #boutonInformationsFacultatives {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var rencontre = $(".ligneBody.selected");
            if (!element.hasClass("boutonInactif") || Project.debug) {
                if (rencontre.length > 0) {
                    Engine.message("Accès aux informations facultatives");
                    var hiddenInfos = rencontre.children(".hiddenInfosMatch");
                    var cr_cl_no = parseInt(hiddenInfos.children(".cr_cl_no").text(), 10);
                    var cv_cl_no = parseInt(hiddenInfos.children(".cv_cl_no").text(), 10);
                    var visiteur = (cr_cl_no == Project.contexteUtilisateur.usr_equipe[0].cl_no) ? false : true;
                    var data = {
                        ma_no : parseInt(hiddenInfos.children(".ma_no").text(), 10),
                        ma_dat : hiddenInfos.children(".ma_dat").text(),
                        li_no : hiddenInfos.children(".li_no").text(),
                        cl_nb_maxi_eqp_typ : parseInt(hiddenInfos.children( visiteur ? ".cv_cl_nb_maxi_eqp_typ" : ".cr_cl_nb_maxi_eqp_typ").text(), 10),
                        cl_eq_no : parseInt(hiddenInfos.children( visiteur ? ".cv_eq_cod" : ".cr_eq_cod").text(), 10),
                        sa_no : parseInt(hiddenInfos.children(".sa_no").text(), 10),
                        cfm_no : parseInt(hiddenInfos.children(".cfm_no").text(), 10),
                        cfm_statut : hiddenInfos.children(".cfm_statut").text(),
                        ph_nb_jou_banc : hiddenInfos.children(".ph_nb_jou_banc").text(),
                        ph_nbmaxi_mut : hiddenInfos.children(".ph_nbmaxi_mut").text(),
                        ph_nb_maxi_etrg : hiddenInfos.children(".ph_nb_maxi_etrg").text(),
                        ph_nb_titul_mini : hiddenInfos.children(".ph_nb_titul_mini").text(),
                        ph_nb_titul : hiddenInfos.children(".ph_nb_titul").text(),
                        ph_num_maillot : hiddenInfos.children(".ph_num_maillot").text(),
                        ph_nb_med_banc : hiddenInfos.children(".ph_nb_med_banc").text(),
                        ph_nb_dir_banc : hiddenInfos.children(".ph_nb_dir_banc").text(),
                        ph_nb_edu_banc : hiddenInfos.children(".ph_nb_edu_banc").text(),
                        ph_nb_staff_banc : hiddenInfos.children(".ph_nb_staff_banc").text(),
                        ph_reglt_locaux : hiddenInfos.children(".ph_reglt_locaux").text(),
                        ph_tactiq : hiddenInfos.children(".ph_tactiq").text(),
                        ph_info_but : hiddenInfos.children(".ph_info_but").text(),
                        ph_info_secu : hiddenInfos.children(".ph_info_secu").text(),
                        ph_info_orga : hiddenInfos.children(".ph_info_orga").text(),
                        visiteur : visiteur,
                    };
                    DataBase.findBy("MATCH", "ma_no", data.ma_no, function(dataReturn) {
                        Engine.fermerPopup();
                        if (Engine.dbActif) {
                            MatchDto.init(dataReturn[0]);
                        } else {
                            MatchDto.init(dataReturn);
                        }

                        AccueilService.setHeaderDatas(rencontre.children(".hiddenInfosMatch"), visiteur);
                        Engine.gotoPage("infosFacultatives.html", {
                            match : data,
                            utilisateur : AccueilService.preparerContexte(data.cl_eq_no)
                        });
                    });
                } else {
                    Engine.alert(Lang.accueil.erreurSelectionRencontre);
                }
            } else if(element.hasClass("boutonInactif")) {
                Engine.alert(Lang.accueil.inactiveInfosFacultatives);
            } else {
                Engine.alert(Lang.accueil.erreurEtatMatch);
            }
        });
    },
    "{name} .ligneBody {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            $("#boutonPreparerEquipe").removeClass("boutonActif boutonInactif").addClass("boutonInactif");
            $("#boutonRemplirFeuilleDeMatch").removeClass("boutonActif boutonInactif").addClass("boutonInactif");
            $("#boutonInformationsFacultatives").removeClass("boutonActif boutonInactif").addClass("boutonInactif");
            if (element.hasClass("selected")) {
                element.removeClass("selected");
            } else {
                element.parent().find(".selected").removeClass("selected");
                element.addClass("selected");
                var strMatchDate = element.find(".ma_dat").text();
                var strHeure = element.find(".ma_heure_lib").text();
                var cfm_statut = parseInt(element.find(".cfm_statut").text(), 10);
                var syncUnitaire = element.find(".syncunitaire").text();
                //vérifications pour l'activation du bouton "Préparer votre équipe"
                //vérifications pour l'activation du bouton "Informations facultatives"
                //vérifications pour l'activation du bouton "feuille de match"
                if ((cfm_statut == 1 || cfm_statut == 2) && (syncUnitaire == "false" || !Engine.dbActif)) {
                    if(AccueilService.checkDateMatch(strMatchDate)) {
                        // Feuille de match actif
                        $("#boutonRemplirFeuilleDeMatch").removeClass("boutonActif boutonInactif").addClass("boutonActif");
                    }
                    if(!AccueilService.checkDateHeureMatchPassee(strMatchDate, strHeure)) {

                        // Vérification que la composition n'est pas déjà validée dans la feuille de match
                        var cfm_no = parseInt(element.find(".cfm_no").text(), 10);
                        var ma_no = parseInt(element.find(".ma_no").text(), 10);
                        var rencontre = $(".ligneBody.selected");
                        
                        var utilisateurActuelClNo = Project.contexteUtilisateur.cl_no;
                        var equipeRecevanteMatchSelected = rencontre.find(".cr_cl_no").text();
                        if (Engine.dbActif) {
                            DataBase.findBy("MATCH_FEUILLE", "cfm_no", cfm_no, function(data) {
                                var alreadyValid = (equipeRecevanteMatchSelected == utilisateurActuelClNo) ? data[0].cr_co_valid : data[0].cv_co_valid;
                                var result = data;
                                if(data.length == 0) {
                                    // Le bouton "préparer équipe" devient actif, on n'a pas encore accédé à la feuille de match
                                    // préparer équipe actif
                                    $("#boutonPreparerEquipe").removeClass("boutonActif boutonInactif").addClass("boutonActif");
                                } else {
                                    if(Utils.isNotNull(alreadyValid) && Utils.isNotBlank(alreadyValid) && alreadyValid == "O"){
                                        // Le bouton "préparer équipe" reste inactif car la composition est déjà validée dans la feuille de match
                                        $("#boutonPreparerEquipe").removeClass("boutonActif boutonInactif").addClass("boutonInactif");
                                    }
                                    else {
                                        // Le bouton "préparer équipe" devient actif, on n'a pas encore accédé à la feuille de match
                                        // préparer équipe actif
                                        $("#boutonPreparerEquipe").removeClass("boutonActif boutonInactif").addClass("boutonActif");
                                    }
                                }
                            });
                        } else {
                            DataBase.findBy("MATCH_FEUILLE", "ma_no", ma_no, function(data) {
                                if(data.length == 0) {
                                    // Le bouton "préparer équipe" devient actif, on n'a pas encore accédé à la feuille de match
                                    // préparer équipe actif
                                    $("#boutonPreparerEquipe").removeClass("boutonActif boutonInactif").addClass("boutonActif");
                                } else {
                                    if(Utils.isNotNull(data.cr_co_valid) && Utils.isNotBlank(data.cr_co_valid) && data.cr_co_valid == "O"){
                                        // Le bouton "préparer équipe" reste inactif car la composition est déjà validée dans la feuille de match
                                        $("#boutonPreparerEquipe").removeClass("boutonActif boutonInactif").addClass("boutonInactif");
                                    }
                                    else {
                                        // Le bouton "préparer équipe" devient actif, on n'a pas encore accédé à la feuille de match
                                        // préparer équipe actif
                                        $("#boutonPreparerEquipe").removeClass("boutonActif boutonInactif").addClass("boutonActif");
                                    }
                                }
                            });
                                    
                        }
                    }
                } else if (cfm_statut == 3) {
                    // Feuille de match actif
                    $("#boutonRemplirFeuilleDeMatch").removeClass("boutonActif boutonInactif").addClass("boutonActif");
                } else if (cfm_statut == 5 || cfm_statut == 6) {
                    if(AccueilService.checkDateMatchInfoFacultatives(strMatchDate)) {
                        // Intervalle de 8 jours
                        // Info facultatives actif
                        $("#boutonInformationsFacultatives").removeClass("boutonActif boutonInactif").addClass("boutonActif");
                    }
                } else if (syncUnitaire == "true" && Engine.dbActif) {
                    element.addClass("notSync");
                    $("#boutonPreparerEquipe").removeClass("boutonActif boutonInactif").addClass("boutonInactif");
                    $("#boutonRemplirFeuilleDeMatch").removeClass("boutonActif boutonInactif").addClass("boutonInactif");
                }
                else if (AccueilDto.isDemonstration){
                    $("#boutonPreparerEquipe").removeClass("boutonActif boutonInactif").addClass("boutonActif");
                    $("#boutonRemplirFeuilleDeMatch").removeClass("boutonActif boutonInactif").addClass("boutonActif");
                }
            }
        });
    },
    "{name} #boutonTransmettreMatch {click}" : function(element, event) {
        event.stopPropagation();
        event.preventDefault();
        Engine.delegate(this, element, event, function(controller, element, event) {
            if (!element.hasClass("disabled_button")) {
                if (Engine.dbActif) {
                    var cfmNo = element.parent().parent().find(".hiddenInfosMatch").find(".cfm_no").text();
                    var idMatch = parseInt(element.parent().parent().find(".hiddenInfosMatch").find(".id").text(), 10);
                    
                    SynchronisationTransfertService.transfertFeuilleDeMatchUnitaire(cfmNo, function() {
                        DataBase.update("MATCH", idMatch, "cfm_statut", 5, function() {
                            var equipeVisiteurMatchSelected = element.closest(".ligneBody").children(".hiddenInfosMatch").find(".cr_cl_no").text();
                            var visiteur = (equipeVisiteurMatchSelected == Project.contexteUtilisateur.usr_equipe[0].cl_no) ? false : true;
                            SynchronisationService.updateTransmissionDate(false, visiteur, idMatch);
                            SynchronisationService.updateTransmissionDate(true, !visiteur, idMatch);
                        });
                    });
                } else {
                    Engine.alert(Lang.accueil.erreurTransmissionWeb);
                }
            }
        });
    },
    "{name} #boutonDemo {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            AccueilDto.isDemonstration = true;
            AccueilDto.isPurgeDemonstrationFaite = false;
            Engine.gotoPage("accueil.html");
        });
    },
    "{name} #boutonExitDemo {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            AccueilDto.isDemonstration = false;
            AccueilDto.isPurgeDemonstrationFaite = false;
            Engine.gotoPage("accueil.html");
        });
    },
}); 