var ApresMatchController = MainController.extend({
    defaults: {
        name: ".ApresMatchController",
        click: Engine.eventClick,
        change: "change",
        dblclick: Engine.eventDblclick,
        pages: new Array(
            "apresMatch/apresMatch.html",
            "apresMatch/onglets/signatures.html",
            "apresMatch/onglets/rencontre.html",
            "apresMatch/onglets/compo.html",
            "equipe/equipe.html",
            "apresMatch/onglets/faitsDeJeu.html",
            "faitsDeMatch/onglets/blessures.html",
            "faitsDeMatch/onglets/buts.html",
            "faitsDeMatch/onglets/discipline.html",
            "faitsDeMatch/onglets/histo.html",
            "faitsDeMatch/onglets/infos.html",
            "faitsDeMatch/onglets/match.html",
            "faitsDeMatch/onglets/rempl.html",
            "feuilleDeMatch/popups.html",
            "reserves/reservesAvantMatch/js/onglets/equipeVisiteurReserve.html"),
        files: new Array(
            "faitsDeMatch/css/faitsDeMatch.css",
	        "apresMatch/css/apresMatch.css",
	        "apresMatch/js/apresMatchFr.js",
	        "feuilleDeMatch/js/dto/compositionsMatchDto.js",
	        "feuilleDeMatch/js/dto/matchDto.js",
	        "faitsDeMatch/js/feuilleDeMatchDto.js",
	        "faitsDeMatch/js/dto/faitsDeMatchHistoriqueDto.js",
	        "faitsDeMatch/js/faitsDeMatchService.js",
	        "faitsDeMatch/js/service/faitsDeMatchHistoService.js",
	        "faitsDeMatch/js/faitsDeMatchOngletsService.js",
	        "faitsDeMatch/js/faitsDeMatchFr.js",
	        "faitsDeMatch/js/service/faitsDeMatchDisciplineService.js",
	        "faitsDeMatch/js/service/faitsDeMatchBlessureService.js",
	        "feuilleDeMatch/js/service/feuilleDeMatchConnexionService.js",
	        "feuilleDeMatch/js/service/feuilleDeMatchSignaturesService.js",
	        "feuilleDeMatch/js/service/feuilleDeMatchInfosMatchService.js",
	        "feuilleDeMatch/js/feuilleDeMatchFr.js",
	        "apresMatch/js/service/apresMatchRencontreService.js",
	        "apresMatch/js/service/apresMatchCompoService.js",
	        "apresMatch/js/service/apresMatchSignaturesService.js",
	        "apresMatch/js/service/apresMatchFaitsDeJeuService.js",
	        "equipe/js/service/equipeLicenceService.js",
	        "equipe/js/service/equipeCompositionService.js",
	        "equipe/js/service/equipeDragAndDropService.js",
	        "equipe/js/equipeDto.js",
            "equipe/js/equipeFr.js",
	        "connexion/js/connexionDto.js",
	        "connexion/js/connexionFr.js",
            "synchronisation/js/service/synchronisationService.js"),
        cloturer: true,
    }
}, {
    init: function(element, options) {
        this._super(this, element, options);
    },
    load: function(page, data) {
        Engine.loadController(page, this.options.pages, this.options.files, this, function(controller) {
            controller.options.match = {};
            controller.options.match = Utils.cloneObject(data.match);
            FeuilleDeMatchService.chargerFeuilleDeMatch(data.match, function(){
                controller.show(controller.element, null);
            });
        });
    },
    show: function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            Engine.headerController.hideSynchroButton();
            
            // Chargement de l'onglet Rencontre
            FaitsDeMatchOngletsService.changeOnglet($("#rencontre"), {});
            
            FeuilleDeMatchDto.ma_no = controller.options.match.ma_no;
            FeuilleDeMatchDto.cfm_no = controller.options.match.cfm_no;
            
            // Onglet Rencontres
            Engine.addView("#rencontreContent", "rencontre.html:onglet", {feuilleDeMatch : FeuilleDeMatchDto});
            DataBase.findBy("MATCH_FEUILLE_MEMBRE", "cfm_no", FeuilleDeMatchDto.data.cfm_no, function(dataOff) {
                Engine.addView("#listeOfficiels", "popups.html:popupListeOfficiels", {
                    officiels : dataOff,
                    forcerVisualiser : true
                });
            });
            Engine.getReferentiel("ref_typ", "FMI_MOTIF_NON_JOUE", function(motifNonJoue){
                Engine.getReferentiel("ref_typ", "FMI_MOTIF_ARRET", function(motifArret){
                    Engine.addView("#infosMatch", "match.html:onglet", {
                        matchFeuille : FeuilleDeMatchDto.data, 
                        match : FeuilleDeMatchDto.datasMatch, 
                        motifNonJoue : motifNonJoue, 
                        motifArret : motifArret,
                        edit : false, 
                        forcerNonJoue: FaitsDeMatchOngletsService.isForcerMatchNonJoue()
                    });
                    FaitsDeMatchService.afficherMasquerElements(true);
                });
            });
            
            // Onglet Faits de Jeu
            Engine.addView("#faitsDeJeuContent", "faitsDeJeu.html:onglet", {feuilleDeMatch : FeuilleDeMatchDto});
            FaitsDeMatchHistoService.findHistorique(true, function(){}, false, false, true);
            
        });
    },
    /******************************************************
     *********** GESTION DES ONGLETS **********************
     ******************************************************/
    "{name} #partie_droite_bottom .onglet {click}": function(element, event){
        Engine.delegate(this, element, event, function(controller) {
            element.parent().children(".isSelected").removeClass("isSelected");
            element.addClass("isSelected");
            
            if (element.hasClass("remplacant")) {
                Engine.deleteScroll("remplacantDisplayZone");
                setTimeout(function () {
                    Engine.initScrolls("remplacantDisplayZone");
                }, 20);

                element.parent().parent().children(".sub").show();
                element.parent().parent().children(".staff").hide();
                element.children("#iconRemplacant").css('background-image', 'url("modules/equipe/img/remplacants_actif.png")');
                element.parent().find("#iconEncadrement").css('background-image', 'url("modules/equipe/img/staff_logo.png")');
            } else if (element.hasClass("encadrement")) {
                Engine.deleteScroll("staffDisplayZone");
                setTimeout(function () {
                    Engine.initScrolls("staffDisplayZone");
                }, 20);
                element.parent().parent().children(".staff").show();
                element.parent().parent().children(".sub").hide();
                element.parent().find("#iconRemplacant").css('background-image', 'url("modules/equipe/img/remplacants.png")');
                element.parent().find("#iconEncadrement").css('background-image', 'url("modules/equipe/img/staff_logo_inactif.png")');
            }
        });
    },
    "{name} .teamSelect > div {click}": function(element, event) {
        //si l'élément est un onglet déjà sélectionné, on ne fait rien
        if(!element.hasClass("selected")){
            var equipeAffichee = element.parent().children(".selected").attr("id");
            var equipeAAfficher = element.attr("id");
            
            $("#" + equipeAffichee + "Content").hide();
            $("#" + equipeAffichee + "Content").parent().hide();
            Engine.deleteScroll(equipeAAfficher + "Content");
            element.parent().children(".selected").removeClass("selected");
            $("#" + equipeAAfficher + "Content").show();
            $("#" + equipeAAfficher + "Content").parent().show();
            element.addClass("selected");
            Engine.initScrolls(equipeAAfficher + "Content");
            EquipeDragAndDropService.vider();
            
            var afficherCompo = 
                (equipeAAfficher === "equipeRecevante" && FeuilleDeMatchDto.data.crCompValides === true) ||
                (equipeAAfficher === "equipeVisiteur" && FeuilleDeMatchDto.data.cvCompValides === true);
            
            if (afficherCompo) {
                EquipeCompositionService.showCompositionOnScreen(
                    CompositionsMatchDto[equipeAAfficher], 
                    true, 
                    FaitsDeMatchHistoriqueDto.remplacantsAyantJoue, 
                    parseInt($("#" + equipeAAfficher).attr("data-tqno"), 10), false);
            }
        }
    },
    "{name} div.onglets div {click}": function(element, event) {
        //si l'élément est un onglet déjà sélectionné, on ne fait rien
        if(!element.hasClass("selected")){
            FaitsDeMatchOngletsService.changeOnglet($("#"+element.attr("id")), {});
        }
    },
    "{name} .enteteDepliant {click}": function(element, event){
        Engine.deleteScroll("equipeRecevanteReservesContent");
        Engine.deleteScroll("equipeVisiteurReservesContent");
        Engine.deleteScroll("equipeRecevanteReservesTechContent");
        Engine.deleteScroll("equipeRecevanteObservationsContent");
        if (!element.hasClass("selected")){
            element.parent().children(".selected").removeClass("selected").children("span").html("+").parent().next().hide();
            element.addClass("selected").children("span").html("-").parent().next().show();
        } else {
            element.removeClass("selected").children("span").html("+").parent().next().hide();
        }
        Engine.initScrolls();
    },
    "{name} .connexionSignature {click}": function(element, event) { // Signatures
        Engine.delegate(this, element, event, function(controller, element, event) {
            if(!element.hasClass("boutonSignaturesInactif")) {
                var typeEquipe = element.attr("id") === "connexionEquipeRecevante" ? "EquipeRecevante" : "EquipeVisiteur";
                FeuilleDeMatchConnexionService.afficherPopupClubConnexion(typeEquipe, true, function () {
                    Engine.bindSignature("#blocSignature" + typeEquipe, 273, 150);
                    if (typeEquipe == "EquipeRecevante") {
                        $("#signatureArbitre").find(".blocsSignature").addClass("signaturesInactives");
                        $(".signerArbitre").addClass("boutonSignaturesInactif");
                        $("#signatureEquipeVisiteur").find(".blocsSignature").addClass("signaturesInactives");
                        $("#connexionEquipeVisiteur").addClass("boutonSignaturesInactif");
                    } else {
                        $("#signatureArbitre").find(".blocsSignature").addClass("signaturesInactives");
                        $(".signerArbitre").addClass("boutonSignaturesInactif");
                        $("#signatureEquipeRecevante").find(".blocsSignature").addClass("signaturesInactives");
                        $("#connexionEquipeRecevante").addClass("boutonSignaturesInactif");
                    }
                    $(".absenceEquipe").hide();
                });
            }
        });
    },
    "{name} .signerArbitre {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if(!element.hasClass("boutonSignaturesInactif")) {
                FeuilleDeMatchSignaturesService.viderSignaturesBase("Arbitre", "apm", function() {
                    Engine.addView("#signatureArbitre", "signatures.html:boutonsValidationSignature", {
                        equipe : "Arbitre",
                        clNoUser : "",
                        signataires : []
                    }, false);

                    Engine.bindSignature("#blocSignatureArbitre", 273, 150);
                    
                    $("#signatureEquipeRecevante").find(".blocsSignature").addClass("signaturesInactives");
                    $("#connexionEquipeRecevante").addClass("boutonSignaturesInactif");
                    $("#signatureEquipeVisiteur").find(".blocsSignature").addClass("signaturesInactives");
                    $("#connexionEquipeVisiteur").addClass("boutonSignaturesInactif");
                    $(".absenceEquipe").hide();
                });
            }
        });
    },
    "{name} #valider-connexion-signatures {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var typeEquipe = element.attr("data-id") == "connexionEquipeRecevante" ? "EquipeRecevante" : "EquipeVisiteur";
            FeuilleDeMatchConnexionService.validerConnexionClubSignature(typeEquipe, function () {
                Engine.bindSignature("#blocSignature" + typeEquipe, 273, 150);
                if (typeEquipe == "EquipeRecevante") {                    
                    $("#signatureArbitre").find(".blocsSignature").addClass("signaturesInactives");
                    $(".signerArbitre").addClass("boutonSignaturesInactif");
                    $("#signatureEquipeVisiteur").find(".blocsSignature").addClass("signaturesInactives");
                    $("#connexionEquipeVisiteur").addClass("boutonSignaturesInactif");
                } else {
                    $("#signatureArbitre").find(".blocsSignature").addClass("signaturesInactives");
                    $(".signerArbitre").addClass("boutonSignaturesInactif");
                    $("#signatureEquipeRecevante").find(".blocsSignature").addClass("signaturesInactives");
                    $("#connexionEquipeRecevante").addClass("boutonSignaturesInactif");
                } 
                $(".absenceEquipe").hide();
                Engine.fermerPopup();
            }, true);
        });
    },
    "{name} .validerSignatures {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            $("#errorValidation").html("");
            var signature = element.attr("data-id");
            var connaissance = $("#validerConnaissance"+signature)[0].checked;
            var signataire = null;
            var clNoUser = element.attr("data-clNoUser");

            //Si ce n'est pas l'arbitre qui signe, on récupère le signataire
            if (signature != "Arbitre") {
                signataire = $("#choixSignataire" + signature + " option:selected").val();
            } else {
                signataire = "Arbitre";
            }

            if (connaissance == false) {
                $("#errorValidation").html(Lang.apresMatch.erreurs.signatures.connaissance);
            } else if (!Utils.isNotBlank(signataire)) {
                $("#errorValidation").html(Lang.apresMatch.erreurs.signatures.signataire);
            } else if (Utils.isSignatureEmpty("#blocSignature" + signature)) {
                $("#errorValidation").html(Lang.apresMatch.erreurs.signatures.signatureVide);
            } else {
                $("#errorValidation").html("");
                var imageSignature = Engine.getSignature("#blocSignature" + signature);
                FeuilleDeMatchSignaturesService.enregistrerSignatures(FeuilleDeMatchDto.data.cfm_no, clNoUser, imageSignature, signature, signataire, "apm", false, function() {
                    ApresMatchSignaturesService.testerAffichageBoutons();
                });
                $(".absenceEquipe").show();
                $("#signatureArbitre").find(".blocsSignature").removeClass("signaturesInactives");
                $(".signerArbitre").removeClass("boutonSignaturesInactif");
                $("#signatureEquipeRecevante").find(".blocsSignature").removeClass("signaturesInactives");
                $("#connexionEquipeRecevante").removeClass("boutonSignaturesInactif");
                $("#signatureEquipeVisiteur").find(".blocsSignature").removeClass("signaturesInactives");
                $("#connexionEquipeVisiteur").removeClass("boutonSignaturesInactif");
            }
        });
    },
    "{name} .absenceEquipeCheckbox {change}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var coteEquipe = element.attr("data-id");
            
            Engine.addView("#boutonConnexion" + coteEquipe, "popups.html:ligneBoutons", {
                equipe : coteEquipe,
                disable : $("#absence"+coteEquipe)[0].checked
            }, true);
            $("#blocSignature" + coteEquipe).children().remove();
        
            ApresMatchSignaturesService.testerAffichageBoutons();
        });
    },
    "{name} #dev-connexion {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if (Project.debug) {
                $("#login").val(Project.loginDebug);
                $("#mdp").val(Project.mdpDebug);
            }
        });
    },
    "{name} #histoListe li {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            $("#histoListe li").removeClass("waitingForTarget");
            element.addClass("waitingForTarget");
            
            var idHisto = element.attr("data-for");
            var typHisto = element.attr("data-type");
            var faitDeJeuAffichage;
            for (var i in FaitsDeMatchHistoriqueDto.histo) {
                var dataHisto = FaitsDeMatchHistoriqueDto.histo[i];
                if (dataHisto.id == idHisto) {
                    faitDeJeuAffichage = dataHisto;
                    faitDeJeuAffichage.l1_cfi_maillot = faitDeJeuAffichage.l2_cfi_maillot = "";
                    if (Utils.isNotBlank(dataHisto.l1_li_no) || Utils.isNotBlank(dataHisto.in_no)) {
                        if (Utils.isNotBlank(dataHisto.l1_li_no)) {
                            var champs = "cfm_noAndli_no";
                            var params = [dataHisto.cfm_no, dataHisto.l1_li_no];
                        } else {
                            var champs = "cfm_noAndin_no";
                            var params = [dataHisto.cfm_no, dataHisto.in_no];
                        }
                        DataBase.findBy("MATCH_FEUILLE_COMPO", champs, params, function(datal1) {
                            faitDeJeuAffichage.l1_cfi_maillot = datal1[0].cfi_typ_role == "J" ? datal1[0].cfi_maillot : datal1[0].cfi_poste;
                            if (Utils.isNotNull(dataHisto.l2_li_no) && Utils.isNotBlank(dataHisto.l2_li_no)) {
                                DataBase.findBy("MATCH_FEUILLE_COMPO", "cfm_noAndli_no", [dataHisto.cfm_no, dataHisto.l2_li_no], function(datal2) {
                                    faitDeJeuAffichage.l2_cfi_maillot = datal2[0].cfi_typ_role == "J" ? datal2[0].cfi_maillot : datal2[0].cfi_poste;
                                    ApresMatchFaitsDeJeuService.visualiserEvenement(typHisto, faitDeJeuAffichage);
                                });
                            } else {
                                ApresMatchFaitsDeJeuService.visualiserEvenement(typHisto, faitDeJeuAffichage);
                            }
                        });
                    } else {
                        ApresMatchFaitsDeJeuService.visualiserEvenement(typHisto, faitDeJeuAffichage);
                    }
                    break;
                }
            }
        });
    },
    "{name} #envoyerFeuilleDeMatch {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            Engine.fermerPopup();
            var disableEnvoi = element.hasClass("disabled_button");
            if (disableEnvoi === false) {
                Engine.addView("#popupLogin", "popups.html:popupLoginArbitre", {
                    envoi : true,
                }, true);
                Engine.popup("#popupLogin");
            }
        });
    },
    "{name} #deverrouillerFeuilleDeMatch {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            Engine.confirm(Lang.apresMatch.alerteDeverrouillage, function(){
                Engine.fermerPopup();
                Engine.addView("#popupLogin", "popups.html:popupLoginArbitre", {
                    data : {}
                }, true);
                Engine.popup("#popupLogin");
            }, false, "240px", false);
        });
    },
    "{name} #accueil-connexion-arbitre {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            $("#popupLogin").removeClass("dont-close");
            Engine.gotoPage("accueil.html");
        });
    },
    "{name} #returnButton {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            Engine.gotoPage("faitsDeMatch.html", {
                match : MatchDto.match
            });
        });
    },
    "{name} .alerteFermer {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if (controller.cloturer === true && element[0].id !== "boutonOkSynchronisation") {
                Engine.gotoPage("accueil.html");
            }
        });
    },
    "{name} #valider-connexion-arbitre {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var popupVerrou = Utils.isNotNull(element.attr("data-verrou"));
            var popupEnvoi = Utils.isNotNull(element.attr("data-envoi"));
            var cfm_no = FeuilleDeMatchDto.cfm_no;
            var datas = {};

            console.log("popupVerrou : " + popupVerrou);
            console.log("popupEnvoi : " + popupEnvoi);

            //Vérification du mot de passe saisie
            var password = $("#mdp").val();
            if (password === "") {
                $("#errorConnexion").html(Lang.connexion.mdpVide);
                return;
            }

            //recherche de l'id en base de la feuille match à mettre à jour
            DataBase.findBy("MATCH_FEUILLE", "cfm_noAndcfm_mdp", [cfm_no, password], function(data) {
                if (data.length === 0) {
                    // error
                    $("#errorConnexion").html(Lang.connexion.connexionImpossible);
                } else if (popupEnvoi) {
                    FeuilleDeMatchService.changerStatut(FeuilleDeMatchDto.cfm_no, 4, function () {
                        controller.cloturer = true;
                        // Mise à jour les dates de transmission pour deux équipes
                        SynchronisationService.majDates("apresMatch");
                        SynchronisationTransfertService.transfertFeuilleDeMatchUnitaire(FeuilleDeMatchDto.cfm_no, function() {
                            FeuilleDeMatchService.changerStatut(FeuilleDeMatchDto.cfm_no, 5);                                
                        });
                    });

                } else if (popupVerrou) {
                    $("#popupLogin").removeClass("dont-close");
                    Engine.fermerPopup();
                } else {
                    // fix pour problème de persistance des boutons d'envoi/modification
                    // pendant les requêtes sql suite à modification.
                    FeuilleDeMatchDto.data.cfm_signat_apm_arb = null;
                    ApresMatchSignaturesService.testerAffichageBoutons();

                    Engine.fermerPopup();
                    controller.cloturer = false;
                    FeuilleDeMatchService.changerStatut(FeuilleDeMatchDto.cfm_no, 3);
                    FeuilleDeMatchService.incrementerDeverrouillage(cfm_no, "fm", function() {
                        FeuilleDeMatchSignaturesService.viderSignatures(cfm_no, "apm", function() {
                            DataBase.update("MATCH_FEUILLE", data[0].id, "cfm_verrou", "N", function() {
                                FeuilleDeMatchSignaturesService.reinitBoutonSignature("EquipeRecevante", FeuilleDeMatchDto.data.cfm_signat_apm_rec, false);
                                FeuilleDeMatchSignaturesService.reinitBoutonSignature("Arbitre", FeuilleDeMatchDto.data.cfm_signat_apm_arb, false);
                                FeuilleDeMatchSignaturesService.reinitBoutonSignature("EquipeVisiteur", FeuilleDeMatchDto.data.cfm_signat_apm_vis, false);
                                ApresMatchSignaturesService.testerAffichageBoutons();
                                SynchronisationTransfertService.saveHistoFeuilleDeMatch(FeuilleDeMatchDto.cfm_no, function(data) {
                                    FeuilleDeMatchSignaturesService.reinitBoutonSignature("EquipeRecevante", FeuilleDeMatchDto.data.cfm_signat_apm_rec, false);
                                    FeuilleDeMatchSignaturesService.reinitBoutonSignature("Arbitre", FeuilleDeMatchDto.data.cfm_signat_apm_arb, false);
                                    FeuilleDeMatchSignaturesService.reinitBoutonSignature("EquipeVisiteur", FeuilleDeMatchDto.data.cfm_signat_apm_vis, false);
                                    ApresMatchSignaturesService.testerAffichageBoutons();
                                    var datas = {
                                        cv_forf : FeuilleDeMatchDto.data.cv_forf,
                                        cr_forf : FeuilleDeMatchDto.data.cr_forf,
                                        feuilleDeMatch : FeuilleDeMatchDto,
                                        cfm_signat_rec : FeuilleDeMatchDto.data.cfm_signat_apm_rec,
                                        cfm_signat_vis : FeuilleDeMatchDto.data.cfm_signat_apm_vis,
                                        cfm_signat_arb : FeuilleDeMatchDto.data.cfm_signat_apm_arb,
                                    };
                                    Engine.addView("#divSignaturesApresMatch", "popups.html:popupSignatures", datas);
                                    ApresMatchSignaturesService.afficherNombreDeverouillage();
                                });
                            });
                        });
                    });
                }
            });
        });
    },
/*    "{name} #lienMotDePasseOublie {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            FeuilleDeMatchConnexionService.afficherPopupMotDePasseRencontreOublie(element.data("cl-no"));
        });
    },*/
    "{name} #validerMotDePasseOublie {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            $("#popupLogin").removeClass("dont-close");
            var questionSecurite = Engine.selectGetVal($("#questionSecurite"));
            var reponseSecurite = $("#reponseSecurite").val();
            var nouveauMotDePasse = $("#nouveauMotDePasse").val();
            var cl_no = element.data("cl-no");
            
            FeuilleDeMatchService.majMotDePasseOublie(cl_no, questionSecurite, reponseSecurite, nouveauMotDePasse, function () {
                Engine.fermerPopup(true);
            });
        });
    }
}); 