var ConnexionController = MainController.extend({
    defaults: { 
        name: ".ConnexionController",
        click: Engine.eventClick,
        pages: new Array(
                "connexion/connexion.html"),
        files: new Array( 
                "connexion/css/connexion.css",
                "connexion/js/connexionFr.js",
                "connexion/js/service/connexionService.js",
                "connexion/js/service/connexionCookieService.js",
                "connexion/js/service/connexionCguService.js",
                "accueil/js/referentielDto.js"),
        header: false,
        all: true,
    }
}, {
    init: function(element, options) {
        this._super(this, element, options);
         
    },
    load: function(page, data) {
        Engine.loadController(page, this.options.pages, this.options.files, this, function(controller) {
            controller.show(controller.element, null);
        });
    },
    show: function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
        });
    },
	"{name} #connexion {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if ($("#login").val() == "") {
                $("#errorConnexion").html(Lang.connexion.loginVide);
                return;
            } else if ($("#mdp").val() == "") {
                $("#errorConnexion").html(Lang.connexion.mdpVide);
                return;
            }
            DataBase.findBy("TABLETTE", "tlb_uuid", Engine.device.uuid, function(data) {
                // pas de clé en base !
                if (data.length==0) {
                    Utils.log("Pas de clé !");
                    Engine.getJsonCle(function() {
                        DataBase.insert("TABLETTE", {
                            "tlb_uuid": Engine.device.uuid, 
                            "tlb_cle_e": Engine.cleE,
                            "tlb_cle_b": Engine.cleB,
                            "tlb_app_version": Engine.device.version,
                            "tlb_nb_eq_typ_max": 3,
                        }, function(event) {
                            ConnexionService.connexion();
                        });
                    });
                } else {
                    Engine.cleE = data[0].tlb_cle_e;
                    Engine.cleB = data[0].tlb_cle_b;
                    Project.contexteUtilisateur.data_syncro = data[0].data_synchro;
                    ConnexionService.connexion();
                }
            });
        });
    },
    "{name} #reserves {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            Engine.gotoPage("reserves.html");
        });
    },
    "{name} .logo-fff {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if (Project.debug) {
                $("#login").val(Project.loginDebug);
                $("#mdp").val(Project.mdpDebug);
            }
        });
    },
    "{name} .title {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if (Project.debug) {
                $('#login').val(Project.loginStore);
                $('#mdp').val(Project.mdpStore);
            }
        });
    },
    "{name} #fond-ballon {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if (Project.debug) {
                Engine.gotoPage("debug.html");
            }
        });
    },
    "{name} #restoreDumpDemo {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if (Project.debug) {
                synchronisationDumpRestoreService.restoreDump();
            }
        });
    },
    "{name} #validerCgu {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if (!element.hasClass("disabled_button") || Project.debug === true) {
                var cgu_no = $("#cgu_no").val();
                ConnexionCguService.validerCgu(cgu_no, function() {
//                    Engine.fermerPopup();
                    Engine.gotoPage("accueil.html");
                });
            }
        });
    }
});