var ConnexionCguService = {
    validerCgu: function(cgu_no, callback) {
        //enregistrement en base et web des cgu
        Utils.log("cgu_no = " + cgu_no);
        var data = {
            cgu_no : cgu_no.toString(),
            usr_no : Project.contexteUtilisateur.usr_no.toString(),
            cgu_dat: Utils.getDate(),
            cgu_version: ""
        };
        DataBase.insert("CGU", data);
        if(!Engine.dbActif) {
            //création du cookie
            ConnexionCookieService.createCookie(data.usr_no, data.cgu_no, 364);
        }
        if (typeof callback === 'function') {
            callback();
        }
    },
    areCguValidees: function(data, callbackValidees, callbackNonValidees){
        if("data" in data && data.data === "OK") {
            Utils.log("Validées par le SI");
            callbackValidees();
        } else if(Engine.dbActif) {
            DataBase.findBy("CGU", "usr_no", Project.contexteUtilisateur.usr_no, function(dataReturn) {
                if(Utils.isNotNull(dataReturn) && dataReturn.length > 0 && dataReturn[0].cgu_no === data.cgu_no) {
                    Utils.log("Validées en base");
                    callbackValidees();
                } else {
                    callbackNonValidees();
                }
            });
        } else {
            if(ConnexionCookieService.readCookie(Project.contexteUtilisateur.usr_no) === data.cgu_no) {
                Utils.log("Validées via cookie");
                callbackValidees();
            } else {
                callbackNonValidees();
            }
        }
    },
    verifCgu: function() {
        //TODO MFD: tablette connectée ? verifs CGU : Skip les vérifs
        var modeWeb = Engine.dbActif ? "N" : "Y";
        var version = Engine.dbActif ? Environnement.version : "";
        var login = $("#login").val().toUpperCase();
        var mdp = Utils.encryptSha1($("#mdp").val()).toUpperCase();
        
        ConnexionCguService.getD003({ login: login, mdp: mdp, mode_web : modeWeb, version : version }, function(data){
            ConnexionCguService.areCguValidees(data, function() {
                Engine.gotoPage("accueil.html");
            }, function() {
                ConnexionCguService.afficherCgu(data);
            });
        }, function() {
            Engine.gotoPage("accueil.html");
        });
    },
    enableValidateButton: function () {
        $("#validerCgu").removeClass("disabled_button");
        $("#validerCgu").addClass("button_jaune");
        $(".scroll-indicator").hide();
    },
    afficherCgu: function(data) {
        Engine.addView("#popupCgu", "connexion.html:popupCgu", {data : data}, true);
        $("#validerCgu").removeClass("button_jaune");
        Engine.popup("#popupCgu");

        // Engine.initScrolls("cguContentValidation");
        if (Engine.isCordovaMobile()) {
            setTimeout(function () {
                Engine.scrolls["cguContentValidation"].scroll.on("scrollEnd", function () {
                    if (this.y <= this.maxScrollY) {
                        ConnexionCguService.enableValidateButton();
                    }
                });
            }, 300);
        } else {
            $("#cguContentValidation").scroll(function(){
                if ($("#cguContentValidation").scrollTop() + $("#cguContentValidation").height() > $(".texteCgu").height()) {
                    ConnexionCguService.enableValidateButton();
                }
            });
        }
    },
    getD003: function(data, callback, callbackError) {
        var demande = "D003";
        var sJson = JSON.stringify({
            "date" : Utils.getDate(), 
            "demande": demande,
            "uuid": Utils.encryptSha1(Engine.device.uuid), 
            "data": Utils.encryptServiceData(data, Engine.cleE)
        });
        var regex = new RegExp(".{1," + Engine.tailleDecoupageFlux + "}", "g"); 
        var aJson = sJson.match(regex);
        jQuery.ajaxSettings.traditional = true;
        ConnexionCguService.ajax("POST", Project.url, {
            'p_json': aJson
        }, function(retour) {
            var json = retour.data;
            try {
                json = Utils.decryptServiceData(retour.data, Project.cleE);
            } catch(e) {
            }
            Utils.log(json);
            if (typeof callback === 'function') {
                callback(json);
            }
            
        }, callbackError);  
    },
    messageKoCgu: function(json, callbackError) {
        if (json.code_erreur === 4) {
            Engine.alert(Lang.connexion.messageMiseAJourBloquante, "235px");
        } else {
            Utils.log("Erreur RESPONSE KO !");
            if (typeof callbackError === 'function') {
                callbackError();
            } else {
                // TODO gérer l'erreur manuellement
            }
        }
    },
    errorCgu: function(error, callbackError) {
        Utils.log(JSON.stringify(error));
        if (error.status=="404" || error.status=="0") {
            if (typeof callbackError === 'function') {
                callbackError();
            }
        } else {
            Engine.alert("Une erreur s'est produit : " + error.status + " " + error.statusText);
        }
        Engine.hideLoader();
    },
    ajax: function(type, url, data, success, callbackError){
        if (Utils.isIe() <= 6 && window.XDomainRequest) {
            var xdr = new XDomainRequest();
            xdr.open(type, url, true);
            xdr.onsuccess = function() {
                var json = xdr.responseText;
                if (json.message==="KO") {
                    ConnexionCguService.messageKoCgu(json, callbackError);
                } else {
                    success(json);
                }
                Engine.hideLoader();
            };
            xdr.onerror = function() {
                var error = xdr.responseText;
                ConnexionCguService.errorCgu(error, callbackError);
            }; 
            xdr.send(JSON.stringify(data));
        } else {
            $.support.cors = true;
            $.ajax({
                type: "post",
                timeout: 99999999999,
                url: url, 
                data: data,
                async: true,
                success: function(json) {
                    if (json.message==="KO") {
                        ConnexionCguService.messageKoCgu(json, callbackError);
                    } else {
                        success(json);
                    }
                    Engine.hideLoader();
                },
                error: function(error) {
                    ConnexionCguService.errorCgu(error, callbackError);
                }
            });
        }
    }
};