var ConnexionService = {
    
    isOnline: function () {
        if (typeof navigator.connection != "undefined") {
            var networkState = navigator.connection.type;
            return networkState !== Connection.UNKNOWN && networkState !== Connection.NONE;
        } else {
            return true;
        }
    },

    stockerContexte: function(json) {
        Project.contexteUtilisateur.usr_ora = Engine.login; 
        Project.contexteUtilisateur.usr_password = Engine.mdp;
        Project.contexteUtilisateur.usr_no = json.usr_no;
        Project.contexteUtilisateur.usr_nom_conx = json.usr_nom_conx;
        Project.contexteUtilisateur.cl_no = json.cl_no;
        Project.contexteUtilisateur.usr_equipe = [];
        $.each(json.usr_equipe, function( key, value ) {
            Project.contexteUtilisateur.usr_equipe.push({
                "cl_no": value.cl_no,
                "sa_no": value.sa_no,
                "lc_cod": value.lc_cod,
                "eq_no": value.eq_no,
            });
        });
        Utils.log(Project.contexteUtilisateur);
        ConnexionCguService.verifCgu();
    },
    
    connexion: function() {
        if (Engine.isBatteryOk()) {
            Engine.login = $("#login").val().trim().toUpperCase();
            Engine.mdp = Utils.encryptSha1($("#mdp").val().trim()).toUpperCase();
            
            // Authentification avec un compte validation
            if (Project.isCompteValidation()) {
                ConnexionService.connexionCompteValidation();
            } else {
                Engine.showLoader();
                // Recherche du login en local
                DataBase.findBy("UTILISATEUR", "usr_ora", [Engine.login], function(data) {
                    // Si on est en ligne, on privilégie toujours l'authentification via le SI
                    if (ConnexionService.isOnline()) {
                        console.log("isonline !!");
                        ConnexionService.authentificationWeb(data.length === 0);
                    } else {
                        // Authentification du login/mdp via la base de données local, 
                        // si incorrect on procède à l'authentification par le SI
                        console.log("pas online : data ->");
                        console.log(data);
                        if (data.length > 0 && data[0].usr_password===Engine.mdp) {
                            ConnexionService.connexionLocal(data[0]);
                        } else {
                            // Pas de réseau, mais appeler le SI tout de même pour
                            // que l'utilisateur voit apparaitre le message suivant : 
                            // Veuillez vous connecter à internet
                            ConnexionService.authentificationWeb(data.length === 0);
                        }
                    }
                });
            }
        // Batterie faible
        } else {
            Engine.alert(Lang.connexion.erreurNiveauBatterie);
        }
    },

    /**
     * Identification par le SI
     */
    authentificationWeb: function (isPremiereConnexion) { 
        var networkCallbackError = function() {
            Engine.hideLoader();
//            Engine.fermerPopup();
            Engine.alert("Utilisateur et/ou Mot de passe invalide. Veuillez vous connecter à internet");
        };
        Engine.getDemande("D002", {}, function(json) {
            ConnexionService.saveOrUpdateConnectedUser(json, function () {
                ConnexionService.refreshUtilisateurEquipes(json);
                ConnexionService.stockerContexte(json);
                Engine.hideLoader();
            });            
        }, networkCallbackError, null, isPremiereConnexion);
    },
    
    connexionCompteValidation: function () {
        ConnexionService.stockerContexte({
            "usr_no" : "", 
            "usr_nom_conx" : Project.loginStore.toUpperCase(), 
            "cl_no" : "", 
            "usr_equipe" : [{
                "cl_no" : "-1",
                "eq_no" : "-1",
                "lc_cod" : "AAAA",
                "sa_no" : "1999"
            }], 
        });
    },
    
    /**
     * Enregistrement 
     */
    connexionLocal: function (user) {
        // Stockage du contexte
        user.usr_equipe = [];
        DataBase.findBy("UTILISATEUR_EQUIPE", "usr_no", user.usr_no, function(user_info) {
            for (var i in user_info) {
                user.usr_equipe.push({
                    "cl_no": user_info[i].cl_no,
                    "sa_no": user_info[i].sa_no,
                    "lc_cod": user_info[i].lc_cod,
                    "eq_no": user_info[i].eq_cod,
                });
                // PATCH mantis #0027471
                user.cl_no = user.usr_equipe[0].cl_no;
            }
//            Engine.fermerPopup();
            ConnexionService.stockerContexte(user);
            Engine.hideLoader();
        });
    },

    /**
     * Enregistrement de l'utilisateur si il n'existe pas.
     * Si l'utilisateur existe dans la base ses informations login/mot de passe sont mis à jour.
     */
    saveOrUpdateConnectedUser: function (user, callback) {
        DataBase.findBy("UTILISATEUR", "usr_ora", [Engine.login], function(data) {
            if (data.length === 0) {
                // Sauvegarder le nouvel utilisateur
                var new_user = {
                    "usr_ora": Engine.login,
                    "usr_password": Engine.mdp,
                    "usr_no": user.usr_no,
                    "usr_nom_conx": user.usr_nom_conx,
                    "cl_no": user.usr_equipe[0].cl_no,
                    "url": user.url
                };
                if (user.url != null){
                    Project.url = user.url;
                }
                DataBase.insert("UTILISATEUR", new_user, function() {
                    callback && callback();
                });
            } else {
                // Synchroniser les informations de l'utilisateur
                var user_info = {
                    "usr_password": Engine.mdp,
                    "usr_no": user.usr_no,
                    "usr_nom_conx": user.usr_nom_conx,
                    // PATCH mantis #0027471
                    "cl_no": user.usr_equipe[0].cl_no,
                    "url": user.url
                };
                if (user.url != null){
                    Project.url = user.url;
                }
                DataBase.updateJson("UTILISATEUR", data[0].id, user_info, function() {
                    callback && callback();
                });
            }
        });        
    },

    /**
     * Réinitialisation des équipes du club
     */
    refreshUtilisateurEquipes: function (user) {
        user.cl_no = (user.usr_equipe.length > 0) ? user.usr_equipe[0].cl_no : "";
        DataBase.findBy("UTILISATEUR_EQUIPE", "usr_no", user.usr_no, function(dataSuppr) {
            for (var i in dataSuppr) {
                DataBase.deleteById("UTILISATEUR_EQUIPE", dataSuppr[i].id); 
            }
        });
        $.each(user.usr_equipe, function( key, value ) {
            value.usr_no = user.usr_no;
            DataBase.insert("UTILISATEUR_EQUIPE", value);
            // PATCH - L'application utilise le champs eq_no au lieu du champs eq_cod
            // La ligne ci-dessous ne doit pas être placé au dessus de l'instruction d'insertion
            value.eq_no = value.eq_cod
        });
    }
};
