var DebugController = MainController.extend({
    defaults: { 
        name: ".DebugController",
        click: Engine.eventClick,
        pages: new Array(
                "debug/debug.html"),
        files: new Array( 
                "synchronisation/js/service/synchronisationGeneriqueService.js",
                "debug/css/debug.css"),
        all: true,
    }
}, {
	init: function(element, options) {
	    this._super(this, element, options);
	},
	load: function(page, data) {
        Engine.loadController(page, this.options.pages, this.options.files, this, function(controller) {
            controller.show(controller.element, null);
        });
	},
	show: function(element, event) {
	    Engine.delegate(this, element, event, function(controller, element, event) {
	        Engine.headerController.showEquipes("accueil.html", {});
            DataBase.findBy("TABLETTE", "tlb_uuid", Engine.uuid, function(data) {
                if (data.length > 0) {
                    Engine.cleE = data[0].tlb_cle_e;
                    Engine.cleB = data[0].tlb_cle_b;
                }
            });
        });
	},
	showTable: function(table) {
	    DataBase.nbMax = 20;
            
        function showData(data) {
            DataBase.nbMax = 10000000;
            var html = "";
            if (data.length > 0) {
                var keys = [];
                for (var i = 0; i < data.length; i++) {
                    var obj = data[i];
                    if (i == 0) {
                        html += "<tr><td><input id='' type='checkbox' /></td>";
                        for (var key in obj) {
                            keys.push(key);
                            html += "<td>" + key + "</td>";
                        }
                        html += "</tr>";
                    }
                    html += "<tr><td><a href='#' class='suppr' alt='" + obj["id"] + "'>X</a></td>";
                    for (var key in keys) {
                        html += "<td>" + obj[keys[key]] + "</td>";
                    }
                    html += "</tr>";
                }
            } else {
                html = "Pas de données";
            }
            $("#table-contenu").html(html);
        }

        var colonne = $("#colonne").val();
        var critere = $("#critere").val();
        
        if (Utils.isNotBlank(colonne) && Utils.isNotBlank(critere)) {
            try {
                DataBase.findBy(table, colonne, critere, function(data) {
                    showData(data);
                }); 
            } catch(e) {
                Engine.hideLoader();
                Engine.alert("La colonne " + colonne + " n'existe pas pour la table " + table);
            }
        } else {
            DataBase.findAll(table, function(data) {
                showData(data);
            }); 
        }
        
        Engine.initScrolls();
	},
    "{name} .suppr {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var id = element.attr("alt");
            var table = $("#table").val();
            DataBase.deleteById(table, id, function() {
                controller.showTable(table);
            });
        });
    },
    "{name} #reset {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            Engine.confirm("Supprimer les données ?", function() {
                $("#popup-gen a").hide();
                var cpt = 0;
                $("#table").find("option").each(function() {
                    var table = $(this).attr("value");
                    SynchronisationGeneriqueService.purgeAll(table, function() {
                        cpt++;
                    });
                });
                Utils.log("Début PURGE : " + Utils.getDate() + " ");
                var sync = new Async();
                sync.timer = 100;
                sync.start(function() {
                    $("#popup-gen div:last").html(cpt + "/" + $("#table").find("option").size());
                    if (cpt == $("#table").find("option").size()) {
                        Utils.log("FIN PURGE : " + Utils.getDate());
                        sync.stop();
                        Engine.fermerPopup();
                    } 
                });
            }, false, null, false);
        });
    },
    "{name} #countDebug {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var table = $("#table").val();
            
            var colonne = $("#colonne").val();
            var critere = $("#critere").val();
            
            if (Utils.isNotBlank(colonne) && Utils.isNotBlank(critere)) {
                try {
                    DataBase.countBy(table, colonne, critere, function(cpt) {
                       Engine.alert("Nombre d'enregistrement dans " + table + " : " + cpt); 
                    });
                } catch(e) {
                    Engine.hideLoader();
                    Engine.alert("La colonne " + colonne + " n'existe pas pour la table " + table);
                }
            } else {
            DataBase.countBy(table, "", "", function(cpt) {
               Engine.alert("Nombre d'enregistrement dans " + table + " : " + cpt); 
            });
            }
            
        });
    },
    "{name} #table change": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var table = $("#table").val();
            controller.showTable(table);
        });
    },
    "{name} #refresh {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var table = $("#table").val();
            controller.showTable(table);
        });
    }
});