var EquipeController = MainController.extend({
    defaults: { 
        name: ".EquipeController",
        click: Engine.eventClick,
        change: "change",
        dblclick: Engine.eventDblclick,
        pages: new Array(
                "equipe/equipe.html"),
        files: new Array( 
                "equipe/css/equipe.css",
                "equipe/js/dao/equipeDao.js",
                
                "equipe/js/service/equipeCompositionService.js",
                "equipe/js/service/equipeDragAndDropService.js",
                "equipe/js/service/equipeFiltreService.js",
                "equipe/js/service/equipeLicenceService.js",
                "equipe/js/equipeDto.js",
                "equipe/js/sanctionDto.js",
                "accueil/js/referentielDto.js",
                
                "equipe/js/equipeFr.js"),
    }
}, {
	init: function(element, options) {
	    this._super(this, element, options);
	},
	load: function(page, data) {
        Engine.loadController(page, this.options.pages, this.options.files, this, function(controller) {
            EquipeDto.composition.joueurSelection = null;
            EquipeDto.composition.joueurCompositionSelection = null;
            EquipeDto.data = Utils.cloneObject(data.match);
            EquipeDto.utilisateur = data.utilisateur;
            controller.show(controller.element, null);
        });
	},
	show: function(element, event) {
	    Engine.delegate(this, element, event, function(controller, element, event) {
	        Engine.headerController.setTransmissionButton();
            Engine.headerController.disableSynchroButton();
	        
            Engine.addView("#remplacantsStaff", "equipe.html:remplacantsStaff", {});
            EquipeFiltreService.preparerFiltresSelect();
            var afficherTactiqueSansPlacement = EquipeDto.data.ph_tactiq != "O";
            EquipeCompositionService.showTactique(afficherTactiqueSansPlacement ? 0 : 1);
            EquipeLicenceService.getSanctions(EquipeDto.data.ma_no);
            EquipeLicenceService.refreshEquipes(EquipeDto.data.li_no, EquipeDto.data.ma_no);
            
            DataBase.findAll("TACTIQUE", function(data) {
                Engine.addView("#selectStrats", "equipe.html:stratsSelect", { strategies : data, afficherTactiqueSansPlacement : afficherTactiqueSansPlacement });
                var base_tactique = afficherTactiqueSansPlacement ? 0 : 1;
                Engine.selectSetVal($('#selectStrats'), base_tactique);
            });
            
            Engine.addView("#selectEquipeType", "equipe.html:selectEquipesType", { nbEquipesType : EquipeDto.data.cl_nb_maxi_eqp_typ });
            Engine.selectSetVal($('#selectEquipeType'), 1);
	    });
	},
	/********************************************************
	 ************* FILTRE ***********************************
	 ********************************************************/
    "{name} #selectFonction, #selectGroupe, #selectPersonne {change}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var selectedFonctionVal = parseInt($("#selectFonction option:selected").val(), 10);
            var selectedFonction = $("#selectFonction option:selected").text();
            var selectedGroupeVal = $("#selectGroupe option:selected").val();
            var selectedGroupe = $("#selectGroupe option:selected").text();
            var selectedPersonneVal = parseInt($("#selectPersonne option:selected").val(), 10);
            var selectedPersonne = $("#selectPersonne option:selected").text();

            EquipeFiltreService.setFonctionFiltre(selectedFonctionVal != 0 ? selectedFonction : null);
            EquipeFiltreService.setGroupeFiltre(parseInt(selectedGroupeVal, 10) != 0 ? selectedGroupeVal : null);
            EquipeFiltreService.setPersonneFiltre(selectedPersonneVal > 0 ? selectedPersonne : null);
            
            EquipeFiltreService.appliquerFiltre();
        });
    },
    "{name} #selectStrats {change}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var newTactique = parseInt(element.find("option:selected").val(), 10);
            EquipeCompositionService.getComposition(false, function(composition, erreur) {
                EquipeCompositionService.showCompositionOnScreen(composition, false, null, newTactique);
            });
        });
    },
    /******************************************************
     *********** GESTION DES ONGLETS **********************
     ******************************************************/
    "{name} .onglet {click}": function(element, event){
        Engine.delegate(this, element, event, function(controller) {
            element.parent().children(".isSelected").removeClass("isSelected");
            element.addClass("isSelected");
            var idJoueurCompoSelection = EquipeDto.composition.joueurCompositionSelection;
            if (EquipeDto.composition.joueurCompositionSelection != null && 
                    ( $("#" + EquipeDto.composition.joueurCompositionSelection).hasClass("staffSelect") || 
                    $("#" + EquipeDto.composition.joueurCompositionSelection).hasClass("remplacantSelect") ) ) {
                $("#" + EquipeDto.composition.joueurCompositionSelection).removeClass("joueurTerrainSelected");
                EquipeDto.composition.joueurCompositionSelection = null;
            }
            if (element.hasClass("remplacant")) {
                // PATCH - Mantis #31827
                // Engine.deleteScroll("remplacantDisplayZone");
                // setTimeout(function () {
                //     Engine.initScrolls("remplacantDisplayZone");
                // }, 0);
                element.parent().parent().children(".sub").show();
                element.parent().parent().children(".staff").hide();
                element.children("#iconRemplacant").css('background-image', 'url("modules/equipe/img/remplacants_actif.png")');
                element.parent().find("#iconEncadrement").css('background-image', 'url("modules/equipe/img/staff_logo.png")');
            } else if (element.hasClass("encadrement")) {
                // PATCH - Mantis #31827
                // Engine.deleteScroll("staffDisplayZone");
                // setTimeout(function () {
                //     Engine.initScrolls("staffDisplayZone");
                // }, 0);
                element.parent().parent().children(".staff").show();
                element.parent().parent().children(".sub").hide();
                element.parent().find("#iconRemplacant").css('background-image', 'url("modules/equipe/img/remplacants.png")');
                element.parent().find("#iconEncadrement").css('background-image', 'url("modules/equipe/img/staff_logo_inactif.png")');
            }
            // PATCH - Mantis #31827
            Engine.updateDeprecatedUScroll();
        });
    },
    /********************************************************
     ************* GESTION DU DRAG & DROP *******************
     ********************************************************/
    "{name} .clicAndDrop {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            EquipeCompositionService.selectionnerJoueur(element);
        });
    },
    "{name} .emplacementLibre {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if (EquipeDragAndDropService.isIndivPresentDansCompo($("#" + EquipeDto.composition.joueurSelection).attr("data-inno"))) {
                Engine.alert(Lang.equipe.individuDejaPresent);
            } else {
                EquipeDragAndDropService.dragAndDrop(element);
            }
        }); 
    },
    "{name} #remplacantDropZone {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            //si on drop un joueur depuis la liste des licenciés 
            if (Utils.isNotNull(EquipeDto.composition.joueurSelection)) {
                if (EquipeLicenceService.isStaff(EquipeDto.composition.joueurSelection)) {
                    Engine.alert(Lang.equipe.deplacementNonAutorise);
                } else {
                    if (EquipeDragAndDropService.isIndivPresentDansCompo($("#" + EquipeDto.composition.joueurSelection).attr("data-inno"))) {
                        Engine.alert(Lang.equipe.individuDejaPresent);
                    } else {
                        var idLicence = EquipeDto.composition.joueurSelection;
                        EquipeDragAndDropService.ajoutJoueurRemplacant(idLicence);
                        EquipeDragAndDropService.griserJoueur(idLicence, true);
                        $("#" + idLicence).removeClass("waitingForTarget");
                        $("#icons_terrain").removeClass("boutonsModifSurbrillance");
                        EquipeDto.composition.joueurSelection = null;
                    }
                }
            } else if (Utils.isNotNull(EquipeDto.composition.joueurCompositionSelection)) {
                if (EquipeLicenceService.isStaff(EquipeDto.composition.joueurCompositionSelection)) {
                    Engine.alert(Lang.equipe.deplacementNonAutorise);
                } else {
                    var joueurCompo = $("#" + EquipeDto.composition.joueurCompositionSelection);
                    if (joueurCompo.hasClass("remplacantSelect")) {
                        Engine.alert(Lang.equipe.deplacementNonAutorise);
                    } else {
                        EquipeDragAndDropService.ajoutJoueurRemplacant(joueurCompo.attr("alt"), joueurCompo.find(".numJoueur").text());
                        EquipeDragAndDropService.supprimerJoueurTerrain(joueurCompo);
                        EquipeDto.composition.joueurCompositionSelection = null;
                    }
                }
            }
        });
    },
    "{name} #staffDropZone {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if(Utils.isNotNull(EquipeDto.composition.joueurSelection)) {
                var typeLicence = $("#listeJoueur li#" + EquipeDto.composition.joueurSelection + " .infosJoueurHidden .tl_uti_typ_lic").val();
                var licenceJoueur = typeLicence === "J" || typeLicence === "F";
                if(licenceJoueur && EquipeDragAndDropService.isJoueurAvecPlusieursLicences(EquipeDto.composition.joueurSelection)) {
                    //si l'individu possède deux licences, alors c'est sa licence staff qui doit aller dans le staff
                    Engine.alert(Lang.equipe.deplacementNonAutorise);
                } else if (EquipeDragAndDropService.isIndivPresentDansCompo($("#" + EquipeDto.composition.joueurSelection).attr("data-inno"))) {
                    Engine.alert(Lang.equipe.individuDejaPresent);
                } else {
                    var idLicence = EquipeDto.composition.joueurSelection;
                    EquipeDragAndDropService.ajoutJoueurStaff(EquipeDto.composition.joueurSelection);
                    EquipeDragAndDropService.griserJoueur(idLicence, true);
                    $("#" + idLicence).removeClass("waitingForTarget"); 
                    $("#icons_terrain").removeClass("boutonsModifSurbrillance"); 
                    EquipeCompositionService.afficherPopupModifierInfoCompo("staff"+EquipeDto.composition.joueurSelection);
                    EquipeDto.composition.joueurSelection = null;
                }
            } else if (Utils.isNotNull(EquipeDto.composition.joueurCompositionSelection)) {
                var typeLicence = $("#listeJoueur li#" + $("#" + EquipeDto.composition.joueurCompositionSelection).attr("alt") + " .infosJoueurHidden .tl_uti_typ_lic").val();
                var licenceJoueur = typeLicence === "J" || typeLicence === "F";
                if(licenceJoueur && EquipeDragAndDropService.isJoueurAvecPlusieursLicences($("#" + EquipeDto.composition.joueurCompositionSelection).attr("alt"))) {
                    //si l'individu possède deux licences, alors c'est sa licence staff qui doit aller dans le staff
                    Engine.alert(Lang.equipe.deplacementNonAutorise);
                }else if ($("#" + EquipeDto.composition.joueurCompositionSelection).hasClass("staffSelect")) {
                    Engine.alert(Lang.equipe.deplacementNonAutorise);
                } else {
                    var li_no = $("#"+EquipeDto.composition.joueurCompositionSelection).attr("alt");
                    EquipeDragAndDropService.ajoutJoueurStaff(li_no);
                    EquipeDragAndDropService.supprimerJoueurTerrain($("#" + EquipeDto.composition.joueurCompositionSelection));
                    EquipeDto.composition.joueurCompositionSelection = "staff"+li_no;
                    $("#"+EquipeDto.composition.joueurCompositionSelection).addClass("staffSelect");
                    EquipeCompositionService.afficherPopupModifierInfoCompo(EquipeDto.composition.joueurCompositionSelection);
                    EquipeDto.composition.joueurCompositionSelection = null;
                }
            }
        });
    },
    /******************************************************
     *********** GESTION AJOUT D'UN STAFF NON EXISTANT ****
     ******************************************************/
    "{name} #boutonAjoutIndividu {click}": function (element, event) {
        Engine.delegate(this, element, event, function(controller) {
            Engine.addView("#ajoutLicencie", "equipe.html:ajoutLicencie", null, true); 
            Engine.popup("#ajoutLicencie");
        });
    },
    
    "{name} #rechercherLicencie {click}": function (element, event) {
        Engine.delegate(this, element, event, function(controller) {
            var inNo = $("#ajoutLicencie_noLicence").val();
            
            EquipeCompositionService.rechercherLicenceStaff(inNo);
        });
    },

    "{name} #validerAjoutLicencie {click}": function (element, event) {
        Engine.delegate(this, element, event, function(controller) {
            var inNo = $("#ajoutLicencie_noLicence").val();
            var nom = $("#ajoutLicencie_nom").val();
            var prenom = $("#ajoutLicencie_prenom").val();
            var dateNaissanceJour = $("#ajoutLicencie_dateNaissance_jour").val();
            var dateNaissanceMois = $("#ajoutLicencie_dateNaissance_mois").val();
            var dateNaissanceAnnee = $("#ajoutLicencie_dateNaissance_annee").val();
            var dateNaissance = [dateNaissanceJour, dateNaissanceMois, dateNaissanceAnnee].join("/");
            
            EquipeCompositionService.validerIndividuLicence(inNo, function () {
                EquipeCompositionService.validerIndividuInfos(nom, prenom, dateNaissance, function () {
                    EquipeDragAndDropService.ajoutNouveauJoueurStaff(inNo, nom, prenom, dateNaissance, null, null);
                    Engine.fermerPopup();
                });
            });
        });
    },
    /******************************************************
     *********** ACTIONS SUR LE LICENCIE ******************
     ******************************************************/
    "{name} .divInfoLicence {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            event.stopPropagation();
            EquipeLicenceService.afficherLicencePopup(element.parent().parent().parent().attr("id"));
        });
    },
    "{name} .boutonsModifSurbrillance #boutonSupprimer {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if (EquipeDto.composition.joueurCompositionSelection != null) {
                EquipeDragAndDropService.griserJoueur($("#" + EquipeDto.composition.joueurCompositionSelection).attr("alt"), false);
                EquipeDragAndDropService.supprimerJoueurTerrain($("#" + EquipeDto.composition.joueurCompositionSelection));
                EquipeFiltreService.appliquerFiltre(); // rafraîchissement des filtres sur la liste des joueurs
            }
        });
    },
    "{name} .boutonsModifSurbrillance #boutonModifier {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            
            if (Utils.isNotNull(EquipeDto.composition.joueurCompositionSelection)) {
                EquipeCompositionService.afficherPopupModifierInfoCompo(EquipeDto.composition.joueurCompositionSelection);
            }
        });
    },

    "{name} #validerModifJoueur {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            EquipeCompositionService.modifierJoueur();
        });
    },
    "{name} #validerModifRemplacant {click}" : function (element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            EquipeCompositionService.modifierRemplacant();
        });
    },
    "{name} #validerModifStaff {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var idLicence = parseInt($(".infosStaffHidden #in_no").val(),10);
            var joueurCompo = $(".infosStaffHidden #staffPosition").val();
            if(joueurCompo === "composition"){
                EquipeCompositionService.validerModifStaffInfo("staff"+idLicence);
                EquipeDto.composition.joueurCompositionSelection = null;
            } else if(joueurCompo === "effectif") {
                EquipeCompositionService.validerModifStaffInfo("staff"+idLicence);
                EquipeDto.composition.joueurSelection = null;
            }
        });
    },
    /******************************************************
     *********** EQUIPE TYPE ******************************
     ******************************************************/
    "{name} #vider {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            Engine.confirm(Lang.equipe.messageConfirmVider, function() {
                EquipeDragAndDropService.vider();
                Engine.fermerPopup();
            });
        });
    },
    "{name} #charger {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            Engine.confirm(Lang.equipe.infoCompoPerdue, function(){
                EquipeCompositionService.chargerEquipeType(Engine.selectGetVal($('#selectEquipeType')), EquipeDto.data.cl_eq_cod, EquipeDto.data.lc_cod, EquipeDto.utilisateur.cl_no);
            });
        });
    },
    "{name} #enregistrer {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            EquipeCompositionService.enregistrerEquipeType();
            var isFeuilleDeMatch = Engine.filAriane.length > 1 && Engine.filAriane[Engine.filAriane.length-2] == "feuilleDeMatch.html";
            if(!AccueilDto.isDemonstration && !isFeuilleDeMatch) {
                Engine.headerController.showSynchroButton();
            }
        });
    },
    /******************************************************
     *********** COMPOSITION ******************************
     ******************************************************/
    "{name} #validerCompo {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            EquipeCompositionService.enregistrerComposition(true);
            var isFeuilleDeMatch = Engine.filAriane.length > 1 && Engine.filAriane[Engine.filAriane.length-2] == "feuilleDeMatch.html";
            if(!AccueilDto.isDemonstration && !isFeuilleDeMatch) {
                Engine.headerController.setTransmissionButton();
                Engine.headerController.showSynchroButton();
            }
        });
    },
    "{name} .iconEffectif {click}" : function(element, event) {
        EquipeDragAndDropService.autoFill();
    }
    
});