var EquipeDragAndDropService = {
    joueurSanctione: function(idLicence) {
        if(SanctionDto.fromPreparer == false){
            for (i in SanctionDto.listSanctions) {
                if(idLicence == SanctionDto.listSanctions[i].in_no){
                    return true;
                }
            }
        }
        return false;
    },
    griserJoueur : function(idJoueurSelectionne, griser) {
        var liJoueur = $("#" + idJoueurSelectionne);
        if (griser) {
            //copie de l'image
            if (liJoueur.find("canvas").length == 0) {
                if (liJoueur.find(".img img").next().length != 0) {
                    liJoueur.find(".img img").next().remove();
                }
                liJoueur.find(".img img").clone().css("display", "none").appendTo(liJoueur.find(".img"));
                liJoueur.find(".img img").first().addClass("canvasDesactive");
                //noir et blanc
                try {
                    liJoueur.find(".img img.canvasDesactive").pixastic("desaturate");
                } catch(e) {
                }
                liJoueur.addClass("placeSurTerrain");
                liJoueur.removeClass("waitingForTarget");
            }
        } else {
            liJoueur.removeClass("placeSurTerrain").find(".img img").show().parent().find("canvas.canvasDesactive").remove();
        }
    },
    attribuerNumeroJoueurAuto: function (positionJoueur, numfixe) {
        if (positionJoueur.find(".numJoueur").length == 0) {
            var numJoueurDiv = $("<div class='numJoueur'></div>");
            if (positionJoueur.hasClass("remplacantSelect")) {

                if(typeof numfixe == 'undefined') {
                    var numMaillotChoisi = parseInt(EquipeDto.data.ph_nb_titul, 10) + 1;
                    // on trouve un numéro qui n'est pas déjà pris en itérant à partir du numéro 12
                    while (Utils.isBlank(numJoueurDiv.text())) {
                        var maillotExistant = $('.numJoueur').filter(function(){ 
                            return Utils.isNotBlank($(this).text()) && numMaillotChoisi == Utils.parseInt($(this).text()); 
                        });
                        if (maillotExistant.length == 0) {
                            numJoueurDiv.text(numMaillotChoisi);
                        } else {
                            numMaillotChoisi++;
                        }
                    }
                } else if(typeof numfixe !== 'undefined') {
                    // Si le joueur a un numéro de maillot fix
                    var numMaillotChoisi = numfixe;
                    numJoueurDiv.text(numMaillotChoisi);
                }
                positionJoueur.find(".joueurVide").append(numJoueurDiv);
            } else {
                if (EquipeDto.tactiques.numeroSelection == 0) {
                    if(typeof numfixe === 'undefined') {
                        // On attribue un maillot prédéfini si il n'est pas encore utilisé
                        var maillotPredefini = positionJoueur.attr("data-position");
                        var maillotExistant = $('.numJoueur').filter(function(){ return  maillotPredefini == $(this).text(); });
                        if (maillotExistant.length == 0) {
                            numJoueurDiv.text(maillotPredefini);
                            positionJoueur.find(".joueurVide").append(numJoueurDiv);
                        }
                    } else if(typeof numfixe !== 'undefined') {
                        // On attribue un numéro de maillot fixe si le joueur a un numéro de maillot fixe
                        numJoueurDiv.text(numfixe);
                        positionJoueur.find(".joueurVide").append(numJoueurDiv);
                    }
                } else {
                    if(typeof numfixe !== 'undefined') {
                        numJoueurDiv.text(numfixe);
                        positionJoueur.find(".joueurVide").append(numJoueurDiv);
                    }
                }
            }
        }
    },
    deposerJoueur : function(dropZone, idJoueurSelectionne, afficherNumMaillot, ph_num_maillot) {
        afficherNumMaillot = afficherNumMaillot !== undefined ? afficherNumMaillot : true;
        if(typeof ph_num_maillot == 'undefined') {
            ph_num_maillot = EquipeDto.data.ph_num_maillot;
        }
        if (!dropZone.hasClass("emplacementOccupe")) {
            var liJoueur = $("#" + idJoueurSelectionne);
            var posteJoueur = (dropZone.attr("data-poste") != "NULL" && afficherNumMaillot && liJoueur.find(".infosJoueurHidden .cfi_poste").val() != "") ? dropZone.attr("data-poste") : "";
            liJoueur.find(".infosJoueurHidden .cfi_poste").val(posteJoueur);
            
            liJoueur.find(".img img").first().clone().appendTo(dropZone.children("div.joueurVide")).show();
            dropZone.addClass("emplacementOccupe");

            liJoueur.removeClass("waitingForTarget");
            this.griserJoueur(idJoueurSelectionne, true);

            $("#terrain").find(".emplacementLibre").removeClass("zoneDropWaiting");
            if (afficherNumMaillot) {
                var numfixe_maillot = parseInt(liJoueur.find(".in_maillot").val(), 10);
                if (ph_num_maillot == "N" && Utils.isNotBlank(liJoueur.find(".in_maillot").val())) {
                    EquipeDragAndDropService.controleNumFixMaillot(numfixe_maillot);
                    EquipeDragAndDropService.attribuerNumeroJoueurAuto(dropZone,numfixe_maillot); 
                } else {
                    EquipeDragAndDropService.attribuerNumeroJoueurAuto(dropZone);
                } 

                
            }
            dropZone.attr("alt", EquipeDto.composition.joueurSelection);
            EquipeDto.composition.joueurSelection = null;
        }
    },
    supprimerJoueurTerrain : function(element) {
        $("#icons_terrain").removeClass("boutonsModifSurbrillance");
        
        if (element.hasClass("remplacantSelect") || element.hasClass("staffSelect")) {
            element.remove();
        } else {
            element.removeClass("emplacementOccupe").removeClass("joueurTerrainSelected").find("div.joueurVide").html("");
        }
        element.attr("alt", "");
        EquipeDto.composition.joueurCompositionSelection = null;
    },

    controleNumFixMaillot : function(numfixe) {
        $(".emplacementLibre").each(function() {
            var numeroMaillot = $(this).find(".numJoueur").text();
            if (Utils.isNotBlank(numeroMaillot) && $(this).attr("id") != EquipeDto.composition.joueurSelection && numeroMaillot == numfixe) {
                $(this).find(".numJoueur").text("..");
            }
        });
    },
    selectionnerJoueurTerrain : function(selectionner) {
        if (selectionner) {
            $("#icons_terrain").addClass("boutonsModifSurbrillance");
            $("#" + EquipeDto.composition.joueurCompositionSelection).addClass("joueurTerrainSelected");
        } else {
            $("#icons_terrain").removeClass("boutonsModifSurbrillance");
            $("#" + EquipeDto.composition.joueurCompositionSelection).removeClass("joueurTerrainSelected");
            EquipeDto.composition.joueurCompositionSelection = null;
        }
    },
    ajoutJoueurRemplacant : function(idLicence, cfi_maillot, remplacantsAyantJoue) {
        Engine.delegate(this, null, null, function(controller, element, event) {
            var $liLicence = $("#" + idLicence);
            cfi_maillot = (Utils.isNotNull(cfi_maillot)) ? cfi_maillot : null;
            var idJoueur = parseInt($liLicence.find(".infosJoueurHidden .li_no").val(), 10);
            var nom = $liLicence.find(".infosJoueurHidden .in_nom").val();
            var inNo = parseInt($liLicence.find(".infosJoueurHidden .in_no").val(), 10);
            var prenom = $liLicence.find(".infosJoueurHidden .in_prenom").val();
            var img = Utils.prepareBase64Image($liLicence.find(".infosJoueurHidden .in_photo").val(), "img/person.png");
            
            var data = {
                joueur : {
                    liNo : idLicence,
                    nom : nom,
                    prenom : prenom,
                    img : img
                },
                typeStaffOuRempl : "remplacant"
            };
            
            Engine.addView("#remplacantDisplayZone table tr", "equipe.html:joueurRemplStaff", data, false, true);
            
            if (Utils.isNotBlank(cfi_maillot)) {
                $("td#remplacant" + idLicence).find(".joueurVide").append("<div class='numJoueur'>"+cfi_maillot+"</div>");
            } else {
                var numfixe_maillot = parseInt($liLicence.find(".infosJoueurHidden .in_maillot").val(), 10);
                if (EquipeDto.data.ph_num_maillot == "N" && Utils.isNotBlank($liLicence.find(".infosJoueurHidden .in_maillot").val())) {
                    EquipeDragAndDropService.controleNumFixMaillot(numfixe_maillot);
                    EquipeDragAndDropService.attribuerNumeroJoueurAuto($("td#remplacant" + idLicence),numfixe_maillot); 
                } else {
                    EquipeDragAndDropService.attribuerNumeroJoueurAuto($("td#remplacant" + idLicence));
                } 
            }
            
            var numJoueur = $("td#remplacant" + idLicence).find(".numJoueur");
            if(numJoueur.length != 0 && (Utils.isNotNull(remplacantsAyantJoue) 
                && $.inArray(parseInt(idLicence, 10), remplacantsAyantJoue) != -1)) {
               numJoueur.addClass("joueurAyantJoue");
            }
        });
    },
    isJoueurAvecPlusieursLicences : function(idLicence) {
        var in_no = $("#" + idLicence).attr("data-inno");
        var nbLicenceJoueur = 0;
        var nbLicenceStaff = 0;
        
        $("#listeJoueur li[data-inno='"+in_no+"'] .infosJoueurHidden .tl_uti_typ_lic").each(function () {
            if ($(this).val() === "F" || $(this).val() === "J") {
                nbLicenceJoueur++;
            } else {
                nbLicenceStaff++;
            }
        });
        return nbLicenceStaff > 0 && nbLicenceJoueur > 0;
    },
    ajoutJoueurStaff : function(idLicence, dirigeantResponsable, fonction) {
        var $liLicence = $("#" + idLicence);
        var nom = $liLicence.find(".infosJoueurHidden .in_nom").val();
        var inNo = parseInt($liLicence.find(".infosJoueurHidden .in_no").val(), 10);
        var prenom = $liLicence.find(".infosJoueurHidden .in_prenom").val();
        var img = Utils.prepareBase64Image($liLicence.find(".infosJoueurHidden .in_photo").val(), "img/person.png");
        fonction = (Utils.isNotNull(fonction)) ? fonction : null;
        Engine.addView("#staffDisplayZone table tr", "equipe.html:joueurRemplStaff", {
            joueur : {
                liNo : idLicence,
                nom : nom,
                prenom : prenom,
                img : img,
                dr : Utils.isNotBlank(dirigeantResponsable),
                fonction : fonction
            },
            typeStaffOuRempl : "staff"
        }, false, true);
    },
    ajoutNouveauJoueurStaff : function (inNo, nom, prenom, dateNaissance, dirigeantResponsable, fonction) {
        EquipeLicenceService.rechercherLicences(inNo, function (licence) { 
            // Si on trouve un joueur corresponsant en base, on associe la photo du joueur au joueur temporaire
            var in_photo = "";
            var li_no = null;
            if (Utils.isNotNull(licence)) {
                in_photo = licence.in_photo;
                li_no = licence.li_no;
            }
            var infosJoueur = {
                li_no: li_no,
                in_no: inNo,
                in_nom: nom,
                in_prenom: prenom,
                in_dat_nais: dateNaissance,
                in_photo: in_photo
            };
            if (Utils.isNull(li_no)){
                li_no = inNo;
            }
            var view = Engine.addView("#staffDisplayZone table tr", "equipe.html:joueurRemplStaff", {
                joueur : {
                    liNo : li_no,
                    nom : nom,
                    prenom : prenom,
                    img : Utils.prepareBase64Image(in_photo, "img/person.png"),
                    dr : Utils.isNotBlank(dirigeantResponsable),
                    fonction : fonction,
                    tmpInfos : infosJoueur
                },
                typeStaffOuRempl : "staff"
            }, false, true);
            $(view).addClass("joueurTemporaire");
            EquipeDragAndDropService.griserJoueur(li_no, true);
        });
    },
    echangerJoueurTerrain: function (joueur1, joueur2) {
        // Sauvegarde des informations du joueur 1
        var altJoueur1 = joueur1.attr("alt");
        var imgJoueur1 = joueur1.find(".joueurVide").find("img").attr("src");
        var numJoueur1 = joueur1.find(".numJoueur").text();
        var isJoueur1Capitaine = joueur1.find(".capitanat").length !== 0;
        
        // Sauvegarde des informations du joueur 2
        var altJoueur2 = joueur2.attr("alt");
        var imgJoueur2 = joueur2.find(".joueurVide").find("img").attr("src");
        var numJoueur2 = joueur2.find(".numJoueur").text();
        var isJoueur2Capitaine = joueur2.find(".capitanat").length !== 0;

        // Joueur 1 ==> Joueur 2
        joueur2.find(".numJoueur").remove();
        joueur2.find(".capitanat").remove();
        joueur2.find(".joueurVide").find("img").remove();
        joueur2.attr("alt", altJoueur1);
//        joueur2.find(".joueurVide").find("img").attr("src", imgJoueur1);
        joueur2.find(".joueurVide").append("<img class='image-joueur drag-image-joueur' src='"+imgJoueur1+"' alt='"+altJoueur1+"'></img>");
        if (numJoueur1 != "") {
            joueur2.find(".joueurVide").append("<div class='numJoueur'>"+numJoueur1+"</div>");
        }
        if (isJoueur1Capitaine && !joueur2.hasClass("remplacantSelect")) {
            joueur2.find(".joueurVide").append("<div class='capitanat'>C</div>");
        }
        if (joueur1.hasClass("joueurTerrainSelected")) {
            joueur2.find(".nomJoueur").text($("#" + altJoueur1).find(".nom").text());
            joueur2.find(".prenomJoueur").text($("#" + altJoueur1).find(".prenom").text());
        }
        
        // Joueur 1 <== Joueur 2
        joueur1.find(".numJoueur").remove();
        joueur1.find(".capitanat").remove();
        joueur1.find(".joueurVide").find("img").remove();
        joueur1.attr("alt", altJoueur2);
//        joueur1.find(".joueurVide").find("img").attr("src", imgJoueur2);
        joueur1.find(".joueurVide").append("<img class='image-joueur drag-image-joueur' src='"+imgJoueur2+"' alt='"+altJoueur2+"'></img>");
        if (numJoueur2 != "") {
            joueur1.find(".joueurVide").append("<div class='numJoueur'>"+numJoueur2+"</div>");
        }
        if (isJoueur2Capitaine && !joueur1.hasClass("remplacantSelect")) {
            joueur1.find(".joueurVide").append("<div class='capitanat'>C</div>");
        }
        if (!joueur2.hasClass("joueurTerrainSelected")) {
            joueur1.find(".nomJoueur").text($("#" + altJoueur2).find(".nom").text());
            joueur1.find(".prenomJoueur").text($("#" + altJoueur2).find(".prenom").text());
        }

        EquipeDragAndDropService.selectionnerJoueurTerrain(false);
    },
    dragAndDrop : function(element) {
        // si un licencié a été sélectionné
        if (EquipeDto.composition.joueurSelection != null) {
            if (EquipeLicenceService.isStaff(EquipeDto.composition.joueurSelection) || element.hasClass("staffSelect")) {
                Engine.alert(Lang.equipe.deplacementNonAutorise);
            } else if (!element.hasClass("emplacementOccupe")) {
                if (EquipeDragAndDropService.isIndivPresentDansCompo($("#" + EquipeDto.composition.joueurSelection).attr("data-inno"))) {
                    Engine.alert(Lang.equipe.individuDejaPresent);
                } else {
                    EquipeDragAndDropService.deposerJoueur(element, EquipeDto.composition.joueurSelection);
                }
            } else {
                this.griserJoueur(element.attr("alt"), false);
                if (element.hasClass("remplacantSelect")) {
                    if (EquipeDragAndDropService.isIndivPresentDansCompo($("#" + EquipeDto.composition.joueurSelection).attr("data-inno"))) {
                        Engine.alert(Lang.equipe.individuDejaPresent);
                    } else {
                        EquipeDragAndDropService.ajoutJoueurRemplacant(EquipeDto.composition.joueurSelection, element.find(".numJoueur").text(), null);
                        EquipeDragAndDropService.supprimerJoueurTerrain(element);
                        $("#" + EquipeDto.composition.joueurSelection).removeClass("waitingForTarget");
                        EquipeDragAndDropService.griserJoueur(EquipeDto.composition.joueurSelection, true);
                        EquipeDto.composition.joueurSelection = null;
                        $("#terrain").find(".emplacementLibre").removeClass("zoneDropWaiting");
                    }
                } else {
                    if (EquipeDragAndDropService.isIndivPresentDansCompo($("#" + EquipeDto.composition.joueurSelection).attr("data-inno"))) {
                        Engine.alert(Lang.equipe.individuDejaPresent);
                    } else {
                        var maillot = element.find(".numJoueur").text();
                        var capitanat = element.find(".capitanat").length !== 0 ? element.find(".capitanat").text() : false;
                        EquipeDragAndDropService.supprimerJoueurTerrain(element);
                        EquipeDragAndDropService.deposerJoueur(element, EquipeDto.composition.joueurSelection);
                        if(capitanat) {
                            element.children().append("<div class='capitanat'>" + capitanat + "</div>");
                        }
                    }
                }
            }
        // pas de sélection dans la liste
        } else {
            // drop sur un emplacement occupé
            if (Utils.isNotBlank(element.attr("alt"))) {
                // test avant si aucun joueurCompo sélectionné
                if (EquipeDto.composition.joueurCompositionSelection == null) {
                    EquipeDto.composition.joueurCompositionSelection = element.attr("id");
                    EquipeDragAndDropService.selectionnerJoueurTerrain(true);
                } else {
                    // Annulation de la séléction si on clique sur le joueur séléctionné
                    if (element.attr("alt") === $("#" + EquipeDto.composition.joueurCompositionSelection).attr("alt")) {
                        EquipeDragAndDropService.selectionnerJoueurTerrain(false);
                    } else {
                        Utils.log("switch");
                        if (($("#" + EquipeDto.composition.joueurCompositionSelection).hasClass("staffSelect") && element.hasClass("staffSelect")) || ($("#" + EquipeDto.composition.joueurCompositionSelection).hasClass("remplacantSelect") && element.hasClass("remplacantSelect"))) {
                            EquipeDragAndDropService.selectionnerJoueurTerrain(false);
                            EquipeDto.composition.joueurCompositionSelection = element.attr("id");
                            EquipeDragAndDropService.selectionnerJoueurTerrain(true);
                        } else if ($("#" + EquipeDto.composition.joueurCompositionSelection).hasClass("staffSelect") || element.hasClass("staffSelect")) {
                            Engine.alert(Lang.equipe.deplacementNonAutorise);
                        } else {
                            EquipeDragAndDropService.echangerJoueurTerrain(
                                $("#" + EquipeDto.composition.joueurCompositionSelection), 
                                element);
                        }
                    }
                }
            // drop sur un emplacement libre
            } else {
                // si un joueur compo à été sélectionné
                if (EquipeDto.composition.joueurCompositionSelection != null) {
                    if ($("#" + EquipeDto.composition.joueurCompositionSelection).hasClass("remplacantSelect")) {
                        var idLicence = $("#" + EquipeDto.composition.joueurCompositionSelection).attr("alt");
                        var numJoueur = $("#" + EquipeDto.composition.joueurCompositionSelection).find(".numJoueur").text();
                        EquipeDragAndDropService.deposerJoueur(element, idLicence, false);
                        $("#" + EquipeDto.composition.joueurCompositionSelection).remove();
                        EquipeDto.composition.joueurCompositionSelection = element.attr("id");
                        element.attr("alt", idLicence);
                        if (numJoueur != "") {
                            element.find(".joueurVide").append("<div class='numJoueur'>"+numJoueur+"</div>");
                        }
                        EquipeDragAndDropService.selectionnerJoueurTerrain(false);
                    } else if (!$("#" + EquipeDto.composition.joueurCompositionSelection).hasClass("staffSelect")) {
                        // si la case est vide on le déplace
                        var alt = $("#" + EquipeDto.composition.joueurCompositionSelection).attr("alt");
                        var clone = $("#" + EquipeDto.composition.joueurCompositionSelection).find(".joueurVide").clone();
                        $("#" + EquipeDto.composition.joueurCompositionSelection).attr("alt", "");
                        $("#" + EquipeDto.composition.joueurCompositionSelection).find(".joueurVide").html("");
                        $("#" + EquipeDto.composition.joueurCompositionSelection).removeClass("emplacementOccupe");
                        EquipeDragAndDropService.selectionnerJoueurTerrain(false);
                        element.find(".joueurVide").html(clone.html());
                        element.attr("alt", alt);
                        element.addClass("emplacementOccupe");
                        EquipeDto.composition.joueurCompositionSelection = element.attr("id");
                        EquipeDragAndDropService.selectionnerJoueurTerrain(false);
                    } else if ($("#" + EquipeDto.composition.joueurCompositionSelection).hasClass("staffSelect")) {
                        Engine.alert(Lang.equipe.deplacementNonAutorise);
                    }
                }
            }
        }
    },
    vider : function() {
        EquipeDto.composition.joueurSelection = null;
        EquipeDto.composition.joueurCompositionSelection = null;
        EquipeDragAndDropService.selectionnerJoueurTerrain(false);
        $("#listeJoueur").find("li").each(function() {
            EquipeDragAndDropService.griserJoueur($(this).attr("id"), false);
        });
        $(".joueurVide").html("");
        $(".emplacementLibre ").removeClass("joueurTerrainSelected").attr("alt", "");
        $(".emplacementLibre ").removeClass("emplacementOccupe").attr("alt", "");
        $("#remplacantDisplayZone").find("td.emplacementLibre").remove();
        $("#staffDisplayZone").find("td.emplacementLibre").remove();
    },
    viderJoueursTitulaires: function() {
        EquipeDto.composition.joueurSelection = null;
        EquipeDto.composition.joueurCompositionSelection = null;
        EquipeDragAndDropService.selectionnerJoueurTerrain(false);
        // Ne dégriser que les titulaires
        for(i in CompositionsMatchDto.equipeRecevante) {
            if(CompositionsMatchDto.equipeRecevante[i].infosCompo.cfi_role == "T") {
                $("#listeJoueur").find("li").each(function() {
                    if($(this).attr("id") == CompositionsMatchDto.equipeRecevante[i].infosJoueur.li_no) {
                        EquipeDragAndDropService.griserJoueur($(this).attr("id"), false);
                    }
                });
            }
        }
    },
    // web only 
    autoFill: function() {
        if (Environnement.debug && !Engine.isCordova) {
            var joueursPlaces = 0;
                $("#listeJoueur").find("li").each(function(index) {
                    if($(this).find(".tl_uti_typ_lic").val() == "J") {
                    if (joueursPlaces < 11) {
                        $(this).trigger("click");
                        for(var i=1; i<=11; i++) {
                            if($("#terrain").find(".emplacementLibre").length > 0) {
                                var element = $("#position"+i);
                                if (!element.hasClass("emplacementOccupe")) {
                                    EquipeDragAndDropService.dragAndDrop(element);
                                    joueursPlaces ++;
                                    break;
                                }
                            }
                        }
                    } else {
                        return false;
                    }
                }
            });
        }
    },
    /**
     * Vérifie si un individu est présent dans la composition (terrain, remplaçants ou staff).
     * 
     * @param {Object} in_no le in_no de l'individu à vérifier
     * 
     * @returns {boolean} Retourne true si l'individu est déjà présent dans la compo, sinon false.
     */
    isIndivPresentDansCompo: function(in_no, testJoueurTempo) {
        var bReturn = false;
        var entraineur = false;
        if (typeof testJoueurTempo == "undefined"){
            testJoueurTempo = true;
        }

        // recherche en tant qu'encadrant temporaire avec le même numéro de licence   
        if(!testJoueurTempo && $("#staff" + in_no).length > 0){
             return true;
        } 
        
        $("#listeJoueur").find("[data-inno=" + in_no + "]").each(function() {
            var li_no = $(this).find("div.infosJoueurHidden > input.li_no").val();
            // li_no de l'encadramnt temporaire est null
            if(li_no !== "null") {
                var tl_uti_typ_lic = $(this).find("div.infosJoueurHidden > input.tl_uti_typ_lic").val();
                if (tl_uti_typ_lic == "T" || tl_uti_typ_lic == "E") {
                    entraineur = true;
                }
                if (entraineur) {
                    bReturn = false;
                } else if($("#terrain img[alt=" + li_no + "]").length > 0 // recherche en tant que titulaire
                        || $("#remplacant" + li_no).length > 0            // recherche en tant que remplaçant
                        || $("#staff" + li_no).length > 0){               // recherche en tant qu'encadrant              
                    bReturn = true;
                } 
            } else if (testJoueurTempo && li_no == "null") {
                return false;
            }
        });
        return bReturn;
    }
};
