var FaitsDeMatchController = MainController.extend({
    defaults: { 
        name: ".FaitsDeMatchController",
        click: Engine.eventClick,
        change: "change",
        dblclick: Engine.eventDblclick,
        pages: new Array(
                "faitsDeMatch/faitsDeMatch.html",
                "feuilleDeMatch/feuilleDeMatch.html",
                "faitsDeMatch/popups.html",
                "feuilleDeMatch/popups.html",
                "faitsDeMatch/onglets/equipeVisiteur.html", 
                "faitsDeMatch/onglets/blessures.html", 
                "faitsDeMatch/onglets/buts.html", 
                "faitsDeMatch/onglets/discipline.html", 
                "faitsDeMatch/onglets/histo.html", 
                "faitsDeMatch/onglets/infos.html", 
                "faitsDeMatch/onglets/match.html", 
                "faitsDeMatch/onglets/rempl.html"),
        files: new Array( 
                "equipe/js/service/equipeLicenceService.js",
                "faitsDeMatch/css/faitsDeMatch.css",
                "faitsDeMatch/js/faitsDeMatchFr.js",
                "faitsDeMatch/js/feuilleDeMatchDto.js",
                "faitsDeMatch/js/faitsDeMatchService.js",
                "faitsDeMatch/js/faitsDeMatchOngletsService.js",
                "faitsDeMatch/js/dto/faitsDeMatchHistoriqueDto.js",
                "faitsDeMatch/js/service/faitsDeMatchHistoService.js",
                "faitsDeMatch/js/service/faitsDeMatchLigneTempsService.js",
                "faitsDeMatch/js/service/faitsDeMatchRemplacantService.js",
                "faitsDeMatch/js/service/faitsDeMatchDisciplineService.js",
                "faitsDeMatch/js/service/faitsDeMatchBlessureService.js",
                "faitsDeMatch/js/service/faitsDeMatchObsApresMatchService.js",
                "faitsDeMatch/js/service/faitsDeMatchReservesTechService.js",
                "faitsDeMatch/js/service/faitsDeMatchButsService.js",
                "faitsDeMatch/js/service/faitsDeMatchInfosService.js",
                "feuilleDeMatch/js/service/feuilleDeMatchSignaturesService.js",
                "feuilleDeMatch/js/service/feuilleDeMatchConnexionService.js",
                "feuilleDeMatch/js/service/feuilleDeMatchInfosMatchService.js",
                "feuilleDeMatch/js/dto/compositionsMatchDto.js",
                "feuilleDeMatch/js/feuilleDeMatchFr.js",
                "feuilleDeMatch/js/feuilleDeMatchService.js",
                "connexion/js/connexionFr.js",
                "faitsDeMatch/js/service/faitsDeMatchButsService.js",
                "faitsDeMatch/js/service/faitsDeMatchInfosService.js"),
        idCfm : 0,
    }
}, {
	init: function(element, options) {
	    this._super(this, element, options);
	},
	load: function(page, data) {
        Engine.loadController(page, this.options.pages, this.options.files, this, function(controller) {
            FaitsDeMatchService.chargerFeuilleDeMatch(data.match, function() {
                FeuilleDeMatchDto.ma_no = data.match.ma_no;
                FeuilleDeMatchDto.cfm_no = data.match.cfm_no;
                controller.show(controller.element, null);
            });
        });
	},
	show: function(element, event) {
	    Engine.delegate(this, element, event, function(controller, element, event) {
            Engine.headerController.hideSynchroButton();
	        
	        if(Engine.filAriane.length > 1 && Engine.filAriane[Engine.filAriane.length-2] == "accueil.html") {
	            $("#popupLogin").addClass("dont-close");
                Engine.addView("#popupLogin", "popups.html:popupLoginArbitre", {verrou : true}, true);
                Engine.popup("#popupLogin");
	        }
//            Engine.message("Chargement des faits de match");
	        FaitsDeMatchService.refreshEjs();
	        
            FaitsDeMatchOngletsService.changeOnglet($("#match"), {}, controller.options.idCfm);
            FaitsDeMatchOngletsService.changeOnglet($("#equipeRecevante"), { page : "faitsDeMatch" });
            //on affiche les éléments nécessaires
            FaitsDeMatchHistoService.findHistorique(false, function(){
                FaitsDeMatchLigneTempsService.refreshTimeline();
                FaitsDeMatchService.prechargerOnglets();
            });
        });
    },
    "{name} div.onglets div {click}": function(element, event) {
        //si l'élément est un onglet déjà sélectionné, on ne fait rien
        if(!element.hasClass("selected")) {
            FaitsDeMatchOngletsService.changeOnglet(element, { page : "faitsDeMatch" });
        }
    },
    
    "{name} #observationsApresMatch {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            if(!element.hasClass("disabled_button")) {
                // RG : Les observations d'après match peuvent être saisies si personnes ne les a signées.
                var reserveContentEditable = false;
                if (Utils.isBlank(FeuilleDeMatchDto.data.cfm_signat_obs_apm_arb) 
                        && Utils.isBlank(FeuilleDeMatchDto.data.cfm_signat_obs_apm_rec)
                        && Utils.isBlank(FeuilleDeMatchDto.data.cfm_signat_obs_apm_vis)) {
                    reserveContentEditable = true;
                }
                Engine.addView("#popupObservations #popupFaitsDeMatchObservations","popups.html:popupObservations", {
                    matchFeuille : FeuilleDeMatchDto.data, 
                    reserveContentEditable: reserveContentEditable
                });
                var datas = {
                    boutonValider : true,
                    boutonModifier : true,
                    cv_forf : FeuilleDeMatchDto.data.cv_abs_obs_apm,
                    cr_forf : FeuilleDeMatchDto.data.cr_abs_obs_apm,
                    feuilleDeMatch : null,
                    signatures : "obs_apm",
                    cfm_signat_rec : FeuilleDeMatchDto.data.cfm_signat_obs_apm_rec,
                    cfm_signat_vis : FeuilleDeMatchDto.data.cfm_signat_obs_apm_vis,
                    cfm_signat_arb : FeuilleDeMatchDto.data.cfm_signat_obs_apm_arb,
                };
                Engine.addView("#popupObservations #popupFaitsDeMatchSignatures #divSignatures","popups.html:popupSignatures", datas , true);
                $("#validerSignaturesGenerale").addClass("validerSignaturesGeneraleObs");
                $("#modifierSignaturesGenerale").addClass("modifierSignaturesGeneraleObs");
                Engine.popup("#popupObservations");
                // resize textarea
                resizeIt = function() {
                  var str = $("#cfm_obs_apm").val();

                  var linecount = 0;
                  $(str.split("\n")).each( function(l) {
                      linecount +=  1;
                  })
                  $("#cfm_obs_apm").height((linecount + 1) * 15);
                };
                resizeIt();
//                $("#cfm_obs_apm").keypress (resizeIt);
            }
        });
    },
    "{name} #reservesTechniques {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            if(!element.hasClass("disabled_button")) {
                // RG : Les réserves techniques peuvent être saisies si personnes ne les a signées.
                var reserveContentEditable = false;
                if (Utils.isBlank(FeuilleDeMatchDto.data.cfm_signat_tech_apm_arb) 
                        && Utils.isBlank(FeuilleDeMatchDto.data.cfm_signat_tech_apm_ass) 
                        && Utils.isBlank(FeuilleDeMatchDto.data.cfm_signat_tech_apm_rec)
                        && Utils.isBlank(FeuilleDeMatchDto.data.cfm_signat_tech_apm_vis)) {
                    reserveContentEditable = true;
                }
                Engine.addView("#popupReservesTech #popupFaitsDeMatchReservesTech","popups.html:popupReservesTech", {
                    matchFeuille : FeuilleDeMatchDto.data, 
                    reserveContentEditable: reserveContentEditable
                });
                var datas = {
                    boutonValider : true,
                    boutonModifier : true,
                    cv_forf : FeuilleDeMatchDto.data.cv_abs_tech_apm,
                    cr_forf : FeuilleDeMatchDto.data.cr_abs_tech_apm,
                    arbitreAssistant : true,
                    feuilleDeMatch : null,
                    signatures : "tech_apm",
                    cfm_signat_rec : FeuilleDeMatchDto.data.cfm_signat_tech_apm_rec,
                    cfm_signat_vis : FeuilleDeMatchDto.data.cfm_signat_tech_apm_vis,
                    cfm_signat_arb : FeuilleDeMatchDto.data.cfm_signat_tech_apm_arb,
                    cfm_signat_ass : FeuilleDeMatchDto.data.cfm_signat_tech_apm_ass,
                };
                Engine.addView("#popupReservesTech #popupFaitsDeMatchSignaturesReservesTech #divSignatures","popups.html:popupSignatures", datas , true);
                Engine.popup("#popupReservesTech");
                // resize textarea
                resizeIt = function() {
                  var str = $("#cfm_res_tech_apm").val();

                  var linecount = 0;
                  $(str.split("\n")).each( function(l) {
                      linecount +=  1;
                  })
                  $("#cfm_res_tech_apm").height((linecount + 1) * 15);
                };
                resizeIt();
//                $("#cfm_res_tech_apm").keypress (resizeIt);
            }
        });
    },
    "{name} #dev-connexion {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if (Project.debug) {
                $("#login").val(Project.loginDebug);
                $("#mdp").val(Project.mdpDebug);
            }
        });
    },
    /*******************************************************************
     ************************** SIGNATURES *****************************
     *******************************************************************/
    "{name} .connexionSignature {click}" : function(element, event) {
        if(!element.hasClass("disabled_button")) {
            var typeEquipe = element.attr("id") === "connexionEquipeRecevante" ? "EquipeRecevante" : "EquipeVisiteur";
            FeuilleDeMatchConnexionService.afficherPopupClubConnexion(typeEquipe, false, function() {
                var height = $(".codeSignat").val() == "tech_apm" ? 186 : 230;
                Engine.bindSignature("#blocSignature"  + typeEquipe, height, 150);
            });
        }
    },
    "{name} .absenceEquipeCheckbox {change}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var equipeCheckbox = element.attr("data-id");
            var datas = {};

            Engine.addView("#boutonConnexion" + equipeCheckbox, "popups.html:ligneBoutons", {
                equipe : equipeCheckbox,
                disable : $("#absence"+equipeCheckbox)[0].checked
            }, true);
            $("#blocSignature" + equipeCheckbox).children().remove();
        });
    },
    "{name} #validerSignaturesGenerale {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var popupName = $("#popup-gen").find(".headerPopup").find("h1").text();
            if (popupName == "Réserves techniques") {
                var cfm_rapp_arb = $("#cfm_rapp_arb")[0].checked ? "O" : "N";
                var reservesTech = {
                    cfm_rapp_arb : cfm_rapp_arb,
                    cfm_res_tech_apm : $("#cfm_res_tech_apm").val()
                };
                if (reservesTech.cfm_res_tech_apm.length > 0 && reservesTech.cfm_res_tech_apm.length > 1024) {
                    $("#errorValidation").html("Les réserves techniques ne peuvent excéder 1024 caractères");
                } else {
                    FeuilleDeMatchSignaturesService.verificationSignature(FeuilleDeMatchDto.data.cfm_no, "tech_apm", function() {
                        FeuilleDeMatchSignaturesService.enregistrerEquipeAbsentes(FeuilleDeMatchDto.data.cfm_no, "tech_apm", function(datas) {
                            if(Utils.isNotNull(datas)) {
                                FaitsDeMatchReservesTechService.enregistrerReservesTech(reservesTech, datas, function(datas) {
                                    DataBase.updateJson("MATCH_FEUILLE", FeuilleDeMatchDto.data.id, datas, function() {
                                        for(i in datas) {
                                            FeuilleDeMatchDto.data[i] = datas[i];
                                        }
                                        FaitsDeMatchService.refreshLigneBoutons();
                                        Engine.fermerPopup();
                                    });
                                });
                            }
                        });
                    });
                }
            } else {
                var cfm_rapp_arb = $("#cfm_rapp_arb")[0].checked ? "O" : "N";
                var observations = {
                    cfm_rapp_arb : cfm_rapp_arb,
                    cfm_obs_apm : $("#cfm_obs_apm").val(),
                };
                if (observations.cfm_obs_apm.length > 0 && observations.cfm_obs_apm.length > 1024) {
                    $("#errorValidation").html("Les observation d'après matchs ne peuvent excéder 1024 caractères");
                } else {
                    FeuilleDeMatchSignaturesService.verificationSignature(FeuilleDeMatchDto.data.cfm_no, "obs_apm", function() {
                        FeuilleDeMatchSignaturesService.enregistrerEquipeAbsentes(FeuilleDeMatchDto.data.cfm_no, "obs_apm", function(datas) {
                            if(Utils.isNotNull(datas)) {
                                FaitsDeMatchObsApresMatchService.enregistrerObservations(observations, datas, function(datas) {
                                    DataBase.updateJson("MATCH_FEUILLE", FeuilleDeMatchDto.data.id, datas, function() {
                                        for(i in datas) {
                                            FeuilleDeMatchDto.data[i] = datas[i];
                                        }
                                        FaitsDeMatchService.refreshLigneBoutons();
                                        Engine.fermerPopup();
                                    });
                                });
                            }
                        });
                    });
                }
            }
        });
    },
    "{name} #modifierSignaturesGenerale {click}" : function(element, event) {
         Engine.delegate(this, element, event, function(controller, element, event) {
            Engine.addView("#popupLogin", "popups.html:popupLoginArbitre", {data : {},verrou: true}, true);
            Engine.popup("#popupLogin", true);    
         });
    },
    "{name} .validerSignatures {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            $("#errorValidation").html("");
            var signature = element.attr("data-id");
            var connaissance = $("#validerConnaissance"+signature)[0].checked;
            var signataire = null;
            var clNoUser = element.attr("data-clNoUser");
            
            //Si ce n'est pas l'arbitre qui signe, on récupère le signataire
            if (signature != "Arbitre" && signature != "ArbitreAssistant") {
                signataire = $("#choixSignataire" + signature + " option:selected").val();
            } else {
                signataire = signature;
            }

            if (connaissance == false) {
                $("#errorValidation").html(Lang.faitsDeMatch.erreurs.signatures.connaissance);
            } else if (!Utils.isNotBlank(signataire)) {
                $("#errorValidation").html(Lang.faitsDeMatch.erreurs.signatures.signataire);
            } else if (Utils.isSignatureEmpty("#blocSignature" + signature)) {
                $("#errorValidation").html(Lang.faitsDeMatch.erreurs.signatures.signatureVide);
            } else {
                $("#errorValidation").html("");
                //on enregistre la signature
                var imageSignature = Engine.getSignature("#blocSignature" + signature);
                FeuilleDeMatchSignaturesService.enregistrerSignatures(FeuilleDeMatchDto.data.cfm_no, clNoUser, imageSignature, signature, signataire, $(".codeSignat").val(), true);
               
                if( $(".codeSignat").val() == "tech_apm") {
                    $("#cfm_res_tech_apm").attr("disabled",true);
                    $("#cfm_res_tech_apm").attr("placeholder","");
                } else if($(".codeSignat").val() == "obs_apm" ) {
                    $("#cfm_obs_apm").attr("disabled",true);
                    $("#cfm_obs_apm").attr("placeholder","");
                }
            }
        });
    },
    "{name} .signerArbitre {click}" : function(element, event) {
        FeuilleDeMatchSignaturesService.viderSignaturesBase("Arbitre", $(".codeSignat").val(), function() {
            Engine.addView("#signatureArbitre", "popups.html:boutonsValidationSignature", {
                equipe : "Arbitre",
                clNoUser : "",
                dirigeantRespPresent : []
            }, true);
            //On bind la signature
            var height = $(".codeSignat").val() == "tech_apm" ? 186 : 230;
            Engine.bindSignature("#blocSignatureArbitre", height, 150);
        });
    },
    "{name} .signerArbitreAssistant {click}" : function(element, event) {
        FeuilleDeMatchSignaturesService.viderSignaturesBase("ArbitreAssistant", "tech_apm", function() {
            Engine.addView("#signatureArbitreAssistant", "popups.html:boutonsValidationSignature", {
                equipe : "ArbitreAssistant",
                clNoUser : "",
                dirigeantRespPresent : []
            }, true);
            //On bind la signature
            Engine.bindSignature("#blocSignatureArbitreAssistant", 186, 150);
        });
    },
    "{name} #valider-connexion-signatures {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var typeEquipe = element.attr("data-id") == "connexionEquipeRecevante" ? "EquipeRecevante" : "EquipeVisiteur";
            FeuilleDeMatchConnexionService.validerConnexionClubSignature(typeEquipe, function () {
                //On bind la signature
                var height = $(".codeSignat").val() == "tech_apm" ? 186 : 230;
                Engine.bindSignature("#blocSignature" + typeEquipe, height, 150);
                Engine.fermerPopup(true);
            });
        });
    },
    /*******************************************************************
     ********************** FIN SIGNATURES *****************************
     *******************************************************************/
   "{name} .enteteDepliant {click}": function(element, event) {
    Engine.delegate(this, element, event, function(controller) {
        element.parent().children(".selected").removeClass("selected").children("span").html("+").parent().next().hide();
       //on affiche l'élément sur lequel on a cliqué (et changement du - en +)
       element.addClass("selected").children("span").html("-").parent().next().show();
       });
    },
    "{name} #signaturesApresMatch {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            if (!element.hasClass("disabled_button")) {
                var nbButsMatch = parseInt(FeuilleDeMatchDto.data.cr_nb_but, 10) + parseInt(FeuilleDeMatchDto.data.cv_nb_but, 10);
                var nbButsSaisis = 0;
                var detailInfo = $("#detailInfo").val();
                var recetteInfo = $("#recetteInfo").val();
                var nombreSpectateursInfo = $("#nombreSpectateursInfo").val();
                var erreur = [];

                for(i in FaitsDeMatchHistoriqueDto.histo){
                    if(FaitsDeMatchHistoriqueDto.histo[i].cfe_typ == "BU"){
                        nbButsSaisis += 1;
                    }
                }
                if(!FeuilleDeMatchDto.data.chbxMatchNonJoue && FeuilleDeMatchDto.datasMatch.ph_info_but == 'O' && nbButsSaisis != nbButsMatch) {
                    erreur.push(Lang.faitsDeMatch.erreurs.buts.nbButsSaisisInsuffisant);
                } 
                if(MatchDto.match.ph_reglt_locaux !== "I" && (Utils.isNull(FeuilleDeMatchDto.data.cfm_reglt_locaux_lib) || Utils.isNull(FeuilleDeMatchDto.data.cfm_reglt_locaux_lib))) {
                    erreur.push(Lang.faitsDeMatch.erreurs.infos.reglementLocaux);
                } 
                if(MatchDto.match.ph_info_orga === "O") {
                     if (Utils.isBlank(FeuilleDeMatchDto.data.cfm_nb_spect) || Utils.isNull(FeuilleDeMatchDto.data.cfm_nb_spect)
                    || Utils.isBlank(FeuilleDeMatchDto.data.cfm_recette) || Utils.isNull(FeuilleDeMatchDto.data.cfm_recette)) {
                        erreur.push(Lang.faitsDeMatch.erreurs.infos.saisieOrganisation);
                    } 
                }
                if((Utils.isNotNull(nombreSpectateursInfo) && Utils.isNotBlank(nombreSpectateursInfo) && !Utils.isInteger(nombreSpectateursInfo) ) || (Utils.isNotNull(recetteInfo) && Utils.isNotBlank(recetteInfo) && !Utils.isInteger(recetteInfo))) {
                    erreur.push(Lang.faitsDeMatch.erreurs.infos.organisationNumerique);
                }
                if(erreur.length === 0) {
                    Engine.gotoPage("apresMatch.html", { match : FeuilleDeMatchDto.datasMatch });
                } else {
                    Engine.headerController.showError(erreur);
                }
            }
        });
    },
    "{name} #chbxProlongations, #chbxTirsAuBut, #chbxMatchNonJoue, #chbxMatchArrete {change}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            FaitsDeMatchService.afficherMasquerElements(false);
            FaitsDeMatchService.griserCheckboxs();
            FaitsDeMatchService.viderChamps();
        });
    },
    "{name} #ma_motif_arret_cod, #ma_motif_non_joue_cod {change}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            var textareaDisabled = element.val() != "autre";
            $("#matchContent textarea#" + element.attr("data-textarea")).attr("disabled", textareaDisabled);
            if(textareaDisabled) {
                $("#matchContent textarea#" + element.attr("data-textarea")).val("");
            }
        });
    },
    "{name} #matchContent .boutonValider {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            FaitsDeMatchService.verifChamps();
        });
    },
    /*******************************************************************
     **************** ONGLET : Généralité ******************************
     *******************************************************************/
    "{name} .listJoueurs li {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            $(".listJoueurs li").removeClass("waitingForTarget");
            element.addClass("waitingForTarget");
            FeuilleDeMatchDto.joueurSelection = element.attr("id");
        });
    },
    "{name} .imageDrop  {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            if (FeuilleDeMatchDto.joueurSelection != null) {
                var ongletActif = $("#enteteOnglets").find(".selected").attr("id");
                  
                if ($("#" + FeuilleDeMatchDto.joueurSelection).find(".cfi_typ_role").val() === "S" && (ongletActif === "rempl" || ongletActif == "buts" || ongletActif == "blessures")) {
                   Engine.alert(Lang.faitsDeMatch.erreurs.deplacementNonAutorise);
                } else {
                    if (ongletActif === "discipline") {
                        // RG: Pour l'onglet discipline, si le match est non joué, seul un carton noir peut être défini
                        var role = $("#" + FeuilleDeMatchDto.joueurSelection).find(".cfi_typ_role").val();
                        if(FeuilleDeMatchDto.data.chbxMatchNonJoue && role !== "S") {
                            Engine.headerController.showError(Lang.faitsDeMatch.erreurs.deplacementNonAutorise);
                        } else {
                            FaitsDeMatchService.dropImageEvent(element);
                            if ($("#chbxAvMatch")[0].checked){
                                $(".cartonContainer").removeClass("cartonActif");
                                $("#chbxAvMatch")[0].checked = false;
                                FaitsDeMatchDisciplineService.showSuspensionHorsMatch(function(){
                                    $("#chbxAvMatch")[0].checked = true;
                                }, $(".chbxAvMatch"), 1);
                            }
                            else if ($("#chbxApMatch")[0].checked){
                                $("#chbxApMatch")[0].checked = false;
                                $(".cartonContainer").removeClass("cartonActif");
                                FaitsDeMatchDisciplineService.showSuspensionHorsMatch(function(){
                                    $("#chbxApMatch")[0].checked = true;
                                }, $(".chbxApMatch"), 2);
                            }
                            else {
                                FaitsDeMatchDisciplineService.showDiscipline();
                            }
                        }
                    } else if (ongletActif === "rempl") {
                        var isAutreElementRempli = element.attr("id") == "remplacant1" ? Utils.isNotNull($("#remplacant2").find("img").attr("alt")) : Utils.isNotNull($("#remplacant1").find("img").attr("alt"));
                        if($("#chbxEntreeSortieSansRempl")[0].checked && isAutreElementRempli) {
                            Engine.alert(Lang.faitsDeMatch.erreurs.remplacant.entreeOuSortieUniquement.part1 
                                + "<br />" + Lang.faitsDeMatch.erreurs.remplacant.entreeOuSortieUniquement.part2
                                + "<br />" + Lang.faitsDeMatch.erreurs.remplacant.entreeOuSortieUniquement.part3, "260px");
                        } else {
                            FaitsDeMatchService.dropImageEvent(element);
                        }
                    } else {
                        FaitsDeMatchService.dropImageEvent(element);
                    }
                }
            }
        });
    },
    "{name} .vider {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            $("#" + element.attr("data-for")).html("");
            $("#prenom_"+element.attr("data-for")).html("");
            $("#nom_"+element.attr("data-for")).html("");
            FaitsDeMatchService.afficherMaillotSanction(false, "_"+element.attr("data-for"));
        });
    },
    "{name} #ma_motif_arret_cod {change}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
           $("#ma_motif_arret_cod option:selected").text() != "Autre" ? $("#ma_motif_arret").prop('disabled',true) : $("#ma_motif_arret").prop('disabled',false);
        });
    },
    "{name} #ma_motif_non_joue_cod {change}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            $("#ma_motif_non_joue_cod option:selected").text() != "Autre" ? $("#ma_motif_non_joue").prop('disabled',true) : $("#ma_motif_non_joue").prop('disabled',false);
        });
    },
    
    /*******************************************************************
     **************** ONGLET : REMPLACANT ******************************
     *******************************************************************/
    "{name} #validerRemplacant {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            FaitsDeMatchRemplacantService.valider();
        });
    },
    /*******************************************************************
     **************** ONGLET : DISCIPLINE ******************************
     *******************************************************************/
    "{name} .cartonContainer {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            $(".cartonContainer").removeClass("cartonActif");
            element.addClass("cartonActif");
            FaitsDeMatchDisciplineService.showDiscipline();
        });
    },
    "{name} #validerDiscipline {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            FaitsDeMatchDisciplineService.valider();
        });
    },
    "{name} .chbxAvMatch, #chbxAvMatch {click}": function(element, event){
        Engine.delegate(this, element, event, function(controller) {
            $(".cartonContainer").removeClass("cartonActif");
            FaitsDeMatchDisciplineService.showSuspensionHorsMatch(function(){

            }, $(".chbxAvMatch"), 1);
        });
    },
    "{name} .chbxApMatch, #chbxApMatch {click}": function(element, event){
        Engine.delegate(this, element, event, function(controller) {
            $(".cartonContainer").removeClass("cartonActif");
            FaitsDeMatchDisciplineService.showSuspensionHorsMatch(function(){

            }, $(".chbxApMatch"), 2);
        });
    },
    /*******************************************************************
     **************** ONGLET : BLESSURES ******************************
     *******************************************************************/
    "{name} #chbxSortieSurBlessure {change}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            FaitsDeMatchBlessureService.activerDesactiveSortieSurBlessure();
        });
    },
    
    "{name} .partieCorps {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            var selectionne = "";
            $("#corps").find("div").each(function() {
                if ($(this).hasClass(this.id + "Affichage")) {
                    $(this).removeClass(this.id + "Affichage");
                    $(this).removeClass("partieCorpsActif");
                    selectionne = this.id;
                }
            });
            if(selectionne !== element[0].id) {
                element.addClass(element[0].id + "Affichage");
                element.addClass("partieCorpsActif");
            }
            FaitsDeMatchBlessureService.showBlessure();
        });
    },
    "{name} #localisationsBlessures {change}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            FaitsDeMatchBlessureService.activerDesactiverChampAutre();
        });
    },
    "{name} #validerBlessure {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            FaitsDeMatchBlessureService.valider();
        });
    },
    /*******************************************************************
     **************** ONGLET : HISTORIQUE ******************************
     *******************************************************************/
    "{name} .histoSupprimer {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            Engine.confirm(Lang.faitsDeMatch.infos.confirmSuppression, function(){
                var idHisto = element.attr("data-for");
                var typHisto = element.attr("data-type");
                DataBase.deleteById("MATCH_FEUILLE_EVENEMENT", idHisto, function() {
                    FaitsDeMatchHistoService.findHistorique(false, function(){
                        FaitsDeMatchLigneTempsService.refreshTimeline();
                    });
                    FaitsDeMatchOngletsService.afficherCompteur(FeuilleDeMatchDto.cfm_no, typHisto);
                });
                Engine.fermerPopup();
            });
        });
    },
    "{name} .histoModifier {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            FaitsDeMatchOngletsService.changerOngletHisto(element.attr("data-for"));
            
            var type = element.attr("data-type");
            if (type=="ES" || type=="EJ" || type=="SJ") {
                FaitsDeMatchRemplacantService.modifier(element);
            }
            if (type=="DI") {
                FaitsDeMatchDisciplineService.modifier(element);
            }
            if (type=="BL") {
                FaitsDeMatchBlessureService.modifier(element);
            }
            if (type=="BU") {
                FaitsDeMatchButsService.modifier(element);
            }
            if (type!="DI" && type!="BL" && type!="BU" && type!="SJ" && type!="EJ" && type!="ES") {
                FaitsDeMatchInfosService.modifier(element);
            }
        });
    },
    /*******************************************************************
     ****************    ONGLET : BUTS    ******************************
     *******************************************************************/
    "{name} #validerButs {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            FaitsDeMatchButsService.valider();
        });
    },
     /*******************************************************************
     ****************    ONGLET : SECU    ******************************
     *******************************************************************/
    "{name} #validerSecu {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            FaitsDeMatchInfosService.validerSecu();
        });
    },
    "{name} #validerOrga {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            FaitsDeMatchInfosService.validerOrga();
        });
    },
     /*******************************************************************
     ****************    POPUP CONNEXION ARBITRE    ********************
     *******************************************************************/
    
    "{name} #accueil-connexion-arbitre {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            $("#popupLogin").removeClass("dont-close");
            Engine.gotoPage("accueil.html");
        });
    },
    "{name} #valider-connexion-arbitre {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var popupVerrou = Utils.isNotNull(element.attr("data-verrou"));
            var cfm_no = MatchDto.match.cfm_no;
            var datas = {};

            //Vérification du mot de passe saisi
            var password = $("#mdp").val();
            if (password === "") {
                $("#errorConnexion").html(Lang.connexion.mdpVide);
                return;
            }

            //recherche de l'id en base de la feuille match à mettre à jour
            DataBase.findBy("MATCH_FEUILLE", "cfm_noAndcfm_mdp", [cfm_no, password], function(data) {
                if (data.length === 0) {
                    // error
                    $("#errorConnexion").html(Lang.connexion.connexionImpossible);
                } else {
                    if(popupVerrou && ($(".codeSignat").val() == "tech_apm" || $(".codeSignat").val() == "obs_apm")) {
                        $("#popupLogin").removeClass("dont-close");
                        Engine.fermerPopup(true);
                        var codeSignature = $(".codeSignat").val();
                        FaitsDeMatchService.deverrouillerSignatures(codeSignature);
                        if(codeSignature == "tech_apm"){
                            $("#cfm_res_tech_apm").attr("disabled",false);
                            $("#cfm_res_tech_apm").attr("placeholder",Lang.faitsDeMatch.saisieReservesTechniques);
                        } else if(codeSignature == "obs_apm") {
                            $("#cfm_obs_apm").attr("disabled",false);
                            $("#cfm_obs_apm").attr("placeholder",Lang.faitsDeMatch.saisieObsApresMatch);
                        }
                    } else {
                        $("#popupLogin").removeClass("dont-close");
                        Engine.fermerPopup();
                    }
                }
            });
        });
    },
/*    "{name} #lienMotDePasseOublie {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            FeuilleDeMatchConnexionService.afficherPopupMotDePasseRencontreOublie(element.data("cl-no"));
        });
    },*/
    "{name} #validerMotDePasseOublie {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            $("#popupLogin").removeClass("dont-close");
            var questionSecurite = Engine.selectGetVal($("#questionSecurite"));
            var reponseSecurite = $("#reponseSecurite").val();
            var nouveauMotDePasse = $("#nouveauMotDePasse").val();
            var cl_no = element.data("cl-no");
            
            FeuilleDeMatchService.majMotDePasseOublie(cl_no, questionSecurite, reponseSecurite, nouveauMotDePasse, function () {
                Engine.fermerPopup(true);
            });
        });
    },
    // FEV13 - EVO4 / FMH
    // Stopper l'ajout de caractère dans la zone de saisie des réserves si l'utilisateur à atteint 1024 caractères
    "{name} .reservesApresMatchInput keypress" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if (event.which !== 0 && element.val().length + 1 > 1024) {
                event.preventDefault();
                event.stopPropagation();
            }
        });
    }
});