var FaitsDeMatchOngletsService = {
    onglets : {
        gauche: $("#equipeRecevante"),
        droite: $("#blessures")
    },
    isForcerMatchNonJoue: function () {
        var crForf = FeuilleDeMatchDto.data.cr_forf === "O" || Utils.isNull(FeuilleDeMatchDto.data.cr_co_valid) || FeuilleDeMatchDto.data.cr_co_valid === "N";
        var cvForf = FeuilleDeMatchDto.data.cv_forf === "O" || Utils.isNull(FeuilleDeMatchDto.data.cv_co_valid) || FeuilleDeMatchDto.data.cv_co_valid === "N";
        return cvForf || crForf || !FaitsDeMatchService.verifNbTitul();
    },
    /**
     * tableau des appels à l'ouverture d'un onglet pas encore ouvert.
     * key : le nom de l'onglet
     * value: function(callback, id de la feuille de match) 
     */
    actionsAvantLoad: {
        match : function(callback, idFeuilleDeMatch){
            Engine.getReferentiel("ref_typ", "FMI_MOTIF_NON_JOUE", function(motifNonJoue){
                Engine.getReferentiel("ref_typ", "FMI_MOTIF_ARRET", function(motifArret){
                    if (typeof callback === 'function') {
                        callback({matchFeuille : FeuilleDeMatchDto.data, match : FeuilleDeMatchDto.datasMatch, motifNonJoue : motifNonJoue, motifArret : motifArret, edit : true, forcerNonJoue: FaitsDeMatchOngletsService.isForcerMatchNonJoue()}, function(){
                            
                            FaitsDeMatchService.afficherMasquerElements(!FaitsDeMatchService.verifNbTitul());
                            FaitsDeMatchService.griserCheckboxs();
                            Engine.selectCreate($('#matchContent select.matchSelectScore'), { minimumResultsForSearch : -1 });
                            Engine.selectCreate($('#matchContent select.motifSelect'), { minimumResultsForSearch : -1 });
                        });
                    }
                });
            });
        },
        equipeRecevante : function(callback, idFeuilleDeMatch){
            // on ajoute la photo d'un individu inconnu (dirigeant)
            for (var i in CompositionsMatchDto.equipeRecevante){
                if (!Utils.isNotBlank(CompositionsMatchDto.equipeRecevante[i].infosJoueur.in_photo) || Utils.isNull(CompositionsMatchDto.equipeRecevante[i].infosJoueur.in_photo)){
                    EquipeLicenceService.rechercherLicences(CompositionsMatchDto.equipeRecevante[i].infosJoueur.in_no, function (licence) {
                        // Si on trouve un joueur corresponsant en base, on associe la photo du joueur au joueur temporaire
                        var in_photo = "";
                        var li_no = null;
                        var in_no = "";
                        if (Utils.isNotNull(licence)) {
                            in_photo = licence.in_photo;
                            li_no = licence.li_no;
                            in_no = licence.in_no;
                        }
                        $("#" + in_no).find("img").attr("src", Utils.prepareBase64Image(in_photo, 'img/person.png'));
                    });
                }
            }
            CompositionsMatchDto.equipeRecevante.sort(function(a, b) {
                var roleA = 10;
                var roleB = 10;
                if (Utils.isNotBlank(a.infosCompo.cfi_role)){
                    switch (a.infosCompo.cfi_role) {
                        case "T":
                            roleA = 1;
                            break;
                        case "R":
                            roleA = 2;
                            break;
                        default:
                            roleA = 3;
                            break;
                    }
                }
                if (Utils.isNotBlank(b.infosCompo.cfi_role)){
                    switch (b.infosCompo.cfi_role) {
                        case "T":
                            roleB = 1;
                            break;
                        case "R":
                            roleB = 2;
                            break;
                        default:
                            roleB = 3;
                            break;
                    }
                }
                var ordreA = Utils.isNotNull(a.infosCompo.cfi_maillot)?parseInt(a.infosCompo.cfi_maillot, 10):1000;
                var ordreB = Utils.isNotNull(b.infosCompo.cfi_maillot)?parseInt(b.infosCompo.cfi_maillot, 10):1000;
                return cmp( 
                    [cmp(roleA, roleB), cmp(ordreA, ordreB), cmp(b.infosCompo.cfi_role, a.infosCompo.cfi_role)], 
                    [cmp(roleB, roleA), cmp(ordreB, ordreA), cmp(a.infosCompo.cfi_role, b.infosCompo.cfi_role)]
                );
            });
            if (typeof callback === 'function') {
                callback({listeJoueurs : CompositionsMatchDto.equipeRecevante});
            }
        },
        equipeVisiteur : function(callback, idFeuilleDeMatch) {
            for (var i in CompositionsMatchDto.equipeVisiteur){
                if (!Utils.isNotBlank(CompositionsMatchDto.equipeVisiteur[i].infosJoueur.in_photo) || Utils.isNull(CompositionsMatchDto.equipeVisiteur[i].infosJoueur.in_photo)){
                    EquipeLicenceService.rechercherLicences(CompositionsMatchDto.equipeVisiteur[i].infosJoueur.in_no, function (licence) {
                        // Si on trouve un joueur corresponsant en base, on associe la photo du joueur au joueur temporaire
                        var in_photo = "";
                        var li_no = null;
                        var in_no = "";
                        if (Utils.isNotNull(licence)) {
                            in_photo = licence.in_photo;
                            li_no = licence.li_no;
                            in_no = licence.in_no;
                        }
                        $("#" + in_no).find("img").attr("src", Utils.prepareBase64Image(in_photo, 'img/person.png'));
                    });
                }
            }
            CompositionsMatchDto.equipeVisiteur.sort(function(a, b) {
                var roleA = 10;
                var roleB = 10;
                if (Utils.isNotBlank(a.infosCompo.cfi_role)){
                    switch (a.infosCompo.cfi_role) {
                        case "T":
                            roleA = 1;
                            break;
                        case "R":
                            roleA = 2;
                            break;
                        default:
                            roleA = 3;
                            break;
                    }
                }
                if (Utils.isNotBlank(b.infosCompo.cfi_role)){
                    switch (b.infosCompo.cfi_role) {
                        case "T":
                            roleB = 1;
                            break;
                        case "R":
                            roleB = 2;
                            break;
                        default:
                            roleB = 3;
                            break;
                    }
                }
                var ordreA = Utils.isNotNull(a.infosCompo.cfi_maillot)?parseInt(a.infosCompo.cfi_maillot, 10):1000;
                var ordreB = Utils.isNotNull(b.infosCompo.cfi_maillot)?parseInt(b.infosCompo.cfi_maillot, 10):1000;
                return cmp( 
                    [cmp(roleA, roleB), cmp(ordreA, ordreB), cmp(b.infosCompo.cfi_role, a.infosCompo.cfi_role)], 
                    [cmp(roleB, roleA), cmp(ordreB, ordreA), cmp(a.infosCompo.cfi_role, b.infosCompo.cfi_role)]
                );
            });
            if (typeof callback === 'function') {
                callback({listeJoueurs : CompositionsMatchDto.equipeVisiteur});
            }
        },
        equipeRecevanteReserve : function(callback, idFeuilleDeMatch){
            if (typeof callback === 'function') {
                callback({listeJoueurs : CompositionsMatchDto.equipeRecevante});
            }
        },
        equipeVisiteurReserve : function(callback, idFeuilleDeMatch) {
            if (typeof callback === 'function') {
                callback({listeJoueurs : CompositionsMatchDto.equipeVisiteur});
            }
        },
        discipline: function(callback, idFeuilleDeMatch) {
            callback({forcerVisualiser: false}, function() {
                FaitsDeMatchDisciplineService.showDiscipline();
                FaitsDeMatchOngletsService.afficherCompteur(FeuilleDeMatchDto.cfm_no, "DI");
            });
        },
        blessures: function(callback, idFeuilleDeMatch) {
            FaitsDeMatchBlessureService.showBlessure(function() {
                callback({forcerVisualiser : false, ph_tps_sup : FeuilleDeMatchDto.datasMatch.ph_tps_sup, localisationsBlessures : FaitsDeMatchBlessureService.FMI_BLESSURES_TOUT}, function() {
                    Engine.addView("#listeLocalisationsBlessures", "blessures.html:afficherListeBlessures", {
                        localisationsBlessures : FaitsDeMatchBlessureService.FMI_BLESSURES_TOUT,
                        forcerVisualiser : false
                    });
                    FaitsDeMatchBlessureService.activerDesactiverChampAutre();
                    FaitsDeMatchOngletsService.afficherCompteur(FeuilleDeMatchDto.cfm_no, "BL");
                });
            });
        },
        histo: function(callback, idFeuilleDeMatch) {
            callback({}, function() {
                FaitsDeMatchHistoService.showHistorique();
            });
        },
        buts: function(callback, idFeuilleDeMatch) {
            Engine.getReferentiel("ref_typ", "FMI_CFE_TYP_BUT", function(typeBut){
                Engine.getReferentiel("ref_typ", "FMI_CFE_ACTION", function(beforeBut){
                    if (typeof callback === 'function') {
                        callback({matchFeuille : FeuilleDeMatchDto.data, typeBut : typeBut, beforeBut : beforeBut, forcerVisualiser : false, ph_tps_sup : FeuilleDeMatchDto.datasMatch.ph_tps_sup}, function(){
                            FaitsDeMatchOngletsService.afficherCompteur(FeuilleDeMatchDto.cfm_no, "BU");
                        });
                    }
                });
            });
        },
        infos: function(callback, idFeuilleDeMatch) {
            Engine.getReferentiel("ref_typ", "FMI_FSI_TYP", function(typeEventInfo){
                if (typeof callback === 'function') {
                    callback({match : FeuilleDeMatchDto.data, typeEventInfo : typeEventInfo, forcerVisualiser : false, ph_tps_sup : FeuilleDeMatchDto.datasMatch.ph_tps_sup}, function(){
                        FaitsDeMatchOngletsService.afficherCompteur(FeuilleDeMatchDto.cfm_no, "SECU");
                    });
                }
            });
        },
        rempl: function(callback, idFeuilleDeMatch) {
            callback({forcerVisualiser : false, ph_tps_sup : FeuilleDeMatchDto.datasMatch.ph_tps_sup}, function() {
                FaitsDeMatchOngletsService.afficherCompteur(FeuilleDeMatchDto.cfm_no, "ES");
            });
        },
        rencontre : function(callback, idFeuilleDeMatch) {
            if (typeof callback === 'function') {
                callback({feuilleDeMatch : FeuilleDeMatchDto});
            }
        },
        faitsDeJeu : function(callback, idFeuilleDeMatch) {
            if (typeof callback === 'function') {
                callback({feuilleDeMatch : FeuilleDeMatchDto});
            }
        },
        compo : function(callback, idFeuilleDeMatch) {
            if (typeof callback === 'function') {
                callback({feuilleDeMatch : FeuilleDeMatchDto, match: MatchDto.match}, function(){
                    DataBase.findBy("MATCH_FEUILLE_COMPO", "cfm_noAndcfi_cl_no", [FeuilleDeMatchDto.datasMatch.cfm_no, FeuilleDeMatchDto.datasMatch.cr_cl_no], function(dataRecevante){
                        var tactiqueRecevante = "";
                        for (var i in dataRecevante) {
                            if(!Utils.isNotBlank(tactiqueRecevante) && Utils.isNotNull(dataRecevante[i].tq_no) && Utils.isNotBlank(dataRecevante[i].tq_no)){
                                tactiqueRecevante = dataRecevante[i].tq_no;
                            }
                        }
                        var tactiqueRecevante = Utils.isNotBlank(tactiqueRecevante) ? tactiqueRecevante : 0;
                        $("#equipeRecevante").attr("data-tqno", tactiqueRecevante);
                        
                        DataBase.findBy("MATCH_FEUILLE_COMPO", "cfm_noAndcfi_cl_no", [FeuilleDeMatchDto.datasMatch.cfm_no, FeuilleDeMatchDto.datasMatch.cv_cl_no], function(dataVisiteur){
                            var tactiqueVisiteur = "";
                            for (var i in dataVisiteur) {
                                if(!Utils.isNotBlank(tactiqueVisiteur) && Utils.isNotNull(dataVisiteur[i].tq_no) && Utils.isNotBlank(dataVisiteur[i].tq_no)){
                                    tactiqueVisiteur = dataVisiteur[i].tq_no;
                                }
                            }
                            var tactiqueVisiteur = Utils.isNotBlank(tactiqueVisiteur) ? tactiqueVisiteur : 0;
                            
                            $("#equipeVisiteur").attr("data-tqno", tactiqueVisiteur);
                            Engine.addView("#partie_droite_bottom", "equipe.html:remplacantsStaff", {});
                            ApresMatchCompoService.creerListeRemplacantsAyantJoue(FaitsDeMatchHistoriqueDto.histo, function(){
                                // RG : Afficher les joueurs de l'équipe recevante uniquement si elle l'a validée dans l'avant match
                                if (FeuilleDeMatchDto.data.crCompValides === true) {
                                    Engine.addView("#divequipeRecevanteContent", "equipeVisiteurReserve.html:onglet", {listeJoueurs : CompositionsMatchDto.equipeRecevante, remplacantsAyantJoue : FaitsDeMatchHistoriqueDto.remplacantsAyantJoue} );
                                }
                                // RG : Afficher les joueurs de l'équipe visiteuse uniquement si elle l'a validée dans l'avant match
                                if (FeuilleDeMatchDto.data.cvCompValides === true) {
                                    Engine.addView("#divequipeVisiteurContent", "equipeVisiteurReserve.html:onglet", {listeJoueurs : CompositionsMatchDto.equipeVisiteur, remplacantsAyantJoue : FaitsDeMatchHistoriqueDto.remplacantsAyantJoue} );
                                }
                                // RG : Afficher la composition de l'équipe recevant uniquement si elle l'a validée dans l'avant match
                                if (FeuilleDeMatchDto.data.crCompValides === true) {
                                    EquipeCompositionService.showCompositionOnScreen(CompositionsMatchDto.equipeRecevante, true, FaitsDeMatchHistoriqueDto.remplacantsAyantJoue, parseInt($("#equipeRecevante").attr("data-tqno"), 10), false);
                                }
                            });
                        });
                    });
                }); 
            }
        },
        tactique : function(callback, idFeuilleDeMatch) {
            if (typeof callback === 'function') {
                // avant affichage
                callback({feuilleDeMatch : FeuilleDeMatchDto}, function(){
                    // après affichage
                    
                    InfosFacultativesService.chargerTactiques();
                    
                    Engine.addView("#partie_droite_bottom", "equipe.html:remplacantsStaff", {});
                    ApresMatchCompoService.creerListeRemplacantsAyantJoue(FaitsDeMatchHistoriqueDto.histo, function(){
                           DataBase.findBy("MATCH_FEUILLE_COMPO", "ma_noAndcfm_noAndcfi_cl_no", [EquipeDto.data.ma_no, EquipeDto.data.cfm_no, EquipeDto.utilisateur.cl_no], function(data) {
                            
                            var tactique = "";
                            for (i in data) {
                                if(!Utils.isNotBlank(tactique) && Utils.isNotNull(data[i].tq_no) && Utils.isNotBlank(data[i].tq_no)){
                                    tactique = data[i].tq_no;
                                }
                            }
                            var tactique = Utils.isNotBlank(tactique) ? tactique : 0;
                            EquipeCompositionService.showCompositionOnScreen(CompositionsMatchDto.equipeRecevante, true, FaitsDeMatchHistoriqueDto.remplacantsAyantJoue, tactique, true);
                        });
                    });
                }); 
            }
        },
        buteurs: function(callback, idFeuilleDeMatch) {
            Engine.getReferentiel("ref_typ", "FMI_CFE_TYP_BUT", function(typeBut){
                Engine.getReferentiel("ref_typ", "FMI_CFE_ACTION", function(beforeBut){
                    if (typeof callback === 'function') {
                        callback({matchFeuille : FeuilleDeMatchDto.data, typeBut : typeBut, beforeBut : beforeBut, ph_tps_sup: MatchDto.match.ph_tps_sup}, function(){
                             InfosFacultativesService.refreshListeButs(function() {});
                        });
                    }
                });
            });
        },
        signatures : function(callback, idFeuilleDeMatch) {
            if (typeof callback === 'function') {
                var reserves = {
                    cfm_res_tech_apm: "",
                    cfm_obs_apm: ""
                };
                // RG : On affiche les réserves techniques si et seulement si elles ont été approuvées.
                // Les réserves techniques sont approuvées si toute les conditions ci-dessous sont remplis
                //   - La signature de l'arbitre est présente
                //   - La signature de l'arbitre assistant est présente
                //   - La signature de l'équipe recevante est présente ou l'équipe recevante a été indiquée absente après le match.
                //   - La signature de l'équipe visiteuse est présente ou l'équipe visiteuse a été indiquée absente après le match.
                if (Utils.isNotBlank(FeuilleDeMatchDto.data.cfm_signat_tech_apm_arb) 
                        && Utils.isNotBlank(FeuilleDeMatchDto.data.cfm_signat_tech_apm_ass) 
                        && (Utils.isNotBlank(FeuilleDeMatchDto.data.cfm_signat_tech_apm_rec) || FeuilleDeMatchDto.data.cr_abs_tech_apm === "O")
                        && (Utils.isNotBlank(FeuilleDeMatchDto.data.cfm_signat_tech_apm_vis) || FeuilleDeMatchDto.data.cv_abs_tech_apm === "O")) {
                    reserves.cfm_res_tech_apm = FeuilleDeMatchDto.data.cfm_res_tech_apm;
                }
                
                // RG : On affiche les observations d'après match si et seulement si elles ont été approuvées.
                // Les observations d'après match sont approuvées si toute les conditions ci-dessous sont remplis
                //   - La signature de l'arbitre est présente
                //   - La signature de l'équipe recevante est présente ou l'équipe recevante a été indiquée absente après le match.
                //   - La signature de l'équipe visiteuse est présente ou l'équipe visiteuse a été indiquée absente après le match.
                if (Utils.isNotBlank(FeuilleDeMatchDto.data.cfm_signat_obs_apm_arb) 
                        && (Utils.isNotBlank(FeuilleDeMatchDto.data.cfm_signat_obs_apm_rec) || FeuilleDeMatchDto.data.cr_abs_obs_apm === "O")
                        && (Utils.isNotBlank(FeuilleDeMatchDto.data.cfm_signat_obs_apm_vis) || FeuilleDeMatchDto.data.cv_abs_obs_apm === "O")) {
                    reserves.cfm_obs_apm = FeuilleDeMatchDto.data.cfm_obs_apm;
                }
                
                callback({feuilleDeMatch : FeuilleDeMatchDto, reserves: reserves}, function() {
                    var datas = {
                        cv_forf : FeuilleDeMatchDto.data.cv_forf,
                        cr_forf : FeuilleDeMatchDto.data.cr_forf,
                        feuilleDeMatch : FeuilleDeMatchDto,
                        cfm_signat_rec : FeuilleDeMatchDto.data.cfm_signat_apm_rec,
                        cfm_signat_vis : FeuilleDeMatchDto.data.cfm_signat_apm_vis,
                        cfm_signat_arb : FeuilleDeMatchDto.data.cfm_signat_apm_arb,
                    };
                    Engine.addView("#divSignaturesApresMatch", "popups.html:popupSignatures", datas);
                    ApresMatchRencontreService.afficherReservesAvantMatch();
                    ApresMatchSignaturesService.testerAffichageBoutons();
                    ApresMatchSignaturesService.afficherNombreDeverouillage();
                });
            }
        },
    },
    /**
     * 
     * @param {Object} ongletAOuvrir l'element correspondant à l'onglet
     * @param {Object} datas les datas à passer à l'addView
     * @param {Object} idFeuilleDeMatch l'id de la feuille de match
     */
    changeOnglet: function(ongletAOuvrir, datas, idFeuilleDeMatch, chargementFaitsDeMatch) {
        if(Utils.isNull(chargementFaitsDeMatch) || chargementFaitsDeMatch !== true) {
            chargementFaitsDeMatch = false;
        }
        if(Utils.isNull(datas)) {
            datas = {};
        }
        if(!ongletAOuvrir.hasClass("ongletDisabled")){
            var ongletOuvert = ongletAOuvrir.parent().find(".selected");
            var idOngletOuvert = ongletOuvert.attr("id");
            var idOngletAOuvrir = ongletAOuvrir.attr("id");
            
            //Chargement de l'onglet depuis le .html 
            //si l'onglet a déjà été chargé, il est en "display:hidden", pas besoin de le charger à nouveau
            if ($("#" + idOngletAOuvrir + "Content").data("loaded") === undefined) {
                if (typeof FaitsDeMatchOngletsService.actionsAvantLoad[idOngletAOuvrir] === 'function') {
                    FaitsDeMatchOngletsService.actionsAvantLoad[idOngletAOuvrir](function(callbackDatas, callback2) {
                        if(Utils.isNotNull(callbackDatas)) {
                            for(i in callbackDatas) {
                                datas[i] = callbackDatas[i];
                            }
                        }
                        var ongletEjs = idOngletAOuvrir;
                        if (idOngletAOuvrir == "equipeRecevante") {
                            ongletEjs = "equipeVisiteur";
                        } else if (idOngletAOuvrir == "equipeRecevanteReserve") {
                            ongletEjs = "equipeVisiteurReserve";
                        } else if (idOngletAOuvrir == "infos") {
                            if(Utils.isNotNull(datas)) {
                                datas.match = FeuilleDeMatchDto.datasMatch;
                            }
                        }
                        if(idOngletAOuvrir == "equipeRecevante" || idOngletAOuvrir == "equipeVisiteur" || idOngletAOuvrir == "equipeVisiteurReserve" || idOngletAOuvrir == "equipeRecevanteReserve" ) {
                            // RG : Afficher la composition de l'équipe uniquement si elle l'a validée dans l'avant match
                            var afficherCompo = (idOngletAOuvrir === "equipeRecevante" && FeuilleDeMatchDto.data.crCompValides) ||
                                (idOngletAOuvrir === "equipeVisiteur" && FeuilleDeMatchDto.data.cvCompValides);
                            if (afficherCompo || idOngletAOuvrir === "equipeRecevanteReserve" || idOngletAOuvrir === "equipeVisiteurReserve") { 
                                Engine.addView("#div" + idOngletAOuvrir + "Content", ongletEjs + ".html:onglet", datas );
                            }        
                            $("#" + idOngletAOuvrir + "Content").attr("data-loaded", "true");
                            if (typeof callback2 === 'function') {
                                callback2();
                            }
                            
                        } else {
                            Engine.addView("#" + idOngletAOuvrir + "Content", ongletEjs + ".html:onglet", datas );
                            $("#" + idOngletAOuvrir + "Content").attr("data-loaded", "true");          
                            if (typeof callback2 === 'function') {
                                callback2();
                            }
                        }
                    },idFeuilleDeMatch);
                } else {
                    Engine.addView("#" + idOngletAOuvrir + "Content", idOngletAOuvrir + ".html:onglet", datas );
                }
            }
            if(!chargementFaitsDeMatch) {
                
                if(Utils.isNotNull(ongletOuvert)) {
                    ongletOuvert.removeClass("selected");
                }
                ongletAOuvrir.addClass("selected");
                
               

//                setTimeout(function() {
                     //masquage de l'onglet précédemment ouvert et affichage de l'onglet cible
                    if(ongletOuvert.length !== 0) {
                        if ($("#" + idOngletOuvert + "Content-scroll-container").length !== 0) {
                            $("#" + idOngletOuvert + "Content-scroll-container").hide();
                        } else if ($("#" + idOngletOuvert + "Content").parent().parent().hasClass("contenuOngletsScrollable")) {
                            $("#" + idOngletOuvert + "Content").parent().hide();
                        } else {
                            $("#" + idOngletOuvert + "Content").hide();
                        }
                    }

                    // Réinitialiser la zone de l'onglet à ouvirir 
                    Engine.deleteScroll(idOngletAOuvrir + "Content");
                    
                    if ($("#" + idOngletAOuvrir + "Content-scroll-container").length !== 0) {
                        $("#" + idOngletAOuvrir + "Content-scroll-container").show();
                    } else if ($("#" + idOngletAOuvrir + "Content").parent().parent().hasClass("contenuOngletsScrollable")) {
                        $("#" + idOngletAOuvrir + "Content").parent().show();
                    } else {
                        $("#" + idOngletAOuvrir + "Content").show();
                    }

                    // Recharger la zone scrollable 
                    Engine.initScrolls(idOngletAOuvrir + "Content"); 
                    Engine.initScrolls();

                    
                    //Sauvegarde des onglets ouverts pour le drop des joueurs
                    if(idOngletAOuvrir == "equipeRecevante" || idOngletAOuvrir == "equipeVisiteur") {
                        FaitsDeMatchOngletsService.onglets.gauche = idOngletAOuvrir;
                        $(".vider").each(function() {
                            $("#" + $(this).attr("data-for")).html("");
                            $("#sanctionMaillotContainer_" + $(this).attr("data-for")).html("");
                            $("#nom_" + $(this).attr("data-for")).html("");
                            $("#prenom_" + $(this).attr("data-for")).html("");
                        });
                    } else {
                        FaitsDeMatchOngletsService.onglets.droite = idOngletAOuvrir;
                    }
//                }, 0);   
            }
        }
    },
    /**
     * Change d'onglet en fonction de l'équipe du joueur concerné par l'évenenement passé en argument
     * 
     * @param {Object} histoId l'id de la feuille de match
     */
    changerOngletHisto: function (histoId) {
        var histo = FaitsDeMatchHistoService.getHisto(histoId);
        if (histo !== null) {
            var idLicence = Utils.isNotBlank(histo.l1_li_no) ? histo.l1_li_no : histo.in_no;
            var cl_no = $("#"+idLicence).find(".cl_no").val();
            var coteEquipeJoueur = Utils.parseInt(MatchDto.match.cv_cl_no) === Utils.parseInt(cl_no) ? "Visiteur" : "Recevante";
            var ongletAOuvirir = $(".onglets #equipe"+coteEquipeJoueur);
            
            if (!ongletAOuvirir.hasClass('selected')) {
                FaitsDeMatchOngletsService.changeOnglet(ongletAOuvirir, { page : "faitsDeMatch" });
            }
        }
    },
    /**
     * vérification de la cohérence des minutes et temps additionnel saisis
     * 
     * @param {Object} erreur: tableau d'erreurs
     * @param {Object} minute: minute saisie
     * @param {Object} tempsSupplementaire: temps additionnel saisi
     */
    addErrorFormatMinute: function(erreur, minute, tempsSupplementaire) {
        var periodesSup = {};
        periodesSup[parseInt(FeuilleDeMatchDto.datasMatch.ph_duree_periode, 10)/2] = FeuilleDeMatchDto.data.ma_min_period1_sup;
        periodesSup[parseInt(FeuilleDeMatchDto.datasMatch.ph_duree_periode, 10)] = FeuilleDeMatchDto.data.ma_min_period2_sup;
        
        if (isNaN(minute) || !Utils.isNotBlank(minute) || !(minute == parseInt(minute, 10))) {
            erreur.push(Lang.faitsDeMatch.erreurs.minuteFormat);
        } else {
            var minute = parseInt(minute, 10);
            var minutesMax = parseInt(FeuilleDeMatchDto.datasMatch.ph_duree_periode, 10);
            if (FeuilleDeMatchDto.datasMatch.ph_prol == "O" && FeuilleDeMatchDto.data.chbxProlongations) {
                minutesMax += parseInt(FeuilleDeMatchDto.datasMatch.ph_duree_prol, 10);
                periodesSup[parseInt(FeuilleDeMatchDto.datasMatch.ph_duree_periode, 10) + parseInt(FeuilleDeMatchDto.datasMatch.ph_duree_prol, 10)/2] = FeuilleDeMatchDto.data.ma_min_prol_sup1;
                periodesSup[parseInt(FeuilleDeMatchDto.datasMatch.ph_duree_periode, 10) + parseInt(FeuilleDeMatchDto.datasMatch.ph_duree_prol, 10)] = FeuilleDeMatchDto.data.ma_min_prol_sup2;
            }
            if (minute < 0 || minute > minutesMax) {
                erreur.push(Lang.faitsDeMatch.erreurs.minuteFormat);
            } else if(FeuilleDeMatchDto.datasMatch.ph_tps_sup == "O" && minute in periodesSup){
                if (Utils.isNull(tempsSupplementaire) || (tempsSupplementaire == "")){
                    tempsSupplementaire = 0;
                }
                if (isNaN(tempsSupplementaire) || !(tempsSupplementaire == parseInt(tempsSupplementaire, 10))) {
                    erreur.push(Lang.faitsDeMatch.erreurs.minute2Format);
                } else if (parseInt(tempsSupplementaire, 10) < 0 || parseInt(tempsSupplementaire, 10) > parseInt(periodesSup[minute], 10)) {
                    erreur.push(Lang.faitsDeMatch.erreurs.minute2HorsLimite);
                }
            } else if(FeuilleDeMatchDto.datasMatch.ph_tps_sup == "O" && Utils.isNotNull(tempsSupplementaire) && Utils.isNotBlank(tempsSupplementaire) && !(minute in periodesSup)){
                erreur.push(Lang.faitsDeMatch.erreurs.minute2Format);
            }
        }
    },
    recuperationInNo: function(li_no, visiteur){
        if (visiteur){
            for (var a = 0; a < CompositionsMatchDto.equipeVisiteur.length; a++){
                if (CompositionsMatchDto.equipeVisiteur[a].infosJoueur.li_no === li_no){
                    return CompositionsMatchDto.equipeVisiteur[a].infosJoueur.in_no;
                }
            }
        }
        else {
            for (var a = 0; a < CompositionsMatchDto.equipeRecevante.length; a++){
                if (CompositionsMatchDto.equipeRecevante[a].infosJoueur.li_no === li_no){
                    return CompositionsMatchDto.equipeRecevante[a].infosJoueur.in_no;
                }
            }
        }
        return null;
    },
    estJoueurEtDirigeant: function(in_no, visiteur){
        var staff = false;
        var joueur = false;
        if (visiteur){
            for (var a = 0; a < CompositionsMatchDto.equipeVisiteur.length; a++){
                if (CompositionsMatchDto.equipeVisiteur[a].infosCompo.in_no === in_no){
                    if (CompositionsMatchDto.equipeVisiteur[a].infosCompo.cfi_typ_role === "S"){
                        staff = true;
                    }
                    else {
                        joueur = true;
                    }
                }
            }
        }
        else {
            for (var a = 0; a < CompositionsMatchDto.equipeRecevante.length; a++){
                if (CompositionsMatchDto.equipeRecevante[a].infosCompo.in_no === in_no){
                    if (CompositionsMatchDto.equipeRecevante[a].infosCompo.cfi_typ_role === "S"){
                        staff = true;
                    }
                    else {
                        joueur = true;
                    }
                }
            }
        }
        return staff && joueur;
    },
    afficherCompteur: function(idFeuilleDeMatch, typeEvent, reinitialiserCompteurs) {
        if(reinitialiserCompteurs) {
            var events = ["SECU", "DI", "BU", "BL"];
            for(i in events) {
                Engine.addView("#compteur"+events[i],"faitsDeMatch.html:compteur", {data : 0});
            }
        } else if(typeEvent == "ES" || typeEvent == "EJ" || typeEvent == "SJ"){
            var nbSecu = 0;
            DataBase.findBy("MATCH_FEUILLE_EVENEMENT","cfm_noAndcfe_typ", [idFeuilleDeMatch,"ES"], function(data){
                nbSecu = nbSecu+data.length; 
                DataBase.findBy("MATCH_FEUILLE_EVENEMENT","cfm_noAndcfe_typ", [idFeuilleDeMatch,"EJ"], function(data){
                    nbSecu = nbSecu+data.length; 
                    DataBase.findBy("MATCH_FEUILLE_EVENEMENT","cfm_noAndcfe_typ", [idFeuilleDeMatch,"SJ"], function(data){
                        nbSecu = nbSecu+data.length; 
                        Engine.addView("#compteurES","faitsDeMatch.html:compteur", {data : nbSecu});
                    });
                });
            });
        } else if(typeEvent!="DI" && typeEvent!="BL" && typeEvent!="BU" && typeEvent!="SJ" && typeEvent!="EJ" && typeEvent!="ES"){
            var nbSecu = 0;
            Engine.getReferentiel("ref_typ", "FMI_FSI_TYP", function(typeEventInfo){
                for (i in typeEventInfo){
                    DataBase.findBy("MATCH_FEUILLE_EVENEMENT","cfm_noAndcfe_typ", [idFeuilleDeMatch,typeEventInfo[i]["ref_cod"]], function(data){
                        nbSecu = nbSecu+data.length;
                        if (i >= (typeEventInfo.length - 1)) {
                            Engine.addView("#compteurSECU","faitsDeMatch.html:compteur", {data : nbSecu});
                        }
                    });
                }
            });
        } else {
            DataBase.findBy("MATCH_FEUILLE_EVENEMENT","cfm_noAndcfe_typ", [idFeuilleDeMatch,typeEvent], function(data){
                Engine.addView("#compteur"+typeEvent,"faitsDeMatch.html:compteur", {data : data.length});
            }); 
        }

    }
};