var FaitsDeMatchService = {
    getSelectedClub : function () {
        if ($(".onglets .selected").attr("id") === "equipeRecevante") {
            return FeuilleDeMatchDto.datasMatch.cr_cl_no;
        } else {
            return FeuilleDeMatchDto.datasMatch.cv_cl_no;
        }
    },
    refreshEjs : function(ongletSelected) {
        if(FeuilleDeMatchDto.data.fdmValidee && !FeuilleDeMatchDto.data.chbxMatchNonJoue) {
            Engine.headerController.showScore(FeuilleDeMatchDto);
        }
        Engine.addView("#enteteOnglets", "faitsDeMatch.html:onglets", {
            feuilleDeMatch : FeuilleDeMatchDto.data,
            match : FeuilleDeMatchDto.datasMatch,
            selected : ongletSelected
        });
        Engine.addView("#ligneDeTempsContent", "faitsDeMatch.html:ligneTemps", {
            feuilleDeMatch : FeuilleDeMatchDto.data,
            match : FeuilleDeMatchDto.datasMatch
        });
        // Reprendre les zones bleus pour les liste des licences
        Engine.deleteScroll("equipeRecevanteContent");
        Engine.deleteScroll("equipeVisiteurContent");
        Engine.initScrolls();
        
        FaitsDeMatchService.refreshLigneBoutons();
    },
    
    /**
     * grise ou dégrise les checkbox en fonction de celles déjà sélectionnées
     * Si "match non joué" -> les 3 autres ne sont plus sélectionnables 
     * Si "prolongations", "tirs au but" ou "match arrêté" -> "match non joué" n'est plus sélectionnable 
     */
    griserCheckboxs : function() {
        //#chbxProlongations, #chbxTirsAuBut, #chbxMatchNonJoue, #chbxMatchArrete
        $("#chbxProlongations").removeAttr("disabled");
        $("#chbxTirsAuBut").removeAttr("disabled");
        $("#chbxMatchNonJoue").removeAttr("disabled");
        $("#chbxMatchArrete").removeAttr("disabled");
        if($("#chbxProlongations")[0].checked || $("#chbxTirsAuBut")[0].checked || $("#chbxMatchArrete")[0].checked) {
            $("#chbxMatchNonJoue").attr("disabled", true);
        } else if($("#chbxMatchNonJoue")[0].checked) {
            $("#chbxProlongations").attr("disabled", true);
            $("#chbxTirsAuBut").attr("disabled", true);
            $("#chbxMatchArrete").attr("disabled", true);
        }
    },
    
    refreshLigneBoutons : function() {
        Engine.addView("#ligneBoutons", "faitsDeMatch.html:ligneBoutons", {
            feuilleDeMatch : FeuilleDeMatchDto.data
        });
    },
    /**
     * précharge les onglets des faits de match pour palier au problème de 
     * remplissage des onglets lors d'une modification si l'onglet n'a pas déjà été ouvert
     */
    prechargerOnglets: function(){
        FaitsDeMatchOngletsService.changeOnglet($("#discipline"), {}, null, true);
        FaitsDeMatchOngletsService.changeOnglet($("#equipeVisiteur"), { page : "faitsDeMatch" }, null, true);
        FaitsDeMatchOngletsService.changeOnglet($("#rempl"), {}, null, true);
        FaitsDeMatchOngletsService.changeOnglet($("#buts"), {}, null, true);
        FaitsDeMatchOngletsService.changeOnglet($("#blessures"), {}, null, true);
        FaitsDeMatchOngletsService.changeOnglet($("#infos"), {}, null, true);
        FaitsDeMatchOngletsService.changeOnglet($("#histo"), {}, null, true);
//        Engine.fermerPopup();
    },
    
    afficherMaillotSanction: function(afficher, nomDropZone, maillot, cfi_role){
        var htmlMaillot = "";
        if(afficher) {
            if(cfi_role == "T") {
                htmlMaillot = "<div class='boxFondBlanc'>" + maillot + "</div>";
            } else {
                htmlMaillot = "<div class='boxFondDore'>" + maillot + "</div>";
            }
        }
        $("#sanctionMaillotContainer" + nomDropZone).html(htmlMaillot);
    },
    /**
     * Effectue tous les affichages d'image, nom-prénom lors du drop d'un joueur pour un événement
     */
    dropImageEvent : function(element) {
        var idClub = FaitsDeMatchService.getSelectedClub();
        var idLicence = FeuilleDeMatchDto.joueurSelection;
        var photo = $("#" + FeuilleDeMatchDto.joueurSelection).find(".in_photo").val();
        var nom = $("#" + FeuilleDeMatchDto.joueurSelection).find(".in_nom").val();
        var prenom = $("#" + FeuilleDeMatchDto.joueurSelection).find(".in_prenom").val();
        var idDrop = element.attr('id');
        element.html("<img src=" + Utils.prepareBase64Image(photo, 'img/person.png') + " height= '43px' width='43px' alt=" + idLicence + " data-id=" + idClub + " />");
        $("#prenom_"+idDrop).html(prenom);
        $("#nom_"+idDrop).html(nom);
        FaitsDeMatchService.afficherMaillotSanction(true, "_"+idDrop, $("#" + FeuilleDeMatchDto.joueurSelection).find(".cfi_maillot").val(), $("#" + FeuilleDeMatchDto.joueurSelection).find(".cfi_role").val());
        $(".listJoueurs li").removeClass("waitingForTarget");
        FeuilleDeMatchDto.joueurSelection = null;
    },

    /**
     * Initialise la feuille de match en base et dans le Dto
     */
    chargerFeuilleDeMatch : function(datasMatch, callback) {
        //création d'une feuille de match si elle n'existe pas
        //TODO: supprimer
        DataBase.findBy("MATCH_FEUILLE", "cfm_no", datasMatch.cfm_no, function(data) {
            if (data.length == 0) {
                DataBase.insert("MATCH_FEUILLE", {
                    cfm_no : datasMatch.cfm_no,
                    ma_no : datasMatch.ma_no
                }, function() {
                    DataBase.findBy("MATCH_FEUILLE", "cfm_no", datasMatch.cfm_no, function(data) {
                        FeuilleDeMatchDto.initValeursMatch(datasMatch, function() {
                            FeuilleDeMatchDto.init(data, function(){
                                FeuilleDeMatchService.verifValidationSignatures(data[0], callback);
                            });
                        });
                    });
                });
            } else {
                FeuilleDeMatchDto.initValeursMatch(datasMatch, function() {
                    FeuilleDeMatchDto.init(data, function(){
                        FeuilleDeMatchService.verifValidationSignatures(data[0], callback);
                    });
                });
            }
        });
    },
    /**
     * Récupère les champs dans le DOM et les set dans le Dto
     * si le match est forcé à "non joué", tous le formulaire sauf les champs du match non joué sont réinitialisés à null
     */
    preparerDtoFeuilleDeMatch : function(initialiser) {
        initialiser = (initialiser === true);
        $("#matchContent #checkboxsReserves input").each(function(key, value) {
            FeuilleDeMatchDto.data[$(this).attr("id")] = $(this)[0].checked;
        });
        $("#matchContent .matchInputTextTemps, #matchContent .motifTextarea").each(function(key, value) {
            FeuilleDeMatchDto.data[$(this).attr("id")] = !initialiser ? $(this).val() : null;
        });
        $("#matchContent select").each(function(key, value) {
            var val = (initialiser || $(this).val() == "null") ? null : $(this).val();
            FeuilleDeMatchDto.data[$(this).attr("id")] = val;
        });
    },
    /**
     * Vide le formulaire (ex: au moment de cocher une checkbox)
     */
    viderChamps : function() {

        // si l'élément est caché, on vide les valeurs
        $("#matchContent select").each(function(key, value) {
            if (!$(this).is(":visible")) {
                Engine.selectSetVal($("#" + $(this).attr("id")), "null");
            }
        });
        $("#matchContent .matchInputTextTemps, #matchContent textarea").each(function(key, value) {
            if (!$(this).is(":visible")) {
                if ($(this).val() !== "0") {
                    $("#" + $(this).attr("id")).val("");
                }
            }
        });
        FaitsDeMatchService.preparerDtoFeuilleDeMatch(false);
    },

    isMotifErreur : function(erreurs, select, textarea, type) {
        if (erreurs.length == 0) {
            if (!Utils.isNotBlank(select)) {
                erreurs.push(Lang.faitsDeMatch.erreurs.erreurChampsManquants);
            } else if (type === "ma_motif_arret" && textarea.length > 0 && textarea.length > 256) {
                erreurs.push(Lang.faitsDeMatch.erreurs.ma_motif_arret_limit);
            } else if (type === "ma_motif_non_joue" && textarea.length > 0 && textarea.length > 256) {
                erreurs.push(Lang.faitsDeMatch.erreurs.ma_motif_non_joue_limit);
            } else if (select == "autre" || select == "AR0"  || select == "NJ0") {
                if (!Utils.isNotBlank(textarea) || !Utils.isNotNull(textarea)) {
                    erreurs.push(Lang.faitsDeMatch.erreurs.erreurChampsManquants);   
                }
            }
        }
    },
    verifErreursResulats : function(erreurs, resultat1, resultat2) {
        if (erreurs.length == 0 && (Utils.isNull(resultat1) || Utils.isNull(resultat2))) {
            erreurs.push(Lang.faitsDeMatch.erreurs.erreurChampsManquants);
        }
    },
    verifErreursResulatsTpsRegl : function(erreurs, resultat1, resultat2, resultatTpsRegl1, resultatTpsRegl2) {
        if (erreurs.length == 0 && (resultatTpsRegl1 > resultat1 || resultatTpsRegl2 > resultat2)) {
            erreurs.push(Lang.faitsDeMatch.erreurs.buts.tpsReglementaireButs);
        }
    },
    verifErreursTemps : function(erreurs, temps) {
        if (erreurs.length != 0) {
            return;
        }
        
        for (i in temps) {
            if (!Utils.isInteger(temps[i])) {
                erreurs.push(Lang.faitsDeMatch.erreurs.minute2Format);
            } else if (temps[i] > 45) {
                erreurs.push(Lang.faitsDeMatch.erreurs.minute2HorsLimite);
            }
        }
    },
    afficherMasquerElements : function(forcerVisualiser) {
        $("#zoneMatchNonJoue, #zoneMatchArrete").hide();
        $("#zoneResultats, #zoneResultatFinal, #zoneResultatProlongations, #zoneResultatTirsAuBut").hide();
        $("#zoneTempsDeJeu, #zoneTempsDeJeuFinal, #zoneTempsProlongations").hide();
        FeuilleDeMatchDto.data.chbxMatchArrete = null;
        FeuilleDeMatchDto.data.chbxMatchNonJoue = null;
        FeuilleDeMatchDto.data.chbxProlongations = null;
        FeuilleDeMatchDto.data.chbxTirsAuBut = null;

        if(!forcerVisualiser) { 
            //si match non joué est coché, on desactive et décoche les autres checkbox
            if (FeuilleDeMatchDto.data.cr_forf == "O" || FeuilleDeMatchDto.data.cv_forf == "O") {
                $("#chbxMatchArrete, #chbxTirsAuBut, #chbxProlongations").removeAttr("checked");
                $("#chbxMatchArrete, #chbxTirsAuBut, #chbxProlongations").attr("disabled", true);
            } else {
                $("#chbxMatchArrete, #chbxTirsAuBut, #chbxProlongations").removeAttr("disabled");
            }
        }

        //affichage des éléments en fonction des checkbox actives
        if ($("#chbxMatchNonJoue")[0].checked) {
            FeuilleDeMatchDto.data.chbxMatchNonJoue = true;
            $("#zoneMatchNonJoue").show();
        } else if ($("#chbxMatchArrete")[0].checked) {
            FeuilleDeMatchDto.data.chbxMatchArrete = true;
            $("#zoneResultats, #zoneResultatFinal, #zoneMatchArrete").show();
            if ($("#chbxProlongations")[0].checked) {
                FeuilleDeMatchDto.data.chbxProlongations = true;
                $("#zoneResultatProlongations").show();
            }
            if ($("#chbxTirsAuBut")[0].checked) {
                FeuilleDeMatchDto.data.chbxTirsAuBut = true;
                $("#zoneResultatTirsAuBut").show();
            }
        } else {
            $("#zoneResultats, #zoneResultatFinal, #zoneTempsDeJeu, #zoneTempsDeJeuFinal").show();
            if ($("#chbxProlongations")[0].checked) {
                FeuilleDeMatchDto.data.chbxProlongations = true;
                $("#zoneResultatProlongations, #zoneTempsProlongations").show();
            }
            if ($("#chbxTirsAuBut")[0].checked) {
                FeuilleDeMatchDto.data.chbxTirsAuBut = true;
                $("#zoneResultatTirsAuBut").show();
            }
        }

    },
    verifChamps : function() {
        var dto_cr_nb_but = Utils.isNotNull(FeuilleDeMatchDto.data.cr_nb_but) ? FeuilleDeMatchDto.data.cr_nb_but : 0;
        var dto_cv_nb_but = Utils.isNotNull(FeuilleDeMatchDto.data.cv_nb_but) ? FeuilleDeMatchDto.data.cv_nb_but : 0;
        this.preparerDtoFeuilleDeMatch();
        var erreurs = [];
        var temps = [];

        delete FeuilleDeMatchDto.data.signaturesValides;
        delete FeuilleDeMatchDto.data.infosValides;
        delete FeuilleDeMatchDto.data.crCompValides; 
        delete FeuilleDeMatchDto.data.cvCompValides; 
        delete FeuilleDeMatchDto.data.verrouillage;

        // TODO  delete !!!  infosValides

        if ($("#chbxMatchNonJoue")[0].checked) {
            FaitsDeMatchService.isMotifErreur(erreurs, FeuilleDeMatchDto.data.ma_motif_non_joue_cod, FeuilleDeMatchDto.data.ma_motif_non_joue, "ma_motif_non_joue");
        } else if ($("#chbxMatchArrete")[0].checked) {
            FaitsDeMatchService.verifErreursResulats(erreurs, FeuilleDeMatchDto.data.cr_nb_but, FeuilleDeMatchDto.data.cv_nb_but);
            FaitsDeMatchService.isMotifErreur(erreurs, FeuilleDeMatchDto.data.ma_motif_arret_cod, FeuilleDeMatchDto.data.ma_motif_arret, "ma_motif_arret");

            if ($("#chbxProlongations")[0].checked) {
                FaitsDeMatchService.verifErreursResulats(erreurs, FeuilleDeMatchDto.data.cr_nb_but_tps_reglt, FeuilleDeMatchDto.data.cv_nb_but_tps_reglt);
                FaitsDeMatchService.verifErreursResulatsTpsRegl(erreurs, FeuilleDeMatchDto.data.cr_nb_but, FeuilleDeMatchDto.data.cv_nb_but,
                     FeuilleDeMatchDto.data.cr_nb_but_tps_reglt, FeuilleDeMatchDto.data.cv_nb_but_tps_reglt);
            }
            if ($("#chbxTirsAuBut")[0].checked) {
                FaitsDeMatchService.verifErreursResulats(erreurs, FeuilleDeMatchDto.data.cr_nb_tir_but, FeuilleDeMatchDto.data.cv_nb_tir_but);
            }
            var minutePlus = FeuilleDeMatchDto.datasMatch.ph_tps_sup == "O" ? FeuilleDeMatchDto.data.ma_min_arret_sup : null;
            FaitsDeMatchOngletsService.addErrorFormatMinute(erreurs, FeuilleDeMatchDto.data.ma_min_arret, minutePlus);
            FeuilleDeMatchDto.data.ma_min_arret = isNaN(parseInt(FeuilleDeMatchDto.data.ma_min_arret, 10))? "0" : parseInt(FeuilleDeMatchDto.data.ma_min_arret, 10);
            FeuilleDeMatchDto.data.ma_min_arret_sup = isNaN(parseInt(FeuilleDeMatchDto.data.ma_min_arret_sup, 10))? "0" : parseInt(FeuilleDeMatchDto.data.ma_min_arret_sup, 10);
        } else {
            FaitsDeMatchService.verifErreursResulats(erreurs, FeuilleDeMatchDto.data.cr_nb_but, FeuilleDeMatchDto.data.cv_nb_but);
            if (FeuilleDeMatchDto.datasMatch.ph_tps_sup == "O") {
                FeuilleDeMatchDto.data.ma_min_period1_sup = isNaN(parseInt(FeuilleDeMatchDto.data.ma_min_period1_sup, 10))? "0" : parseInt(FeuilleDeMatchDto.data.ma_min_period1_sup, 10);
                FeuilleDeMatchDto.data.ma_min_period2_sup = isNaN(parseInt(FeuilleDeMatchDto.data.ma_min_period2_sup, 10))? "0" : parseInt(FeuilleDeMatchDto.data.ma_min_period2_sup, 10);
                temps.push(FeuilleDeMatchDto.data.ma_min_period1_sup);
                temps.push(FeuilleDeMatchDto.data.ma_min_period2_sup);
            }

            if ($("#chbxProlongations")[0].checked) {
                FaitsDeMatchService.verifErreursResulats(erreurs, FeuilleDeMatchDto.data.cr_nb_but_tps_reglt, FeuilleDeMatchDto.data.cv_nb_but_tps_reglt);
                FaitsDeMatchService.verifErreursResulatsTpsRegl(erreurs, FeuilleDeMatchDto.data.cr_nb_but, FeuilleDeMatchDto.data.cv_nb_but,
                     FeuilleDeMatchDto.data.cr_nb_but_tps_reglt, FeuilleDeMatchDto.data.cv_nb_but_tps_reglt);
                if (FeuilleDeMatchDto.datasMatch.ph_tps_sup == "O") {
                    FeuilleDeMatchDto.data.ma_min_prol_sup1 = isNaN(parseInt(FeuilleDeMatchDto.data.ma_min_prol_sup1, 10))? "0" : parseInt(FeuilleDeMatchDto.data.ma_min_prol_sup1, 10);
                    FeuilleDeMatchDto.data.ma_min_prol_sup2 = isNaN(parseInt(FeuilleDeMatchDto.data.ma_min_prol_sup2, 10))? "0" : parseInt(FeuilleDeMatchDto.data.ma_min_prol_sup2, 10);
                    temps.push(FeuilleDeMatchDto.data.ma_min_prol_sup1);
                    temps.push(FeuilleDeMatchDto.data.ma_min_prol_sup2);
                }
            }
            if ($("#chbxTirsAuBut")[0].checked) {
                FaitsDeMatchService.verifErreursResulats(erreurs, FeuilleDeMatchDto.data.cr_nb_tir_but, FeuilleDeMatchDto.data.cv_nb_tir_but);
            }
            //vérification de tous les temps stockés dans le tableau (temps à vérifier)
            FaitsDeMatchService.verifErreursTemps(erreurs, temps);
        }

        if (erreurs.length > 0) {
            Engine.headerController.showError(erreurs[0]);
        } else {
            //suppression des buts de l'équipe qui en a trop
            //TODO: refactoriser
            var ids = [];
            if (FaitsDeMatchHistoriqueDto.histo.length > 0) {
                if (parseInt(Engine.selectGetVal($("#cr_nb_but")), 10) < parseInt(dto_cr_nb_but, 10)) {
                    for (var i = 0; i < FaitsDeMatchHistoriqueDto.histo.length; i++){
                        if (FaitsDeMatchHistoriqueDto.histo[i].cfe_typ == "BU"){
                            var idClubJoueur = FaitsDeMatchService.idClubJoueur(FaitsDeMatchHistoriqueDto.histo[i].l1_li_no);
                            var visiteur = parseInt(idClubJoueur, 10) == FeuilleDeMatchDto.datasMatch.cv_cl_no;
                            
                            if ((visiteur && FaitsDeMatchHistoriqueDto.histo[i].cfe_typ_but == "CSC") || !visiteur) {
                                ids.push(FaitsDeMatchHistoriqueDto.histo[i].id);
                            }
                        }
                    }
                }
                if (parseInt(Engine.selectGetVal($("#cv_nb_but")), 10) < parseInt(dto_cv_nb_but, 10)) {
                    for (var i = 0; i < FaitsDeMatchHistoriqueDto.histo.length; i++){
                        if (FaitsDeMatchHistoriqueDto.histo[i].cfe_typ == "BU"){
                            var idClubJoueur = FaitsDeMatchService.idClubJoueur(FaitsDeMatchHistoriqueDto.histo[i].l1_li_no);
                            var visiteur = parseInt(idClubJoueur, 10) == FeuilleDeMatchDto.datasMatch.cv_cl_no;
                            
                            if ((!visiteur && FaitsDeMatchHistoriqueDto.histo[i].cfe_typ_but == "CSC") || visiteur) {
                                ids.push(FaitsDeMatchHistoriqueDto.histo[i].id);
                            }
                        }
                    }
                }
            }
            FaitsDeMatchService.enregistrementInfosMatch(function() {
                FaitsDeMatchService.deleteButsFromIdList(Utils.cloneObject(ids));
            });
        }
    },
    /**
     * Permet de supprimer une liste de buts en base et dans le dto
     */
    deleteButsFromIdList: function(ids) {
        if (ids.length === 0) {
            FaitsDeMatchHistoService.findHistorique(false, function() {
                FaitsDeMatchLigneTempsService.refreshTimeline();
                FaitsDeMatchOngletsService.afficherCompteur(FeuilleDeMatchDto.cfm_no, "BU", false);
            }, false);
        } else {
            var id = ids[0];
            ids.shift();
            DataBase.deleteById("MATCH_FEUILLE_EVENEMENT", id, function() {
                FaitsDeMatchService.deleteButsFromIdList(ids);
            });
        }
    },
    idClubJoueur: function(idLicence) {
        var idClub = null;
        for (var i in CompositionsMatchDto.equipeRecevante) {
            var dataJoueur = CompositionsMatchDto.equipeRecevante[i].infosJoueur;
            var id_joueur = Utils.isNotBlank(dataJoueur.li_no) ? dataJoueur.li_no : dataJoueur.in_no;
            if (parseInt(id_joueur, 10) === parseInt(idLicence, 10)) {
                idClub = CompositionsMatchDto.equipeRecevante[i].infosCompo.cfi_cl_no;
            }
        }
        if(Utils.isBlank(idClub)) {
            for (var i in CompositionsMatchDto.equipeVisiteur) {
                var dataJoueur = CompositionsMatchDto.equipeVisiteur[i].infosJoueur;
                var id_joueur = Utils.isNotBlank(dataJoueur.li_no) ? dataJoueur.li_no : dataJoueur.in_no;
                if (parseInt(id_joueur, 10) === parseInt(idLicence, 10)) {
                    idClub = CompositionsMatchDto.equipeVisiteur[i].infosCompo.cfi_cl_no;
                }
            }
        }
        return idClub;
    },
    enregistrementInfosMatch: function(callback){
        // enregistrement des checkbox du haut
        $("#matchContent .ongletsEtatsMatch input").each(function(key, value) {
            FeuilleDeMatchDto.data[$(this).attr("id")] = $(this)[0].checked;
        });
        FeuilleDeMatchDto.data.fdmValidee = true;
        DataBase.updateJson("MATCH_FEUILLE", FeuilleDeMatchDto.idCfm, FeuilleDeMatchDto.data, function(updated) {
            FaitsDeMatchService.refreshEjs("match");
            if (typeof callback === 'function') {
                callback();
            }
        });
        Engine.headerController.showError("");
        //FaitsDeMatchLigneTempsService.refreshTimeline();
        Engine.alert(Lang.faitsDeMatch.valide);
    },
    verificationParametreCompetition : function(element, param1, param2) {
        // Vérification des paramètres de la compétition
        if (FeuilleDeMatchDto.datasMatch[param1] == "O" && !Utils.isNotBlank($("." + param2).find(".").val())) {
            Utils.log("Des paramètres de la compétition obligatoires n'ont pas été remplis ! ");
            erreur = [Lang.faitsDeMatch.erreurs.parametresCompetitionObligatoires];
            Engine.headerController.showError(erreur);
            FeuilleDeMatchDto.data.erreurParamCompet = true;
        } else {
            FeuilleDeMatchDto.data.erreurParamCompet = false;
        }
    },
    /**
     * Vérifie si le match est non joué dans le cas où la composition d'une des deux équipes
     * n'atteint pas le nombre de joueurs minimum.
     * 
     * @return {Boolean} true si le nombre de titulaire des deux composition est correcte
     */
    verifNbTitul : function() {
        var nbTitulOkCv = FeuilleDeMatchDto.data.cv_forf == "O" || FaitsDeMatchService.verifNbTitulEquipe(CompositionsMatchDto.equipeVisiteur);
        var nbTitulOkCr = FeuilleDeMatchDto.data.cr_forf == "O" || FaitsDeMatchService.verifNbTitulEquipe(CompositionsMatchDto.equipeRecevante);
        
        return nbTitulCorrect = nbTitulOkCv && nbTitulOkCr;
    },
    verifNbTitulEquipe : function(equipe) {
        var cptTitul = 0;
        for(var i in equipe) {
            if(equipe[i].infosCompo.cfi_role == "T") {
                cptTitul++;
            }
        }
        return (cptTitul >= FeuilleDeMatchDto.datasMatch.ph_nb_titul_mini);
    },

    deverrouillerSignatures : function (codeSignature) {
    
        var datas = {};
        var codeLibelleSignature = codeSignature.toLowerCase();
        var signature = signataire = "";

        var typeSignature_technique = ["Arbitre","EquipeRecevante", "EquipeVisiteur", "ArbitreAssistant"];
        var typeSignature_observation = ["Arbitre","EquipeRecevante", "EquipeVisiteur"];   
        //tableau pour les champs à mettre à jour en base en fonction de la signature, du signataire, et de la page
        var tab = {
            "Arbitre" : {
                signature: "cfm_signat_" + codeLibelleSignature + "_arb",
                signataire : "in_no_" + codeLibelleSignature + "_arb",
            },
            "EquipeRecevante" : {
                signature: "cfm_signat_" + codeLibelleSignature + "_rec",
                signataire : "in_no_" + codeLibelleSignature + "_rec",
            },
            "EquipeVisiteur" : {
                signature: "cfm_signat_" + codeLibelleSignature + "_vis",
                signataire : "in_no_" + codeLibelleSignature + "_vis",
            },
            "ArbitreAssistant" : {
                signature: "cfm_signat_" + codeLibelleSignature + "_ass",
                signataire: "in_no_" + codeLibelleSignature + "_ass",
            }
        };    
        if (codeSignature == "tech_apm") {
            typeSignature_technique.forEach(function (typeSignature){
                datas[tab[typeSignature].signature] = null;
                FeuilleDeMatchDto.data[tab[typeSignature].signature] = null;
                datas[tab[typeSignature].signataire] = null;
                FeuilleDeMatchDto.data[tab[typeSignature].signataire] = null;
            });
        } else if(codeSignature == "obs_apm") {
             typeSignature_observation.forEach(function (typeSignature){
                datas[tab[typeSignature].signature] = null;
                FeuilleDeMatchDto.data[tab[typeSignature].signature] = null;
                datas[tab[typeSignature].signataire] = null;
                FeuilleDeMatchDto.data[tab[typeSignature].signataire] = null;
            });
        }
        
        //enregistrement
        DataBase.updateJson("MATCH_FEUILLE", FeuilleDeMatchDto.data.id, datas, function() {
            if (codeSignature == "tech_apm") {
                typeSignature_technique.forEach(function (typeSignature){
                    Engine.addView("#signature" + typeSignature, "popups.html:boutonsConnexionSignature", {
                        equipe : typeSignature,
                        imageSignature : null,
                        feuilleDeMatch : null,
                        reservesAvantMatch : false,
                        cv_forf : FeuilleDeMatchDto.data.cv_abs_tech_apm,
                        cr_forf : FeuilleDeMatchDto.data.cr_abs_tech_apm
                    }, true);
                });
            } else if (codeSignature == "obs_apm") {
                 typeSignature_observation.forEach(function (typeSignature){
                    Engine.addView("#signature" + typeSignature, "popups.html:boutonsConnexionSignature", {
                        equipe : typeSignature,
                        imageSignature : null,
                        feuilleDeMatch : null,
                        reservesAvantMatch : false,
                        cv_forf : FeuilleDeMatchDto.data.cv_abs_obs_apm,
                        cr_forf : FeuilleDeMatchDto.data.cr_abs_obs_apm
                    }, true);
                });
            }

        });
    }
}; 