var FaitsDeMatchInfosService = {
     modifier: function(element) {
        FaitsDeMatchHistoriqueDto.idInfoModifier = element.attr("data-for");
        FaitsDeMatchOngletsService.changeOnglet($("#infos"));
        $("#minuteInfo").val(element.parent().parent().find(".cfe_min").val());
        $("#minuteInfoPlus").val(element.parent().parent().find(".cfe_min_sup").val());
        var typeEventInfo = element.parent().parent().find(".cfe_typ").val();
        Engine.selectSetVal($('#typeEventInfo'), typeEventInfo);
        $("#denombrementInfo").val(element.parent().parent().find(".cfe_nb_evmt").val());
        $("#tribuneInfo").val(element.parent().parent().find(".cfe_trib").val());
        $("#detail").val(element.parent().parent().find(".cfe_lib").val());
    },
     validerSecu: function() {
        var minute = $("#minuteInfo").val();
        var minutePlus = $("#minuteInfoPlus").val();
        var typeEventInfo = $("#typeEventInfo").val();
        var denombrementInfo = $("#denombrementInfo").val();
        var tribuneInfo = $("#tribuneInfo").val();
        var detailInfo = $("#detail").val();
        if($("#rapportDelegueInfo")[0].checked){
            var rapportDelegueInfo = "O";
        } else {
            var rapportDelegueInfo = "N";
        }

        var erreur = [];
        FaitsDeMatchOngletsService.addErrorFormatMinute(erreur, minute, minutePlus);
        minute = parseInt(minute, 10);
        
        if (isNaN(denombrementInfo) || !Utils.isNotNull(denombrementInfo) || !Utils.isNotBlank(denombrementInfo)) {
            erreur.push(Lang.faitsDeMatch.erreurs.infos.denombrement);
        } else if (denombrementInfo.length > 0 && denombrementInfo.length > 3) {
            erreur.push(Lang.faitsDeMatch.erreurs.cfe_nb_evmt_limit);
        } else if (tribuneInfo.length > 0 && tribuneInfo.length > 10) {
            erreur.push(Lang.faitsDeMatch.erreurs.cfe_trib_limit);
        } else if (detailInfo.length > 0 && detailInfo.length > 50) {
            erreur.push(Lang.faitsDeMatch.erreurs.cfe_lib_securite_limit);
        }

        if (erreur.length == 0) {
            Engine.headerController.showError("");
            FaitsDeMatchHistoService.init();
            FaitsDeMatchHistoriqueDto.data.ma_no = FeuilleDeMatchDto.ma_no;
            FaitsDeMatchHistoriqueDto.data.cfm_no = FeuilleDeMatchDto.cfm_no;
            FaitsDeMatchHistoriqueDto.data.cfe_min = minute;
            FaitsDeMatchHistoriqueDto.data.cfe_min_sup = minutePlus;
            FaitsDeMatchHistoriqueDto.data.cfe_typ = typeEventInfo;
            FaitsDeMatchHistoriqueDto.data.cfe_no = 1;
            FaitsDeMatchHistoriqueDto.data.cfe_nb_evmt = denombrementInfo;
            FaitsDeMatchHistoriqueDto.data.cfe_trib = tribuneInfo;
            FaitsDeMatchHistoriqueDto.data.cfe_lib = detailInfo;   
            
            if (FaitsDeMatchHistoriqueDto.idInfoModifier != null) {
                DataBase.deleteById("MATCH_FEUILLE_EVENEMENT", FaitsDeMatchHistoriqueDto.idInfoModifier);
                FaitsDeMatchHistoriqueDto.idInfoModifier = null;
            }
            FaitsDeMatchHistoService.insertHistorique();
            $("#minuteInfo").val("");
            $("#minuteInfoPlus").val("");
            $("#denombrementInfo").val("");
            $("#tribuneInfo").val("");
            $("#detail").val("");
            FaitsDeMatchOngletsService.afficherCompteur(FeuilleDeMatchDto.cfm_no, "SECU");
            DataBase.update("MATCH_FEUILLE", FeuilleDeMatchDto.idCfm, "cfm_rapp_deleg", rapportDelegueInfo, function() {
            });

            
        } else {
            Engine.headerController.showError(erreur[0]);
        }
    },
    validerOrga: function() {
        
        var recetteInfo = $("#recetteInfo").val();
        var nombreSpectateursInfo = $("#nombreSpectateursInfo").val();    
        var detailInfo = "";
        if (MatchDto.match.ph_reglt_locaux !== "I") {
            detailInfo = $("#detailInfo").val();
        }

        var erreur = [];
              
        // Si les informations d'organisation est obligatoire 
        if(MatchDto.match.ph_info_orga === "O") {
            if (!Utils.isNotNull(recetteInfo) || !Utils.isNotBlank(recetteInfo) || !Utils.isNotNull(nombreSpectateursInfo) || !Utils.isNotBlank(nombreSpectateursInfo)) {
                erreur.push(Lang.faitsDeMatch.erreurs.infos.saisieOrganisation);
            } else if(isNaN(recetteInfo) || !Utils.isInteger(recetteInfo) || isNaN(nombreSpectateursInfo) || !Utils.isInteger(nombreSpectateursInfo)) {
                erreur.push(Lang.faitsDeMatch.erreurs.infos.saisieOrganisation);
            }
        } else if (Utils.isNotBlank(detailInfo) && Utils.isNotNull(detailInfo) && detailInfo.length > 256) {
            erreur.push(Lang.faitsDeMatch.erreurs.cfm_reglt_locaux_lib_limit);
        }

        if((!Utils.isIntegerPositif(recetteInfo) && Utils.isNotNull(recetteInfo) && Utils.isNotBlank(recetteInfo)) || (Utils.isNotNull(nombreSpectateursInfo) && Utils.isNotBlank(nombreSpectateursInfo) && !Utils.isIntegerPositif(nombreSpectateursInfo))) {           
            erreur.push(Lang.faitsDeMatch.erreurs.infos.organisationNumerique);
        } 

        if (Utils.isNotBlank(recetteInfo) && Utils.isNotNull(recetteInfo) && recetteInfo.length > 11) {
            erreur.push(Lang.faitsDeMatch.erreurs.infos.recetteInfoMax);
        }

        if (Utils.isNotBlank(nombreSpectateursInfo) && Utils.isNotNull(nombreSpectateursInfo) && nombreSpectateursInfo.length > 6) {
            erreur.push(Lang.faitsDeMatch.erreurs.infos.nombreSpectateursInfoMax);
        }

        if(MatchDto.match.ph_reglt_locaux !== "I" && (!Utils.isNotNull(detailInfo) || !Utils.isNotBlank(detailInfo))){
            erreur.push(Lang.faitsDeMatch.erreurs.infos.reglementLocaux);
        }
        if (erreur.length === 0) {
            Engine.headerController.showError("");
            
            var data = {
                cfm_recette : recetteInfo,
                cfm_nb_spect : nombreSpectateursInfo,
                cfm_reglt_locaux_lib : detailInfo
            };
                        
            DataBase.updateJson("MATCH_FEUILLE", FeuilleDeMatchDto.idCfm, data, function(){
                FeuilleDeMatchDto.data.cfm_recette = recetteInfo;
                FeuilleDeMatchDto.data.cfm_nb_spect = nombreSpectateursInfo;
                FeuilleDeMatchDto.data.cfm_reglt_locaux_lib = detailInfo;
            });


            
        } else {
            Engine.headerController.showError(erreur);

        }
        
    }
};