var FaitsDeMatchLigneTempsService = {
    refreshTimeline : function(callback) {
        FaitsDeMatchLigneTempsService.viderTimeline(function() {
            var listeCartons = Utils.cloneObject(FaitsDeMatchHistoriqueDto.histo);
            var listeCartonsJaunes = [];
            var listeCartonsReste = [];
            
            for(var i = 0; i < listeCartons.length; i++) {
                if(listeCartons[i].cfe_typ == "DI" && listeCartons[i].cfe_cod_motif.substring(0,1) === "J") {
                    listeCartonsJaunes.push(listeCartons[i]);
                } else {
                    listeCartonsReste.push(listeCartons[i]);
                }
            }
            
            cmp = function(x, y) {
                return x > y ? 1 : x < y ? -1 : 0; 
            };
    
            listeCartonsJaunes.sort(function(a, b) {
                return cmp(
                    [cmp(a.in_no, b.in_no), cmp(parseInt(a.cfe_min, 10), parseInt(b.cfe_min, 10))], 
                    [cmp(b.in_no, a.in_no), cmp(parseInt(b.cfe_min, 10), parseInt(a.cfe_min, 10))]
                );
            });
            FaitsDeMatchLigneTempsService.afficherCartonJaunes(listeCartonsJaunes, function() {
                for(var i = 0; i < listeCartonsReste.length; i++) {
                    FaitsDeMatchLigneTempsService.afficherEvenement(listeCartonsReste[i], function(srcImage){
                        FaitsDeMatchLigneTempsService.positionnerEvenement(listeCartonsReste[i], srcImage);
                    });
                }
                if (typeof callback === 'function') {
                    callback();
                }
            });
        });
    },
    viderTimeline: function(callback) {
        $("#events .event").each(function(){
            $(this).remove();
        });
        if (typeof callback === 'function') {
            callback();
        }
    },
    /**
     * vérifie chaque carton jaune pour afficher le second en "jaune->rouge"
     * 
     * @param {Object} listeCartonsJaunes la liste des événements de l'historique qui sont des cartons jaunes
     * @param {Object} callback
     */
    afficherCartonJaunes: function(listeCartonsJaunes, callback) {
        if (listeCartonsJaunes.length == 0 && typeof callback === 'function') {
            callback();
        } else {
            for (var i=0; i < listeCartonsJaunes.length; i++) {
                var srcImage = "img/carton_jaune.png";
                if(i > 0 && listeCartonsJaunes[i].in_no == listeCartonsJaunes[i-1].in_no) {
                    srcImage = "img/carton_jaune_devient_rouge.png";
                    if(i > 1 && listeCartonsJaunes[i].in_no == listeCartonsJaunes[i-2].in_no) {
                        srcImage = "img/carton_jaune.png";
                    }
                }
                FaitsDeMatchLigneTempsService.positionnerEvenement(listeCartonsJaunes[i], srcImage);
            }
            if (typeof callback === 'function') {
                callback();
            }
        }
    },
    afficherEvenement: function(event, callback) {
        var role = event.l1_role;
        var srcImage = "";
        if (event.cfe_typ == "ES") {
            srcImage = "img/picto_remplacement.png";
        } else if (event.cfe_typ == "EJ") {
            srcImage = "img/picto_entree.png";
        } else if (event.cfe_typ == "SJ") {
            srcImage = "img/picto_sortie.png";
        } else if (event.cfe_typ == "DI") {
            var cartonType = event.cfe_cod_motif.substring(0,1);
            if (cartonType === "J") {
                srcImage = "img/carton_jaune.png";
            } else if ( cartonType === "R") {
                srcImage = "img/carton_rouge.png";
            } else if ( cartonType === "B") {
                srcImage = "img/carton_blanc.png";
            }
        } else if (event.cfe_typ == "BU") {
            srcImage = "img/picto_but.png";
        } else if (event.cfe_typ == "BL") {
            srcImage = "img/picto_blessure.png";
        } else if (event.cfe_typ!="DI" && event.cfe_typ!="BL" && event.cfe_typ!="BU" && event.cfe_typ!="SJ" && event.cfe_typ!="EJ" && event.cfe_typ!="ES") {
            srcImage = "img/picto_securite.png";
        }
        
        if (typeof callback === 'function') {
            callback(srcImage);
        }
        
    },
    positionnerEvenement: function(event, srcImage) {
        var periodesSup = {};
        periodesSup[parseInt(FeuilleDeMatchDto.datasMatch.ph_duree_periode, 10)/2] = "eventTpsSupPer1";
        periodesSup[parseInt(FeuilleDeMatchDto.datasMatch.ph_duree_periode, 10)] = "eventTpsSupPer2";
        if (FeuilleDeMatchDto.datasMatch.ph_prol == "O" && FeuilleDeMatchDto.data.chbxProlongations) {
            periodesSup[parseInt(FeuilleDeMatchDto.datasMatch.ph_duree_periode, 10) + parseInt(FeuilleDeMatchDto.datasMatch.ph_duree_prol, 10)/2] = "eventTpsSupProl1";
            periodesSup[parseInt(FeuilleDeMatchDto.datasMatch.ph_duree_periode, 10) + parseInt(FeuilleDeMatchDto.datasMatch.ph_duree_prol, 10)] = "eventTpsSupProl2";
        }
        if(Utils.isNotBlank(event.cfe_min_sup) && parseInt(event.cfe_min_sup, 10) != 0){
            Engine.addView("#" + periodesSup[parseInt(event.cfe_min, 10)],"faitsDeMatch.html:evenementTimeline", {srcImage : srcImage, typeEvent: event.cfe_typ});
        } else {
            Engine.addView(".eventMin" + event.cfe_min,"faitsDeMatch.html:evenementTimeline", {srcImage : srcImage, typeEvent: event.cfe_typ});
        }
    }
};