var FeuilleDeMatchController = MainController.extend({
    defaults : {
        name : ".FeuilleDeMatchController",
        click : Engine.eventClick,
        change : "change",
        dblclick : Engine.eventDblclick,
        pages : new Array(
                "feuilleDeMatch/feuilleDeMatch.html",
                "feuilleDeMatch/popups.html"),
        files : new Array(
                "feuilleDeMatch/css/feuilleDeMatch.css",
                "feuilleDeMatch/js/dto/compositionsMatchDto.js",
                "feuilleDeMatch/js/feuilleDeMatchService.js",
                "feuilleDeMatch/js/feuilleDeMatchService.js",
                "feuilleDeMatch/js/service/feuilleDeMatchSignaturesService.js",
                "feuilleDeMatch/js/service/feuilleDeMatchConnexionService.js",
                "feuilleDeMatch/js/service/feuilleDeMatchControlesService.js",
                "feuilleDeMatch/js/service/feuilleDeMatchInfosMatchService.js",
                "feuilleDeMatch/js/feuilleDeMatchFr.js",
                "reserves/reservesAvantMatch/js/service/reservesService.js",
                "reserves/reservesAvantMatch/js/reserveDto.js",
                "accueil/js/referentielDto.js",
                "faitsDeMatch/js/feuilleDeMatchDto.js",
                "connexion/js/connexionDto.js",
                "connexion/js/connexionFr.js",
                "equipe/js/service/equipeCompositionService.js",
                "equipe/js/equipeDto.js",
                "equipe/js/equipeFr.js",
                "equipe/js/sanctionDto.js"),
        
        equipes : {},
        clNoUser : {},
        liNoUser : {}
    }
}, {
    init : function(element, options) {
        this._super(this, element, options);
    },
    load : function(page, data) {
        if (Utils.isNotNull(data) && Utils.isNotNull(data.match)) {
            $.extend(this.options, data.match);
        }
        
        Engine.loadController(page, this.options.pages, this.options.files, this, function(controller) {
            FeuilleDeMatchService.chargerFeuilleDeMatch(data.match, function(){
                FeuilleDeMatchDto.afficherMdpVerrouArbitre = !(Utils.isNotNull(data) && Utils.isNotNull(data.utilisateur));
                controller.show(controller.element, null);
            });
        });
    },
    show : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            Engine.headerController.setTransmissionButton();
            Engine.headerController.disableSynchroButton();
            if (FeuilleDeMatchDto.data.verrouillage){
                Engine.headerController.showSynchroButton();
            }
            var cfm_no = FeuilleDeMatchDto.data.cfm_no;
            if(FeuilleDeMatchDto.data.cfm_infos_valid == "O" && FeuilleDeMatchDto.afficherMdpVerrouArbitre) {
                $("#popupLogin").addClass("dont-close");
                Engine.addView("#popupLogin", "popups.html:popupLoginArbitre", {verrou : true, log : true}, true);
                Engine.popup("#popupLogin");
            }
            else {
                Engine.message("Chargement de la feuille de match");
            }
            
            DataBase.findBy("MATCH_FEUILLE_MEMBRE", "cfm_noAndmmf_typAndpo_cod", [cfm_no, "A", "AC"], function(data) {
                var arbitre = null;
                if (data.length > 0) {
                    arbitre = data[0];
                }
                FeuilleDeMatchInfosMatchService.chargerInfosMatch(arbitre, function(){
                    FeuilleDeMatchConnexionService.afficherBoutonsBas();
                    controller.afficherCompositions();
                });
            });
        });
    },

    afficherCompositions : function() {
        var controller = this;

        var matchId = controller.options.ma_no;
        var clubRecevantPropertyName = "cr_cl_no";
        var clubVisiteurPropertyName = "cv_cl_no";

        var idClubRecevant = controller.options[clubRecevantPropertyName];
        var idClubVisiteur = controller.options[clubVisiteurPropertyName];

        // Purge des données existantes pour ne pas se retrouver avec des données incohérentes
        controller.options.equipes = {};
        
        //charger les joueurs des compositions des équipes
        controller.options.equipes[idClubRecevant] = {
            statut : "equipeRecevante"
        };
        controller.options.equipes[idClubVisiteur] = {
            statut : "equipeVisiteur"
        };

        //récupère les joueurs de l'équipe recevante
        FeuilleDeMatchService.getJoueursFromCompo(matchId, idClubRecevant, function(joueursRecevant) {
            
            //récupère les joueurs de l'équipe visiteur
            FeuilleDeMatchService.getJoueursFromCompo(matchId, idClubVisiteur, function(joueursVisiteur) {
                var joueursRecevantTries = FeuilleDeMatchService.trierJoueursParNumero(joueursRecevant);     
                var joueursVisiteurTries = FeuilleDeMatchService.trierJoueursParNumero(joueursVisiteur);     
                
                CompositionsMatchDto.equipeRecevante = Utils.cloneObject(joueursRecevantTries);
                CompositionsMatchDto.equipeVisiteur = Utils.cloneObject(joueursVisiteurTries);
                
                controller.options.equipes[idClubRecevant].joueurs = Utils.cloneObject(joueursRecevantTries);;
                controller.options.equipes[idClubVisiteur].joueurs = Utils.cloneObject(joueursVisiteurTries);
                
                controller.afficherComposValides();

                // PATCH - Mantis #31827
                // Engine.deleteScroll("equipe-content-"+idClubVisiteur);
                // Engine.deleteScroll("equipe-content-"+idClubRecevant);
                
                $('.equipe-content img').hide();
                $('.equipe-content img').load(function(event) {
                    controller.redimensionnerLogo(event.target, 360, 360);
                    $(event.target).show();
                    // PATCH - Mantis #31827
                    // Engine.initScrolls();
                    Engine.updateDeprecatedUScroll();
                });
                if(!(FeuilleDeMatchDto.data.cfm_infos_valid == "O" && FeuilleDeMatchDto.afficherMdpVerrouArbitre)) {
                    Engine.fermerPopup();
                }
            });
        });

    },
    
    /**
     * Redimensionner une image trop grande pour uen dimensions maximal donnée
     * @param {Object} img
     * @param {Integer} maxWidth
     * @param {Integer} maxHeight
     */
    redimensionnerLogo: function(img, maxWidth, maxHeight) {
        var rate = img.width / img.height;
        
        if (img.width > maxWidth && rate >= 1.0) {
            img.height = img.height * maxWidth / img.width;
            img.width = maxWidth;
        } else if (img.height > maxHeight && rate < 1.0) {
            img.width = img.width * maxHeight / img.height;
            img.height= maxHeight;
        }
    },
    
    afficherComposValides: function(callback){
        Engine.delegate(this, null, null, function(controller, element, event) {
            $.each(controller.options.equipes, function(key, equipe) {
                equipe.id = key;
                var modelData = {
                    match : {
                        infosMatch : {
                            cv_co_valid : FeuilleDeMatchDto.data.cv_co_valid, 
                            cr_co_valid : FeuilleDeMatchDto.data.cr_co_valid
                        },
                        cv_cl_blason : MatchDto.match.cv_cl_blason,
                        cr_cl_blason : MatchDto.match.cr_cl_blason,
                        cv_cl_no : MatchDto.match.cv_cl_no,
                        cr_cl_no : MatchDto.match.cr_cl_no,
                    },
                    equipe : equipe
                };

                // Vérifier le status de validation de la compo
                var compoValide =   
                    (equipe.statut === "equipeRecevante" && FeuilleDeMatchDto.data.crCompValides === true) ||
                    (equipe.statut === "equipeVisiteur" && FeuilleDeMatchDto.data.cvCompValides === true);

                //si déjà connecté
                //Patch des connexions: si on ne vient pas de la page équipe ou reserves, on déconnecte les utilisateurs
                if((controller.isConnected(key) && !FeuilleDeMatchDto.afficherMdpVerrouArbitre)
                    || (FeuilleDeMatchDto.data.cvCompValides === true && FeuilleDeMatchDto.data.crCompValides === true) 
                    || (FeuilleDeMatchDto.data.signaturesValides && compoValide)) {
                    //alors afficher les compositions
                    controller.afficherCompo(modelData);
                    if(typeof callback === 'function'){
                        callback();
                    }
                }else{
                    //sinon les cacher
                    controller.cacherCompo(modelData);
                    if(typeof callback === 'function'){
                        callback();
                    }
                }
            });
        });
    },

    changeValidation : function(idEquipe, validation, callback) {
        var datas = {};
        if (this.options.equipes[idEquipe] && this.options.equipes[idEquipe].statut === "equipeRecevante") {
            FeuilleDeMatchDto.data.cr_co_valid = validation;
            datas["cr_co_valid"] = validation;
            FeuilleDeMatchDto.data.crCompValides = "O" == validation;
        } else if (this.options.equipes[idEquipe] && this.options.equipes[idEquipe].statut === "equipeVisiteur") {
            FeuilleDeMatchDto.data.cv_co_valid = validation;
            datas["cv_co_valid"] = validation;
            FeuilleDeMatchDto.data.cvCompValides = "O" == validation;
        }
        DataBase.findBy("MATCH_FEUILLE", "cfm_no", this.options.cfm_no, function(data) {
            DataBase.updateJson("MATCH_FEUILLE", data[0].id, datas, function() {
                if ( typeof callback === 'function') {
                    callback();
                }
            });
        });
    },

    isConnected : function(idEquipe) {
        var result = null;
        if (this.options.equipes[idEquipe] && this.options.equipes[idEquipe].statut === "equipeRecevante") {
            result = FeuilleDeMatchDto.equipeRecevanteConnectionStatus;
        } else if (this.options.equipes[idEquipe] && this.options.equipes[idEquipe].statut === "equipeVisiteur") {
            result = FeuilleDeMatchDto.equipeVisiteurConnectionStatus;
        }
        return result === "CONNECTED";
    },

    setConnectionStatus : function(idEquipe, dto, status) {
        if (dto) {
            if (this.options.equipes[idEquipe] && this.options.equipes[idEquipe].statut === "equipeRecevante") {
                dto.equipeRecevanteConnectionStatus = status;
            } else {
                if (this.options.equipes[idEquipe] && this.options.equipes[idEquipe].statut === "equipeVisiteur") {
                    dto.equipeVisiteurConnectionStatus = status;
                }
            }
        }
    },

    validerCompostion : function(idEquipe, callback) {
        Engine.delegate(this, null, null, function(controller, element, event) {
            controller.changeValidation(idEquipe, 'O', callback);
        });
    },
    invaliderCompostion : function(idEquipe, callback) {
        Engine.delegate(this, null, null, function(controller, element, event) {
            controller.changeValidation(idEquipe, 'N', callback);
        }); 
    },

    afficherCompo : function(element) {
        Engine.addView(".div-equipes-boutons #" + element.equipe.statut, "feuilleDeMatch.html:" + element.equipe.statut + "Shown", {
            data : element,
            verrouillage : FeuilleDeMatchDto.data.verrouillage || FeuilleDeMatchDto.data.signaturesValides
        });
        // PATCH - Mantis #31827
        // setTimeout(function() {
        //  Engine.initScrolls("equipe-content-" + element.equipe.id);
        // }, 100);
        Engine.updateDeprecatedUScroll();
    },
    cacherCompo : function(element) {
        Engine.addView(".div-equipes-boutons #" + element.equipe.statut, "feuilleDeMatch.html:" + element.equipe.statut + "Hidden", {
            data : element,
            verrouillage : FeuilleDeMatchDto.data.verrouillage || FeuilleDeMatchDto.data.signaturesValides,
            fdmValidee: "equipeVisiteur" == element.equipe.statut ? FeuilleDeMatchDto.data.cvCompValides : FeuilleDeMatchDto.data.crCompValides
        });
        // PATCH - Mantis #31827
        // Engine.deleteScroll("equipe-content-"+ element.equipe.id);
    },
    toggleEquipeAbsenteSignature: function (coteEquipe, absent) {
        Engine.addView("#boutonConnexion" + coteEquipe, "popups.html:ligneBoutons", {
            equipe : coteEquipe,
            disable : absent
        }, true);
        $("#blocSignature" + coteEquipe).children().remove();
    },
    afficherSignatureAvantMatch : function () {
        var controller = this;
        
        var datas = {
            cv_forf : FeuilleDeMatchDto.data.cv_forf,
            cr_forf : FeuilleDeMatchDto.data.cr_forf,
            feuilleDeMatch : FeuilleDeMatchDto,
            cfm_signat_rec : FeuilleDeMatchDto.data.cfm_signat_avm_rec,
            cfm_signat_vis : FeuilleDeMatchDto.data.cfm_signat_avm_vis,
            cfm_signat_arb : FeuilleDeMatchDto.data.cfm_signat_avm_arb,
            boutonValider : true,
            signatures : "avm"
        };
        FeuilleDeMatchSignaturesService.recupererSignatures(FeuilleDeMatchDto.data.cfm_no, "avm", function(){
            Engine.addView("#popupSignatures #divSignatures", "popups.html:popupSignatures", datas, true);
            
            // Si l'équipe recevante n'a pas validé sa composition la signature est désactivée
            if (!FeuilleDeMatchDto.data.crCompValides) {
                $("#absenceEquipeRecevante").attr('checked','checked');
                $("#absenceEquipeRecevante").attr('disabled', 'disabled');
                controller.toggleEquipeAbsenteSignature("EquipeRecevante", !FeuilleDeMatchDto.data.crCompValides);
            }
            // Si l'équipe visiteur n'a pas validé sa composition la signature est désactivée
            if (!FeuilleDeMatchDto.data.cvCompValides) {
                $("#absenceEquipeVisiteur").attr('checked','checked');
                $("#absenceEquipeVisiteur").attr('disabled', 'disabled');
                controller.toggleEquipeAbsenteSignature("EquipeVisiteur", !FeuilleDeMatchDto.data.cvCompValides);
            }
            
            Engine.popup("#popupSignatures");
        }); 
    },
    "{name} .actionConnexion {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var idEquipe = element.attr("id");
            var coteEquipe = element.attr("data-equipe");
            if(AccueilDto.isDemonstration) {
                // Pas de login dans le cas du module démonstration
                var dataEjs = {
                    match : {
                        infosMatch : {
                            cv_co_valid : FeuilleDeMatchDto.data.cv_co_valid,
                            cr_co_valid : FeuilleDeMatchDto.data.cr_co_valid
                        },
                        cv_cl_blason : MatchDto.match.cv_cl_blason,
                        cr_cl_blason : MatchDto.match.cr_cl_blason,
                        cv_cl_no : MatchDto.match.cv_cl_no,
                        cr_cl_no : MatchDto.match.cr_cl_no,
                    },
                    equipe : controller.options.equipes[idEquipe]
                };
                controller.afficherCompo(dataEjs);
            } else {
                Engine.addView("#popupLoginEquipe", "popups.html:popupLogin", {
                    equipe : controller.options.equipes[idEquipe],
                    data : {
                        coteEquipe : coteEquipe,
                        signatures : "",
                        formulaireMdpRencontre: true
                    },
                    superieure : false
                }, true);
                Engine.popup("#popupLoginEquipe");
//                Engine.selectCreate($("#questionSecuriteRencontre"), { minimumResultsForSearch : -1, width: '204px' });

                if(navigator.appVersion.indexOf("Win") != -1){
                    $(".showMdp").hide();
                }
            }
        });
    },

    "{name} .actionValider {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var idEquipe = element.attr("id");
            var erreurs = {
                erreursBloquantes: [],
                erreursNonBloquantes: []
            };
            EquipeDto.data = MatchDto.match;
            EquipeDto.utilisateur = ConnexionDto.users[parseInt(idEquipe, 10)];
            FeuilleDeMatchService.verifErreursComposition(controller.options.equipes[idEquipe], erreurs, function() {
                // RG : Seul les erreurs bloquantes sont affichées dans l'avant match
                Engine.headerController.showError(erreurs.erreursBloquantes);
                
                if (erreurs.erreursBloquantes.length == 0) {
                    //composition valide
                    controller.validerCompostion(idEquipe, function() {
                        // deconnexion
                        controller.setConnectionStatus(idEquipe, FeuilleDeMatchDto, null);
                        controller.cacherCompo({
                            match : MatchDto.match,
                            equipe : controller.options.equipes[idEquipe]
                        });
                        var matchValide = FeuilleDeMatchDto.data.cr_co_valid === 'O' && FeuilleDeMatchDto.data.cv_co_valid === 'O';
                        //si tout est validé, afficher les boutons
                        FeuilleDeMatchDto.data.crCompValides = FeuilleDeMatchDto.data.cr_co_valid === 'O';
                        FeuilleDeMatchDto.data.cvCompValides = FeuilleDeMatchDto.data.cv_co_valid === 'O';
                        FeuilleDeMatchConnexionService.afficherBoutonsBas();
                        
                        if(matchValide) {
                            controller.afficherComposValides();
                        }
                    });
                }
            });
        });
    },
    "{name} .actionConnexionEquipe {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var idEquipe = element.attr("id");
            if(AccueilDto.isDemonstration) {
                // Pas de login dans le cas du module démonstration
                controller.options.equipes[idEquipe].valide = false;
                
                controller.invaliderCompostion(idEquipe, function() {
                    controller.options.equipes[idEquipe].masque = false;
                    // Pas de login dans le cas du module démonstration
                    var dataEjs = {
                        match : {
                            infosMatch : {
                                cv_co_valid : FeuilleDeMatchDto.data.cv_co_valid,
                                cr_co_valid : FeuilleDeMatchDto.data.cr_co_valid
                            },
                            cv_cl_blason : MatchDto.match.cv_cl_blason,
                            cr_cl_blason : MatchDto.match.cr_cl_blason,
                            cv_cl_no : MatchDto.match.cv_cl_no,
                            cr_cl_no : MatchDto.match.cr_cl_no,
                        },
                        equipe : controller.options.equipes[idEquipe]
                    };
                    controller.afficherCompo(dataEjs);
                });
            } else {
                var coteEquipe = element.attr("data-equipe");
                var cl_no;
                var mdpRencontrePresent = false;
                if (coteEquipe === "recevante") {
                    cl_no = FeuilleDeMatchDto.datasMatch.cr_cl_no;
                    mdpRencontrePresent = Utils.isNotBlank(FeuilleDeMatchDto.data.cfm_cr_mdp);
                } else {
                    cl_no = FeuilleDeMatchDto.datasMatch.cv_cl_no;
                    mdpRencontrePresent = Utils.isNotBlank(FeuilleDeMatchDto.data.cfm_cv_mdp);
                }
                
                if (FeuilleDeMatchDto.data.cfm_signat_avm_arb || FeuilleDeMatchDto.data.cfm_signat_avm_vis || FeuilleDeMatchDto.data.cfm_signat_avm_rec || FeuilleDeMatchDto.data.cfm_signat_res_avm_arb || FeuilleDeMatchDto.data.cfm_signat_res_avm_rec || FeuilleDeMatchDto.data.cfm_signat_res_avm_vis){
                    Engine.confirm(Lang.feuilleDeMatch.alerteSuppressionSignaturesAvantMatch, function(){
                        FeuilleDeMatchSignaturesService.viderSignaturesReservesBase(function(){
                            Engine.addView("#popupLogin", "popups.html:popupLogin", {
                                equipe : controller.options.equipes[idEquipe],
                                data : {
                                    coteEquipe : coteEquipe,
                                    signatures : "-club",
                                    motDePasseOublie : mdpRencontrePresent,
                                    cl_no: cl_no
                                },
                                superieure : false
                            }, true);
                            if (Utils.isNotNull(cl_no) && mdpRencontrePresent) {
                                $("#popupLogin").css("height", "355px");
                            }
                            Engine.popup("#popupLogin");
                        });
                    }, false, "250px", null, null, { confirmKO: Lang.feuilleDeMatch.boutonConfirmKO, confirmOK: Lang.feuilleDeMatch.boutonConfirmOK });
                }
                else {
                    Engine.addView("#popupLogin", "popups.html:popupLogin", {
                        equipe : controller.options.equipes[idEquipe],
                        data : {
                            coteEquipe : coteEquipe,
                            signatures : "-club",
                            motDePasseOublie : mdpRencontrePresent,
                            cl_no: cl_no
                        },
                        superieure : false
                    }, true);
                    if (Utils.isNotNull(cl_no) && mdpRencontrePresent) {
                        $("#popupLogin").css("height", "355px");
                    }
                    Engine.popup("#popupLogin");
                }
            }
        });

    },
    "{name} #valider-connexion-club {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var idEquipe = element.attr("data-id");
            var coteEquipe = element.attr("data-equipe");
            var typeEquipe = coteEquipe=="recevante"?"EquipeRecevante":"EquipeVisiteur";
            
            FeuilleDeMatchConnexionService.validerConnexionRencontre(typeEquipe, function (cl_no, data) {
                controller.setConnectionStatus(idEquipe, FeuilleDeMatchDto, "CONNECTED");
                var eq_no = coteEquipe=="recevante"?controller.options.cr_eq_no:controller.options.cv_eq_no;
                if(Utils.isNull(ConnexionDto.users[parseInt(idEquipe, 10)])) {
                    FeuilleDeMatchService.enregistrerContexte(data[0], controller.options.ma_no, eq_no);
                }
                
                controller.options.equipes[idEquipe].valide = false;
                controller.options.equipes[idEquipe].masque = false;
                
                controller.invaliderCompostion(idEquipe, function() {
                    controller.afficherComposValides(function(){
                        FeuilleDeMatchDto.data.crCompValides = FeuilleDeMatchDto.data.cr_co_valid === 'O';
                        FeuilleDeMatchDto.data.cvCompValides = FeuilleDeMatchDto.data.cv_co_valid === 'O';
                        
                        FeuilleDeMatchConnexionService.afficherBoutonsBas(); 
                        
                        var dataEjs = {
                            match : {
                                infosMatch : {
                                    cv_co_valid : FeuilleDeMatchDto.data.cv_co_valid,
                                    cr_co_valid : FeuilleDeMatchDto.data.cr_co_valid
                                },
                                cv_cl_blason : MatchDto.match.cv_cl_blason,
                                cr_cl_blason : MatchDto.match.cr_cl_blason,
                                cv_cl_no : MatchDto.match.cv_cl_no,
                                cr_cl_no : MatchDto.match.cr_cl_no,
                            },
                            equipe : controller.options.equipes[idEquipe]
                        };
                        controller.afficherCompo(dataEjs);
                    });
                    Engine.fermerPopup();
                });
            });
        });
    },
    "{name} #valider-connexion {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var idEquipe = element.attr("data-id");
            var coteEquipe = element.attr("data-equipe");

            var login = $("#login").val();
            var password = $("#mdp").val();
            
            var typeEquipe = coteEquipe=="recevante"?"EquipeRecevante":"EquipeVisiteur";

            FeuilleDeMatchConnexionService.validerConnexionClub(login, password, typeEquipe, function(cl_no, data) {
                FeuilleDeMatchConnexionService.majInfosConnexionRencontre(idEquipe, function () {
                    controller.setConnectionStatus(idEquipe, FeuilleDeMatchDto, "CONNECTED");
                    var eq_no = coteEquipe=="recevante"?controller.options.cr_eq_no:controller.options.cv_eq_no;
                    if(Utils.isNull(ConnexionDto.users[parseInt(idEquipe, 10)])) {
                        FeuilleDeMatchService.enregistrerContexte(data[0], controller.options.ma_no, eq_no);
                    }
                    
                    var dataEjs = {
                        match : {
                            infosMatch : {
                                cv_co_valid : FeuilleDeMatchDto.data.cv_co_valid,
                                cr_co_valid : FeuilleDeMatchDto.data.cr_co_valid
                            },
                            cv_cl_blason : MatchDto.match.cv_cl_blason,
                            cr_cl_blason : MatchDto.match.cr_cl_blason,
                            cv_cl_no : MatchDto.match.cv_cl_no,
                            cr_cl_no : MatchDto.match.cr_cl_no,
                        },
                        equipe : controller.options.equipes[idEquipe]
                    };
                    controller.afficherCompo(dataEjs);
                    Engine.fermerPopup();
                });
            }, function () {
                controller.setConnectionStatus(idEquipe, FeuilleDeMatchDto, null);
            });
        });
    },
    "{name} .actionPreparer {click}" : function(element, event) {
        SanctionDto.fromPreparer = true;

        var idEquipe = element.attr("id");
        var coteEquipe = element.parent().attr("data-equipe");

        var visiteur = (coteEquipe == "recevante") ? false : true;
        var data = {
            cr_cl_no: FeuilleDeMatchDto.datasMatch.cr_cl_no,
            cv_cl_no: FeuilleDeMatchDto.datasMatch.cv_cl_no,
            ma_no : MatchDto.match.ma_no,
            ma_dat : MatchDto.match.ma_dat,
            lc_cod : MatchDto.match.lc_cod,
            li_no : MatchDto.match.li_no,
            cl_nb_maxi_eqp_typ : visiteur ? MatchDto.match.cv_cl_nb_maxi_eqp_typ : MatchDto.match.cr_cl_nb_maxi_eqp_typ,
            cl_eq_cod : visiteur ? MatchDto.match.cv_eq_cod : MatchDto.match.cr_eq_cod,
            sa_no : MatchDto.match.sa_no,
            cfm_no : MatchDto.match.cfm_no,
            cfm_statut : MatchDto.match.cfm_statut,
            ph_tactiq : MatchDto.match.ph_tactiq,
            ph_nb_jou_banc : MatchDto.match.ph_nb_jou_banc,
            ph_nbmaxi_mut : MatchDto.match.ph_nbmaxi_mut,
            ph_nb_maxi_etrg : MatchDto.match.ph_nb_maxi_etrg,
            ph_nb_titul_mini : MatchDto.match.ph_nb_titul_mini,
            ph_nb_titul : MatchDto.match.ph_nb_titul,
            ph_num_maillot : MatchDto.match.ph_num_maillot,
            ph_nb_med_banc : MatchDto.match.ph_nb_med_banc,
            ph_nb_dir_banc : MatchDto.match.ph_nb_dir_banc,
            ph_nb_edu_banc : MatchDto.match.ph_nb_edu_banc,
            ph_nb_staff_banc : MatchDto.match.ph_nb_staff_banc
        };
        
        Engine.headerController.headerDatas.visiteur = visiteur;
        if(AccueilDto.isDemonstration) {
            Engine.gotoPage("equipe.html", {
                match : data,
                utilisateur : AccueilService.preparerContexte(data.cl_eq_cod)
            });
        } else {
            Engine.gotoPage("equipe.html", {
                match : data,
                utilisateur : ConnexionDto.users[parseInt(idEquipe, 10)]
            });
        }
    },

    "{name} .caseJoueurs {click}" : function(element, event) {
         Engine.delegate(this, element, event, function(controller, element, event) {
            var index = element.attr("attr-ordre") - 1;
            var equipe = element.attr("attr-equipe");
            FeuilleDeMatchControlesService.changerLicence(index, equipe);
         });
    },

    "{name} #popup-gen .croixFermeturePopup2 {click}" : function(element, event) {
        Engine.confirm(Lang.feuilleDeMatch.alerteFermeturePopupInfosMatch, function(){
            Engine.fermerPopup();
        }, true, 250);
    },
    "{name} #infoMatch {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            // RG : Dès que l'arbitre a saisie un mot de passe, l'accès aux infos arbitres doit être sécurisé 
            if (Utils.isNotBlank(FeuilleDeMatchDto.data.cfm_mdp) && FeuilleDeMatchDto.data.cfm_mdp.length > 0) {
                Engine.addView("#popupLogin", "popups.html:popupLoginArbitre", {data : {}, infosArbitre: true}, true);
                Engine.popup("#popupLogin");
            } else {
                FeuilleDeMatchInfosMatchService.openInfosArbitre();
            }
        });
    },
    "{name} #controles_apresValider {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if(FeuilleDeMatchDto.data.crCompValides && FeuilleDeMatchDto.data.cvCompValides) {
                FeuilleDeMatchControlesService.afficherTrombinoscope();
            } else {
                Engine.alert(Lang.feuilleDeMatch.alerteBoutonControlesManqueEquipe, "240px");
            }
        });
    },

    "{name} .boutonsSwitchEquipe .trombinoscopeSwitchEquipe {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            FeuilleDeMatchControlesService.switchEquipeTrombinoscope(element.attr("id"));
        });
    },

    "{name} #controles_avantValider {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if(FeuilleDeMatchDto.data.crCompValides && FeuilleDeMatchDto.data.cvCompValides) {
                FeuilleDeMatchControlesService.controleLicence_avantSignature(0,"equipeRecevante");
            } else {
                Engine.alert(Lang.feuilleDeMatch.alerteBoutonControlesManqueEquipe, "240px");
            }
        });
    },

    "{name} .flecheGauche {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var index = parseInt($("#licence [name='position']").val()) - 1;
            var equipe = $("#licence [name='equipe']").val();
            FeuilleDeMatchControlesService.changerLicence_avantSignature(index, equipe);
        });
    },
    "{name} .flecheDroite {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var index = parseInt($("#licence [name='position']").val()) + 1;
            var equipe = $("#licence [name='equipe']").val();
            FeuilleDeMatchControlesService.changerLicence_avantSignature(index, equipe);
        });
    },

    "{name} .boutonsSwitchEquipe .conteneurBoutonsEquipe {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            FeuilleDeMatchControlesService.changerLicence_avantSignature(0, element.attr("id"));
        });
    },
 
    "{name} #reserves {click}" : function(element, event) {
        Engine.gotoPage("reserves.html");
    },
    "{name} #signatures {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            // affichage de la popup de confirmation des signatures si les deux compos ne sont pas validées
            if(FeuilleDeMatchDto.data.crCompValides && FeuilleDeMatchDto.data.cvCompValides) {
                controller.afficherSignatureAvantMatch();
            } else {
                Engine.confirm(Lang.feuilleDeMatch.alerteBoutonFaitsDeMatchManqueEquipe, function(){
                    controller.afficherSignatureAvantMatch();
                }, false, "250px", null, null, { confirmKO: Lang.feuilleDeMatch.boutonConfirmKO, confirmOK: Lang.feuilleDeMatch.boutonConfirmOK });
            }
        });
    },
    "{name} .connexionSignature {click}" : function(element, event) {
        if(!element.hasClass("disabled_button")) {
            var typeEquipe = element.attr("id") === "connexionEquipeRecevante" ? "EquipeRecevante" : "EquipeVisiteur";
            FeuilleDeMatchConnexionService.afficherPopupClubConnexion(typeEquipe, false, function () {
                Engine.bindSignature("#blocSignature" + typeEquipe, 273, 265);
            });
        }
    },
    "{name} #valider-connexion-signatures {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var typeEquipe = element.attr("data-id") == "connexionEquipeRecevante" ? "EquipeRecevante" : "EquipeVisiteur";
            FeuilleDeMatchConnexionService.validerConnexionClubSignature(typeEquipe, function () {
                //On bind la signature
                Engine.bindSignature("#blocSignature" + typeEquipe, 273, 265);
                Engine.fermerPopup(true);
            });
        });
    },
    "{name} .signerArbitre {click}" : function(element, event) {
        FeuilleDeMatchSignaturesService.viderSignaturesBase("Arbitre", "avm", function() {
            Engine.addView("#signatureArbitre", "popups.html:boutonsValidationSignature", {
                equipe : "Arbitre",
                clNoUser : ""
            }, true);
            //On bind la signature
            Engine.bindSignature("#blocSignatureArbitre", 273, 265);
        });
    },
    "{name} .validerSignatures {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            $("#errorValidation").html("");
            var signature = element.attr("data-id");
            var connaissance = $("#validerConnaissance"+signature)[0].checked;
            var signataire = null;
            var clNoUser = element.attr("data-clNoUser");

            //Si ce n'est pas l'arbitre qui signe, on récupère le signataire
            if (signature != "Arbitre" && signature != "ArbitreAssistant") {
                signataire = $("#choixSignataire" + signature + " option:selected").val();
            } else {
                signataire = "Arbitre";
            }

            if (connaissance == false) {
                $("#errorValidation").html(Lang.feuilleDeMatch.erreurs.signatures.connaissance);
            } else if (!Utils.isNotBlank(signataire)) {
                $("#errorValidation").html(Lang.feuilleDeMatch.erreurs.signatures.signataire);
            } else if (Utils.isSignatureEmpty("#blocSignature" + signature)) {
                $("#errorValidation").html(Lang.feuilleDeMatch.erreurs.signatures.signatureVide);
            } else {
                $("#errorValidation").html("");
                //on enregistre la signature
                var imageSignature = Engine.getSignature("#blocSignature" + signature);
                FeuilleDeMatchSignaturesService.enregistrerSignatures(FeuilleDeMatchDto.data.cfm_no, clNoUser, imageSignature, signature, signataire, "avm", true);
            }
        });
    },
    "{name} .absenceEquipeCheckbox {change}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            controller.toggleEquipeAbsenteSignature(element.attr("data-id"), element[0].checked);
        });
    },
    "{name} #partLogo {click}" : function(element, event) {
        if(Environnement.debug) {
            Engine.delegate(this, element, event, function(controller, element, event) {
                var data = {
                    ma_no : controller.options.ma_no,
                    cv_eq_no : controller.options.cv_eq_no,
                    cr_eq_no : controller.options.cr_eq_no,
                    cfm_no : controller.options.cfm_no,
                    ph_duree_periode : controller.options.ph_duree_periode,
                    ph_duree_prol : controller.options.ph_duree_prol,
                    ph_nb_titul_mini : controller.options.ph_nb_titul_mini,
                    ph_tps_sup : controller.options.ph_tps_sup,
                    ph_prol : controller.options.ph_prol,
                    ph_tir_but : controller.options.ph_tir_but,
                    cr_cl_no : controller.options.cr_cl_no,
                    cv_cl_no : controller.options.cv_cl_no,
                    visiteur : controller.options.visiteur,
                    ph_tactiq : MatchDto.match.ph_tactiq,
                    ph_num_maillot : MatchDto.match.ph_tactiq,
                    ph_reglt_locaux : MatchDto.match.ph_reglt_locaux,
                    ph_info_but : MatchDto.match.ph_info_but,
                    ph_info_secu : MatchDto.match.ph_info_secu,
                    ph_info_orga : MatchDto.match.ph_info_orga,
                    ph_carton_blanc : MatchDto.match.ph_carton_blanc,
                    ph_carton_vert : MatchDto.match.ph_carton_vert
                };
                Engine.gotoPage("faitsDeMatch.html", {
                    match : data
                });
            });
        }
    },
    "{name} #faitsDeMatch {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var data = {
                ma_no : controller.options.ma_no,
                cv_eq_no : controller.options.cv_eq_no,
                cr_eq_no : controller.options.cr_eq_no,
                cfm_no : controller.options.cfm_no,
                ph_duree_periode : controller.options.ph_duree_periode,
                ph_duree_prol : controller.options.ph_duree_prol,
                ph_nb_titul_mini : controller.options.ph_nb_titul_mini,
                ph_tps_sup : controller.options.ph_tps_sup,
                ph_prol : controller.options.ph_prol,
                ph_tir_but : controller.options.ph_tir_but,
                cr_cl_no : controller.options.cr_cl_no,
                cv_cl_no : controller.options.cv_cl_no,
                visiteur : controller.options.visiteur,
                ph_tactiq : MatchDto.match.ph_tactiq,
                ph_num_maillot : MatchDto.match.ph_tactiq,
                ph_reglt_locaux : MatchDto.match.ph_reglt_locaux,
                ph_info_but : MatchDto.match.ph_info_but,
                ph_info_secu : MatchDto.match.ph_info_secu,
                ph_info_orga : MatchDto.match.ph_info_orga,
                ph_carton_blanc : MatchDto.match.ph_carton_blanc,
                ph_carton_vert : MatchDto.match.ph_carton_vert
            };
            
            FeuilleDeMatchDto.data.fdmValidee = true;
            Engine.gotoPage("faitsDeMatch.html", {
                match : data
            });
        });
    },
    "{name} #composition {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            DataBase.findBy("MATCH_FEUILLE_MEMBRE", "cfm_noAndmmf_typAndpo_cod", [FeuilleDeMatchDto.data.cfm_no, "A", "AC"], function(data) {
                var dataEjs = {
                    match : {
                        infosMatch : {
                            cv_co_valid : FeuilleDeMatchDto.data.cv_co_valid,
                            cr_co_valid : FeuilleDeMatchDto.data.cr_co_valid
                        },
                        cv_cl_blason : MatchDto.match.cv_cl_blason,
                        cr_cl_blason : MatchDto.match.cr_cl_blason,
                        cv_cl_no : MatchDto.match.cv_cl_no,
                        cr_cl_no : MatchDto.match.cr_cl_no,
                    },
                    equipeRecevante : controller.options.equipes[FeuilleDeMatchDto.datasMatch.cr_cl_no],
                    equipeVisiteur  : controller.options.equipes[FeuilleDeMatchDto.datasMatch.cv_cl_no],
                    arbitre: data.length > 0 ? data[0] : null
                };
                Engine.addView("#compositions", "popups.html:popupCompositions", {
                    data : dataEjs,
                }, true);
                Engine.popup("#compositions");
            });  
        });
    },
    "{name} #selectOfficielType {change}" : function(element, event) {
        var selectedType = element.val();
        FeuilleDeMatchInfosMatchService.creerSelectOfficielStatut(selectedType, function () {
            Engine.selectCreate($("#selectOfficielStatut"), { minimumResultsForSearch : -1, width: '256px' });
        });
        FeuilleDeMatchInfosMatchService.creerSelectOfficielFonction(selectedType, function () {
            Engine.selectCreate($("#selectOfficielFonction"), { minimumResultsForSearch : -1, width: '256px' });
        });
    },
    "{name} #ajouter {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var data = {
                mmf_no : null,
                ma_no : FeuilleDeMatchDto.datasMatch.ma_no,
                cfm_no : FeuilleDeMatchDto.data.cfm_no,
                mm_no : null,
                po_cod : $("#selectOfficielFonction option:selected").val(),
                po_lib : $("#selectOfficielFonction option:selected").html(),
                mmf_typ : $("#selectOfficielType option:selected").val(),
                // type de pièce d'identiification utilisé : Licence, CNI, Passeport, Autre
                mmf_typ_piece : $("#selectOfficielIdtype option:selected").val(),
                mmf_statut : $("#selectOfficielStatut option:selected").val(),
                mmf_pres : null,
                mmf_in_no : $("#numLicence").val(),
                mmf_in_nom : $("#nomInfo").val(),
                mmf_in_prenom : $("#prenomInfo").val(),
                nbArbitre : $('#popup-gen #blocListOfficiels .A').length,
                nbDelegue : $('#popup-gen #blocListOfficiels .D').length,
                nbArbitreCentre : $('#popup-gen #blocListOfficiels .AC').length,
                nbArbitreAssistant1 : $('#popup-gen #blocListOfficiels .A1').length,
                nbArbitreAssistant2 : $('#popup-gen #blocListOfficiels .A2').length,
            };
            FeuilleDeMatchInfosMatchService.ajoutOfficielBenevole(data);
        });
    },
    
    "{name} #enregistre {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var data =  {
                cfm_te_loca : $("#lieuInfo").val(),
                cfm_te_nom : $("#terrainInfo").val(),
                cfm_med : $("#medecinInfo").val(),
                cfm_tech_lum : $("#technicienLumiereInfo").val(),
                cfm_direc_secu : $("#directeurSecuriteInfo").val(),
                date: $("#dateInfo").val(), 
                heure: Utils.isNotBlank($("#heureInfo").val())
                    || Utils.isNotBlank($("#minuteInfo").val()) ? [$("#heureInfo").val(), $("#minuteInfo").val()].join("h") : ""
            };
            FeuilleDeMatchInfosMatchService.enregistreInfosArbitres(data);
        });
    },

    "{name} #valider {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var data = {
                cfm_te_loca : $("#lieuInfo").val(),
                cfm_te_nom : $("#terrainInfo").val(),
                cfm_med : $("#medecinInfo").val(),
                cfm_tech_lum : $("#technicienLumiereInfo").val(),
                cfm_direc_secu : $("#directeurSecuriteInfo").val(),
                cfm_mdp : $("#motDePasseInputArbitre").val(),
                cfm_mdpC : $("#motDePasseInputArbitreC").val(),
                lc_cod : MatchDto.match.lc_cod,
                tl_cod: MatchDto.match.tl_cod,
                date: $("#dateInfo").val(), 
                heure: Utils.isNotBlank($("#heureInfo").val()) 
                    || Utils.isNotBlank($("#minuteInfo").val()) ? [$("#heureInfo").val(), $("#minuteInfo").val()].join("h") : ""
            };
            FeuilleDeMatchInfosMatchService.majInfosMatch(data, function() {
                Engine.fermerPopup();
                FeuilleDeMatchDto.data.infosValides = true;
                FeuilleDeMatchDto.data.cfm_infos_valid = "O";
                FeuilleDeMatchConnexionService.afficherBoutonsBas();
                $("#infoMatch").removeClass("infos_match_invalides");
                $("#infoMatch").addClass("infos_match_valides");
            });
            FeuilleDeMatchInfosMatchService.majHeaderDates([data.date, data.heure].join(" à "));
        });
    },
    "{name} .suppressionOfficiel {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            Engine.confirm(Lang.feuilleDeMatch.popupConfirm, function() {
                Engine.fermerPopup(true);
                FeuilleDeMatchInfosMatchService.supprimerOfficiel(element);
            }, true, 250, false);
        }, 1000);
    },
    "{name} #dev-connexion {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if (Project.debug) {
                $("#login").val(Project.loginDebug);
                $("#mdp").val(Project.mdpDebug);
            }
        });
    },
    "{name} #validerSignaturesGenerale {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            FeuilleDeMatchSignaturesService.verificationSignature(FeuilleDeMatchDto.data.cfm_no, "avm", function() {
                FeuilleDeMatchSignaturesService.enregistrerEquipeAbsentes(FeuilleDeMatchDto.data.cfm_no, "avm", function(datas) {
                    DataBase.updateJson("MATCH_FEUILLE", FeuilleDeMatchDto.data.id, datas, function() {
                        //
                        // FEV 13 EVO 5 - FMH
                        // Mise à jour de l'état du match à "en cours" à la confirmation des signatures d'avant match
                        //
                        FeuilleDeMatchService.changerStatut(FeuilleDeMatchDto.data.cfm_no, 3, function() {
                            controller.afficherCompositions();
                            FeuilleDeMatchConnexionService.afficherBoutonsBas();
                            if(!AccueilDto.isDemonstration) {
                                Engine.headerController.showSynchroButton();
                            }
                            
                            Engine.fermerPopup();
                        });
                    });
                });
            });
        });
    },
    "{name} #deverouiller {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            Engine.confirm(Lang.feuilleDeMatch.alerteDeverrouillage, function(){
                Engine.fermerPopup();
                Engine.addView("#popupLogin", "popups.html:popupLoginArbitre", {data : {},verrou:true}, true);
                Engine.popup("#popupLogin");
            }, false, "240px", false);
        });
    },
    "{name} #accueil-connexion-arbitre {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            $("#popupLogin").removeClass("dont-close");
            Engine.gotoPage("accueil.html");
        });
    },
    "{name} #valider-connexion-arbitre {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var popupVerrou = Utils.isNotNull(element.attr("data-verrou"));
            var popupInfosArbitre = Utils.isNotNull(element.attr("data-infos-arbitre"));
            var logFeuillDeMatch = Utils.isNotNull(element.attr("data-log"));
            var cfm_no = controller.options.cfm_no;
            var datas = {};

            //Vérification du mot de passe saisi
            var password = $("#mdp").val();
            if (password === "") {
                $("#errorConnexion").html(Lang.connexion.mdpVide);
                return;
            }

            //recherche de l'id en base de la feuille match à mettre à jour
            DataBase.findBy("MATCH_FEUILLE", "cfm_noAndcfm_mdp", [cfm_no, password], function(data) {
                if (data.length === 0) {
                    // error
                    $("#errorConnexion").html(Lang.connexion.connexionImpossible);
                } else if (logFeuillDeMatch) {
                    $("#popupLogin").removeClass("dont-close");
                    Engine.fermerPopup();
                } else if(popupVerrou){
                     $("#popupLogin").removeClass("dont-close");
                    Engine.headerController.disableSynchroButton();
                    Engine.fermerPopup();
                    FeuilleDeMatchSignaturesService.viderSignatures(controller.options.cfm_no, "avm", function() {
                        FeuilleDeMatchDto.data.signaturesValides = false;
                        FeuilleDeMatchDto.data.fdmValidee = false;
                        FeuilleDeMatchConnexionService.afficherBoutonsBas();
                        //on met à jour le champ de verrouillage
                        FeuilleDeMatchDto.data.verrouillage = false;
                        //on cache infos match
                        $("#infoMatch").show();
                        FeuilleDeMatchService.incrementerDeverrouillage(controller.options.cfm_no, "avm", function() {
                            // Revenir au status non joué / préparé
                            FeuilleDeMatchService.changerStatut(controller.options.cfm_no, 2, function() {
                                DataBase.update("MATCH_FEUILLE", data[0].id, "cfm_verrou", "N", function() {
                                    SynchronisationTransfertService.saveHistoFeuilleDeMatch(controller.options.cfm_no, function(data) {
                                        controller.afficherCompositions();
                                    });
                                });
                            });
                        });
                    });
                } else if (popupInfosArbitre) {
                    $("#popupLogin").removeClass("dont-close");
                    Engine.fermerPopup();
                    FeuilleDeMatchInfosMatchService.openInfosArbitre();
                }
            });
        });
    },
/*    "{name} #lienMotDePasseOublie {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            FeuilleDeMatchConnexionService.afficherPopupMotDePasseRencontreOublie(element.data("cl-no"));
        });
    },*/
    "{name} #validerMotDePasseOublie {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            $("#popupLogin").removeClass("dont-close");
            var questionSecurite = Engine.selectGetVal($("#questionSecurite"));
            var reponseSecurite = $("#reponseSecurite").val();
            var nouveauMotDePasse = $("#nouveauMotDePasse").val();
            var cl_no = element.data("cl-no");
            
            FeuilleDeMatchService.majMotDePasseOublie(cl_no, questionSecurite, reponseSecurite, nouveauMotDePasse, function () {
                Engine.fermerPopup(true);
            });
        });
    },

    "{name} #infosArbitre_icon {click}" : function(element, event) {
        if (Project.debug) {
             var data1 = {
                mmf_no : null,
                ma_no : FeuilleDeMatchDto.datasMatch.ma_no,
                cfm_no : FeuilleDeMatchDto.data.cfm_no,
                mm_no : null,
                po_cod : "AC",
                po_lib : "Arbitre centre",
                mmf_typ : "A",
                mmf_statut : "B",
                mmf_pres : null,
                mmf_typ_piece : "IN",
                mmf_in_no : Lang.feuilleDeMatch.remplirAutoInfosArbitre.no_licence1,
                mmf_in_nom : Lang.feuilleDeMatch.remplirAutoInfosArbitre.nom,
                mmf_in_prenom : Lang.feuilleDeMatch.remplirAutoInfosArbitre.prenom,
                nbArbitre : $('#popup-gen #blocListOfficiels .A').length,
                nbDelegue : $('#popup-gen #blocListOfficiels .D').length,
                nbArbitreCentre : $('#popup-gen #blocListOfficiels .AC').length,
                nbArbitreAssistant1 : $('#popup-gen #blocListOfficiels .A1').length,
                nbArbitreAssistant2 : $('#popup-gen #blocListOfficiels .A2').length
            };
            FeuilleDeMatchInfosMatchService.ajoutOfficielBenevole(data1);
            var data2 = data1;
            data2.po_cod = "A1";
            data2.po_lib = "Arbitre assistant 1";
            data2.mmf_in_no = Lang.feuilleDeMatch.remplirAutoInfosArbitre.no_licence2; 
            FeuilleDeMatchInfosMatchService.ajoutOfficielBenevole(data2);
            var data3 = data1;
            data3.po_cod = "A2";
            data3.po_lib = "Arbitre assistant 2";
            data3.mmf_in_no = Lang.feuilleDeMatch.remplirAutoInfosArbitre.no_licence3;
            FeuilleDeMatchInfosMatchService.ajoutOfficielBenevole(data3);
        }
    },

    "{document} #tableCellImage, #tableCellNomPrenom, #tableCellLicenceDate {click}": function (element, event) {
        Engine.delegate(this, element, event, function(controller) {
            Engine.fermerPopup(true);
            $("#numLicence").val(element.parent().attr("id"));
            $("#nomInfo").val(element.parent().children(".tableCellNomPrenom").children(".in_nom").text());
            $("#prenomInfo").val(element.parent().children(".tableCellNomPrenom").children(".in_prenom").text());
            $("#selectOfficielIdtype").val("IN");
        })
    },

    "{name} #rechercherLicencie {click}": function (element, event) {
        Engine.delegate(this, element, event, function(controller) {
            $("#errorValidation").html("");
            var OfName = $("#nomInfo").val();
            if (OfName.length > 2){
                Engine.message("Recherche d'une correspondance", true);
                FeuilleDeMatchService.rechercheOfficielBenevole(OfName);
            }
            else {
                $("#errorValidation").html(Lang.feuilleDeMatch.erreurs.infosMatch.rechercheLicence);
            }
        });
    },
});
