var FeuilleDeMatchService = {
    
    trierJoueursParNumero: function(data) {
        var titulaires = [], remplacants = [], staff = [];

        // Répartition des licenciés selon leur rôle
        for (var i in data) {
            var licencier = data[i];
            if (licencier.infosCompo.cfi_role == 'T') {
                titulaires.push(Utils.cloneObject(licencier));
            } else if (licencier.infosCompo.cfi_role == 'R') {
                remplacants.push(Utils.cloneObject(licencier));
            } else {
                staff.push(Utils.cloneObject(licencier));
            }
        }
        
        function valueCmp(x, y) {
            return x > y ? 1 : x < y ? -1 : 0;
        }
        
        // Trie des titulaires et des remplacants par numéro de maillot
        function cmpByMaillot(a,b){
            var maillotA = parseInt(a.infosCompo.cfi_maillot, 10);
            var maillotB = parseInt(b.infosCompo.cfi_maillot, 10);
            return valueCmp(maillotA, maillotB);
        };
        
        function cmpByRole(a,b){
            return valueCmp(a.infosCompo.cfi_role, b.infosCompo.cfi_role);
        };
        
        titulaires.sort(cmpByMaillot);
        remplacants.sort(cmpByMaillot);
        
        // Trie du staff par role
        staff.sort(cmpByRole);
        
        return titulaires.concat(remplacants).concat(staff);
    },
    //récupérer une composition avec un numéro de match et un numéro de club
    getComposition: function(matchId, clubId, callback){
      DataBase.findBy("MATCH_FEUILLE_COMPO","ma_noAndcfi_cl_no", [matchId, clubId],callback);
    },
    getLicence: function(liNoToParse, dataReturn, compos, callback) {
        if (Engine.dbActif) {
            if (liNoToParse.length === 0) {
                var resultArray = [];            
                //merge joueur infos with compo infos
                for(var i = 0; i < compos.length; i++) {
                    var indiceFind = null;
                    for (var j in dataReturn) {
                        if (compos[i].li_no === dataReturn[j].li_no) {
                            indiceFind = j;
                        }
                    }
                    if (indiceFind !== null) {
                        // Joueur du SI
                        resultArray.push({infosJoueur: dataReturn[indiceFind], infosCompo: compos[i]});
                    } else {
                        // Joueur temporaire
                        var infosJoueur = {
                            li_no: Utils.isNotBlank(compos[i].li_no) ? compos[i].li_no : null,
                            in_no: compos[i].in_no, 
                            in_nom: compos[i].in_nom, 
                            in_prenom: compos[i].in_prenom, 
                            in_dat_nais: compos[i].in_dat_nais, 
                            cl_no: compos[i].cl_no
                        };
                        if (Utils.isNotNull(infosJoueur.in_no) && Utils.isNotNull(infosJoueur.in_nom) && Utils.isNotNull(infosJoueur.in_prenom) && Utils.isNotNull(infosJoueur.in_dat_nais)){
                            resultArray.push({infosJoueur: infosJoueur, infosCompo: compos[i]});
                        }
                    }
                }
                callback(resultArray);
            } else {
                var recherche = liNoToParse[0];
                liNoToParse.shift();
                DataBase.findBy("CLUB_LICENCE", "li_no", recherche, function(data) {
                    if (data.length > 0) {
                        dataReturn.push(data[0]);
                    }
                    FeuilleDeMatchService.getLicence(liNoToParse, dataReturn, compos, callback);
                });
            }
        } else {
            DataBase.findBy("CLUB_LICENCE", "", FeuilleDeMatchDto.data.ma_no, function(data) {
                FeuilleDeMatchService.getLicenceWeb(data, dataReturn, compos, callback);
            });
        }
    },
    getLicenceWeb: function(club_licences, dataReturn, compos, callback) {
        var cloneLicences = {};
        
        for (var i in club_licences) {
            cloneLicences[club_licences[i].li_no] = club_licences[i];
        }

        var resultArray = [];    
        for (var i in compos) {
            if (Utils.isNotBlank(compos[i].li_no) && compos[i].li_no !== "null") {
                var infosJoueur = cloneLicences[compos[i].li_no];
            } else {
                var infosJoueur = {
                    li_no: null,
                    in_no: compos[i].in_no, 
                    in_nom: compos[i].in_nom, 
                    in_prenom: compos[i].in_prenom, 
                    in_dat_nais: compos[i].in_dat_nais, 
                    cl_no: compos[i].cl_no
                };
            }
            resultArray.push({infosJoueur: infosJoueur, infosCompo: compos[i]});
        }
        callback(resultArray);
    },
    getJoueursFromCompo: function(matchId, clubId, callback) {
        FeuilleDeMatchService.getComposition(matchId, clubId, function(compos) {
            var liNoToParse = [];
            for (var i in compos) {
                liNoToParse.push(compos[i].li_no);
            }
            FeuilleDeMatchService.getLicence(Utils.cloneObject(liNoToParse), [], compos, callback);
        });
    },    
    validerComposition: function(matchId, clubId ,callback){        
        var match = null;
        var composition = null;               
        //smal pyramid of doom
        DataBase.findById("MATCH", matchId, function(resultMatch) {
            match = resultMatch;
            FeuilleDeMatchService.getComposition(matchId, clubId, function(compo) {
                composition = compo;
                DataBase.findBy("MATCH_FEUILLE", "ma_noAndcl_no", [matchId, clubId], function(feuillesDeMatch) {
                    var feuilleDeMatch = null;
                    if (feuillesDeMatch && Array.isArray(feuillesDeMatch) && feuillesDeMatch.length > 0) {
                        feuilleDeMatch = feuillesDeMatch[0];
                    }
                    callback(FeuilleDeMatchService.validerCompo(match, feuilleDeMatch, compo));
                });
            });
        }); 

    },
    verifErreursCompo: function(){
        
    },
    //vérification des règles de gestion pour la validation d'une composition de match
    validerCompo: function(match, feuilleDeMatch, compo){          
          var errors = [];      
          var minimumTituProperty = "ph_nb_titul_mini";
          var captainProperty = "cfi_capi";
          var numberProperty = "cfi_maillot";
          var roleProperty = "cfi_role";
          var tacticStatusProperty = "mph_tactiq";
          var tacticProperty = "tq_no";
          var roleTitulaire = "TITULAIRE";
          
          var numberArray = [];
              
          if(match && compo && feuilleDeMatch && Array.isArray(compo)){
              //récupération du nombre minium de titulaires
              var minimumTitu = match[minimumTituProperty];
              //récupération du statut tactique du match
              var tacticStatus = match[tacticStatusProperty];
              var nbTitu = 0;
              var captainValid = false;
              var playerNumberUniqueness = true;
              var duplicateNumber = 0;
              
              for(var i in compo){
                  var comp = compo[i];
                  //check number uniqueness
                    if(numberArray.indexOf(comp[numberProperty]) === -1){
                        numberArray.push(comp[numberProperty]);    
                    }else{
                        playerNumberUniqueness = false;
                        duplicateNumber = comp[numberProperty];
                    }
                    //check captain                        
                     if(compo[captainProperty]){
                         captainValid = true;                         
                     }                     
                     //check titulaire
                     if(comp[roleProperty] && comp[roleProperty].toUpperCase() === roleTitulaire){
                         nbTitu++;
                     }
              }            
                //pas de capitaine dans l'équipe
                if(!captainValid){                    
                    errors.push({
                       code: 1,
                       message: Lang.feuilleDeMatch.erreurs.erreurValidationPasCapitaine 
                    });
                }
                //numéro de maillot en double
                if(!playerNumberUniqueness){
                    errors.push({
                        code:2,
                        message: Lang.feuilleDeMatch.erreurs.erreurValidationDoublonMaillot,
                        details: duplicateNumber   
                    });
                }
                //pas assez de titulaires
                if(nbTitu < minimumTitu){
                    errors.push({
                        code:3,
                        message: Lang.feuilleDeMatch.erreurs.erreurValidationNombreTitulaire,
                        details: nbTitu + " < " + minimumTitu 
                    });
                }                
                //tactique indiquée obligatoire mais non renseignée
                if(tacticStatus && tacticStatus.toUpperCase() === 'O' && !feuilleDeMatch[tacticProperty]){
                    errors.push({
                        code:4,
                        message: Lang.feuilleDeMatch.erreurs.erreurValidationTactique   
                    });
                }
          } else{
              //pas de composition
              if(!compo){
                    errors.push({
                        code: 0,
                        message: Lang.feuilleDeMatch.erreurs.erreurValidationPasComposition 
                    });
              }
              //pas de feuille de match
              if(!feuilleDeMatch){
                  errors.push({
                        code: 0,
                        message: Lang.feuilleDeMatch.erreurs.erreurValidationPasFeuilleDeMatch
                    });
              }
          }
          return errors;          
    },
    
    /**
     * Initialise la feuille de match en base et dans le Dto
     */
    chargerFeuilleDeMatch: function(datasMatch, callback) {
        //création d'une feuille de match si elle n'existe pas
        if (Engine.dbActif) {
            DataBase.findBy("MATCH_FEUILLE", "cfm_no", datasMatch.cfm_no, function(data) {
                if(data.length == 0) {
                    DataBase.insert("MATCH_FEUILLE",{cfm_no : datasMatch.cfm_no, ma_no : datasMatch.ma_no}, function(){
                        DataBase.findBy("MATCH_FEUILLE", "cfm_no", datasMatch.cfm_no, function(data) {
                            FeuilleDeMatchDto.initValeursMatch(datasMatch, function(){
                                FeuilleDeMatchDto.init(data, function(){
                                    FeuilleDeMatchService.verifValidationSignatures(data[0], callback);
                                });
                            });
                        });
                    });
                } else {
                    FeuilleDeMatchDto.initValeursMatch(datasMatch, function(){
                        FeuilleDeMatchDto.init(data, function(){
                            FeuilleDeMatchService.verifValidationSignatures(data[0], callback);
                        });
                    });
                }
            });
        } else {
            DataBase.findBy("MATCH_FEUILLE", "ma_no", datasMatch.ma_no, function(data) {
                FeuilleDeMatchDto.initValeursMatch(datasMatch, function(){
                    FeuilleDeMatchDto.init(data, function(){
                        FeuilleDeMatchService.verifValidationSignatures(data, callback);
                    });
                });
            });
                    
        }
    },
    verifValidationSignatures: function(data, callback){
        FeuilleDeMatchDto.data.signaturesValides = false;
        FeuilleDeMatchDto.data.infosValides = false;
        FeuilleDeMatchDto.data.crCompValides = false;
        FeuilleDeMatchDto.data.cvCompValides = false;
        FeuilleDeMatchDto.data.verrouillage = false;
        
        if(Utils.isNotNull(data.cfm_infos_valid) && Utils.isNotBlank(data.cfm_infos_valid) && data.cfm_infos_valid == "O"){
            FeuilleDeMatchDto.data.infosValides = true;
        }
        if(Utils.isNotNull(data.cr_co_valid) && Utils.isNotBlank(data.cr_co_valid) && data.cr_co_valid == "O"){
            FeuilleDeMatchDto.data.crCompValides = true;
        }
        if(Utils.isNotNull(data.cv_co_valid) && Utils.isNotBlank(data.cv_co_valid) && data.cv_co_valid == "O"){
            FeuilleDeMatchDto.data.cvCompValides = true;
        }
        if(Utils.isNotNull(data.cfm_verrou) && Utils.isNotBlank(data.cfm_verrou) && data.cfm_verrou == "O"){
            FeuilleDeMatchDto.data.verrouillage = true;
        }
        
        if (((Utils.isNotNull(data.cfm_signat_avm_rec) && Utils.isNotBlank(data.cfm_signat_avm_rec)) || data.cr_forf == "O") 
        && ((Utils.isNotNull(data.cfm_signat_avm_vis) && Utils.isNotBlank(data.cfm_signat_avm_vis)) || data.cv_forf == "O") 
        && (Utils.isNotNull(data.cfm_signat_avm_arb) && Utils.isNotBlank(data.cfm_signat_avm_arb))) {
            FeuilleDeMatchDto.data.signaturesValides = true;
            callback();
        } else {
            callback();
        }
    },
    enregistrerContexte: function(data, ma_no, eq_no){
        DataBase.findBy("UTILISATEUR_EQUIPE", "usr_no", data.usr_no, function(utilisateursEquipe) {
            var lc_cod = null;
            for(i in utilisateursEquipe) {
                if(parseInt(utilisateursEquipe[i].eq_cod, 10) == parseInt(eq_no, 10)){
                    lc_cod = utilisateursEquipe[i].lc_cod;
                }
            }
            data.ma_no = ma_no;
            data.eq_no = eq_no;
            data.lc_cod = lc_cod;
            ConnexionDto.init(Utils.parseIntBooleansInArray(data));
        });
    },
    verifErreursComposition: function(equipe, erreurs, callback){
        var composition = [];
        for(i in equipe.joueurs){
            var infos = {};
            $.extend(infos, equipe.joueurs[i].infosCompo);
            $.extend(infos, equipe.joueurs[i].infosJoueur);
            composition.push(infos);
        }
        EquipeCompositionService.testErreurCompo(erreurs, composition, callback);
    },
    incrementerDeverrouillage: function(cfm_no, typeDeverrouillage, callback) {
        //recherche de l'id en base de la feuille match à mettre à jour
        DataBase.findBy("MATCH_FEUILLE", "cfm_no", cfm_no, function(data) {
            var datas = {};
            var cfm_nb_deverrouillages = 0;
            
            if(typeDeverrouillage == "avm") {
                if (Utils.isNotNull(data[0].cfm_nb_signat_avm) && Utils.isNotBlank(data[0].cfm_nb_signat_avm) && !isNaN(data[0].cfm_nb_signat_avm)) {
                    cfm_nb_deverrouillages = parseInt(data[0].cfm_nb_signat_avm, 10);
                }
            } else if(typeDeverrouillage == "fm") {
                if (Utils.isNotNull(data[0].cfm_nb_signat_fm) && Utils.isNotBlank(data[0].cfm_nb_signat_fm) && !isNaN(data[0].cfm_nb_signat_fm)) {
                    cfm_nb_deverrouillages = parseInt(data[0].cfm_nb_signat_fm, 10);
                }
            } else {
                return;
            }

            datas["cfm_nb_signat_" + typeDeverrouillage] = cfm_nb_deverrouillages+1;
            FeuilleDeMatchDto.data["cfm_nb_signat_" + typeDeverrouillage] = cfm_nb_deverrouillages+1;
            
            //enregistrement
            DataBase.updateJson("MATCH_FEUILLE", data[0].id, datas, function() {
                if(typeof callback === 'function'){
                    callback();
                }
            });
        });
    },
    changerStatut: function(cfm_no, statut, callback) {
        //recherche de l'id en base de la feuille match à mettre à jour
        DataBase.findBy("MATCH_FEUILLE", "cfm_no", cfm_no, function(data) {
            FeuilleDeMatchDto.data.cfm_statut = statut;
            
            //enregistrement feuille de match
            DataBase.updateJson("MATCH_FEUILLE", data[0].id, { cfm_statut: statut }, function() {
                MatchDto.match.cfm_statut = statut;
                
                //enregistrement match
                DataBase.updateJson("MATCH", MatchDto.match.id, { cfm_statut: statut }, function() {
                    if(typeof callback === 'function'){
                        callback();
                    }
                });
            });
        });
    },
    majMotDePasseOublie: function(cl_no, questionSecurite, reponseSecurite, nouveauMotDePasse, callback) {
        // Maj mot de passe de rencontre
        if (Utils.isNotBlank(cl_no)) {
            var data = {
                cfm_mdp: nouveauMotDePasse,
                cfm_question: questionSecurite,
                cfm_rep: reponseSecurite
            };
            FeuilleDeMatchConnexionService.verifierQuestionReponseSecurite(cl_no, questionSecurite, reponseSecurite, nouveauMotDePasse);
            if(Utils.isBlank($("#errorValidationPopupMotDePasseOublie").html())) {
                FeuilleDeMatchConnexionService.majMotDePasseEquipe(cl_no, data, callback);
            }
        // Maj mot de passe arbitre
        } else {
            var data = {
                cfm_mdp: nouveauMotDePasse,
                cfm_question: questionSecurite,
                cfm_rep: reponseSecurite
            };
            FeuilleDeMatchInfosMatchService.verifierQuestionReponseSecurite(questionSecurite, reponseSecurite, nouveauMotDePasse);
            if(Utils.isBlank($("#errorValidationPopupMotDePasseOublie").html())) {
                FeuilleDeMatchInfosMatchService.majMotDePasseArbitre(data, function(){
                    if(typeof callback === 'function'){
                        callback();
                    }
                });
            }
        }
    },
    rechercheOfficielBenevole: function(ofName) {
        DataBase.selectMatchDirigeant(MatchDto.match.cr_cl_no, MatchDto.match.cv_cl_no, function(result){
            var data = [];
            for (var i = 0; i < result.length; i++) {
                if (result[i].in_nom.indexOf(ofName.toUpperCase()) >= 0){
                    var oneLi = {
                        li_no : result[i].li_no,
                        in_no : result[i].in_no,
                        in_nom : result[i].in_nom,
                        in_prenom : result[i].in_prenom,
                        in_photo : result[i].in_photo,
                        in_dat_nais : result[i].in_dat_nais
                    };
                    data.push(oneLi);
                }
            }
            Engine.fermerPopup(true);
            Engine.addView("#popupRechercheArbitre", "popups.html:popupRechercheArbitre", {data : data}, true)
            Engine.popup("#popupRechercheArbitre", true);
            Engine.hideLoader();
        });
/*        DataBase.findBy("CLUB_LICENCE", "cl_no", MatchDto.match.cr_cl_no, function(result){
            var data = [];
            for (var i = 0; i < result.length; i++) {
                if (!(result[i].tl_cod === "LI") && (result[i].li_no.indexOf(inNo) >= 0)){
                    var oneLi = {
                        li_no : result[i].li_no,
                        in_no : result[i].in_no,
                        in_nom : result[i].in_nom,
                        in_prenom : result[i].in_prenom,
                        in_photo : result[i].in_photo,
                        in_dat_nais : result[i].in_dat_nais
                    };
                    data.push(oneLi);
                }
            }
            DataBase.findBy("CLUB_LICENCE", "cl_no", MatchDto.match.cv_cl_no, function(result){
                for (var i = 0; i < result.length; i++) {
                    if (!(result[i].tl_cod === "LI") && (result[i].li_no.indexOf(inNo) >= 0)){
                        var oneLi = {
                            li_no : result[i].li_no,
                            in_no : result[i].in_no,
                            in_nom : result[i].in_nom,
                            in_prenom : result[i].in_prenom,
                            in_photo : result[i].in_photo,
                            in_dat_nais : result[i].in_dat_nais
                        };
                        data.push(oneLi);
                    }
                }
                Engine.addView("#popupRechercheArbitre", "popups.html:popupRechercheArbitre", {data : data}, true)
                Engine.popup("#popupRechercheArbitre", true);
                Engine.hideLoader();
            });
        });*/
    }
};