var FeuilleDeMatchConnexionService = {
    validerConnexionClubSignature: function (typeEquipe, callback, isApresMatch) {
        FeuilleDeMatchConnexionService.validerConnexionRencontre(typeEquipe, function(cl_no) {
            FeuilleDeMatchSignaturesService.viderSignaturesBase(typeEquipe, $(".codeSignat").val(), function() {
                FeuilleDeMatchSignaturesService.findMatchSignataireTypes(cl_no, MatchDto.match.lc_cod, function (signataires) {
                    var script = "";
                    if (isApresMatch === true) {
                        script = "signatures.html:boutonsValidationSignature";
                    } else {
                        script = "popups.html:boutonsValidationSignature";
                    }
                    Engine.addView("#signature" + typeEquipe, script, {
                        equipe : typeEquipe,
                        clNoUser : cl_no
                    }, true);
                    Engine.addView("#signature" + typeEquipe + " #blocChoixSignataire", "feuilleDeMatch.html:signataireList", {
                        equipe : typeEquipe,
                        signataires : signataires
                    }, true);
                    if(typeof callback === 'function'){
                        callback();
                    }
                });
            });
        });
    },
    // Connexion par mot de passe de rencontre
    validerConnexionRencontre: function (typeEquipe, callback) {
        var password = $("#mdp").val().trim();
        if (password === "") {
            $("#errorConnexion").html(Lang.connexion.mdpVide);
        } else {
            var encryptedPassword = Utils.encryptSha1(password);
            var cl_no = null;
            if (typeEquipe == "EquipeRecevante") {
                cl_no = FeuilleDeMatchDto.datasMatch.cr_cl_no;
            } else if(typeEquipe == "EquipeVisiteur") {
                cl_no = FeuilleDeMatchDto.datasMatch.cv_cl_no;
            }
            DataBase.findBy("MATCH_FEUILLE", "cfm_no", FeuilleDeMatchDto.data.cfm_no, function(mf) {
                var mdpRencontreField = typeEquipe == "EquipeRecevante" ? "cfm_cr_mdp" : "cfm_cv_mdp";
                var mdp_rencontre = mf[0][mdpRencontreField];
                // vérification du mot de passe de recontre
                if (encryptedPassword != mdp_rencontre) {
                    $("#errorConnexion").html(Lang.connexion.connexionImpossible);
                } else {
                    // Recherche de l'utilisateur
                    DataBase.findBy("UTILISATEUR", "cl_no", [cl_no], function(data) {
                        if(typeof callback === 'function'){
                            callback(cl_no, data);
                        }
                    });
                }
            });
        }
        
    },
    // Connexion par mot de passe du club
    validerConnexionClub: function(login, password, typeEquipe, callback, callbackError){
        login = login.toUpperCase().trim();
        password = password.trim();
        $("#errorConnexion").html("");
        
        if (login === "") {
            $("#errorConnexion").html(Lang.connexion.loginVide);
            if(typeof callbackError === 'function'){
                callbackError();
            }
            return;
        } else if (password === "") {
            $("#errorConnexion").html(Lang.connexion.mdpVide);
            if(typeof callbackError === 'function'){
                callbackError();
            }
            return;
        } else {
            var cl_no = null, eq_cod = null;
            
            if (typeEquipe == "EquipeRecevante") {
                cl_no = MatchDto.match.cr_cl_no;
                eq_cod = MatchDto.match.cr_eq_cod;
            } else if(typeEquipe == "EquipeVisiteur") {
                cl_no = MatchDto.match.cv_cl_no;
                eq_cod = MatchDto.match.cv_eq_cod;
            }
            
            var encryptedPassword = Utils.encryptSha1(password);
            
            Utils.log("Connexion avec mot de passe du club");
            DataBase.findBy("UTILISATEUR", "usr_oraAndusr_password", [login, encryptedPassword.toUpperCase()], function(data) {
                if (data.length === 0) {
                    // error
                    DataBase.findBy("UTILISATEUR", "usr_ora", login, function(subdata) {
                        if (subdata.length === 0) {
                            $("#errorConnexion").html(Lang.connexion.identifiantInvalide);
                            if(typeof callbackError === 'function'){
                                callbackError();
                            }
                        }
                        else {
                            $("#errorConnexion").html(Lang.connexion.connexionImpossible);
                            if(typeof callbackError === 'function'){
                                callbackError();
                            }
                        }
                    });
                } else {
                    DataBase.findBy("UTILISATEUR_EQUIPE", "usr_noAndcl_noAndeq_codAndlc_codAndsa_no", [data[0].usr_no, cl_no, eq_cod, MatchDto.match.lc_cod, MatchDto.match.sa_no], function(res) {
                        if (res.length === 0) {
                            // error
                            $("#errorConnexion").html(Lang.connexion.nonHabilite);
                            if(typeof callbackError === 'function'){
                                callbackError();
                            }
                        } else {
                            if(typeof callback === 'function'){
                                callback(cl_no, data);
                            }
                        }
                    });
                }
            });
        }
    },
    afficherBoutonsBas : function() {
        var ejsData = {
            matchValide : (Utils.isNotNull(FeuilleDeMatchDto.data.signaturesValides) && FeuilleDeMatchDto.data.signaturesValides),
            infosValide : (Utils.isNotNull(FeuilleDeMatchDto.data.infosValides) && FeuilleDeMatchDto.data.infosValides),
            crCompValides : (Utils.isNotNull(FeuilleDeMatchDto.data.crCompValides) && FeuilleDeMatchDto.data.crCompValides),
            cvCompValides : (Utils.isNotNull(FeuilleDeMatchDto.data.cvCompValides) && FeuilleDeMatchDto.data.cvCompValides),
            verrouillage : (Utils.isNotNull(FeuilleDeMatchDto.data.verrouillage) && FeuilleDeMatchDto.data.verrouillage)
        };
        
        DataBase.findBy("MATCH_FEUILLE_RESERVE", "cfm_no", FeuilleDeMatchDto.data.cfm_no, function(data) {
            Engine.addView("#boutons", "feuilleDeMatch.html:boutonsBasDePage", {
                data : ejsData,
                nbReserves : data.length,
                cfm_nb_signat_avm : FeuilleDeMatchDto.data.cfm_nb_signat_avm
            });
        });
    },
    majInfosConnexionRencontre : function (cl_no, callback) {
        var dataInfos = {
            cfm_mdp: $("#mdpRencontre").val().trim(),
            cfm_mdpC: $("#mdpConfirmation").val().trim(),
/*            cfm_question: $("#questionSecuriteRencontre").val(),
            cfm_rep: $("#reponseSecuriteRencontre").val(),*/
        };
        if (Utils.isBlank(dataInfos.cfm_mdp)) {
            $("#errorConnexion").html(Lang.feuilleDeMatch.erreurs.infosConnectionRencontre.motDePasse);
        } else if (Utils.isBlank(dataInfos.cfm_mdpC) || (dataInfos.cfm_mdp !== dataInfos.cfm_mdpC)) {
            $("#errorConnexion").html(Lang.feuilleDeMatch.erreurs.infosConnectionRencontre.motDePasseConfirmation);
/*        } else if (Utils.isBlank(dataInfos.cfm_question) || dataInfos.cfm_question == "0") {
            $("#errorConnexion").html(Lang.feuilleDeMatch.erreurs.infosConnectionRencontre.questionSecrete);
        } else if (Utils.isBlank(dataInfos.cfm_rep)) {
            $("#errorConnexion").html(Lang.feuilleDeMatch.erreurs.infosConnectionRencontre.reponseSecrete);*/
        }
        if (Utils.isBlank($("#errorConnexion").html())) {
            FeuilleDeMatchConnexionService.majMotDePasseEquipe(cl_no, dataInfos, callback);
        }
    },
    verifierQuestionReponseSecurite: function(cl_no, question, reponse, motDePasse) {
        $("#errorValidationPopupMotDePasseOublie").html("");
        
        var equipeRecevante = cl_no == FeuilleDeMatchDto.datasMatch.cr_cl_no;
        var equipeVisiteur  = cl_no == FeuilleDeMatchDto.datasMatch.cv_cl_no;
        
        if(Utils.isBlank(question) || question == "0") {
            $("#errorValidationPopupMotDePasseOublie").html(Lang.feuilleDeMatch.erreurs.questionSecu.choixQuestion);
        } else if(Utils.isBlank(reponse)) {
            $("#errorValidationPopupMotDePasseOublie").html(Lang.feuilleDeMatch.erreurs.questionSecu.choixReponse);
        } else {
            var secuInfos = {};
            if (equipeRecevante) {
                secuInfos.question = FeuilleDeMatchDto.data.cfm_cr_question;
                secuInfos.rep = FeuilleDeMatchDto.data.cfm_cr_rep;
            } else if (equipeVisiteur) {
                secuInfos.question = FeuilleDeMatchDto.data.cfm_cv_question;
                secuInfos.rep = FeuilleDeMatchDto.data.cfm_cv_rep;
            }
            
            if (Utils.encryptSha1(question) != secuInfos.question) {
                $("#errorValidationPopupMotDePasseOublie").html(Lang.feuilleDeMatch.erreurs.questionSecu.questNonCorrespondante);
            } else if(Utils.encryptSha1(reponse) != secuInfos.rep) {
                $("#errorValidationPopupMotDePasseOublie").html(Lang.feuilleDeMatch.erreurs.questionSecu.repNonCorrespondante);
            } else if(Utils.isBlank(motDePasse)) {
                $("#errorValidationPopupMotDePasseOublie").html(Lang.feuilleDeMatch.erreurs.questionSecu.nouveauMotDePasse);
            }
        }
    },
    majMotDePasseEquipe: function(cl_no, dataInfos, callback) {
        DataBase.findBy("MATCH_FEUILLE", "cfm_no", FeuilleDeMatchDto.data.cfm_no, function(data) {
            var datas = {};
            var equipeRecevante = cl_no == FeuilleDeMatchDto.datasMatch.cr_cl_no;
            var equipeVisiteur  = cl_no == FeuilleDeMatchDto.datasMatch.cv_cl_no;
            
            if (equipeRecevante) {
                datas["cfm_cr_mdp"] = Utils.encryptSha1(dataInfos.cfm_mdp);
/*                datas["cfm_cr_question"] = Utils.encryptSha1(dataInfos.cfm_question);
                datas["cfm_cr_rep"] = Utils.encryptSha1(dataInfos.cfm_rep);*/
            } else if (equipeVisiteur) {
                datas["cfm_cv_mdp"] = Utils.encryptSha1(dataInfos.cfm_mdp);
/*                datas["cfm_cv_question"] = Utils.encryptSha1(dataInfos.cfm_question);
                datas["cfm_cv_rep"] = Utils.encryptSha1(dataInfos.cfm_rep);*/
            }
            
            $.extend(FeuilleDeMatchDto.data, datas);
            DataBase.updateJson("MATCH_FEUILLE", FeuilleDeMatchDto.data.id, datas, callback);
        });
    },
    afficherPopupClubConnexion: function (typeEquipe, isApresMatch, callbackDemo) {
        var cl_no;
        if (typeEquipe === "EquipeRecevante") {
            cl_no = FeuilleDeMatchDto.datasMatch.cr_cl_no;
        } else if(typeEquipe === "EquipeVisiteur") {
            cl_no = FeuilleDeMatchDto.datasMatch.cv_cl_no;
        }
        if(AccueilDto.isDemonstration) {
            // Pas de login dans le cas du module démonstration
            FeuilleDeMatchSignaturesService.findMatchSignataireTypes(cl_no, MatchDto.match.lc_cod, function (signataires) {
                Engine.addView("#signature" + typeEquipe, "popups.html:boutonsValidationSignature", {
                    equipe : typeEquipe,
                    clNoUser : cl_no,
                    signataires : signataires
                }, true);
                
                var script = "";
                if (isApresMatch === true) {
                    script = "signatures.html:boutonsValidationSignature";
                } else {
                    script = "popups.html:boutonsValidationSignature";
                }
                Engine.addView("#signature" + typeEquipe, script, {
                    equipe : typeEquipe,
                    clNoUser : cl_no,
                    signataires : signataires
                }, true);
                Engine.addView("#signature" + typeEquipe + " #blocChoixSignataire", "feuilleDeMatch.html:signataireList", {
                    equipe : typeEquipe,
                    signataires : signataires
                }, true);
                
                if(typeof callbackDemo === 'function'){
                    callbackDemo();
                }
            });
        } else {
            Engine.addView("#popupLogin", "popups.html:popupLogin", {
                equipe : {
                    id : "connexion"+typeEquipe
                },
                data : {
                    signatures : "-signatures",
                    motDePasseOublie : true,
                    cl_no: cl_no
                },
                superieure : true
            }, true);
            $("#popupLogin").css("height", "355px");
            Engine.popup("#popupLogin", !isApresMatch);
        }
    },
/*    afficherPopupMotDePasseRencontreOublie: function (cl_no) {
        Engine.addView("#popupMotDePasseOublie", "popups.html:popupMotDePasseOublie", {cl_no: cl_no}, true);
        Engine.popup("#popupMotDePasseOublie", true);
        Engine.selectCreate($("#questionSecurite"), { minimumResultsForSearch : -1, width: '355px' });
        if(navigator.appVersion.indexOf("Win") != -1){
                $(".showMdp").hide();
        }
    }*/
};