var FeuilleDeMatchSignaturesService = {
    
    reinitBoutonSignature: function(typeSignature, imageSignature, popup, reservesAvantMatch, callback) {
        if(popup) {
            Engine.addView("#signature" + typeSignature, "popups.html:boutonsConnexionSignature", {
                equipe : typeSignature,
                imageSignature : imageSignature,
                feuilleDeMatch : null,
                reservesAvantMatch : reservesAvantMatch
            }, true);
        } else {
            Engine.addView("#signature" + typeSignature, "popups.html:boutonsConnexionSignature", {
                equipe : typeSignature,
                imageSignature : imageSignature,
                feuilleDeMatch : FeuilleDeMatchDto,
                reservesAvantMatch : reservesAvantMatch
            }, false);
        }
        if (typeof callback === 'function') {
            callback();
        }
    },
    getEquipe: function(cl_no) {
        var equipe;
        if(cl_no == FeuilleDeMatchDto.datasMatch.cr_cl_no) {
            equipe = CompositionsMatchDto.equipeRecevante;
        } else if(cl_no == FeuilleDeMatchDto.datasMatch.cv_cl_no) {
            equipe = CompositionsMatchDto.equipeVisiteur;
        }
        return equipe;
    },
    getCapitaine : function (cl_no) {
        var equipe = FeuilleDeMatchSignaturesService.getEquipe(cl_no);
        for(var i in equipe) {
            var joueur = equipe[i];
            if(joueur.infosCompo.cfi_typ_role == "J" && joueur.infosCompo.cfi_capi == "C") {
                return joueur;
            }
        }
        return null;
    },
    dirigeantResponsablePresent: function(cl_no) {
        var equipe = FeuilleDeMatchSignaturesService.getEquipe(cl_no);
        for(var i in equipe) {
            var joueur = equipe[i];
            if(joueur.infosCompo.cfi_typ_role === "S" && (joueur.infosCompo.cfi_capi === "D" || joueur.infosCompo.cfi_capi === "A" || joueur.infosCompo.cfi_capi === "M" || joueur.infosCompo.cfi_capi === "E")) {
                return true;
            }
        }
        return false;
    },
    findMatchSignataire: function (cl_no, ma_lc_cod, cfm_no, callback/*(in_no)*/) {
        FeuilleDeMatchSignaturesService.findMatchSignataireTypes(cl_no, ma_lc_cod, function (signataires) {
            if (Utils.inArray("C", signataires)) {
                FeuilleDeMatchSignaturesService.findCapitaineSignataire(cfm_no, cl_no, callback);
            } else if (Utils.inArray("DR", signataires)) {
                FeuilleDeMatchSignaturesService.findDirigeantResponsableSignataire(cfm_no, cl_no, callback);
            }
        });
    },
    findMatchSignataireTypes: function (cl_no, ma_lc_cod, callback/*(signataires : Array)*/) {
        Engine.getReferentiel("ref_typ","FMI_LC_COD", function(lcCodList){
            var isCompetitionMineur = true;
            var signataires = [];
            // Si on trouve le lc_cod du match dans le référentiel, c'est qu'il s'agit d'une compétition de majeur
            for (var i=0; i<lcCodList.length; i++) {
                if (lcCodList[i].ref_cod == ma_lc_cod) {
                    isCompetitionMineur = false;
                }
            }
            // Si le lc_cod est défini dans le référentiel par le ref_cod FMI_LC_COD, c'est une compétition de majeur. 
            // Le capitaine est le signataire.
            if (isCompetitionMineur) {
                // Dans le cas d'une compétition de jeune,
                // si le capitaine est majeur il peut être signataire
                var capitaine = FeuilleDeMatchSignaturesService.getCapitaine(cl_no);
                if (Utils.isNotNull(capitaine) && Utils.calculerAge(Utils.stringToDate(capitaine.infosJoueur.in_dat_nais)) >= 18) {
                    signataires.push("C");
                }
                // Dans le cas d'une compétition de jeune,
                // si le dirigeant responsable est présent sur la composition du match
                // il peut être signataire
                if (FeuilleDeMatchSignaturesService.dirigeantResponsablePresent(cl_no)) {
                    signataires.push("DR");
                }

                // Si aucun signataires n'a pu être déterminé, le capitaine mineur est alors signataire.
                if (signataires.length === 0) {
                    signataires.push("C");
                }
            } else {
                signataires.push("C");
            }
            callback && callback(signataires);
       });
    },
    findDirigeantResponsableSignataireByRole: function(staff_cfi_role, datas, in_no, callback){
        if(Utils.isNull(in_no)){
            DataBase.findBy("MATCH_FEUILLE_COMPO", "cfm_noAndcfi_cl_noAndcfi_capiAndcfi_typ_role", [datas.cfm_no, datas.cl_no, staff_cfi_role, "S"], function(data) {
                if (data.length > 0) {
                    Utils.log("Signataire trouvé : [li_no = " + data[0].li_no + ", cfi_role = " + staff_cfi_role + "]");
                    DataBase.findBy("CLUB_LICENCE", "li_no", [data[0].li_no], function (licences) {
                        if (licences.length > 0) {
                            Utils.log("Individu signataire : [li_no = " + licences[0].li_no + "]");
                            if (typeof callback === 'function') {
                                callback(licences[0].in_no);
                            }
                        } else {
                            // Si pas de joueur trouvé par le li_no, on essaye avec le in_no
                            // Cas où le dirigeant responsable est un individu hors-effectif du club
                            callback(data[0].in_no);

                            // DataBase.findBy("CLUB_LICENCE", "in_no", [data[0].in_no], function (licences2) {
                            //     if (licences2.length > 0) {
                            //         Utils.log("Individu signataire : [in_no = " + licences2[0].in_no + "]");
                            //         if (typeof callback === 'function') {
                            //             callback(licences2[0].in_no);
                            //         }
                            //     } else {
                            //         Utils.log("Erreur : aucun individu trouvé avec le in_no=" + data[0].in_no + " ou le li_no=" + data[0].li_no);
                            //     }
                            // });
                        }
                    });
                } else {
                    callback(null);
                }
            });
        } else {
            callback(in_no);
        }
    },
    findDirigeantResponsableSignataire: function (cfm_no, cl_no, callback/*(in_no)*/) {
        FeuilleDeMatchSignaturesService.findDirigeantResponsableSignataireByRole("M", {cfm_no: cfm_no, cl_no: cl_no }, null, function(in_no){
            FeuilleDeMatchSignaturesService.findDirigeantResponsableSignataireByRole("D", {cfm_no: cfm_no, cl_no: cl_no }, in_no, function(in_no){
                FeuilleDeMatchSignaturesService.findDirigeantResponsableSignataireByRole("E", {cfm_no: cfm_no, cl_no: cl_no }, in_no, function(in_no){
                    FeuilleDeMatchSignaturesService.findDirigeantResponsableSignataireByRole("A", {cfm_no: cfm_no, cl_no: cl_no }, in_no, function(in_no){
                        if (typeof callback === 'function') {
                            if (Utils.isNotBlank(in_no)) {
                                callback(in_no);
                            } else {
                                Engine.alert("Aucun dirigeant responsable n'a été désigné dans votre composition");
                                callback(null);
                            }
                        }
                    });
                });
            });
        });
    },
    findCapitaineSignataire: function (cfm_no, cl_no, callback/*(in_no)*/) {
        DataBase.findBy("MATCH_FEUILLE_COMPO", "cfm_noAndcfi_cl_noAndcfi_capi", [cfm_no, cl_no, "C"], function(data) {
            if (data.length !== 0) {
                var capitaine = null;
                // Possibilité de recevoir deux résultats (un capitaine et un coach), seul le capitaine nous intéresse ici
                for (var i=0; i<data.length; i++) {
                    if (data[i].cfi_typ_role !== "S") {
                        capitaine = data[i];
                    }
                }
                if (typeof callback === 'function') {
                    if (Utils.isNotNull(capitaine)) {
                        Utils.log("Signataire trouvé : [li_no = " + capitaine.li_no + "]");
                        DataBase.findBy("CLUB_LICENCE", "li_no", [capitaine.li_no], function (licences) {
                            if (licences.length > 0) {
                                Utils.log("Individu signataire : [in_no = " + licences[0].in_no + "]");
                                if (typeof callback === 'function') {
                                    callback(licences[0].in_no);
                                }
                            } else {
                                // Si pas de joueur trouvé par le li_no, on essaye avec le in_no
                                DataBase.findBy("CLUB_LICENCE", "in_no", [capitaine.in_no], function (licences2) {
                                    if (licences2.length > 0) {
                                        Utils.log("Individu signataire : [in_no = " + licences2[0].in_no + "]");
                                        if (typeof callback === 'function') {
                                            callback(licences2[0].in_no);
                                        }
                                    } else {
                                        Utils.log("Erreur : aucun individu trouvé avec le in_no=" + capitaine.in_no + " ou le li_no=" + capitaine.li_no);
                                    }
                                });

                                Utils.log("Erreur : aucun individu trouvé avec le li_no " + capitaine.li_no);
                            }
                        });
                    } else {
                        Engine.alert("Aucun capitaine n'a été désigné dans votre composition");
                        if (typeof callback === 'function') {
                            callback(null);
                        }
                    }
                }
            } else {
                Engine.alert("Aucun capitaine n'a été désigné dans votre composition");
                if (typeof callback === 'function') {
                    callback(null);
                }
            }
        });
    },
    /**
     * cfm_no: feuille de match à mettre à jour
     * cl_no: club de l'utilisateur ayant signé
     * imageSignature: la signature sous forme d'image
     * typeSignature: Arbitre, EquipeRecevante ou EquipeVisiteur
     */
    enregistrerSignatures : function(cfm_no, cl_no, imageSignature, typeSignature, signataire, codeSignature, popup, callback) {
        if (signataire == "Arbitre") {
            DataBase.findBy("MATCH_FEUILLE_MEMBRE", "cfm_noAndpo_cod", [cfm_no, "AC"], function(data) {
                if (data.length !== 0) {
                    FeuilleDeMatchSignaturesService.enregistrerSignatureUnique(cfm_no, data[0].mmf_in_no, typeSignature, imageSignature, codeSignature, popup, callback);
                }
            });
        } else if (signataire == "ArbitreAssistant") {
            DataBase.findBy("MATCH_FEUILLE_MEMBRE", "cfm_noAndpo_cod", [cfm_no, "A1"], function(data) {
                if (data.length !== 0) {
                    FeuilleDeMatchSignaturesService.enregistrerSignatureUnique(cfm_no, data[0].mmf_in_no, typeSignature, imageSignature, codeSignature, popup, callback);
                }
            });
        } else if (signataire == "DR") {
            FeuilleDeMatchSignaturesService.findDirigeantResponsableSignataire(cfm_no, cl_no, function (in_no) {
                if (Utils.isNotNull(in_no)) {
                    FeuilleDeMatchSignaturesService.enregistrerSignatureUnique(cfm_no, in_no, typeSignature, imageSignature, codeSignature, popup, callback);
                }
            });
        } else if (signataire == "C") {
            FeuilleDeMatchSignaturesService.findCapitaineSignataire(cfm_no, cl_no, function (in_no) {
                if (Utils.isNotNull(in_no)) {
                    FeuilleDeMatchSignaturesService.enregistrerSignatureUnique(cfm_no, in_no, typeSignature, imageSignature, codeSignature, popup, callback);
                }
            });
        }
    },
    
    viderSignaturesBase: function(typeSignature, codeSignature, callback) {
        var datas = {};
        var codeLibelleSignature = codeSignature.toLowerCase();
        //tableau pour les champs à mettre à jour en base en fonction de la signature, du signataire, et de la page
        var tab = {
            "Arbitre" : {
                signature: "cfm_signat_" + codeLibelleSignature + "_arb",
                signataire : "in_no_" + codeLibelleSignature + "_arb",
            },
            "EquipeRecevante" : {
                signature: "cfm_signat_" + codeLibelleSignature + "_rec",
                signataire : "in_no_" + codeLibelleSignature + "_rec",
            },
            "EquipeVisiteur" : {
                signature: "cfm_signat_" + codeLibelleSignature + "_vis",
                signataire : "in_no_" + codeLibelleSignature + "_vis",
            },
            "ArbitreAssistant" : {
                signature: "cfm_signat_" + codeLibelleSignature + "_ass",
                signataire: "in_no_" + codeLibelleSignature + "_ass",
            }
        };
        if (codeSignature == "avm" && typeSignature == "EquipeRecevante") {
            datas["cr_forf"] = "N";
        } else if(codeSignature == "avm" && typeSignature == "EquipeVisiteur") {
            datas["cv_forf"] = "N";
        }
        
        if (Utils.isNotNull(tab[typeSignature])) {
            datas[tab[typeSignature].signature] = null;
            FeuilleDeMatchDto.data[tab[typeSignature].signature] = null;
            datas[tab[typeSignature].signataire] = null;
            FeuilleDeMatchDto.data[tab[typeSignature].signataire] = null;
        }
        
        //enregistrement
        DataBase.updateJson("MATCH_FEUILLE", FeuilleDeMatchDto.data.id, datas, function() {
            callback();
        });
    },

    viderSignaturesReservesBase: function(callback) {
        
        var datas = {};
        datas["cv_forf"] = "N";
        datas["cr_forf"] = "N";
        datas["cfm_signat_avm_arb"] = null;
        FeuilleDeMatchDto.data.cfm_signat_avm_arb = null;
        datas["cfm_signat_res_avm_arb"] = null;
        FeuilleDeMatchDto.data.cfm_signat_res_avm_arb = null;
        datas["in_no_avm_arb"] = null;
        FeuilleDeMatchDto.data.in_no_avm_arb = null;
        datas["cfm_signat_avm_rec"] = null;
        FeuilleDeMatchDto.data.cfm_signat_avm_rec = null;
        datas["cfm_signat_res_avm_rec"] = null;
        FeuilleDeMatchDto.data.cfm_signat_res_avm_rec = null;
        datas["cfm_signat_res_abs_avm_rec"] = null;
        FeuilleDeMatchDto.data.cfm_signat_res_abs_avm_rec = null;
        datas["in_no_avm_rec"] = null;
        FeuilleDeMatchDto.data.in_no_avm_rec = null;
        datas["cfm_signat_avm_vis"] = null;
        FeuilleDeMatchDto.data.cfm_signat_avm_vis = null;
        datas["cfm_signat_res_avm_vis"] = null;
        FeuilleDeMatchDto.data.cfm_signat_res_avm_vis = null;
        datas["cfm_signat_res_abs_avm_vis"] = null;
        FeuilleDeMatchDto.data.cfm_signat_res_abs_avm_vis = null;
        datas["in_no_avm_vis"] = null;
        FeuilleDeMatchDto.data.in_no_avm_vis = null;
        //enregistrement
        DataBase.updateJson("MATCH_FEUILLE", FeuilleDeMatchDto.data.id, datas, function() {
            Engine.fermerPopup();
            callback();
        });
    },
    /**
     * 
     * @param {Object} cfm_no le numéro de la feuille de match
     * @param {Object} in_no_signataire le numéro de licence du signataire
     * @param {Object} typeSignature Arbitre, EquipeRecevante ou EquipeVisiteur
     * @param {Object} imageSignature l'image de la signature à insérer en base
     * @param {Object} codeSignature le code de la signature:
     *  -avm = signature d'avant match
     *  -res_avm = signature des réserves d'avant match
     *  -tech_apm = signature des réserves techniques d'après match
     *  -obs_apm = signature des observations d'après match
     *  -apm = signature d'après match
     * @param {Boolean} popup Est-ce une popup
     * @param {function} callback La méthode callback appelée si elle existe
     */
    enregistrerSignatureUnique: function(cfm_no, in_no_signataire, typeSignature, imageSignature, codeSignature, popup, callback) {
        //recherche de l'id en base de la feuille match à mettre à jour
        DataBase.findBy("MATCH_FEUILLE", "cfm_no", cfm_no, function(data) {
            var datas = {};
            var codeLibelleSignature = codeSignature.toLowerCase();
            var signature = signataire = "";
            
            //tableau pour les champs à mettre à jour en base en fonction de la signature, du signataire, et de la page
            var tab = {
                "Arbitre" : {
                    signature: "cfm_signat_" + codeLibelleSignature + "_arb",
                    signataire : "in_no_" + codeLibelleSignature + "_arb",
                },
                "EquipeRecevante" : {
                    signature: "cfm_signat_" + codeLibelleSignature + "_rec",
                    signataire : "in_no_" + codeLibelleSignature + "_rec",
                },
                "EquipeVisiteur" : {
                    signature: "cfm_signat_" + codeLibelleSignature + "_vis",
                    signataire : "in_no_" + codeLibelleSignature + "_vis",
                },
                "ArbitreAssistant" : {
                    signature: "cfm_signat_" + codeLibelleSignature + "_ass",
                    signataire: "in_no_" + codeLibelleSignature + "_ass",
                }
            };
            if (codeSignature == "avm" && typeSignature == "EquipeRecevante") {
                datas["cr_forf"] = "N";
            } else if(codeSignature == "avm" && typeSignature == "EquipeVisiteur") {
                datas["cv_forf"] = "N";
            }
            
            if (Utils.isNotNull(tab[typeSignature])) {
                datas[tab[typeSignature].signature] = imageSignature;
                FeuilleDeMatchDto.data[tab[typeSignature].signature] = imageSignature;
                datas[tab[typeSignature].signataire] = in_no_signataire;
                FeuilleDeMatchDto.data[tab[typeSignature].signataire] = in_no_signataire;
            }
            
            //enregistrement
            DataBase.updateJson("MATCH_FEUILLE", data[0].id, datas, function() {
                //on remet les boutons de connexion
                FeuilleDeMatchSignaturesService.reinitBoutonSignature(typeSignature, imageSignature, popup, (codeSignature == "res_avm"), callback);
            });
        });
    },
    enregistrerAbsenceSignatureReserves : function(cfm_no, codeSignature, dataSignature, callback){
        DataBase.findBy("MATCH_FEUILLE", "cfm_no", cfm_no, function(data) {
            var datas = {};
            
            datas[codeSignature] = dataSignature;
            //enregistrement
            DataBase.updateJson("MATCH_FEUILLE", data[0].id, datas, function() {
                if (typeof callback === 'function') {
                    callback();
                }
            });
        });
    },
    viderSignatures : function(cfm_no, codeSignature, callback) {
        var codeLibelleSignature = codeSignature.toLowerCase();
        
        //recherche de l'id en base de la feuille match à mettre à jour
        DataBase.findBy("MATCH_FEUILLE", "cfm_no", cfm_no, function(data) {
            
            var datas = {};
            datas["cfm_signat_" + codeLibelleSignature + "_arb"] = null;
            datas["in_no_" + codeLibelleSignature + "_arb"] = null;
            datas["cfm_signat_" + codeLibelleSignature + "_rec"] = null;
            datas["in_no_" + codeLibelleSignature + "_rec"] = null;
            datas["cfm_signat_" + codeLibelleSignature + "_vis"] = null;
            datas["in_no_" + codeLibelleSignature + "_vis"] = null;
            
            if (codeLibelleSignature == "tech_apm") {
                datas["cfm_signat_" + codeLibelleSignature + "_ass"] = null;
                datas["in_no_" + codeLibelleSignature + "_ass"] = null;
            }
            else if (codeLibelleSignature == "avm") {
                datas["cr_forf"] = "N";
                datas["cv_forf"] = "N";
                datas["cv_abs_tech_apm"] = "N";
                datas["cv_abs_obs_apm"] = "N";
                datas["cr_abs_tech_apm"] = "N";
                datas["cr_abs_obs_apm"] = "N";
            }

            // mise à jour dans la bd
            DataBase.updateJson("MATCH_FEUILLE", data[0].id, datas, function() {
                // mise à jour du DTO
                $.extend(FeuilleDeMatchDto.data, datas);
                
                if(typeof callback === 'function'){
                    callback();
                }
            });
        });
    },
    recupererSignatures : function(cfm_no, codeSignature, callback) {
        // on récupère les infos de la feuille de match qu'on va signer.
        DataBase.findBy("MATCH_FEUILLE", "cfm_no", cfm_no, function(data) {
            
            $.extend(FeuilleDeMatchDto.data, data);
            
            if(typeof callback === 'function'){
                callback();
            }
        });
    },
    /**
     * @param {Object} cfm_no: feuille de match à mettre à jour
     */
    verificationSignature : function(cfm_no, codeSignature, callback) {
        var codeLibelleSignature = codeSignature.toLowerCase();
        var datas = {};

        //recherche de l'id en base de la feuille match à mettre à jour
        DataBase.findBy("MATCH_FEUILLE", "cfm_no", cfm_no, function(data) {
            if (((Utils.isNotNull(data[0]["cfm_signat_" + codeLibelleSignature + "_rec"]) && data[0]["cfm_signat_" + codeLibelleSignature + "_rec"] != "") || (Utils.isNotNull($("#absenceEquipeRecevante")[0]) && $("#absenceEquipeRecevante")[0].checked)) &&
                ((Utils.isNotNull(data[0]["cfm_signat_" + codeLibelleSignature + "_vis"]) && data[0]["cfm_signat_" + codeLibelleSignature + "_vis"] != "") || (Utils.isNotNull($("#absenceEquipeVisiteur")[0]) && $("#absenceEquipeVisiteur")[0].checked)) &&
                 ((Utils.isNotNull(data[0]["cfm_signat_" + codeLibelleSignature + "_arb"]) && data[0]["cfm_signat_" + codeLibelleSignature + "_arb"] != ""))) {
                
                if(codeLibelleSignature == "avm") {
                    FeuilleDeMatchDto.data.signaturesValides = true;
                    
                    //on met à jour le champ de verrouillage
                    FeuilleDeMatchDto.data.verrouillage = true;
                    $("#infoMatch").hide();
                    DataBase.update("MATCH_FEUILLE", data[0].id, "cfm_verrou", "O", function() {
                        if(typeof callback === 'function') {
                            callback();
                        }
                    });              
                } else if(typeof callback === 'function') {
                    callback();
                }
            } else if (codeLibelleSignature == "res_avm" &&
                ((Utils.isNotNull(data[0]["cfm_signat_" + codeLibelleSignature + "_rec"]) && data[0]["cfm_signat_" + codeLibelleSignature + "_rec"] != "") ||
                (Utils.isNotNull(data[0]["cfm_signat_" + codeLibelleSignature + "_vis"]) && data[0]["cfm_signat_" + codeLibelleSignature + "_vis"] != "")) &&
                Utils.isNotNull(data[0]["cfm_signat_" + codeLibelleSignature + "_arb"]) && data[0]["cfm_signat_" + codeLibelleSignature + "_arb"] != "") {
                if(typeof callback === 'function') {
                    callback();
                }
            } else {
                $("#errorValidation").html("Veuillez remplir et valider les signatures");
            }
        });
    },
    /**
     * @param {Object} cfm_no: feuille de match à mettre à jour
     * @param {Object} codeSignature le code de la signature:
     */
    enregistrerEquipeAbsentes: function(cfm_no, codeSignature, callback) {
        var codeLibelleSignature = codeSignature.toLowerCase();
        var datas = {};
        if ($("#absenceEquipeRecevante")[0].checked || $("#absenceEquipeVisiteur")[0].checked) {
            //On vide le in_no du signataire et la signature
            DataBase.findBy("MATCH_FEUILLE", "cfm_no", cfm_no, function(data) {
                // RG : si l'équipe est absente avant le match, elle est forcé "absente" pour l'après match.
                if ($("#absenceEquipeRecevante")[0].checked) {
                    if(codeSignature === "avm") {
                        datas["cr_forf"] = "O";
                        datas["cr_abs_tech_apm"] = "O";
                        datas["cr_abs_obs_apm"] = "O";
                    } else if (codeSignature === "tech_apm") {
                        datas["cr_abs_tech_apm"] = "O";
                    } else if (codeSignature === "obs_apm") {
                        datas["cr_abs_obs_apm"] = "O";
                    }
                    datas["in_no_" + codeLibelleSignature + "_rec"] = null;
                    datas["cfm_signat_" + codeLibelleSignature + "_rec"] = null;
                }
                if ($("#absenceEquipeVisiteur")[0].checked) {
                    if(codeSignature === "avm") {
                        datas["cv_forf"] = "O";
                        datas["cv_abs_tech_apm"] = "O";
                        datas["cv_abs_obs_apm"] = "O";
                    } else if (codeSignature === "tech_apm") {
                        datas["cv_abs_tech_apm"] = "O";
                    } else if (codeSignature === "obs_apm") {
                        datas["cv_abs_obs_apm"] = "O";
                    }
                    datas["in_no_" + codeLibelleSignature + "_vis"] = null;
                    datas["cfm_signat_" + codeLibelleSignature + "_vis"] = null;
                }
                if(typeof callback === 'function') {
                    callback(datas);
                }
            });
        } else {
            if(typeof callback === 'function') {
                callback(datas);
            }
        }
    },
};