var HeaderController = MainController.extend({
    defaults: { 
        name: "#header",
        click: Engine.eventClick,
        pages: new Array(
                "header/header.html"),
        files: new Array( 
                "header/css/header.css",
                "header/js/headerFr.js",
                "reserves/reservesAvantMatch/js/reservesFr.js",
                "accueil/js/accueilDto.js",
                "evenementsGeneriques/js/evenementsGeneriquesController.js"),
    }
}, {
	init: function(element, options) {
	    this._super(this, element, options);
	    headerDatas = null;
	},
	load: function(page, data, callback) {
        Engine.loadController(page, this.options.pages, this.options.files, this, function(controller) {
            if (typeof callback === 'function') {
                callback();
            }
        });
	},
	show: function(element, event) {
	    Engine.delegate(this, element, event, function(controller, element, event) {
	    });
	},
	showLogo: function(accueil) {
        Engine.delegate(this, null, null, function(controller, element, event) {
            var isAccueil = Utils.isNotNull(accueil) && accueil;
            var blason = (Utils.isNotNull(controller.headerDatas) && Utils.isNotNull(controller.headerDatas.blason)) ? controller.headerDatas.blason : null;
    	    if (isAccueil || Utils.isNull(blason)) {
    	        blason = "modules/header/img/logo_fff.png";
    	    }
    	    var image = "<img src='" + blason + "'></img>";
    	    if(AccueilDto.isDemonstration) {
    	        image += "<br/><div id='texteDemo'>! DEMO !</div>";
    	    }
    	    $("#header #partLogo").html(image);
        });
	},
	showUtilisateurSynchro: function(data) {
        Engine.delegate(this, null, null, function(controller, element, event) {
            if (!Utils.isNotNull(data)) {
                data = {
                    prenomUtilisateur: Project.contexteUtilisateur.usr_nom_conx,
                    dateSynchronisation: Utils.isNotBlank(Project.contexteUtilisateur.data_syncro) ? Project.contexteUtilisateur.data_syncro.substring(0,16) : "-"
                };
            }
            Engine.addView("#partSynchro", "header.html:afficherUtilisateurSynchro", {data : data});
            if ((!Engine.dbSiteWeb && !Engine.isCordova)) {
                $("#boutonSynchronisation").hide();
                $("#boutonRecuperation").hide();
            }
            var isPreparation = Engine.filAriane.length > 1 && Engine.filAriane[Engine.filAriane.length-1] == "equipe.html";
            if (isPreparation) {
                $(".dateSynchronisation").hide();
            }
            controller.showBatterie();
            controller.showConnexionStatus();
        });
	},
	showScore: function(feuilleDeMatch) {
	    Engine.delegate(this, null, null, function(controller, element, event) {
            Engine.addView(".partRencontreEquipe", "header.html:afficherScore", {data : controller.headerDatas, feuilleDeMatch : feuilleDeMatch});
	    });
	},
	showEquipes: function(page) {
        Engine.delegate(this, null, null, function(controller, element, event) {
            if (page != "accueil.html") {
                switch(page) {
                    case "equipe.html":
                        controller.headerDatas.titre = Lang.header.equipeTitre;
                        break;
                    case "feuilleDeMatch.html":
                        controller.headerDatas.titre = Lang.header.feuilleDeMatchTitre;
                        break;
                    case "faitsDeMatch.html":
                        controller.headerDatas.titre = Lang.header.faitsDeMatchTitre;
                        break;
                    case "reserves.html":
                        controller.headerDatas.titre = Lang.header.reservesTitre;
                        break;
                    case "apresMatch.html":
                        controller.headerDatas.titre = Lang.header.faitsDeMatchTitre;
                        break;
                    case "infosFacultatives.html":
                        controller.headerDatas.titre = Lang.infosFacultatives.headerTitre;
                        break;
                    default:
                        controller.headerDatas.titre = "PAS DE TITRE !!!!!!!!!!";
                        break;
                }
                controller.headerDatas.titre = controller.headerDatas.titre.toUpperCase();
                
                // Chercher dans MatchFeuille pour avoir cfm_ma_dat et cfm_ma_heure_lib //
                DataBase.findBy("MATCH_FEUILLE", "ma_no", controller.headerDatas.ma_no, function(data) {
                    Engine.addView("#partRencontreContent", "header.html:afficherUtilisateurEquipe", {data : controller.headerDatas, dataMatch : data});
                });
            } else {
                Engine.addView("#partRencontreContent", "header.html:afficherSynchroUnitaire", {modeWeb: !Engine.dbActif});
            }
        });
	},
	showBatterie: function() {
        Engine.delegate(this, null, null, function(controller, element, event) {
    	    $("#batterie").hide();
            if (Engine.batterieLevel != null) {
                $("#batterie").attr("class", "");
                var suffixe = "1";
                if (Engine.batterieLevel > 25) {
                    suffixe = "3";
                } else if (Engine.batterieLevel > 10) {
                    suffixe = "2";
                }
                $("#batterie").show();
                $("#batterie").attr("class", "batterie_" + suffixe);
            }
        });
	},
	showConnexionStatus: function() {
        Engine.delegate(this, null, null, function(controller, element, event) {
            $("#iconeReseau").hide();
            if (Engine.reseauConnexion != null) {
                $("#iconeReseau").show();
                var suffixe = "0";
                if (Engine.reseauConnexion != 'No network connection') {
                    suffixe = "3";
                }
                $("#iconeReseau").attr("class", "iconeReseau_" + suffixe);
            }
        });
    },
    showError: function(erreurs) {
        Engine.delegate(this, null, null, function(controller, element, event) {
            var html = "";

            // Erreurs 
            if (erreurs.constructor == Array ) {
                if (erreurs.length > 0) {
                    for (var i in erreurs) {
                        if (erreurs[i].err) {};
                        html += "<div class='errorBloquant'>" + erreurs[i] + "</div>";
                    }
                }
            } else {
                html = Utils.isNotBlank(erreurs)?"<div class='errorBloquant'>" + erreurs + "</div>":"";
            }
            
            // show erreurs
            $("#displayErrors").find(".errorsBody").html(html);
            if (Utils.isNotBlank(html)) {
                $("#displayErrors").show();
            } else {
                $("#displayErrors").hide();
            }
        });
    },
	showDistinctError: function(erreursBloquantes, erreursNonBloquantes, showOnlyNonBloquantes) {
        Engine.delegate(this, null, null, function(controller, element, event) {
            var html = "";

            // Erreurs bloquantes
            if (erreursBloquantes.constructor == Array ) {
                if (erreursBloquantes.length > 0) {
                    for (var i in erreursBloquantes) {
                        if(showOnlyNonBloquantes) {
                            html += "<div class='errorNonBloquant'>" + erreursBloquantes[i] + "</div>";
                        } else { 
                            html += "<div class='errorBloquant'>" + erreursBloquantes[i] + "</div>";
                        }
                    }
                }
            } else {
                if(showOnlyNonBloquantes) {
                    html = Utils.isNotBlank(erreursBloquantes)?"<div class='errorNonBloquant'>" + erreursBloquantes + "</div>":"";
                } else {
                    html = Utils.isNotBlank(erreursBloquantes)?"<div class='errorBloquant'>" + erreursBloquantes + "</div>":"";
                }
            }
            // Erreurs non bloquantes
            if (erreursNonBloquantes.constructor == Array ) {
                if (erreursNonBloquantes.length > 0) {
                    for (var i in erreursNonBloquantes) {
                        html += "<div class='errorNonBloquant'>" + erreursNonBloquantes[i] + "</div>";
                    }
                }
            } else {
                html = Utils.isNotBlank(erreursNonBloquantes)?"<div class='errorNonBloquant'>" + erreursNonBloquantes + "</div>":"";
            }

            // show erreurs
            if(showOnlyNonBloquantes) {
                $("#displayErrorsOrange").find(".errorsBody").html(html);
                if (Utils.isNotBlank(html)) {
                    $("#displayErrorsOrange").show();
                } else {
                    $("#displayErrorsOrange").hide();
                }
            } else {
                $("#displayErrors").find(".errorsBody").html(html);
    	        if (Utils.isNotBlank(html)) {
                    $("#displayErrors").show();
    	        } else {
                    $("#displayErrors").hide();
    	       }
            }
        });
	},
	showButton: function(page) {
        Engine.delegate(this, null, null, function(controller, element, event) {
	        $("#partRight #information").show();
	        
    	    if (page != "accueil.html") {
    	        $("#partRight #home").show();
    	        $("#partRight #deconnexion").hide();
    	    } else {
                $("#partRight #home").hide();
                $("#partRight #deconnexion").show();
    	    }
        });
	},
	
	setSynchroButton: function () {
	    if (Engine.isCordova || Engine.dbSiteWeb) {
            var page = Engine.filAriane[Engine.filAriane.length - 1];
            if (page === "accueil.html") {
                $("#boutonRecuperation").show();
//                $("#boutonRecuperation").removeClass("boutonSynchronisationDisable");
            }
            else {
                $("#boutonRecuperation").hide();
                $("#boutonSynchronisation").data("mode", "synchro");
                $("#boutonSynchronisation").text(Lang.header.synchroniser);
            }
	    }
	},
	setTransmissionButton: function () {
	    if (Engine.isCordova || Engine.dbSiteWeb) {
            $("#boutonRecuperation").hide();
            $("#boutonSynchronisation").data("mode", "transmission");
            $("#boutonSynchronisation").text(Lang.header.transmettre);
	    }
	},
	
	showSynchroButton: function () {
	    if (Engine.isCordova || Engine.dbSiteWeb) {
            var page = Engine.filAriane[Engine.filAriane.length - 1];
            if (page === "accueil.html") {
                $("#boutonRecuperation").show();
                $("#boutonRecuperation").removeClass("boutonSynchronisationDisable");
            }
            else {
                $("#boutonRecuperation").hide();
        	    $("#boutonSynchronisation").removeClass("boutonSynchronisationDisable");
                $("#boutonSynchronisation").show();
            }
        }
	},
	disableSynchroButton: function () {
	    if (Engine.isCordova || Engine.dbSiteWeb) {
            var page = Engine.filAriane[Engine.filAriane.length - 1];
            if (page === "accueil.html") {
                $("#boutonRecuperation").show();
                $("#boutonRecuperation").addClass("boutonSynchronisationDisable");
            }
            else {
                $("#boutonRecuperation").hide();
                $("#boutonSynchronisation").addClass("boutonSynchronisationDisable");
                $("#boutonSynchronisation").show();
            }
        }
	},
	hideSynchroButton: function () {
	    if (Engine.isCordova || Engine.dbSiteWeb) {
            $("#boutonRecuperation").hide();
    	    $("#boutonSynchronisation").hide();
    	}
	},
	afficherInformation: function () {
	    Engine.getReferentiel("ref_typ", "FMI_CGU", function (data) {
	        var htmlCgu = data.length !== 0 ? data[0].ref_libelle : "<p>" + Lang.header.cguIndisponible + "</p>";
	        Engine.addView("#popupInformation", "header.html:popupInformation", {cgu : htmlCgu}, true);
            Engine.popup("#popupInformation");
	    });
    },
	"#partRight #home click": function(element, event) {
        Engine.delegate(this, null, null, function(controller, element, event) {
            if (Engine.filAriane.length > 1 && Engine.filAriane[Engine.filAriane.length-1] == "apresMatch.html" &&
                ApresMatchSignaturesService.isSignaturesApresMatchRempli()) 
            {
                AccueilService.afficherWarningConfirmPopup(
                    Lang.header.confirmMatchNonCloture,
                    function () {
                        Engine.fermerPopup();
                        Engine.gotoPage("accueil.html");
                    },
                    function () {
                        Engine.fermerPopup();
                    }
                );
            } else {
                Engine.gotoPage("accueil.html");
            }
        });
	},
    "#partRight #deconnexion click": function(element, event) {
        Engine.delegate(this, null, null, function(controller, element, event) {
            Engine.confirm(Lang.header.deconnexion, function() {
                Engine.login = "";
                Engine.gotoPage("connexion.html");
            });
        });
    },
    "#partRight #information click": function(element, event) {
        Engine.delegate(this, null, null, function(controller, element, event) {
            controller.afficherInformation();
        });
    },
});