var InfosFacultativesController = MainController.extend({
    defaults : { 
        name : ".InfosFacultativesController",
        click : Engine.eventClick,
        change : "change",
        dblclick : Engine.eventDblclick,
        pages : new Array("infosFacultatives/infosFacultatives.html",
                "faitsDeMatch/onglets/equipeVisiteur.html",
                "reserves/reservesAvantMatch/js/onglets/equipeVisiteurReserve.html",
                "equipe/equipe.html",
                "faitsDeMatch/onglets/histo.html",
                "infosFacultatives/onglets/tactique.html",
                "infosFacultatives/onglets/buteurs.html",
                "infosFacultatives/onglets/organisation.html"),
        files : new Array(
                "apresMatch/js/service/apresMatchCompoService.js",
                "apresMatch/js/service/apresMatchRencontreService.js",
                
                "infosFacultatives/css/infosFacultatives.css",
                "infosFacultatives/js/infosFacultativesFr.js",
                "infosFacultatives/js/infosFacultativesService.js",
                
                "faitsDeMatch/js/faitsDeMatchOngletsService.js",
                "faitsDeMatch/js/feuilleDeMatchDto.js",
                "faitsDeMatch/js/service/faitsDeMatchHistoService.js",
                "faitsDeMatch/js/dto/faitsDeMatchHistoriqueDto.js",
                "faitsDeMatch/js/faitsDeMatchFr.js",
                "faitsDeMatch/js/service/faitsDeMatchButsService.js",
                
                "feuilleDeMatch/js/feuilleDeMatchService.js",
                "feuilleDeMatch/js/dto/matchDto.js",
                "feuilleDeMatch/js/dto/compositionsMatchDto.js",
                "feuilleDeMatch/js/feuilleDeMatchFr.js",
                
                "equipe/js/dao/equipeDao.js",
                "equipe/js/service/equipeCompositionService.js",
                "equipe/js/service/equipeDragAndDropService.js",
                "equipe/js/service/equipeLicenceService.js",
                "equipe/js/equipeDto.js",
                "equipe/js/equipeFr.js"),
    }
}, {
    init: function(element, options) {
        this._super(this, element, options);
    },
    load: function(page, data) {
        Engine.loadController(page, this.options.pages, this.options.files, this, function(controller) {
            EquipeDto.composition.joueurSelection = null;
            EquipeDto.composition.joueurCompositionSelection = null;            
            EquipeDto.data = Utils.cloneObject(data.match);
            EquipeDto.utilisateur = data.utilisateur;
            Engine.message("Chargement des infos");
//            Engine.showLoader();
            FeuilleDeMatchService.chargerFeuilleDeMatch(data.match, function(){
                FeuilleDeMatchService.getJoueursFromCompo(data.match.ma_no, EquipeDto.utilisateur.cl_no, function(joueursCompo) {
                    FaitsDeMatchHistoService.findHistorique(false, function(events){
                        FaitsDeMatchHistoriqueDto.histo = Utils.cloneObject(events);
                        Engine.hideLoader();
                        CompositionsMatchDto.equipeRecevante = Utils.cloneObject(joueursCompo);
                        //charger la compo dans l'EquipeDto et  dans le show : showLicences(equipeDto.composition)
                        controller.show(controller.element, null);
                    }, false, true);
                },true);
            });
        });
    },
    show: function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            Engine.addView("#enteteOnglets", "infosFacultatives.html:onglets", { 
                ongletTactique: EquipeDto.data.ph_tactiq === "F",
                ongletButeurs: EquipeDto.data.ph_info_but === "F",
                ongletOrganisation: EquipeDto.data.ph_info_orga === "F" && Utils.parseInt(EquipeDto.utilisateur.cl_no) === Utils.parseInt(MatchDto.match.cr_cl_no)
            });
            InfosFacultativesService.afficherTousLesJoueurs(function() {
                // Séléctionner le premier onglet
                if(InfosFacultativesService.isOngletTactiqueEnabled()) {
                    FaitsDeMatchOngletsService.changeOnglet($("#tactique"));
                } else if(InfosFacultativesService.isOngletButeursEnabled()) {
                    FaitsDeMatchOngletsService.changeOnglet($("#buteurs"));
                } else if(InfosFacultativesService.isOngletOrganisationEnabled()) {
                    FaitsDeMatchOngletsService.changeOnglet($("#organisation"));
                }
                Engine.fermerPopup();
            });
        });
    },
    "{name} div.onglets div {click}": function(element, event) {
        if(!element.hasClass("selected")) {
            // Les joueurs sont tous grisés pour l'onglet tactique
            var onglet = element.attr("id");
            $("#listeJoueur li").each(function () {
                EquipeDragAndDropService.griserJoueur($(this).attr("id"), (onglet === "tactique" || onglet === "organisation"));
            });
            
            // les membres du staff sont tous grisés pour l'onglet buteurs
            if (onglet === "buteurs"){
                $("#listeJoueur li").each(function () {
                    if ($(this).find(".infosJoueurHidden").find(".tl_uti_typ_lic").val() !== "J"){
                    EquipeDragAndDropService.griserJoueur($(this).attr("id"), true);
                    }
                });
            }

            FaitsDeMatchOngletsService.changeOnglet(element);
        }
    },
     /******************************************************
     *********** GESTION DES ONGLETS **********************
     ******************************************************/
    "{name} #partie_droite_bottom .onglet {click}": function(element, event){
        Engine.delegate(this, element, event, function(controller) {
            element.parent().children(".isSelected").removeClass("isSelected");
            element.addClass("isSelected");
            if (element.hasClass("remplacant")) {
                element.parent().parent().children(".sub").show();
                element.parent().parent().children(".staff").hide();
                element.children("#iconRemplacant").css('background-image', 'url("modules/equipe/img/remplacants_actif.png")');
                element.parent().find("#iconEncadrement").css('background-image', 'url("modules/equipe/img/staff_logo.png")');
            } else if (element.hasClass("encadrement")) {
                element.parent().parent().children(".staff").show();
                element.parent().parent().children(".sub").hide();
                element.parent().find("#iconRemplacant").css('background-image', 'url("modules/equipe/img/remplacants.png")');
                element.parent().find("#iconEncadrement").css('background-image', 'url("modules/equipe/img/staff_logo_inactif.png")');
            }
            Engine.updateUScrollView();
        });
    },
     /********************************************************
     ************* GESTION DU DRAG & DROP *******************
     ********************************************************/
    "{name} .clicAndDrop {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            $("#listeJoueur").find("li").each(function() {
                if (!$(this).hasClass("placeSurTerrain")) {
                    $(this).removeClass("waitingForTarget");
                }
            });
            if (!$(element).hasClass("placeSurTerrain")) {
                if (EquipeDto.composition.joueurCompositionSelection != null) {
                    $("#" + EquipeDto.composition.joueurCompositionSelection).removeClass("joueurTerrainSelected");
                    EquipeDto.composition.joueurCompositionSelection = null;
                }
                
                if (EquipeDto.composition.joueurSelection != element.attr("id")) {
                    element.addClass("waitingForTarget");
                    EquipeDto.composition.joueurSelection = element.attr("id");
                } else {
                    EquipeDto.composition.joueurSelection = null;
                }
            }
        });
    },
    "{name} .emplacementLibre {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if(!element.hasClass("remplacantSelect") && !element.hasClass("staffSelect")) {
                EquipeDragAndDropService.dragAndDrop(element);
            }
        }); 
    },
    "{name} .imageDrop  {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            if (EquipeDto.composition.joueurSelection != null) {
                var ongletActif = $("#enteteOnglets").find(".selected").attr("id");
                  
                if ($("#" + EquipeDto.composition.joueurSelection).find(".cfi_typ_role").val() === "S" && ongletActif == "buteurs") {
                   Engine.alert(Lang.faitsDeMatch.erreurs.deplacementNonAutorise);
                } else {
                    var idLicence = $("#" + EquipeDto.composition.joueurSelection).find(".li_no").val();
                    var photo = $("#" + EquipeDto.composition.joueurSelection).find(".in_photo").val();
                    var nom = $("#" + EquipeDto.composition.joueurSelection).find(".in_nom").val();
                    var prenom = $("#" + EquipeDto.composition.joueurSelection).find(".in_prenom").val();
                    var idDrop = element.attr('id');
                    element.html("<img src=" + Utils.prepareBase64Image(photo) + " height= '43px' width='43px' alt=" + idLicence + " />");
                    $("#prenom_"+idDrop).html(prenom);
                    $("#nom_"+idDrop).html(nom);
                    $("#listeJoueur li").removeClass("waitingForTarget");
                    EquipeDto.composition.joueurSelection = null;
                }
            }
        });
    },
     /******************************************************
     *********** ACTIONS SUR LE LICENCIE ******************
     ******************************************************/
    "{name} .divInfoLicence {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            event.stopPropagation();
            if (!element.hasClass("disabled") && !(element.parent().parent().parent().hasClass("placeSurTerrain"))) {
                EquipeLicenceService.afficherLicencePopup(element.parent().parent().parent().attr("id"));
            }
        });
    },
    "{name} .boutonsModifSurbrillance #boutonSupprimer {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if (EquipeDto.composition.joueurCompositionSelection != null) {
                EquipeDragAndDropService.griserJoueur($("#" + EquipeDto.composition.joueurCompositionSelection).attr("alt"), false);
                EquipeDragAndDropService.supprimerJoueurTerrain($("#" + EquipeDto.composition.joueurCompositionSelection));
            }
        });
    },
    "{name} #selectStrats {change}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            Engine.addView("#partie_droite_bottom", "equipe.html:remplacantsStaff", {});
            ApresMatchCompoService.creerListeRemplacantsAyantJoue(FaitsDeMatchHistoriqueDto.histo, function(){
                var tactique = parseInt($("#selectStrats option:selected").val(), 10);
                EquipeCompositionService.showCompositionOnScreen(CompositionsMatchDto.equipeRecevante, true, FaitsDeMatchHistoriqueDto.remplacantsAyantJoue, tactique);
            });
        });
    },
    "{name} #validerButs {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            InfosFacultativesService.validerBut();
        });
    },
    "{name} .vider {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            InfosFacultativesService.viderDropZone(element.attr("data-for"));
        });
    },
    "{name} .butModifier {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            InfosFacultativesService.modifier(element);
        });
    },
    "{name} .butSupprimer {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            Engine.confirm(Lang.faitsDeMatch.infos.confirmSuppression, function(){
                var idBut = element.attr("data-id");
                
                if (Engine.dbActif) {
                    for(i in FaitsDeMatchHistoriqueDto.histo) {
                        if(FaitsDeMatchHistoriqueDto.histo[i].id == idBut) {
                            delete FaitsDeMatchHistoriqueDto.histo[i];
                        }
                    }
                    DataBase.deleteById("MATCH_FEUILLE_EVENEMENT", idBut, function() {
                        InfosFacultativesService.refreshListeButs(function() {});
                    });
                } else {
                    InfosFacultativesService.enregistrerBut(idBut);
                }
            });
        });
    },
    "{name} #validerInfos {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            if (Engine.dbActif) {
                InfosFacultativesService.validerInfos();
                EquipeCompositionService.enregistrerComposition(false);
            } else {
                InfosFacultativesService.envoyerInfosFacultativesWeb();
            }
        });
    }
});