var InfosFacultativesService = {
    chargerTactiques: function(callback){
        DataBase.findAll("TACTIQUE", function(data) {
            Engine.addView("#selectStrats", "equipe.html:stratsSelect", { strategies : data, afficherTactiqueSansPlacement : 1 });
            if(typeof callback === "function") {
                callback();
            }
        });
    },
    validerBut: function(callback) {
        var minute = $("#minuteButs").val();
        var minutePlus = $("#minuteButsPlus").val();
        var licence1 = $("#butteur").find("img").attr("alt");
        var licence2 = $("#passeur").find("img").attr("alt");
        var typBut = $("#typeBut").val();
        var action = $("#beforeBut").val();
        var nbButSaisiEquipeConnectee = 0;
        var nbButSaisiEquipeAdverse = 0;
        var isVisiteur = Project.contexteUtilisateur.cl_no == MatchDto.match.cv_cl_no;
        var nbButEquipeConnectee = isVisiteur ? FeuilleDeMatchDto.data.cv_nb_but : FeuilleDeMatchDto.data.cr_nb_but;
        var nbButEquipeAdverse = isVisiteur ? FeuilleDeMatchDto.data.cr_nb_but : FeuilleDeMatchDto.data.cv_nb_but;
        
        var erreur = [];
        FaitsDeMatchOngletsService.addErrorFormatMinute(erreur, minute, minutePlus);
        minute = parseInt(minute, 10);
        minutePlus = Utils.isNotBlank(minutePlus) ? parseInt(minutePlus, 10) : null;
        
        if (!Utils.isNotBlank(licence1)) {
            erreur.push(Lang.faitsDeMatch.erreurs.buts.licence1);
        } else if (licence1 == licence2) {
            erreur.push(Lang.faitsDeMatch.erreurs.buts.licencedifferent);
        }
        
        // on compte le nombre de buts saisis pour l'équipe en cours
        // en comptant les buts contre son camp de la part de l'équipe adverse
        for (i in FaitsDeMatchHistoriqueDto.histo){
            if (FaitsDeMatchHistoriqueDto.histo[i].cfe_typ == "BU"){
                // si le but est celui que l'on est en train de modifier, on ne le compte pas
                if (Utils.isNotNull(FaitsDeMatchHistoriqueDto.idButModifier) && 
                ((Engine.dbActif && FaitsDeMatchHistoriqueDto.histo[i].id == FaitsDeMatchHistoriqueDto.idButModifier) ||
                 (!Engine.dbActif && i == FaitsDeMatchHistoriqueDto.idButModifier))) {
                    break;
                }
                var butEquipeConnectee = false;
                for (j in CompositionsMatchDto.equipeRecevante) {
                    if (CompositionsMatchDto.equipeRecevante[j].infosCompo.li_no == FaitsDeMatchHistoriqueDto.histo[i].l1_li_no) {
                        butEquipeConnectee = true;
                        break;
                    }
                }
                if (FaitsDeMatchHistoriqueDto.histo[i].cfe_typ_but == "CSC") {
                    if (butEquipeConnectee) {
                        nbButSaisiEquipeAdverse++;
                    } else {
                        nbButSaisiEquipeConnectee++;
                    }
                } else {
                    if (butEquipeConnectee) {
                        nbButSaisiEquipeConnectee++;
                    } else {
                        nbButSaisiEquipeAdverse++;
                    }
                }
            }            
        }
        
        if(typBut == "CSC") {
            nbButSaisiEquipeAdverse++;
        } else {
            nbButSaisiEquipeConnectee++;
        }
        
        if(FeuilleDeMatchDto.data.ma_motif_non_joue_cod == "NJ" || (nbButSaisiEquipeAdverse > nbButEquipeAdverse) || (nbButSaisiEquipeConnectee > nbButEquipeConnectee)) {
            erreur.push(Lang.faitsDeMatch.erreurs.buts.nbButsMaximum);
        }
        
        if (erreur.length == 0) {
            Engine.headerController.showError("");
            FaitsDeMatchHistoService.init();
            FaitsDeMatchHistoriqueDto.data.l1_cfi_maillot = FaitsDeMatchHistoriqueDto.data.l2_cfi_maillot = null;
            for (i in CompositionsMatchDto.equipeRecevante) {
                if(licence1 == CompositionsMatchDto.equipeRecevante[i].infosCompo.li_no) {
                    FaitsDeMatchHistoriqueDto.data.l1_cfi_maillot = CompositionsMatchDto.equipeRecevante[i].infosCompo.cfi_maillot;
                }
                if(!Utils.isNotBlank(licence2) && licence2 == CompositionsMatchDto.equipeRecevante[i].infosCompo.li_no) {
                    FaitsDeMatchHistoriqueDto.data.l2_cfi_maillot = CompositionsMatchDto.equipeRecevante[i].infosCompo.cfi_maillot;
                }
                
            }
            FaitsDeMatchHistoriqueDto.data.ma_no = MatchDto.match.ma_no;
            FaitsDeMatchHistoriqueDto.data.cfm_no = FeuilleDeMatchDto.cfm_no;
            FaitsDeMatchHistoriqueDto.data.cfe_min = minute;
            FaitsDeMatchHistoriqueDto.data.cfe_min_sup = minutePlus;
            FaitsDeMatchHistoriqueDto.data.l1_li_no = Utils.isNotNull(licence1) ? parseInt(licence1, 10) : null;
            FaitsDeMatchHistoriqueDto.data.l2_li_no = Utils.isNotNull(licence2) ? parseInt(licence2, 10) : null;
            FaitsDeMatchHistoriqueDto.data.cfe_typ = "BU";
            FaitsDeMatchHistoriqueDto.data.cfe_no = 1;
            FaitsDeMatchHistoriqueDto.data.cfe_typ_but = typBut;
            FaitsDeMatchHistoriqueDto.data.cfe_action = action;
            
            if (FaitsDeMatchHistoriqueDto.idButModifier != null) {
                if (Engine.dbActif) {
                    DataBase.deleteById("MATCH_FEUILLE_EVENEMENT", FaitsDeMatchHistoriqueDto.idButModifier);
                } else {
                    FaitsDeMatchHistoriqueDto.histo.splice(FaitsDeMatchHistoriqueDto.idButModifier, 1);
                }
                //TODO: supprimer le match dans le dto
                FaitsDeMatchHistoriqueDto.idButModifier = null;
            }
            
            $("#minuteButs").val("");
            $("#minuteButsPlus").val("");
            InfosFacultativesService.viderDropZone("passeur");
            InfosFacultativesService.viderDropZone("butteur");
            
            InfosFacultativesService.enregistrerBut(null);
        } else {
            Engine.headerController.showError(erreur[0]);
        }
    },
    enregistrerBut: function(idToDelete){
        if (!Engine.dbActif) {
            if (Utils.isNotNull(idToDelete)) {
                FaitsDeMatchHistoriqueDto.histo.splice(idToDelete, 1);
            } else {
                FaitsDeMatchHistoriqueDto.histo.push(Utils.cloneObject(FaitsDeMatchHistoriqueDto.data));
            }
        }
        DataBase.insert("MATCH_FEUILLE_EVENEMENT", Engine.dbActif ? FaitsDeMatchHistoriqueDto.data : FaitsDeMatchHistoriqueDto.histo, function() {
            
            if (Engine.dbActif) {
                //raffraichissement l'objet "histo" de FaitsDeMatchHistoriqueDto
                FaitsDeMatchHistoService.findHistorique(true, function(){}, true);
            } else {
                InfosFacultativesService.refreshListeButs();
            }
        });
    },
    modifier: function(element) {
        FaitsDeMatchHistoriqueDto.idButModifier = element.attr("data-id");

        $("#minuteButs").val(element.parent().parent().find(".cfe_min").val());
        $("#minuteButsPlus").val(element.parent().parent().find(".cfe_min_sup").val());
        var idLicence = $("#" + element.parent().parent().find(".l1_li_no").val()).find(".li_no").val();
        var photo = $("#" + element.parent().parent().find(".l1_li_no").val()).find(".in_photo").val();
        $("#butteur").html("<img src=" + Utils.prepareBase64Image(photo) + " height= '43px' width='43px' alt=" + idLicence + " />");
        $("#nom_butteur").html($("#" + idLicence).find(".in_nom").val());
        $("#prenom_butteur").html($("#" + idLicence).find(".in_prenom").val());
        var idLicence = $("#" + element.parent().parent().find(".l2_li_no").val()).find(".li_no").val();
        var photo = $("#" + element.parent().parent().find(".l2_li_no").val()).find(".in_photo").val();
        if(Utils.isNotBlank(idLicence) && Utils.isNotNull(idLicence)){
            $("#passeur").html("<img src=" + Utils.prepareBase64Image(photo) + " height= '43px' width='43px' alt=" + idLicence + " />");
            $("#nom_passeur").html($("#" + idLicence).find(".in_nom").val());
            $("#prenom_passeur").html($("#" + idLicence).find(".in_prenom").val());  
        } else {
            $("#passeur").html("");
            $("#nom_passeur").html("");
            $("#prenom_passeur").html(""); 
        }
        var typeBut = element.parent().parent().find(".cfe_typ_but").val();
        Engine.selectSetVal($('#typeBut'), typeBut);

        var actionBut = element.parent().parent().find(".cfe_action").val();
        Engine.selectSetVal($('#beforeBut'), actionBut);
    },
    refreshListeButs: function(callback){
        if (Engine.dbActif) {
            DataBase.findBy("MATCH_FEUILLE_EVENEMENT", "cfm_noAndcfe_typ", [FeuilleDeMatchDto.cfm_no,"BU"], function(data) {
                InfosFacultativesService.getButsEquipeCo(data, callback);
            });     
        } else {
            InfosFacultativesService.getButsEquipeCo(FaitsDeMatchHistoriqueDto.histo, callback);
        }
    },
    getButsEquipeCo: function(data, callback) {
        // Ne récupérer que les buts de l'équipe connectée
        var buteursEquipe = new Array();
        for(var i = 0, len = data.length; i < len; i++) {
            var idClubJoueur = FaitsDeMatchHistoService.recupererClubJoueur(data[i].l1_li_no);
            if(idClubJoueur == EquipeDto.utilisateur.cl_no) {
                for (var j = 0; j < CompositionsMatchDto.equipeRecevante.length; j++) {
                    if(CompositionsMatchDto.equipeRecevante[j].infosJoueur.li_no == data[i].l1_li_no) {
                        data[i]["l1_cfi_maillot"] = CompositionsMatchDto.equipeRecevante[j].infosCompo.cfi_maillot;
                        break;
                    }
                }
                data[i]["nom"] = $("#"+data[i].l1_li_no).find(".nom").text();
                data[i]["prenom"] = $("#"+data[i].l1_li_no).find(".prenom").text();
                buteursEquipe.push(data[i]);
            }
        }
        Engine.addView("#listeButs", "buteurs.html:listeButs", { buts : buteursEquipe, dbActif : Engine.dbActif });
        if(typeof callback === "function") {
            callback();
        }
    },
    validerInfos: function(){
        if (InfosFacultativesService.isOngletOrganisationEnabled()) {
            //Enregistrement organisation
            var recetteInfo = $("#recetteInfo").val();
            var nombreSpectateursInfo = $("#nombreSpectateursInfo").val();
            
            var erreur = [];
                  
            if (isNaN(recetteInfo) || Utils.isNull(recetteInfo) || Utils.isBlank(recetteInfo) || !Utils.isIntegerPositif(recetteInfo)
                || isNaN(nombreSpectateursInfo) || Utils.isNull(nombreSpectateursInfo) || Utils.isBlank(nombreSpectateursInfo) || !Utils.isIntegerPositif(nombreSpectateursInfo)) {
                erreur.push(Lang.faitsDeMatch.erreurs.infos.nbSpecDenombrement);
            }
            
            if (erreur.length == 0) {
                Engine.headerController.showError("");
                var data = {
                    cfm_recette : recetteInfo,
                    cfm_nb_spect : nombreSpectateursInfo,
                };
                    
                DataBase.updateJson("MATCH_FEUILLE", FeuilleDeMatchDto.idCfm, data, function(){
                    $.extend(FeuilleDeMatchDto.data, data);
                    Engine.alert(Lang.infosFacultatives.messageOk);
                });
            } else {
                Engine.headerController.showError(erreur[0]);
            }
        }
    },
    afficherTousLesJoueurs: function(callback) {
        var licencesCompo = "";
        for(i in CompositionsMatchDto.equipeRecevante) {
            licencesCompo += CompositionsMatchDto.equipeRecevante[i].infosJoueur.li_no;
            if(i < CompositionsMatchDto.equipeRecevante.length -1) {
                licencesCompo += ";";
            }
        }

        InfosFacultativesService.joueursAyantJoueInfoFac(MatchDto.match.ma_no, EquipeDto.utilisateur.cl_no, licencesCompo.split(";"), [], function(dataReturn) {
            cmp = function(x, y) {
                return x > y ? -1 : x < y ? 1 : 0; 
            };
            dataReturn.sort(function(a, b) {
                return cmp( 
                    [cmp(a.in_nom, b.in_nom), cmp(a.in_prenom, b.in_prenom)], 
                    [cmp(b.in_nom, a.in_nom), cmp(b.in_prenom, a.in_prenom)]
                );
            });
            EquipeLicenceService.showLicences(dataReturn, function() {
                if (typeof callback === 'function') {
                    callback();
                }
            }, ".InfosFacultativesController");
        });
    },
    joueursAyantJoueInfoFac: function(numeroMatch, clNo, liNoRestant, dataReturn, callback) {
        for (i in CompositionsMatchDto.equipeRecevante) {
            dataReturn.push(CompositionsMatchDto.equipeRecevante[i].infosJoueur);
        }
        callback(dataReturn);
    },
    getPositionJoueursTerrain: function() {
        var compo = {
            ma_no : EquipeDto.data.ma_no,
            cfm_no : EquipeDto.data.cfm_no,
            individu : []
        };
        $("#terrain .emplacementOccupe").each(function() {
            var individu = {
                li_no : parseInt($(this).attr("alt"), 10),
                cfi_poste : $(this).attr("data-poste") === "NULL" ? null : $(this).attr("data-poste"),
                cfi_ordre : parseInt($(this).attr("data-position"), 10)
            };
            compo.individu.push(individu);
        });
        return compo;
    },
    envoyerInfosFacultativesWeb: function(error){
        var erreur = [];
        var ma_no = EquipeDto.data.ma_no;
        var cfm_no = EquipeDto.data.cfm_no;
        var match_feuille_compo = Engine.dbActif ? null : InfosFacultativesService.getPositionJoueursTerrain();
        var cfi_cl_no = EquipeDto.utilisateur.cl_no;
        var tq_no = InfosFacultativesService.isOngletTactiqueEnabled() ? parseInt(Engine.selectGetVal($('#selectStrats')), 10) : null;
        if (tq_no === 0) {
            tq_no = null;
        }
        var data = {
            match_feuille : {
                tq_no : tq_no,
                cfm_no : cfm_no,
                cfm_recette : null,
                cfm_nb_spect : null
            },
            match_feuille_compo : match_feuille_compo,
            match_feuille_evenement : null
        };
        
        if (InfosFacultativesService.isOngletOrganisationEnabled()) {
            if (Utils.isNotBlank($("#recetteInfo").val()) && ($("#recetteInfo").val() != parseInt($("#recetteInfo").val(), 10))) {
                erreur.push(Lang.infosFacultatives.erreurRecette);
            }
            if (Utils.isNotBlank($("#nombreSpectateursInfo").val()) && ($("#nombreSpectateursInfo").val() != parseInt($("#nombreSpectateursInfo").val(), 10))) {
                erreur.push(Lang.infosFacultatives.erreurSpectateur);
            }
            
            data.match_feuille.cfm_recette = $("#recetteInfo").length > 0 ? parseInt($("#recetteInfo").val(), 10) : parseInt(FeuilleDeMatchDto.data.cfm_recette, 10);
            data.match_feuille.cfm_nb_spect = $("#nombreSpectateursInfo").length > 0 ? parseInt($("#nombreSpectateursInfo").val(), 10) : parseInt(FeuilleDeMatchDto.data.cfm_nb_spect, 10);
        }
        
        if (erreur.length == 0){
            Engine.headerController.showError("");
            Engine.getDemande("T003", data, function(json) {
                Engine.alert(Lang.infosFacultatives.messageOk);
            });
        }
        else {
            Engine.headerController.showError(erreur[0]);
        }
    },
    isOngletOrganisationEnabled: function () {
        return MatchDto.match.ph_info_orga === "F" && EquipeDto.utilisateur.cl_no == MatchDto.match.cr_cl_no;
    },
    isOngletTactiqueEnabled: function () {
        return MatchDto.match.ph_tactiq === "F";
    },
    isOngletButeursEnabled: function () {
        return MatchDto.match.ph_info_but === "F";
    },
    viderDropZone: function(zoneId) {
        $("#" + zoneId).html("");
        $("#prenom_"+zoneId).html("");
        $("#nom_"+zoneId).html("");
    }
}; 