var ReservesController = MainController.extend({
    defaults: { 
        name: ".ReservesController",
        click: Engine.eventClick,
        change: "change",
        dblclick: Engine.eventDblclick,
        pages: new Array(
                "reserves/reservesAvantMatch/reserves.html",
                "reserves/reservesAvantMatch/popups.html",
                "reserves/reservesAvantMatch/js/onglets/equipeVisiteurReserve.html"),
        files: new Array( 
                "reserves/reservesAvantMatch/css/reserves.css",
                "reserves/reservesAvantMatch/js/reservesFr.js",
                "reserves/reservesAvantMatch/js/service/reservesService.js",
                "faitsDeMatch/js/faitsDeMatchOngletsService.js",
                "reserves/reservesAvantMatch/js/reserveDto.js",
                "feuilleDeMatch/js/dto/compositionsMatchDto.js",
                "feuilleDeMatch/js/service/feuilleDeMatchSignaturesService.js",
                "feuilleDeMatch/js/service/feuilleDeMatchInfosMatchService.js",
                "feuilleDeMatch/js/service/feuilleDeMatchConnexionService.js"),
        joueurSelectionne : null,

    }
}, {
    init: function(element, options) {
        this._super(this, element, options);
    },
    load: function(page, data) {
        Engine.loadController(page, this.options.pages, this.options.files, this, function(controller) {
            controller.show(controller.element, null);
        });
    },
    show: function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            FaitsDeMatchOngletsService.changeOnglet($("#equipeRecevanteReserve"), {afficherCompo: FeuilleDeMatchDto.data.crCompValides});
            FaitsDeMatchOngletsService.changeOnglet($("#equipeVisiteurReserve"), {afficherCompo: FeuilleDeMatchDto.data.cvCompValides},null,true);
            
            ReserveDto.sexeEquipe = $("#listJoueurs").find(".in_sexe").val();
            ReservesService.getTypeReserve(ReserveDto.sexeEquipe);

            // TODO : corriger le cas ou tous les siganatures sont remplis, mais ne cliquer pas sur "valider"
            ReservesService.verifSignatures(FeuilleDeMatchDto.data.cfm_no);    
            DataBase.findBy("MATCH_FEUILLE_RESERVE", "cfm_no", FeuilleDeMatchDto.data.cfm_no, function(data) {
                ReserveDto.listReserves = data;
                if (data.length > 0) {     
                    ReservesService.refreshReserves();
                }
                ReservesService.refreshBoutonPoserReserves();
                ReservesService.refreshBoutonsBasPage();
            });
        });
    },
    
    "{name} div.onglets div {click}": function(element, event) {
        //si l'élément est un onglet déjà sélectionné, on ne fait rien
        if(!element.hasClass("selected")){
             $(".waitingForTarget").each(function(){ 
                 $(this).removeClass("waitingForTarget");
             });
             $("#reserveText").val("");
             $("#enteteReserveDescription").html("");
             Engine.selectSetVal($('#selectReserve'), 0);
            FaitsDeMatchOngletsService.changeOnglet(element);
        }
    },
    "{name} .listJoueurs li {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller) {
            if(element.hasClass("waitingForTarget")){
               element.removeClass("waitingForTarget");  
            } else {
               element.addClass("waitingForTarget");
            }
            
        });
    },
    "{name} #selectReserve {change}": function(element, event) {
        $("#enteteReserveDescription").html("");
        $("#reserveText").val("");
        $("#reserveText").attr("readonly", false);
        
        if (element.val() != "0") {
            var reserveSurJoueur = ReservesService.isReserveSurJoueur(element.val());
            var joueurSelectionne = $(".waitingForTarget").length != 0;
            
            if (reserveSurJoueur && !joueurSelectionne) {
                Engine.alert("Veuillez sélectionner un joueur");
                Engine.selectSetVal($('#selectReserve'), 0);
                $(".listeReservesContainer").removeClass("listeReservesContainer_ReservesAutes");
                $("#modifierReserve").hide();
            } else if (reserveSurJoueur) {
                ReservesService.afficherDescriptionReserve(ReserveDto.sexeEquipe, element.val());
                $(".listeReservesContainer").removeClass("listeReservesContainer_ReservesAutes");
                if (element.children(':selected').hasClass("modifiable")){
                    $("#modifierReserve").show();
                }
                else {
                    $("#modifierReserve").hide();
                }
            } else if (element.val() == "RACR" || element.val() == "RACV") {
                ReservesService.afficherEnteteDescriptionReserve(element.val());
                 $(".listeReservesContainer").addClass("listeReservesContainer_ReservesAutes");
                 $("#modifierReserve").hide();
            } else if (element.val() == "RICV") {
                $(".listeReservesContainer").removeClass("listeReservesContainer_ReservesAutes");
                $("#modifierReserve").hide();
            }

            setTimeout(function (){
                Engine.deleteScroll("listReserve");
                Engine.initScrolls("listReserve");
            },100);
        }
    },
     "{name} #poserReserve {click}": function(element, event) {
         if($("#selectReserve").val() == "0"){
             Engine.alert("Veuillez sélectionner un type de réserve");
         } else if(Utils.isBlank($("#reserveText").val()) || Utils.isNull($("#reserveText").val())){
             Engine.alert("Veuillez renseigner une description");
         } else if($(".waitingForTarget").length == 0 && ReservesService.isReserveSurJoueur($("#selectReserve").val())){
             Engine.alert("Veuillez sélectionner un joueur");
         } else if(($("#selectReserve").children(':selected').hasClass("modifiable")) && ($("#reserveText").val().indexOf("...") >= 0)){
            // Check si la réserve contient encore la chaine de caractères '...'. Si c'est le cas, la description n'a pas été modifiée (ou pas complètement) => message d'erreur
             Engine.alert("La description n'a pas été complètement modifiée. Remplacez les '...' restants");
         } else {
            ReservesService.enregistrerReserve();
            $(".liCompo").removeClass("waitingForTarget");  
         }
    },
    "{name} #modifierReserve {click}": function (element, event) {
        // $("#reserveText").attr("readonly", false);
        var isReadOnly = $("#reserveText").attr("readonly") === "readonly";
        if (isReadOnly) {
            $("#reserveText").attr("readonly", false);
        }
        
        $("#reserveText").focus();

        $("#reserveText").blur(function (event) {
            if (isReadOnly) {
                $( this ).attr("readonly", true);
            }
            $( this ).unbind( event );
        });
    },
    "{name} #annulerReserve {click}": function(element, event) {
        var idDelete = element.attr("data-id");
        var idIndex = element.attr("data-index");
        Engine.confirm("Confirmer ?", function() {
            ReservesService.annulerReserve(idDelete, idIndex);
            Engine.fermerPopup();
        });
    },
    "{name} #returnButton {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if (!ReservesService.isReservesAvantMatchSignatureOk() && ReserveDto.listReserves.length > 0) {
                Engine.confirm(Lang.reserves.confirmationRetourFeuilleDeMatch, function(){
                    if (!ReserveDto.verrouillage){
                        ReservesService.viderSignaturesReservesBase(ReservesService.retourFeuilleDeMatch);
                    }
                });
            } else {
                ReservesService.retourFeuilleDeMatch();
            }
        });
    },
    "{name} .enteteDepliant {click}": function(element, event){
        Engine.delegate(this, element, event, function(controller) {
            element.parent().parent().children('li').children(".selected").removeClass("selected").find(".partieGaucheDepliant").children("span").html("+").parent().parent().next().hide();
            //on affiche l'élément sur lequel on a cliqué (et changement du - en +)
            element.addClass("selected").find(".partieGaucheDepliant").children("span").html("-").parent().parent().next().show();
            Engine.updateUScrollView();
       });
    },

    "{name} .enteteDepliantPopup {click}" : function(element,event) {
         Engine.delegate(this, element, event, function(controller) {
            element.parent().children(".selected").removeClass("selected").find(".partieGaucheDepliant").children("span").html("+").parent().parent().next().hide();
            element.addClass("selected").find(".partieGaucheDepliant").children("span").html("-").parent().parent().next().show();
            Engine.deleteScroll(element.next().find('.divScrollable').attr('id'));
            Engine.initScrolls(element.next().find('.divScrollable').attr('id'));
       });
    },

    
    "{name} #signatures {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var descriptionEquipeRecevante = "";
            var descriptionEquipeVisiteur = "";
            
            for(i in ReserveDto.listReserves){
                if(Utils.isNotNull(ReserveDto.listReserves[i].cl_no) && ReserveDto.listReserves[i].cl_no == MatchDto.match.cr_cl_no){
                    descriptionEquipeRecevante += ReserveDto.listReserves[i].mfr_libre+"<br/><br/>";
                } else if(Utils.isNotNull(ReserveDto.listReserves[i].cl_no) && ReserveDto.listReserves[i].cl_no == MatchDto.match.cv_cl_no){
                    descriptionEquipeVisiteur += ReserveDto.listReserves[i].mfr_libre+"<br/><br/>";
                }
            }
            Engine.addView("#popupSignatures #listeReservesSignatures", "popups.html:listeReservesSignatures", {reservesEquipeRecevante : descriptionEquipeRecevante, reservesEquipeVisiteur : descriptionEquipeVisiteur}, true);
            Engine.addView("#popupSignatures #divSignatures", "popups.html:popupSignaturesRes", {boutonValider : true}, true);
            Engine.popup("#popupSignatures");
            
        });
    },
    "{name} #deverrouiller {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            Engine.confirm(Lang.reserves.alerteDeverrouillage, function(){
                Engine.addView("#popupLogin", "popups.html:popupLoginArbitre", {data : {}}, true);
                Engine.popup("#popupLogin");      
            }, false, "240px", false);
        });
    },
    "{name} .connexionSignature {click}" : function(element, event) {
        if(!element.hasClass("disabled_button")) {
            var typeEquipe = element.attr("id") === "connexionEquipeRecevante" ? "EquipeRecevante" : "EquipeVisiteur";
            FeuilleDeMatchConnexionService.afficherPopupClubConnexion(typeEquipe, false, function () {
              Engine.bindSignature("#blocSignature" + typeEquipe, 273, 150);
            });
        }
    },
    "{name} #valider-connexion-signatures {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var typeEquipe = element.attr("data-id") == "connexionEquipeRecevante" ? "EquipeRecevante" : "EquipeVisiteur";
            FeuilleDeMatchConnexionService.validerConnexionClubSignature(typeEquipe, function () {
                //On bind la signature
                Engine.bindSignature("#blocSignature" + typeEquipe, 273, 150);
                Engine.fermerPopup(true);
            });
        });
    },
    "{name} .signerArbitre {click}" : function(element, event) {
        FeuilleDeMatchSignaturesService.viderSignaturesBase("Arbitre", "res_avm", function() {
            Engine.addView("#signatureArbitre", "popups.html:boutonsValidationSignature", {
                equipe : "Arbitre",
                clNoUser : ""
            }, true);
            //On bind la signature
            Engine.bindSignature("#blocSignatureArbitre", 273, 150);
        });
    },
    "{name} .validerSignatures {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            $("#errorValidation").html("");
            var signature = element.attr("data-id");
            var connaissance = $("#validerConnaissance"+signature)[0].checked;
            var signataire = null;
            var clNoUser = element.attr("data-clNoUser");
            

            //Si ce n'est pas l'arbitre qui signe, on récupère le signataire
            if (signature != "Arbitre" && signature != "ArbitreAssistant") {
                signataire = $("#choixSignataire" + signature + " option:selected").val();
            } else {
                signataire = "Arbitre";
            }

            if (connaissance == false) {
                $("#errorValidation").html(Lang.reserves.erreurs.signatures.connaissance);
            } else if (!Utils.isNotBlank(signataire)) {
                $("#errorValidation").html(Lang.reserves.erreurs.signatures.signataire);
            } else if (Utils.isSignatureEmpty("#blocSignature" + signature)) {
                $("#errorValidation").html(Lang.reserves.erreurs.signatures.signatureVide);
            } else {
                $("#errorValidation").html("");
                //on enregistre la signature
                var imageSignature = Engine.getSignature("#blocSignature" + signature);
                FeuilleDeMatchSignaturesService.enregistrerSignatures(FeuilleDeMatchDto.data.cfm_no, clNoUser, imageSignature, signature, signataire, "res_avm", true);
            }
        });
    },
    "{name} #validerSignaturesGenerale {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            FeuilleDeMatchSignaturesService.verificationSignature(FeuilleDeMatchDto.data.cfm_no, "res_avm", function(){
                if (FeuilleDeMatchDto.data.cfm_signat_avm_arb || FeuilleDeMatchDto.data.cfm_signat_avm_vis || FeuilleDeMatchDto.data.cfm_signat_avm_rec){
                    Engine.confirm(Lang.reserves.alerteSignatures, function(){
                        FeuilleDeMatchSignaturesService.viderSignaturesBase("Arbitre", "avm", function() {
                            FeuilleDeMatchSignaturesService.viderSignaturesBase("EquipeRecevante", "avm", function() {
                                FeuilleDeMatchSignaturesService.viderSignaturesBase("EquipeVisiteur", "avm", function() {
                                    ReserveDto.verrouillage = true;
                                    ReservesService.refreshBoutonsBasPage();
                                    ReservesService.refreshReserves();
                                    ReservesService.refreshBoutonPoserReserves();
                                    Engine.fermerPopup();
                                });
                            });
                        });
                    }, false, "250px", null, function(){
                        FeuilleDeMatchSignaturesService.viderSignaturesBase("Arbitre", "res_avm", function() {
                            FeuilleDeMatchSignaturesService.viderSignaturesBase("EquipeRecevante", "res_avm", function() {
                                FeuilleDeMatchSignaturesService.viderSignaturesBase("EquipeVisiteur", "res_avm", function() {
                                });
                            });
                        });
                    }, { confirmKO: Lang.feuilleDeMatch.boutonConfirmKO, confirmOK: Lang.feuilleDeMatch.boutonConfirmOK });
                }
                else {
                    ReserveDto.verrouillage = true;
                    ReservesService.refreshBoutonsBasPage();
                    ReservesService.refreshReserves();
                    ReservesService.refreshBoutonPoserReserves();
                    Engine.fermerPopup();
                }
            });
        });
    },
    "{name} #valider-connexion-arbitre {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            
           var cfm_no = FeuilleDeMatchDto.data.cfm_no;
           var datas = {};
            
            //Vérification du mot de passe saisie
            var password = $("#mdp").val();
            if (password === "") {
                $("#errorConnexion").html(Lang.connexion.mdpVide);
                return;
            }         
        
            //recherche de l'id en base de la feuille match à mettre à jour
            DataBase.findBy("MATCH_FEUILLE", "cfm_noAndcfm_mdp", [cfm_no, password], function(data) {
                if (data.length === 0) {    
                    // error
                    $("#errorConnexion").html(Lang.connexion.connexionImpossible);
                } else {
                    Engine.fermerPopup();
                    FeuilleDeMatchSignaturesService.viderSignaturesReservesBase(function(){
                        //on met à jour le champ de verrouillage
                        ReserveDto.verrouillage = false;
                        ReservesService.refreshBoutonsBasPage();
                        ReservesService.refreshReserves();
                        ReservesService.refreshBoutonPoserReserves();
                    });
                }
            });
        });
    },
/*    "{name} #lienMotDePasseOublie {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            FeuilleDeMatchConnexionService.afficherPopupMotDePasseRencontreOublie(element.data("cl-no"));
        });
    },*/
    "{name} #validerMotDePasseOublie {click}" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            $("#popupLogin").removeClass("dont-close");
            var questionSecurite = Engine.selectGetVal($("#questionSecurite"));
            var reponseSecurite = $("#reponseSecurite").val();
            var nouveauMotDePasse = $("#nouveauMotDePasse").val();
            var cl_no = element.data("cl-no");
            
            FeuilleDeMatchService.majMotDePasseOublie(cl_no, questionSecurite, reponseSecurite, nouveauMotDePasse, function () {
                Engine.fermerPopup(true);
            });
        });
    },
    // FEV13 - EVO4 / FMH
    // Stopper l'ajout de caractère dans la zone de saisie des réserves si l'utilisateur à atteint 1024 caractères
    "{name} #reserveText keypress" : function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if (event.which !== 0 && element.val().length + 1 > 1024) {
                event.preventDefault();
                event.stopPropagation();
            }
        });
    }
});