var ReservesService = {
    isReserveSurJoueur: function (reserveCode) {
        return !Utils.inArray(reserveCode, ["RICV","RACR", "RACV"]);
    },
    getTypeReserve : function(sexeEquipe) {
            Engine.getReferentiel("ref_typ", "FMI_"+sexeEquipe+"_MFR_TYP", function(typeReserve){
                var typReserve = [];
                for(i in typeReserve){
                   typReserve[typeReserve[i].ref_cod] = typeReserve[i].ref_libelle;
                }
                Engine.getReferentiel("ref_typ", "FMI_"+sexeEquipe+"_MFR_TYP_M", function(typeReserveM){
                    for(a in typeReserveM){
                       i++;
                       typReserve[typeReserveM[a].ref_cod] = typeReserveM[a].ref_libelle;
                       typeReserve[i] = typeReserveM[a];
                    }
                    ReserveDto.typeReserves = typReserve;
                    Engine.addView("#reservesHead","reserves.html:selectTypeReserves", { typeReserve : typeReserve });
                });
            });
    },
    rechercherSignataire : function (reserveCode, callback/*(signataire)*/) {
        var cfm_no = FeuilleDeMatchDto.data.cfm_no;
        var cl_no = null;
        
        if (Utils.inArray(reserveCode, ["RACV"])) {
            cl_no = FeuilleDeMatchDto.datasMatch.cr_cl_no;
        } else if (Utils.inArray(reserveCode, ["RACR", "RICV"])) {
            cl_no = FeuilleDeMatchDto.datasMatch.cv_cl_no;
        } else {
            // Pour les réserves sur individu, le club n'étant PAS séléctionné est ce celui qui formule la réserve
            cl_no = $(".onglets > div:not(.selected)").attr("data-cl-no");
        }
        
        FeuilleDeMatchSignaturesService.findMatchSignataire(cl_no, MatchDto.match.lc_cod, FeuilleDeMatchDto.data.cfm_no, function (in_no) {
            if (Utils.isNotNull(in_no)) {
                var joueur = $(".liCompo[data-inno='"+in_no+"']");
                
                ReserveDto.signataire = {
                    in_no: joueur.find(".in_no").val(),
                    in_nom: joueur.find(".in_nom").val(),
                    in_prenom: joueur.find(".in_prenom").val(),
                    li_no: joueur.find(".li_no").val(),
                    cfi_typ_role: joueur.find(".cfi_typ_role").val(),
                    cl_nom: joueur.find(".cl_nom").val() || $(".liCompo .cl_no[value='"+cl_no+"']").parent().find(".cl_nom").val()
                };
                
                if (typeof callback === 'function') {
                    callback(ReserveDto.signataire);
                }
            } else {
                $("#reserveText").val("");
                Engine.selectSetVal($('#selectReserve'), 0);
            }
        });
    },
    afficherEnteteDescriptionReserve : function (reserveCode) {
        ReservesService.rechercherSignataire(reserveCode, function(signataire) {
            var entete = Lang.reserves.enteteDescriptionReservesAutres
                .replace(new RegExp("\\[NOM_F\\]", 'g'),signataire.in_nom)
                .replace(new RegExp("\\[PRENOM_F\\]", 'g'),signataire.in_prenom)
                .replace(new RegExp("\\[LICENCE_F\\]", 'g'),signataire.in_no)
                .replace(new RegExp("\\[CLUB_F\\]", 'g'),signataire.cl_nom)
                .replace(new RegExp("\\[ROLE_F\\]", 'g'),signataire.cfi_typ_role == "J" ? "Capitaine" : "Dirigeant responsable")
                
                .replace(/@@@/g, "<br>");
            
            $("#enteteReserveDescription").html(entete);
            $("#reserveText").val("");
            $("#reserveText").attr("readonly", false);
        });
    },
    viderSignaturesReservesBase: function(callback) {
        
        var datas = {};
        datas["cv_forf"] = "N";
        datas["cr_forf"] = "N";
        datas["cfm_signat_avm_arb"] = null;
        FeuilleDeMatchDto.data.cfm_signat_avm_arb = null;
        datas["cfm_signat_res_avm_arb"] = null;
        FeuilleDeMatchDto.data.cfm_signat_res_avm_arb = null;
        datas["in_no_avm_arb"] = null;
        FeuilleDeMatchDto.data.in_no_avm_arb = null;
        datas["cfm_signat_avm_rec"] = null;
        FeuilleDeMatchDto.data.cfm_signat_avm_rec = null;
        datas["cfm_signat_res_avm_rec"] = null;
        FeuilleDeMatchDto.data.cfm_signat_res_avm_rec = null;
        datas["cfm_signat_res_abs_avm_rec"] = null;
        FeuilleDeMatchDto.data.cfm_signat_res_abs_avm_rec = null;
        datas["in_no_avm_rec"] = null;
        FeuilleDeMatchDto.data.in_no_avm_rec = null;
        datas["cfm_signat_avm_vis"] = null;
        FeuilleDeMatchDto.data.cfm_signat_avm_vis = null;
        datas["cfm_signat_res_avm_vis"] = null;
        FeuilleDeMatchDto.data.cfm_signat_res_avm_vis = null;
        datas["cfm_signat_res_abs_avm_vis"] = null;
        FeuilleDeMatchDto.data.cfm_signat_res_abs_avm_vis = null;
        datas["in_no_avm_vis"] = null;
        FeuilleDeMatchDto.data.in_no_avm_vis = null;
        //enregistrement
        DataBase.updateJson("MATCH_FEUILLE", FeuilleDeMatchDto.data.id, datas, function() {
            Engine.fermerPopup();
            callback();
        });
    },
    afficherDescriptionReserve : function(sexeEquipe, refCode){
        ReservesService.rechercherSignataire(refCode, function(signataire) {
            Engine.getReferentiel("ref_typAndref_cod",["FMI_F_MFR_TYP_TEXT", refCode], function(descriptionReserveFeminin){
                Engine.getReferentiel("ref_typAndref_cod",["FMI_M_MFR_TYP_TEXT", refCode], function(descriptionReserveMasculin){
                    ReserveDto.descriptionReserve["F"] = descriptionReserveFeminin[0].ref_libelle;
                    ReserveDto.descriptionReserve["M"] = descriptionReserveMasculin[0].ref_libelle;
                    
                    //on remplace les valeurs pour celui qui FORMULE la réserve
                    var description = [];
                    
                    if($(".waitingForTarget").length > 1) {
                        var noms_joueurs = [];
                        var prenoms_joueurs = [];
                        var licences_joueurs = "";
                        var sexe;
                        var club_joueurs; 
                        var licenseEnr_joueur;
                        //INFOS de la cible de la réserve
                        $(".waitingForTarget").each(function(){ 
                            //INFOS de la cible de la réserve
                            noms_joueurs.push($(this).find(".in_nom").val());
                            prenoms_joueurs.push($(this).find(".in_prenom").val());
                            licences_joueurs += $(this).find(".in_no").val() + ";";
                            club_joueurs = $(this).find(".cl_nom").val();
                            licenseEnr_joueur = $(this).find(".li_dat_enr").val();
                            sexe = $(this).find(".in_sexe").val() || "M";

                        });
                        var descriptionLicencie = ReserveDto.descriptionReserve[sexe]
                            .replace(new RegExp("\\[NOM_F\\]", 'g'),signataire.in_nom)
                            .replace(new RegExp("\\[PRENOM_F\\]", 'g'),signataire.in_prenom)
                            .replace(new RegExp("\\[LICENCE_F\\]", 'g'),signataire.in_no)
                            .replace(new RegExp("\\[CLUB_F\\]", 'g'),signataire.cl_nom)
                            .replace(new RegExp("\\[ROLE_F\\]", 'g'),signataire.cfi_typ_role == "J" ? "Capitaine" : "Dirigeant responsable")
                            .replace(/@@@/g, "\n");

                        var nomsPrenoms_joueurs="";
                        for(var i=0; i<$(".waitingForTarget").length; i++) {
                            nomsPrenoms_joueurs += prenoms_joueurs[i] + " "+ noms_joueurs[i];
                            if(i < $(".waitingForTarget").length - 1){
                                nomsPrenoms_joueurs += ", ";
                            }
                        }

                        descriptionLicencie = descriptionLicencie
                            .replace(new RegExp("\\[NOM\\] \\[PRENOM\\]", 'g'),nomsPrenoms_joueurs)
                            .replace(new RegExp("\\[LICENCE\\]", 'g'),licences_joueurs)
                            .replace(new RegExp("\\[CLUB\\]", 'g'),club_joueurs)
                            .replace(new RegExp("LI_DAT_ENR", 'g'),licenseEnr_joueur);

                        description.push(descriptionLicencie);
                    } else {
                        var nom = $(".waitingForTarget").find(".in_nom").val();
                        var prenom = $(".waitingForTarget").find(".in_prenom").val();
                        var licence = $(".waitingForTarget").find(".in_no").val();
                        var club = $(".waitingForTarget").find(".cl_nom").val();
                        var licenseEnr = $(".waitingForTarget").find(".li_dat_enr").val();
                        var sexe = $(".waitingForTarget").find(".in_sexe").val() || "M";
                        
                        var descriptionLicencie = ReserveDto.descriptionReserve[sexe]
                            .replace(new RegExp("\\[NOM_F\\]", 'g'),signataire.in_nom)
                            .replace(new RegExp("\\[PRENOM_F\\]", 'g'),signataire.in_prenom)
                            .replace(new RegExp("\\[LICENCE_F\\]", 'g'),signataire.in_no)
                            .replace(new RegExp("\\[CLUB_F\\]", 'g'),signataire.cl_nom)
                            .replace(new RegExp("\\[ROLE_F\\]", 'g'),signataire.cfi_typ_role == "J" ? "Capitaine" : "Dirigeant responsable")
                            
                            .replace(new RegExp("\\[NOM\\]", 'g'),nom)
                            .replace(new RegExp("\\[PRENOM\\]", 'g'),prenom)
                            .replace(new RegExp("\\[LICENCE\\]", 'g'),licence)
                            .replace(new RegExp("\\[CLUB\\]", 'g'),club)
                            .replace(new RegExp("LI_DAT_ENR", 'g'),licenseEnr)
                            
                            .replace(/@@@/g, "\n");
                        
                        description.push(descriptionLicencie);
                    }
                    
                    $("#reserveText").val(description.join("\n\n"));
                    $("#reserveText").attr("readonly", true);
                });
            });
        });
    },
    getJoueurReserve: function(joueur) {
        var data;
        if (joueur.length === 1){
            data = {
            mfr_no : 1,
            cfm_no : FeuilleDeMatchDto.data.cfm_no,
            cl_no : joueur.find(".cl_no").val(),
            in_no : joueur.find(".in_no").val(),
            li_no : joueur.find(".li_no").val(),
            in_nom : joueur.find(".in_nom").val(),
            in_prenom : joueur.find(".in_prenom").val(),
            in_sexe : joueur.find(".in_sexe").val(),
            mfr_typ : $("#selectReserve").val(),
            mfr_libre : $("#reserveText").val()
            };
        
            var licenseEnr = joueur.find(".li_dat_enr").val();
            var club = joueur.find(".cl_nom").val();
        
/*            data.mfr_libre = ReserveDto.descriptionReserve[data.in_sexe || "M"]
                .replace(new RegExp("\\[NOM_F\\]", 'g'),ReserveDto.signataire.in_nom)
                .replace(new RegExp("\\[PRENOM_F\\]", 'g'),ReserveDto.signataire.in_prenom)
                .replace(new RegExp("\\[LICENCE_F\\]", 'g'),ReserveDto.signataire.in_no)
                .replace(new RegExp("\\[CLUB_F\\]", 'g'),ReserveDto.signataire.cl_nom)
                .replace(new RegExp("\\[ROLE_F\\]", 'g'),ReserveDto.signataire.cfi_typ_role == "J" ? "Capitaine" : "Dirigeant responsable")
                
                .replace(new RegExp("\\[NOM\\]", 'g'), data.in_nom)
                .replace(new RegExp("\\[PRENOM\\]", 'g'), data.in_prenom)
                .replace(new RegExp("\\[LICENCE\\]", 'g'), data.in_no)
                .replace(new RegExp("\\[CLUB\\]", 'g'), club)
                .replace(new RegExp("LI_DAT_ENR", 'g'), licenseEnr)
                
                .replace(/@@@/g, "\n");*/
        
        } else if (joueur.length > 1) {
            var joueurs_cl_no;
            var joueurs_in_no = "";
            var joueurs_li_no = [];
            var joueurs_in_prenom = [];
            var joueurs_in_nom = [];
            var joueur_licesEnr = "";
            var joueurs_club = [];
            var joueur_in_sexe;

            joueur.each(function(){ 
                joueurs_in_no += $(this).find(".in_no").val() + ";";
                joueurs_li_no.push($(this).find(".li_no").val());
                joueurs_cl_no = $(this).find(".cl_no").val();
                joueurs_in_prenom.push($(this).find(".in_prenom").val());
                joueurs_in_nom.push($(this).find(".in_nom").val());
                joueur_in_sexe = $(this).find(".in_sexe").val();
                joueur_licesEnr = $(this).find(".li_dat_enr").val();
                joueurs_club = $(this).find(".cl_nom").val();
            });

            data = {
            mfr_no : 1,
            cfm_no : FeuilleDeMatchDto.data.cfm_no,
            cl_no : joueurs_cl_no,
            in_no : joueurs_in_no,
            li_no : null,
            in_nom : joueurs_in_nom,
            in_prenom : joueurs_in_prenom,
            in_sexe : null,
            mfr_typ : $("#selectReserve").val(),
            mfr_libre : $("#reserveText").val()
            };

/*        data.mfr_libre = ReserveDto.descriptionReserve[data.in_sexe || "M"]
            .replace(new RegExp("\\[NOM_F\\]", 'g'),ReserveDto.signataire.in_nom)
            .replace(new RegExp("\\[PRENOM_F\\]", 'g'),ReserveDto.signataire.in_prenom)
            .replace(new RegExp("\\[LICENCE_F\\]", 'g'),ReserveDto.signataire.in_no)
            .replace(new RegExp("\\[CLUB_F\\]", 'g'),ReserveDto.signataire.cl_nom)
            .replace(new RegExp("\\[ROLE_F\\]", 'g'),ReserveDto.signataire.cfi_typ_role == "J" ? "Capitaine" : "Dirigeant responsable")
            .replace(/@@@/g, "\n");   */

        var nomsPrenoms_joueurs="";
        for(var i=0; i<joueur.length; i++) {
            nomsPrenoms_joueurs += joueurs_in_prenom[i] + " "+ joueurs_in_nom[i];
            if(i < joueur.length - 1){
                nomsPrenoms_joueurs += ", ";
            }
        }

        data.mfr_libre = data.mfr_libre
            .replace(new RegExp("\\[NOM] \\[PRENOM\\]", 'g'),nomsPrenoms_joueurs)
            .replace(new RegExp("\\[LICENCE\\]", 'g'),joueurs_li_no)
            .replace(new RegExp("\\[CLUB\\]", 'g'),joueurs_club)
            .replace(new RegExp("LI_DAT_ENR", 'g'),joueur_licesEnr);
        }

        return data;
    },
    getClubReserve: function() {
        var data = {
            mfr_no : 1,
            cfm_no : FeuilleDeMatchDto.data.cfm_no,
            cl_no : null,
            in_no : null,
            li_no : null,
            in_nom : null,
            in_prenom : null,
            in_sexe : null,
            mfr_typ : $("#selectReserve").val(),
            mfr_libre : $("#enteteReserveDescription").text().replace(/br/g, " ") + $("#reserveText").val()
        };
        
        if (Utils.inArray($("#selectReserve").val(), ["RICV", "RACR"])){
            data.cl_no = MatchDto.match.cr_cl_no;
        } else if (Utils.inArray($("#selectReserve").val(), ["RACV"])){
            data.cl_no = MatchDto.match.cv_cl_no;
        }
        
        return data;
    },
    enregistrerReserve : function() {
        var reservesToSave = [];
        
        if (ReservesService.isReserveSurJoueur($("#selectReserve").val())) {
            reservesToSave.push(ReservesService.getJoueurReserve($(".waitingForTarget")));
        } else {
            reservesToSave.push(ReservesService.getClubReserve());
        }   

        for (var i=0;i<reservesToSave.length;i++) {
            DataBase.insert("MATCH_FEUILLE_RESERVE", reservesToSave[i], function() {
                Engine.selectSetVal($('#selectReserve'), 0);
                $("#reserveText").val("");
                Engine.alert(Lang.reserves.enregistrer);

                DataBase.findBy("MATCH_FEUILLE_RESERVE", "cfm_no", FeuilleDeMatchDto.data.cfm_no, function(datas) {
                    if (datas.length > 0) {
                        ReserveDto.listReserves = datas;
                        ReservesService.refreshReserves();
                        ReservesService.refreshBoutonsBasPage();
                    }
                });
            });
        }
    },
    annulerReserve : function(idDelete, idIndex){
        DataBase.deleteById("MATCH_FEUILLE_RESERVE", idDelete, function(){
            ReserveDto.listReserves.splice(idIndex, 1);
            ReservesService.refreshReserves();
            ReservesService.refreshBoutonsBasPage();
        });
    },
    refreshReserves : function(){
        Engine.addView("#listeReserves","reserves.html:listeReserves", { listReserve : ReserveDto.listReserves, verrouiller : ReserveDto.verrouillage, isNewReserve : false});
            if(ReserveDto.listReserves.length >= 3) {
            Engine.deleteScroll("listReserve");
            Engine.initScrolls("listReserve");
        } 
    },
    refreshBoutonsBasPage : function(){
        Engine.addView("#boutonsBasPage","reserves.html:boutonsBasPage", { listReserve : ReserveDto.listReserves, verrouiller : ReserveDto.verrouillage });
    },
    refreshBoutonPoserReserves : function(){
        Engine.addView("#boutonPoserReserves","reserves.html:boutonPoserReserves", { verrouiller : ReserveDto.verrouillage });
    },
    verifSignatures : function(cfm_no, callback){
        //recherche de l'id en base de la feuille match à mettre à jour
        DataBase.findBy("MATCH_FEUILLE", "cfm_no", cfm_no, function(data) {
            if (((Utils.isNotNull(data[0]["cfm_signat_res_avm_rec"]) && Utils.isNotBlank(data[0]["cfm_signat_res_avm_rec"])) ||
                (Utils.isNotNull(data[0]["cfm_signat_res_avm_vis"]) && Utils.isNotBlank(data[0]["cfm_signat_res_avm_vis"]))) &&
                 Utils.isNotNull(data[0]["cfm_signat_res_avm_arb"]) && Utils.isNotBlank(data[0]["cfm_signat_res_avm_arb"])) {
                ReserveDto.verrouillage = true;
            } else {
                ReserveDto.verrouillage = false;
            }
        });
    },

    isReservesAvantMatchSignatureOk: function () {
        return (Utils.isNotBlank(FeuilleDeMatchDto.data.cfm_signat_res_avm_rec)
            || Utils.isNotBlank(FeuilleDeMatchDto.data.cfm_signat_res_avm_vis))
            && Utils.isNotBlank(FeuilleDeMatchDto.data.cfm_signat_res_avm_arb);
    },
    retourFeuilleDeMatch: function () {
        Engine.gotoPage("feuilleDeMatch.html", {utilisateur : Project.contexteUtilisateur, match : MatchDto.match});
    }
};