var SynchronisationGeneriqueService = {
    callbackPurge : function(table, data, callback) {
        Utils.log(data.length + " enregistrement trouvé dans la table " + table);
        if (data.length == 0) {
            if (typeof callback === 'function') {
                callback();
            }
        } else {
            var cpt = 0;
            for (var i in data) {
                DataBase.deleteById(table, data[i].id, function() {
                    cpt++;
                    if (parseInt(cpt, 10) === parseInt(data.length, 10)) {
                        if (typeof callback === 'function') {
                            callback(data);
                        }
                    }
                });
            }
        }
    },
    purgeAll : function(table, callback) {
        Utils.log("Purge de la table '" + table + "'");
        DataBase.findAll(table, function(data) {
            SynchronisationGeneriqueService.callbackPurge(table, data, callback);
        });
    },
    purge : function(table, callback) {
        SynchronisationGeneriqueService.purgeAll(table, callback);
    },
    insert : function(table, data, callback) {
        var nbToInsert = (Utils.isNotNull(data) && data.constructor == Array) ? data.length : 1; 
        Utils.log(nbToInsert + " à insérer dans la table " + table);
        if (Utils.isNull(data) || data.length == 0) {
            if (typeof callback === 'function') {
                callback();
            }
        } else {
            /*if (data.constructor == Array) {
                var cpt = 0;
                for (var i in data) {
                    DataBase.insert(table, data[i], function() {
                        cpt++;
                        if (cpt == data.length) {
                            if (typeof callback === 'function') {
                                callback();
                            }
                        }
                    });
                }
            } else {*/
                DataBase.insert(table, data, function() {
                    if (typeof callback === 'function') {
                        callback();
                    }
                });
            /*}*/
        }
    },
    
    
    /**
     * Purge de données de manière récursive (simulation du IN).
     * @param {String} table Le nom de la table à purger
     * @param {String} champ Le nom du champ à chercher
     * @param {List} listeValeur Les valeurs à trouver
     * @param {List} dataReturn Les enregistrements trouvés
     * @param {function} callback La méthode de retour
     */
    purgeRecursif: function(table, champ, listeValeur, dataReturn, callback) {
        if (listeValeur.length == 0) {
            SynchronisationGeneriqueService.callbackPurge(table, dataReturn, callback);
        } else {
            var recherche = listeValeur[0];
            listeValeur.shift();
            DataBase.findBy(table, champ, recherche, function(data) {
                if (data.length > 0) {
                    for (var i in data) {
                        dataReturn.push(data[i]);
                    }
                }
                SynchronisationGeneriqueService.purgeRecursif(table, champ, listeValeur, dataReturn, callback);
            });
        }
    }
};