/**
 * Service de transfert des données : https://fdm.fff.fr/fdmpil/log/log.html.
 */
var SynchronisationTransfertService = {
    matchPreparer: null,
    matchsEnCours: null,
    matchsATransmettre: null,
    matchsAutresASynchro: null,
    matchsTermine: null,
    getMatch: function(callback) {
        SynchronisationTransfertService.matchPreparer = [];
        SynchronisationTransfertService.matchsEnCours = [];
        SynchronisationTransfertService.matchsATransmettre = [];
        SynchronisationTransfertService.matchsAutresASynchro = [];
        SynchronisationTransfertService.matchsTermine = [];
        var dejaATransmettre = [];
        // on récupère les matchs de l'utilisateur
        AccueilService.getMatchUtilisateur("N", function(data) {
            if (data.length > 0) {
                for (var i in data) {
                    if (data[i].cfm_statut === "5" || data[i].cfm_statut === "6") {
                        Utils.log("Match Terminé : " + data[i].ma_no);
                        SynchronisationTransfertService.matchsTermine.push(data[i]);
                    } else if (data[i].cfm_statut === "4") {
                        Utils.log("Match à transmettre : " + data[i].ma_no);
                        dejaATransmettre.push(data[i].ma_no);
                        SynchronisationTransfertService.matchsATransmettre.push(data[i]);
                    } else if (data[i].cfm_statut === "3") {
                        Utils.log("Match en cours : " + data[i].ma_no);
                        SynchronisationTransfertService.matchsEnCours.push(data[i]);
                    } else if (data[i].cfm_statut === "2") {
                        Utils.log("Match préparé : " + data[i].ma_no);
                        SynchronisationTransfertService.matchPreparer.push(data[i]); 
                    }
                }
            }

            DataBase.findBy("MATCH", "cfm_statut", ["4"], function(data) {
                if (data.length > 0) {
                    for (var i in data) {
                        if (!Utils.containsInArray(data[i].ma_no, dejaATransmettre)) {
                            SynchronisationTransfertService.matchsATransmettre.push(data[i]);
                            SynchronisationTransfertService.matchsAutresASynchro.push(data[i]);
                            dejaATransmettre.push(data[i].ma_no);
//                            Utils.log("Match à transmettre (d'une autre équipe) : " + data[i].ma_no);
                        }
                    }
                }
                Utils.log("Match préparé (T001)");
                Utils.log(SynchronisationTransfertService.matchPreparer);
                Utils.log("Match en cours (T005)");
                Utils.log(SynchronisationTransfertService.matchsEnCours);
                Utils.log("Match à transmettre (T002)");
                Utils.log(SynchronisationTransfertService.matchsATransmettre);
                Utils.log("Match terminé (T003)");
                Utils.log(SynchronisationTransfertService.matchsTermine);
                callback();
            });
        });
    },
    getCompositionForOneMatch: function(maNo, cfmNo, clNo, callback) {
        var champs = "ma_noAndcfm_noAndcfi_cl_no";
        var valeurs = [maNo, cfmNo, clNo];
        if (clNo === null) {
            champs = "ma_noAndcfm_no";
            valeurs = [maNo, cfmNo];
        }
        DataBase.findBy("MATCH_FEUILLE_COMPO", champs, valeurs, function(dataReturn) {
            var myData = [];
            if (dataReturn.length > 0) {
                for (var ii in dataReturn) {
                    if ((dataReturn[ii].li_mut != null) && (dataReturn[ii].li_mut === "")){
                        dataReturn[ii].li_mut = null;
                    }
                    if ((dataReturn[ii].cfi_capi != null) && (dataReturn[ii].cfi_capi === "CC")){
                        dataReturn[ii].cfi_capi = "C";
                    }
                    if ((dataReturn[ii].cfi_maillot != null) && (dataReturn[ii].cfi_maillot.length > 2)){
                        dataReturn[ii].cfi_maillot = dataReturn[ii].cfi_maillot / 10;
                    }
                    myData.push({
                        li_no : Utils.wsValue(dataReturn[ii].li_no),
                        ma_no : dataReturn[ii].ma_no,
                        cfm_no : dataReturn[ii].cfm_no,
                        cfi_cl_no : dataReturn[ii].cfi_cl_no,
                        cfi_poste : dataReturn[ii].cfi_poste,
                        cfi_ordre : dataReturn[ii].cfi_ordre,
                        cfi_maillot : dataReturn[ii].cfi_maillot,
                        cfi_capi : dataReturn[ii].cfi_capi,
                        cfi_typ_role : dataReturn[ii].cfi_typ_role,
                        cfi_role : dataReturn[ii].cfi_role,
                        tq_no: dataReturn[ii].tq_no,
                        li_statut : dataReturn[ii].li_statut,
                        li_mut : dataReturn[ii].li_mut,
                        in_nat : dataReturn[ii].in_nat,
                        dat_modif : dataReturn[ii].dat_modif,
                        usr_no : dataReturn[ii].usr_no,
                        in_no : dataReturn[ii].in_no,
                        in_nom : dataReturn[ii].in_nom,
                        in_prenom : dataReturn[ii].in_prenom,
                        in_dat_nais : dataReturn[ii].in_dat_nais
                    });
                }
            }
            callback(myData);
        });
    },
    getComposition: function(callback) {
        if (SynchronisationTransfertService.matchsEnCours.length == 0 && SynchronisationTransfertService.matchPreparer.length == 0 ) {
            callback();
        } else {
            var cpt = 0;
            if (SynchronisationTransfertService.matchsEnCours.length > 0) {
                for(var i in SynchronisationTransfertService.matchsEnCours) {
                    var individuComposition = [];
                    SynchronisationTransfertService.getCompositionForOneMatch(SynchronisationTransfertService.matchsEnCours[i].ma_no, 
                            SynchronisationTransfertService.matchsEnCours[i].cfm_no, Project.contexteUtilisateur.usr_equipe[0].cl_no, function(myData) {
                        if (myData.length > 0) {
                            individuComposition.push(myData);
                        }
                        cpt++;
                        if (parseInt(cpt, 10) === parseInt(SynchronisationTransfertService.matchsEnCours.length, 10)) {
                            SynchronisationTransfertService.transmissionComposition(individuComposition, callback);
                        }
                    });
                }
               
            } else if (SynchronisationTransfertService.matchPreparer.length > 0) {
                cpt = 0;
                for(var i in SynchronisationTransfertService.matchPreparer) {
                    var individuComposition = [];
                    SynchronisationTransfertService.getCompositionForOneMatch(SynchronisationTransfertService.matchPreparer[i].ma_no,  
                        SynchronisationTransfertService.matchPreparer[i].cfm_no, Project.contexteUtilisateur.usr_equipe[0].cl_no, function(myData) {
                        if (myData.length > 0) {
                            individuComposition.push(myData);
                        }
                        cpt++;
                        if (parseInt(cpt, 10) === parseInt(SynchronisationTransfertService.matchPreparer.length, 10)) {
                            SynchronisationTransfertService.transmissionComposition(individuComposition, callback);
                        }
                    });
                }
            }
        }
    },
    dataComposition : [],
    dataCompositionToTransmission : [],
    transmissionComposition: function(individuComposition, callback) {
        if (individuComposition.length == 0) {
            callback();
        } else {
            SynchronisationTransfertService.dataComposition = [];
            SynchronisationTransfertService.dataCompositionToTransmission = [];
            var data = [];
            if (individuComposition.length > 0) {
                for (var i in individuComposition) {
                    if (Utils.isNotBlank(individuComposition[i][0].dat_modif)) {
                        data.push({
                            ma_no : parseInt(individuComposition[i][0].ma_no, 10),
                            cfm_no : parseInt(individuComposition[i][0].cfm_no, 10),
                            cfi_cl_no : parseInt(individuComposition[i][0].cfi_cl_no, 10),
                            dat_modif : Utils.isNotBlank(individuComposition[i][0].dat_modif) ? individuComposition[i][0].dat_modif : "",
                            usr_no : !isNaN(individuComposition[i][0].usr_no) ? parseInt(individuComposition[i][0].usr_no, 10) : "",
                            tq_no : individuComposition[i][0].tq_no == 0 ? null : parseInt(individuComposition[i][0].tq_no, 10),
                            individu : individuComposition[i]
                        });
                        for (var j in data[data.length - 1].individu) {
                            delete data[data.length - 1].individu[j].ma_no;
                            delete data[data.length - 1].individu[j].cfm_no;
                            delete data[data.length - 1].individu[j].cfi_cl_no;
                            delete data[data.length - 1].individu[j].tq_no;
                            delete data[data.length - 1].individu[j].id;
                        }
                    }
                }
            }
            if (data.length === 0) {
                callback();   
            } else {
                var cpt = 0;
                if (data.length > 0) {
                    for (var i in data) {
                        Engine.getDemande("DT01", {
                            "ma_no": data[i].ma_no,
                            "cfm_no": data[i].cfm_no,
                            "cfi_cl_no": data[i].cfi_cl_no,
                            "dat_modif": data[i].dat_modif,
                            "usr_no": data[i].usr_no 
                        }, function(json) {
                            if (json.data === "1") {
                                var date = json.date_trans;
                                var usr_no = json.usr_no;
                                DataBase.findBy("UTILISATEUR", "usr_no", usr_no, function(utilisateur) {
                                    DataBase.findBy("MATCH", "ma_no", data[cpt].ma_no, function(dataMatch) {
                                        var text = "Il existe une autre composition sur le serveur pour le match " + dataMatch[0].cr_eq_nom_abr + " - " + dataMatch[0].cv_eq_nom_abr;
                                        text += " par " + utilisateur[0].usr_nom_conx + " le " + date + ", souhaitez-vous transmettre votre composition ?";
                                        SynchronisationTransfertService.dataComposition.push({
                                            data : data[cpt],
                                            text : text
                                        });
                                        cpt++;
                                        if (cpt === data.length) {
                                            SynchronisationTransfertService.launchTransmissionComposition(callback);
                                        }
                                    });
                                });
                            } else {
                                SynchronisationTransfertService.dataComposition.push({
                                    data : data[cpt],
                                    text : ""
                                });
                                cpt++;
                                if (cpt === data.length) {
                                    SynchronisationTransfertService.launchTransmissionComposition(callback);
                                }
                            }
                            
                        }, function() {
                            SynchronisationService.showError(Lang.synchronisation.erreurTransmissionCompositionConflit);
                        });
                    }
                }
            }
        }
    },
    dataEc : null,
    launchTransmissionComposition: function(callback) {
        if (SynchronisationTransfertService.dataComposition.length === 0) {
            if (SynchronisationTransfertService.dataCompositionToTransmission.length === 0) {
                callback();
            } else {
                var cpt = 0;
                if (SynchronisationTransfertService.dataCompositionToTransmission.length > 0) {
                    for (var i in SynchronisationTransfertService.dataCompositionToTransmission) {
                        Engine.getDemande("T001", {"match_feuille_compo": SynchronisationTransfertService.dataCompositionToTransmission[i].data, "equipe_type": null}, function(json) {
                            cpt++;
                            if (parseInt(cpt, 10) === parseInt(SynchronisationTransfertService.dataCompositionToTransmission.length, 10)) {
                                callback();
                            }
                        }, function() {
                            SynchronisationService.showError(Lang.synchronisation.erreurTransmissionComposition);
                        });
                    }
                }
            }
        } else {
            SynchronisationTransfertService.dataEc = SynchronisationTransfertService.dataComposition[0];
            SynchronisationTransfertService.dataComposition.shift();
            
            if (Utils.isNotBlank(SynchronisationTransfertService.dataEc.text)) {
                Engine.confirmConflit(SynchronisationTransfertService.dataEc.text, function() {
                    Engine.fermerPopup(true);
                    SynchronisationTransfertService.dataCompositionToTransmission.push(SynchronisationTransfertService.dataEc);
                    SynchronisationTransfertService.launchTransmissionComposition(callback);
                }, function() {
                    Engine.fermerPopup(true);
                    SynchronisationTransfertService.launchTransmissionComposition(callback);
                });
            } else {
                SynchronisationTransfertService.dataCompositionToTransmission.push(SynchronisationTransfertService.dataEc);
                SynchronisationTransfertService.launchTransmissionComposition(callback);
            }
        }
    },
    getEquipeType: function(callback/*(individuEquipeType : Array)*/) {
        SynchronisationTransfertService.rechercherIndividuEquipeType(Project.contexteUtilisateur.cl_no, function (individuEquipeType) {
            SynchronisationTransfertService.transmissionEquipeType(individuEquipeType, callback);
        });
    },
    transmissionCgu: function(callback) {
        DataBase.findBy("CGU", "usr_no", Project.contexteUtilisateur.usr_no, function(data) {
            if(data.length > 0) {
                var cgu = {
                    cgu_dat : data[0]["cgu_dat"],
                    cgu_no : data[0]["cgu_no"],
                    id : data[0]["id"],
                    usr_no : data[0]["usr_no"]
                };
                Engine.getDemande("T004", {"cgu":[cgu]}, function(json) {
                    if (typeof callback === 'function') {
                        callback();
                    }
                });
            } else {
                if (typeof callback === 'function') {
                    callback();
                }
            }
        });
    },
    transmissionEquipeType: function(individuEquipeType, callback) {
        if (individuEquipeType.length == 0) {
            if (typeof callback === 'function') {
                callback();
            }
        } else {
            var cpt = 0;
            var cpt_test = 0;
            if (individuEquipeType.length > 0) {
                for (var i in individuEquipeType) {
                    cpt_test = 0;
                    var data = {
                        cei_no : individuEquipeType[i][0].cei_no,
                        eq_cod : parseInt(individuEquipeType[i][0].eq_cod, 10),
                        lc_cod : individuEquipeType[i][0].lc_cod,
                        cl_no : parseInt(individuEquipeType[i][0].cl_no, 10),
                        sa_no : parseInt(individuEquipeType[i][0].sa_no, 10),
                        tq_no: individuEquipeType[i][0].tq_no == 0 ? null : parseInt(individuEquipeType[i][0].tq_no, 10),
                        equipe_type_individu : individuEquipeType[i]
                    };
                    for (var j in data.equipe_type_individu) {
                        delete data.equipe_type_individu[j].cei_no;
                        delete data.equipe_type_individu[j].eq_cod;
                        delete data.equipe_type_individu[j].lc_cod;
                        delete data.equipe_type_individu[j].cl_no;
                        delete data.equipe_type_individu[j].sa_no;
                        delete data.equipe_type_individu[j].tq_no;
                        if(data.equipe_type_individu[j].in_no == "") {
                            cpt_test++; 
                        }
                    }
                    
                    if(cpt_test == data.equipe_type_individu.length){
                         data.equipe_type_individu = [];
                    }

                    Engine.getDemande("T001", {"match_feuille_compo": null, "equipe_type": data}, function(json) {
                        cpt++;
                        if (parseInt(cpt, 10) === parseInt(individuEquipeType.length, 10)) {
                            if (typeof callback === 'function') {
                                callback();
                            }
                        }
                    }, function() {
                        SynchronisationService.showError(Lang.synchronisation.erreurTransmissionEquipeType);
                    });
                }
            }
        }
    },

    transmissionFeuilleMatchHisto: function (cfm_no, callback) {
        DataBase.findBy("FEUILLE_MATCH_HISTO", "cfm_no", cfm_no, function(dataReturn) {
            if (dataReturn.length == 0) {
                callback();
            } else {
                var histo = [];
                for (var ii in dataReturn) {
                    histo.push({
                        "cfm_no" : parseInt(dataReturn[ii].cfm_no, 10),
                        "cfmh_dat" : dataReturn[ii].cfmh_dat +" " + dataReturn[ii].cfmh_heure,
                        "cfmh_flux" : JSON.parse(dataReturn[ii].cfmh_flux)
                    });
                }
                Engine.getDemande("T005", { "feuille_match_histo" : histo }, function() {
                    callback();
                }, function() {
                    SynchronisationService.showError(Lang.synchronisation.erreurTransmissionHistoFeuilleDeMatch);
                });
            }
        });
    },
    
    getFeuilleDeMatchForOneMatch: function(cfm_no, callback, enableT005) {

        //
        // FEV13 EVO 5
        // Activer/Désactiver l'envoi d'une T005
        //
        enableT005 = enableT005 || true;

        DataBase.findBy("MATCH_FEUILLE", "cfm_no", cfm_no, function(myData) {
            
            if (myData.length > 0) {
                var data = {
                    "match_feuille": {},
                    "match_feuille_compo": null,
                    "match_feuille_evenement": null,
                    "match_feuille_membre": null,
                    "match_feuille_reserve": null,
                };
                for (var k in myData[0]) {
                    if (k !== "id") {
                        data.match_feuille[k] = myData[0][k];
                    }
                }
                data.match_feuille.cfm_no = parseInt(data.match_feuille.cfm_no, 10);
                data.match_feuille.ma_no = parseInt(data.match_feuille.ma_no, 10);
                data.match_feuille.ma_min_period1 = Utils.parseInt(data.match_feuille.ma_min_period1);
                data.match_feuille.ma_min_period1_sup = Utils.parseInt(data.match_feuille.ma_min_period1_sup);
                data.match_feuille.ma_min_period2 = Utils.parseInt(data.match_feuille.ma_min_period2);
                data.match_feuille.ma_min_period2_sup = Utils.parseInt(data.match_feuille.ma_min_period2_sup);
                data.match_feuille.ma_min_prol = Utils.parseInt(data.match_feuille.ma_min_prol);
                data.match_feuille.ma_min_prol_sup1 = Utils.parseInt(data.match_feuille.ma_min_prol_sup1);
                data.match_feuille.ma_min_prol_sup2 = Utils.parseInt(data.match_feuille.ma_min_prol_sup2);
                data.match_feuille.ma_min_arret = Utils.parseInt(data.match_feuille.ma_min_arret);
                data.match_feuille.ma_min_arret_sup = Utils.parseInt(data.match_feuille.ma_min_arret_sup);
                data.match_feuille.cr_nb_but = Utils.parseInt(data.match_feuille.cr_nb_but);
                data.match_feuille.cv_nb_but = Utils.parseInt(data.match_feuille.cv_nb_but);
                data.match_feuille.cr_nb_tir_but = Utils.parseInt(data.match_feuille.cr_nb_tir_but);
                data.match_feuille.cv_nb_tir_but = Utils.parseInt(data.match_feuille.cv_nb_tir_but);
                data.match_feuille.cr_nb_but_tps_reglt = Utils.parseInt(data.match_feuille.cr_nb_but_tps_reglt);
                data.match_feuille.cv_nb_but_tps_reglt = Utils.parseInt(data.match_feuille.cv_nb_but_tps_reglt);
                data.match_feuille.cfm_nb_signat_avm = Utils.parseInt(data.match_feuille.cfm_nb_signat_avm);
                data.match_feuille.cfm_nb_signat_fm = Utils.parseInt(data.match_feuille.cfm_nb_signat_fm);
                data.match_feuille.in_no_avm_rec = Utils.parseInt(data.match_feuille.in_no_avm_rec);
                data.match_feuille.in_no_avm_vis = Utils.parseInt(data.match_feuille.in_no_avm_vis);
                data.match_feuille.in_no_avm_arb = Utils.parseInt(data.match_feuille.in_no_avm_arb);
                data.match_feuille.in_no_ravm_rec = Utils.parseInt(data.match_feuille.in_no_ravm_rec);
                data.match_feuille.in_no_res_avm_vis = Utils.parseInt(data.match_feuille.in_no_res_avm_vis);
                data.match_feuille.in_no_res_avm_arb = Utils.parseInt(data.match_feuille.in_no_res_avm_arb);
                data.match_feuille.in_no_tech_apm_rec = Utils.parseInt(data.match_feuille.in_no_tech_apm_rec);
                data.match_feuille.in_no_tech_apm_vis = Utils.parseInt(data.match_feuille.in_no_tech_apm_vis);
                data.match_feuille.in_no_tech_apm_arb = Utils.parseInt(data.match_feuille.in_no_tech_apm_arb);
                data.match_feuille.in_no_tech_apm_ass = Utils.parseInt(data.match_feuille.in_no_tech_apm_ass);
                data.match_feuille.in_no_obs_apm_rec = Utils.parseInt(data.match_feuille.in_no_obs_apm_rec);
                data.match_feuille.in_no_obs_apm_vis = Utils.parseInt(data.match_feuille.in_no_obs_apm_vis);
                data.match_feuille.in_no_obs_apm_arb = Utils.parseInt(data.match_feuille.in_no_obs_apm_arb);
                data.match_feuille.in_no_apm_rec = Utils.parseInt(data.match_feuille.in_no_apm_rec);
                data.match_feuille.in_no_apm_vis = Utils.parseInt(data.match_feuille.in_no_apm_vis);
                data.match_feuille.in_no_apm_arb = Utils.parseInt(data.match_feuille.in_no_apm_arb);
                data.match_feuille.cfm_recette = Utils.parseInt(data.match_feuille.cfm_recette);
                data.match_feuille.cfm_nb_spect = Utils.parseInt(data.match_feuille.cfm_nb_spect);
                
                SynchronisationTransfertService.getCompositionForOneMatch(myData[0].ma_no, myData[0].cfm_no, null, function(individuComposition) {
                    if (individuComposition.length > 0) {
                        data.match_feuille_compo = {
                            ma_no : parseInt(individuComposition[0].ma_no, 10),
                            cfm_no : parseInt(individuComposition[0].cfm_no, 10),
                            cfi_cl_no : parseInt(individuComposition[0].cfi_cl_no, 10),
                            tq_no : individuComposition[0].tq_no == 0 ? null : parseInt(individuComposition[0].tq_no, 10),
                            individu : individuComposition
                        };
                        Utils.convertDataParseInt(data.match_feuille_compo.individu);
                    }
                    
                    DataBase.findBy("MATCH_FEUILLE_EVENEMENT", "ma_noAndcfm_no", [myData[0].ma_no, myData[0].cfm_no], function(dataReturn) {
                        if (dataReturn.length > 0) {
                            var dataTransmis = Utils.convertArrayToArrayJson(dataReturn);
                            for (var k in dataTransmis) {
                                if (Utils.isNotNull(dataTransmis[k].cfe_action)) {
                                    dataTransmis[k].cfe_action = dataTransmis[k].cfe_action.substring(0, 2);
                                }
                            }
                            data.match_feuille_evenement = {
                                ma_no : parseInt(dataReturn[0].ma_no, 10),
                                cfm_no : parseInt(dataReturn[0].cfm_no, 10),
                                evenement : dataTransmis
                            };
                            Utils.convertDataParseInt(data.match_feuille_evenement.evenement);
                        } 
                        DataBase.findBy("MATCH_FEUILLE_MEMBRE", "ma_noAndcfm_no", [myData[0].ma_no, myData[0].cfm_no], function(dataReturn) {
                            if (dataReturn.length > 0) {
                                var dataTransmis = Utils.convertArrayToArrayJson(dataReturn);
                                for (var k in dataTransmis) {
                                    // TODO : mmf_pres est obligatoire et sur un seul caractère ! Pourquoi est-il vide ? 
                                    dataTransmis[k].mmf_pres = "T";
                                }
                                data.match_feuille_membre = {
                                    ma_no : parseInt(dataReturn[0].ma_no, 10),
                                    cfm_no : parseInt(dataReturn[0].cfm_no, 10),
                                    individu : dataTransmis
                                };
                                for (var i in data.match_feuille_membre.individu) {
                                    var tmp = [data.match_feuille_membre.individu[i]];
                                    if (!(data.match_feuille_membre.individu[i].mmf_typ_piece == "IN")) {
                                        var savePiece = data.match_feuille_membre.individu[i].mmf_in_no;
                                        Utils.convertDataParseInt(tmp);
                                        // si mmf_in_no est autre qu'une licence, repasser la variable en string
                                        data.match_feuille_membre.individu[i].mmf_in_no = savePiece;
                                    }
                                    else {
                                        Utils.convertDataParseInt(tmp);
                                    }
                                }
                            } 
                            DataBase.findBy("MATCH_FEUILLE_RESERVE", "cfm_no", myData[0].cfm_no, function(dataReturn) {
                                // RG : On transmet les réserves d'avant match au SI si et seulement si elles ont été signées par tout les membres signataires.
                                if (Utils.isBlank(data.match_feuille.cfm_signat_res_avm_arb) 
                                        || (Utils.isBlank(data.match_feuille.cfm_signat_res_avm_rec)
                                        && Utils.isBlank(data.match_feuille.cfm_signat_res_avm_vis))) {
                                    data.match_feuille_reserve = null;
                                } else {
                                    if (dataReturn.length > 0) {
                                        //Pour la réserve mutli-joueurs, les champs in_nom,in_prenom,in_sex et li_o sont null.
                                        //Le champ in_no contient tous les in_no des joueurs séparé par ";"
                                        //Le champ in_no est conservé dans in_no_reserveMulti en type string.
                                        var in_no_reserveMulti = [];
                                        var indexReserve = 0;
                                        dataReturn.forEach(function (dataReserve){
                                            if(dataReserve.in_nom !== null && dataReserve.in_nom.indexOf(",") !== -1) {
                                                indexReserve = dataReturn.indexOf(dataReserve);
                                                dataReturn[indexReserve].in_nom = null;
                                                dataReturn[indexReserve].in_prenom = null;
                                                in_no_reserveMulti.push(dataReserve.in_no);
                                            }
                                        });   
                                        data.match_feuille_reserve = {
                                            cfm_no : parseInt(dataReturn[0].cfm_no, 10),
                                            reserve : Utils.convertArrayToArrayJson(dataReturn)
                                        };
                                        Utils.convertDataParseInt(data.match_feuille_reserve.reserve);

                                        var i=0;
                                        data.match_feuille_reserve.reserve.forEach(function (dataReserve) {
                                            if(dataReserve.in_nom == null && dataReserve.mfr_typ !== "RICV" && dataReserve.mfr_typ !== "RACV" && dataReserve.mfr_typ !== "RACR") {
                                                indexReserve = data.match_feuille_reserve.reserve.indexOf(dataReserve);
                                                data.match_feuille_reserve.reserve[indexReserve].in_no = in_no_reserveMulti[i];
                                                i++;
                                            }  
                                        });
                                    }
                                }
                                
                                // RG : On transmet les réserves techniques au SI si et seulement si elles ont été approuvées.
                                // Les réserves techniques sont approuvées si toute les conditions ci-dessous sont remplis
                                //   - La signature de l'arbitre est présente
                                //   - La signature de l'arbitre assistant est présente
                                //   - La signature de l'équipe recevante est présente ou l'équipe recevante a été indiquée absente après le match.
                                //   - La signature de l'équipe visiteuse est présente ou l'équipe visiteuse a été indiquée absente après le match.
                                if (Utils.isBlank(data.match_feuille.cfm_signat_tech_apm_arb) 
                                        || Utils.isBlank(data.match_feuille.cfm_signat_tech_apm_ass) 
                                        || (Utils.isBlank(data.match_feuille.cfm_signat_tech_apm_rec) && data.match_feuille.cr_abs_tech_apm !== "O")
                                        || (Utils.isBlank(data.match_feuille.cfm_signat_tech_apm_vis) && data.match_feuille.cv_abs_tech_apm !== "O")) {
                                    data.match_feuille.cfm_res_tech_apm = null;
                                }
                                
                                // RG : On transmet les observations d'après match au SI si et seulement si elles ont été approuvées.
                                // Les observations d'après match sont approuvées si toute les conditions ci-dessous sont remplis
                                //   - La signature de l'arbitre est présente
                                //   - La signature de l'équipe recevante est présente ou l'équipe recevante a été indiquée absente après le match.
                                //   - La signature de l'équipe visiteuse est présente ou l'équipe visiteuse a été indiquée absente après le match.
                                if (Utils.isBlank(data.match_feuille.cfm_signat_obs_apm_arb) 
                                        || (Utils.isBlank(data.match_feuille.cfm_signat_obs_apm_rec) && data.match_feuille.cr_abs_obs_apm !== "O")
                                        || (Utils.isBlank(data.match_feuille.cfm_signat_obs_apm_vis) && data.match_feuille.cv_abs_obs_apm !== "O")) {
                                    data.match_feuille.cfm_obs_apm = null;
                                }
                                
                                // Exlusion des données de mot de passe de rencontre
                                delete data.match_feuille.cfm_cr_mdp;
                                delete data.match_feuille.cfm_cr_question;
                                delete data.match_feuille.cfm_cr_rep;
                                delete data.match_feuille.cfm_cv_mdp;
                                delete data.match_feuille.cfm_cv_question;
                                delete data.match_feuille.cfm_cv_rep;
                                
                                // Exlusion des données indiquant les équipes absentes après le match
                                delete data.match_feuille.cr_abs_tech_apm;
                                delete data.match_feuille.cv_abs_tech_apm;
                                delete data.match_feuille.cr_abs_obs_apm;
                                delete data.match_feuille.cv_abs_obs_apm;
                                
                                if (enableT005 === true) {
                                    SynchronisationTransfertService.transmissionFeuilleMatchHisto(myData[0].cfm_no, function () {
                                        callback(data);
                                    });
                                }
                            });
                        });
                    });
                    
                });
            }
            else {
                callback(null);
            }
        });
    },

    // 
    // FEV 13 EVO 5 - FMH
    // Transmission de l'historique des feuilles de match en cours avant de démarrer
    // la synchronisation
    // 
    getFeuilleDeMatchEnCours: function (callback) {
        if (SynchronisationTransfertService.matchsEnCours.length == 0) {
            callback();
        } else {
            var cpt = 0;
            for (var i in SynchronisationTransfertService.matchsEnCours) {
                SynchronisationTransfertService.getFeuilleDeMatchForOneMatch(SynchronisationTransfertService.matchsEnCours[i].cfm_no, function(data) {
                    var date = Utils.getDate();
                    var dataHisto = {
                        cfmh_no : null,
                        cfm_no : SynchronisationTransfertService.matchsEnCours[i].cfm_no,
                        cfmh_dat : date.split(" ")[0],
                        cfmh_heure : date.split(" ")[1],
                        cfmh_flux : JSON.stringify(data)    
                    };
                    DataBase.insert("FEUILLE_MATCH_HISTO", dataHisto, function() {
                        SynchronisationTransfertService.transmissionFeuilleMatchHisto(SynchronisationTransfertService.matchsEnCours[i].cfm_no, function () {
                            cpt++;
                            if (cpt === SynchronisationTransfertService.matchsEnCours.length) {
                                callback();
                            }
                        });
                    });
                }, false);
            }
        }
    },

    getFeuilleDeMatch: function(callback) {
        if (SynchronisationTransfertService.matchsATransmettre.length == 0) {
            callback();
        } else {
            var cpt = 0;
            if (SynchronisationTransfertService.matchsATransmettre.length > 0) {
                for (var i in SynchronisationTransfertService.matchsATransmettre) {
                    
                    SynchronisationTransfertService.getFeuilleDeMatchForOneMatch(SynchronisationTransfertService.matchsATransmettre[i].cfm_no, function(data) {
                        Engine.getDemande("T002", data, function(json) {
                            cpt++;
                            if (parseInt(cpt, 10) === parseInt(SynchronisationTransfertService.matchsATransmettre.length, 10)) {
                                if (SynchronisationTransfertService.matchsAutresASynchro.length > 0) {
                                    for (var i in SynchronisationTransfertService.matchsAutresASynchro) {
                                        DataBase.update("MATCH", SynchronisationTransfertService.matchsAutresASynchro[i].id, "cfm_statut", 5, function() {});
                                    }
                                }
                                callback();
                            }
                        }, function() {
                            SynchronisationService.showError(Lang.synchronisation.erreurTransmissionFeuilleDeMatch);
                        });
                    });
                }
            }
        }
    },
    
    getInfosCompletementaireForOneMatch: function(cfm_no, callback) {
        DataBase.findBy("MATCH_FEUILLE", "cfm_no", cfm_no, function(myData) {
            if (myData.length === 0) {
                return callback();
            }

            var data = {
                "match_feuille": {
                    "cfm_no": parseInt(myData[0].cfm_no, 10),
                    "cfm_recette": myData[0].cfm_recette,
                    "cfm_nb_spect": myData[0].cfm_nb_spect,
                    "tq_no" : null
                },
                "match_feuille_compo": null,
                "match_feuille_evenement": null,
            };
            
            SynchronisationTransfertService.getCompositionForOneMatch(myData[0].ma_no, myData[0].cfm_no, Project.contexteUtilisateur.usr_equipe[0].cl_no, function(individuComposition) {
                if (individuComposition.length > 0) {
                    data.match_feuille.tq_no = individuComposition[0].tq_no == 0 ? null : parseInt(individuComposition[0].tq_no, 10);
                }
                
                DataBase.findBy("MATCH_FEUILLE_EVENEMENT", "ma_noAndcfm_no", [myData[0].ma_no, myData[0].cfm_no], function(dataReturn) {
                    if (dataReturn.length > 0) {
                        var dataTransmis = Utils.convertArrayToArrayJson(dataReturn);
                        for (var k in dataTransmis) {
                            if (Utils.isNotNull(dataTransmis[k].cfe_action)) {
                                dataTransmis[k].cfe_action = dataTransmis[k].cfe_action.substring(0, 2);
                            }
                        }
                        data.match_feuille_evenement = {
                            ma_no : parseInt(dataReturn[0].ma_no, 10),
                            cfm_no : parseInt(dataReturn[0].cfm_no, 10),
                            evenement : dataTransmis
                        };
                        Utils.convertDataParseInt(data.match_feuille_evenement.evenement);
                    } 
                    callback(data);
                });
                
            });
        });
    },
    getInfosCompletementaire: function(callback) {
        if (SynchronisationTransfertService.matchsTermine.length == 0) {
            callback();
        } else {
            var cpt = 0;
            var feuilleDeMatch = [];
            if (SynchronisationTransfertService.matchsTermine.length > 0) {
                for (var i in SynchronisationTransfertService.matchsTermine) {
                    
                    SynchronisationTransfertService.getInfosCompletementaireForOneMatch(SynchronisationTransfertService.matchsTermine[i].cfm_no, function(data) {
                        if (data !== undefined) {
                            Engine.getDemande("T003", data, function(json) {
                                cpt++;
                                if (cpt === parseInt(SynchronisationTransfertService.matchsTermine.length, 10)) {
                                    callback();
                                }
                            }, function() {
                                SynchronisationService.showError(Lang.synchronisation.erreurTransmissionInfosComplementaires);
                            });
                        } else {
                            cpt++;
                            if (cpt === parseInt(SynchronisationTransfertService.matchsTermine.length, 10)) {
                                callback();
                            }
                        }
                    });
                }
            }
        }
    },
    transfertCompositionAvecEquipesType: function(maNo, cfmNo, clNo, callback) {
        Engine.addView("#alert","index.html:synchro", {mode: "transmission"});
        Engine.popup("#alert");
        SynchronisationService.startTime = new Date().getTime();
        SynchronisationDto.nmMatch = "";
        SynchronisationService.setPourcent(0);
        $("#popup-gen .alerteFermer").hide();
        SynchronisationTransfertService.getCompositionForOneMatch(maNo, cfmNo, clNo, function(myData) {
            var individuComposition = [];
            if (myData.length > 0) {
                individuComposition.push(myData);
            }
            SynchronisationTransfertService.transmissionComposition(individuComposition, function() {
                SynchronisationTransfertService.rechercherIndividuEquipeType(clNo, function (individuEquipeType) { 
                    SynchronisationTransfertService.transmissionEquipeType(individuEquipeType, function () {
                        SynchronisationService.endTransmission();
                        if (typeof callback === 'function') {
                            callback();
                        }
                    });
                });
                
            });
        });
    },
    transfertFeuilleDeMatchUnitaire: function(cfmNo, callback) {
        Engine.addView("#alert","index.html:synchro", {mode: "transmission"});
        Engine.popup("#alert");
        SynchronisationService.startTime = new Date().getTime();
        SynchronisationDto.nmMatch = "";
        SynchronisationService.setPourcent(0);
        $("#popup-gen .alerteFermer").hide();
        
        SynchronisationTransfertService.getFeuilleDeMatchForOneMatch(cfmNo, function(data) {
            Engine.getDemande("T002", data, function(json) {
                SynchronisationService.endTransmission();
                if (typeof callback === 'function') {
                    callback();
                }
            }, function(error) {
                // Pas de connection internet
                if (error.status == "404" || error.status == "0") {
                    SynchronisationService.showError(Lang.erreurConnectionInternet);
                // Erreur de transmission au SI
                } else {
                    SynchronisationService.showError(Lang.synchronisation.erreurTransmissionFeuilleDeMatch);
                }
            }, null, false);
        });
    },
    transfertInfosCompletementaireUnitaire: function(cfmNo, callback) {
        Engine.addView("#alert","index.html:synchro", {mode: "transmission"});
        Engine.popup("#alert");
        SynchronisationService.startTime = new Date().getTime();
        SynchronisationDto.nmMatch = "";
        SynchronisationService.setPourcent(0);
        $("#popup-gen .alerteFermer").hide();
        
        SynchronisationTransfertService.getInfosCompletementaireForOneMatch(cfmNo, function(data) {
            Engine.getDemande("T003", data, function(json) {
                SynchronisationService.endTransmission();
                if (typeof callback === 'function') {
                    callback();
                }
            }, function() {
                SynchronisationService.showError(Lang.synchronisation.erreurTransmissionInfosComplementaires);
            });
        });
    },
    saveHistoFeuilleDeMatch: function(cfmNo, callback) {
        SynchronisationTransfertService.getFeuilleDeMatchForOneMatch(cfmNo, function(data) {
            var date = Utils.getDate();
            var dataHisto = {
                cfmh_no : null,
                cfm_no : cfmNo,
                cfmh_dat : date.split(" ")[0],
                cfmh_heure : date.split(" ")[1],
                cfmh_flux : JSON.stringify(data)    
            };
            DataBase.insert("FEUILLE_MATCH_HISTO", dataHisto, function() {
                callback();
            });
        });
    },
    /**
     * Rechercher toutes les équipes types d'un club
     * @param {Object} cl_no L'identifiant du club
     * @param {Object} callback 
     */
    rechercherIndividuEquipeType: function(cl_no, callback/*(individuEquipeType : Array)*/) {
        var cpt = 0;
        DataBase.findBy("UTILISATEUR_EQUIPE", "cl_no", [cl_no], function(utilisateurEquipes) {
            if (utilisateurEquipes.length > 0) {
                var individuEquipeType = [];
                for (var i = 0; i < utilisateurEquipes.length; i++) {
                    var equipe = utilisateurEquipes[i];
                    for (var j = 1; j <= 10; j++) {
                        DataBase.findBy("EQUIPE_TYPE_INDIVIDU", "cei_noAndeq_codAndlc_codAndcl_no", [j, equipe.eq_cod, equipe.lc_cod, equipe.cl_no], function(dataReturn) {
                            cpt++;
                            if (dataReturn.length > 0) {
                                var myData = [];
                                for (var ii in dataReturn) {
                                    myData.push({
                                        cei_no : dataReturn[ii].cei_no,
                                        eq_cod : dataReturn[ii].eq_cod,
                                        lc_cod : dataReturn[ii].lc_cod,
                                        cl_no : dataReturn[ii].cl_no,
                                        sa_no : dataReturn[ii].sa_no,
                                        tq_no: dataReturn[ii].tq_no,
                                        in_no : dataReturn[ii].li_no,
                                        in_nat : dataReturn[ii].in_nat,
                                        li_mut : dataReturn[ii].li_mut,
                                        li_statut : dataReturn[ii].li_statut,
                                        cei_poste : dataReturn[ii].cfi_poste,
                                        cei_ordre : dataReturn[ii].cfi_ordre,
                                        cei_maillot : dataReturn[ii].cfi_maillot,
                                        cei_capi : dataReturn[ii].cfi_capi,
                                        cei_typ_role : dataReturn[ii].cfi_typ_role,
                                        cei_role : dataReturn[ii].cfi_role,
                                    });
                                }
                                individuEquipeType.push(myData);
                            }
                            if (parseInt(cpt, 10) === parseInt(utilisateurEquipes.length*10, 10)) {
                                if (typeof callback === 'function') {
                                    callback(individuEquipeType);
                                }
                            }
                        });
                    }
                }
            } else {
                if (typeof callback === 'function') {
                    callback([]);
                }
            }
            
        });
    },
};