var SynchronisationController = MainController.extend({
    defaults: { 
        name: ".SynchronisationController",
        click: Engine.eventClick,
        pages: new Array(),
        files: new Array( 
                "synchronisation/js/dto/synchronisationDto.js",
                "synchronisation/js/service/synchronisationGeneriqueService.js",
                "synchronisation/js/service/synchronisationInsertService.js",
                "synchronisation/js/service/synchronisationPurgeCordovaService.js",
                "synchronisation/js/service/synchronisationPurgeService.js",
                "synchronisation/js/service/synchronisationTransfertService.js",
                "synchronisation/js/service/synchronisationService.js",
                "synchronisation/js/service/synchronisationDumpRestoreService.js",
                "synchronisation/js/synchronisationFr.js"),
    }
}, {
	init: function(element, options) {
	    this._super(this, element, options);
	},
	load: function(page, data, callback) {
        Engine.loadController(page, this.options.pages, this.options.files, this, function(controller) {
            if (typeof callback === 'function') {
                callback();
            }
        });
	},
	show: function(element, event) {
	    Engine.delegate(this, element, event, function(controller, element, event) {
	    });
	},
    "{document} #boutonSynchronisation {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if (!element.hasClass("boutonSynchronisationDisable")) {
                if (!AccueilDto.isDemonstration){
                    AccueilDto.isSynchronizing = true;
                    var page = Engine.filAriane[Engine.filAriane.length - 1];
                    var dateActuelle = Utils.getDate();
                    if (page === "accueil.html") {
                        Engine.addView("#alert","index.html:synchro", { mode: "synchro" });
                        Engine.popup("#alert");
                        $("#popup-gen #pourcentSynchro").html("0%");
                        $("#popup-gen .alerteFermer").hide();
                        SynchronisationService.start();

                    } else if (page === "equipe.html") {
                        SynchronisationService.majDates("equipe");
                        SynchronisationTransfertService.transfertCompositionAvecEquipesType(EquipeDto.data.ma_no, EquipeDto.data.cfm_no, EquipeDto.utilisateur.cl_no, function () {
                            Engine.headerController.setTransmissionButton();
                            Engine.headerController.disableSynchroButton();
                        });
                    } else if (page === "infosFacultatives.html") {
                        SynchronisationService.majDates("infosFacultatives");
                        SynchronisationTransfertService.transfertInfosCompletementaireUnitaire(EquipeDto.data.cfm_no);
                    } else if (page === "feuilleDeMatch.html") {
                        SynchronisationService.majDates("feuilleDeMatch");
                        SynchronisationTransfertService.transfertFeuilleDeMatchUnitaire(FeuilleDeMatchDto.cfm_no, function () {
                             Engine.headerController.setTransmissionButton();
                        });
                    }
                }
                else {
                    AccueilDto.isSynchronizing = true;
                    var page = Engine.filAriane[Engine.filAriane.length - 1];
                    var dateActuelle = Utils.getDate();
                    if (page === "accueil.html") {
                        Engine.addView("#alert","index.html:synchro", { mode: "synchro" });
                        Engine.popup("#alert");
                        $("#popup-gen #pourcentSynchro").html("0%");
                        SynchronisationService.startTime = new Date().getTime();
                        SynchronisationService.setPourcent(0);
                        Utils.log("Debut de la synchronistation !");
                        $("#popup-gen .alerteFermer").hide();
                        SynchronisationPurgeService.purgeAndInsertDemo(function () {
                            SynchronisationPurgeService.purgeAndInsertReferentiel(function() {
                                SynchronisationService.end();
                            });
                        });
                    }
                }
            }
        });
    },
    "{document} #boutonOkSynchronisation {click}": function(element, event) {
        
        var page = Engine.filAriane[Engine.filAriane.length - 1];
        if (page === "accueil.html" || page === "apresMatch.html") {
              Engine.gotoPage("accueil.html"); 
        }
    },

    "{document} .sendTechnicalReportAction {click}": function(element, event) {
        Engine.message("Envoi du rapport en cours");
        
        SynchronisationService.sendTechnicalReport().then(function () {
            Engine.fermerPopup();
            Engine.alert(Lang.accueil.rapportEnvoye, function() {
                Engine.fermerPopup();
            });
        }).catch(function (error) {
            Engine.fermerPopup();
            Engine.alert(error, function() {
                Engine.fermerPopup();
            });
        });
    },

// SYNCHRONISATION UNITAIRE
    "{document} #boutonRecuperation {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            if (!element.hasClass("boutonRecuperationDisable")) {
                if (!AccueilDto.isDemonstration){
                    AccueilDto.isSynchronizing = true;
                    var dateActuelle = Utils.getDate();
                    Engine.addView("#alert","index.html:synchro", { mode: "recup" });
                    Engine.popup("#alert");
                    $("#popup-gen #pourcentSynchro").html("0%");
                    $("#popup-gen .alerteFermer").hide();
                    SynchronisationService.startGlobal();
                }
                else {
                    AccueilDto.isSynchronizing = true;
                    var page = Engine.filAriane[Engine.filAriane.length - 1];
                    var dateActuelle = Utils.getDate();
                    if (page === "accueil.html") {
                        Engine.addView("#alert","index.html:synchro", { mode: "synchro" });
                        Engine.popup("#alert");
                        $("#popup-gen #pourcentSynchro").html("0%");
                        SynchronisationService.startTime = new Date().getTime();
                        SynchronisationService.setPourcent(0);
                        Utils.log("Debut de la synchronistation !");
                        $("#popup-gen .alerteFermer").hide();
                        SynchronisationPurgeService.purgeAndInsertDemo(function () {
                            SynchronisationPurgeService.purgeAndInsertReferentiel(function() {
                                SynchronisationService.end();
                            });
                        });
                    }
                }
            }
        });
    },
    "{document} #boutonSynchroUnitaire {click}": function(element, event) {
        Engine.delegate(this, element, event, function(controller, element, event) {
            var strMatchDate = element.parent().parent().find(".hiddenInfosMatch").find(".ma_dat").text();
            var strHeure = element.parent().parent().find(".hiddenInfosMatch").find(".ma_heure_lib").text();
            if (!AccueilService.checkDateHeureMatchPassee(strMatchDate, strHeure) && !element.hasClass("boutonSynchronisationDisable")) {
                AccueilDto.isSynchronizing = true;
                var dateActuelle = Utils.getDate();
                var matchName = element.parent().parent().find(".hiddenInfosMatch").find(".cr_eq_nom_abr").text() + " - " + element.parent().parent().find(".hiddenInfosMatch").find(".cv_eq_nom_abr").text();
                $("#alert").css("height", "240px");
                Engine.addView("#alert","index.html:synchro", { mode: "synchroUnitaire", matchName: matchName });
                Engine.popup("#alert");
                $("#popup-gen #pourcentSynchro").html("0%");
                $("#popup-gen .alerteFermer").hide();
                var selected_ma_no = parseInt(element.parent().parent().find(".hiddenInfosMatch").find(".ma_no").text(), 10);
//                var selected_cfm_no = parseInt(element.parent().parent().find(".hiddenInfosMatch").find(".cfm_no").text(), 10);
                Utils.log("match sélectionné :" + selected_ma_no + "\n feuille de match sélectionnée :");
                SynchronisationService.startUnitary(selected_ma_no);
            }
            else if (AccueilService.checkDateHeureMatchPassee(strMatchDate, strHeure)){
                Engine.alert(Lang.accueil.dateMatchDepassee, function() {
                    Engine.fermerPopup();
                });
            }
        });
    }
});