DataBaseIndexedDb.name = "BD_FFF_FMI";
DataBaseIndexedDb.version = 2;

DataBaseIndexedDb.createBase = function(event) {
	Utils.log("onupgradeneeded");
	Utils.log("Ancienne version BD : " + event.oldVersion);
	DataBase.db = event.target.result;
    var transaction = event.target.transaction;
	
    var objectStore = DataBaseIndexedDb.createTable("CLUB_GROUPE", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "cl_no", "cl_no", false); //n° club
    DataBaseIndexedDb.createIndex(objectStore, "cgr_no", "cgr_no", false); //club groupe id
    DataBaseIndexedDb.createIndex(objectStore, "lc_cod", "lc_cod", false); //code catégorie
    DataBaseIndexedDb.createIndex(objectStore, "cgr_nom", "cgr_nom", false); //club groupe nom
    
    objectStore = DataBaseIndexedDb.createTable("CLUB_GROUPE_INDIVIDU", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "cgr_no", "cgr_no", false); //club groupe id
    DataBaseIndexedDb.createIndex(objectStore, "in_no", "in_no", false); //n° individu
    
    objectStore = DataBaseIndexedDb.createTable("CLUB_LICENCE", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "cl_no", "cl_no", false); //n° club
    DataBaseIndexedDb.createIndex(objectStore, "li_no", "li_no", false); //n° licence
    DataBaseIndexedDb.createIndex(objectStore, "in_no", "in_no", false); //n° individu
    
    objectStore = DataBaseIndexedDb.createTable("EQUIPE_TYPE", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "cei_no", "cei_no", false); //n° equipe type
    DataBaseIndexedDb.createIndex(objectStore, "cl_no", "cl_no", false); //n° club
    DataBaseIndexedDb.createIndex(objectStore, "eq_cod", "eq_cod", false); //equipe
    DataBaseIndexedDb.createIndex(objectStore, "lc_cod", "lc_cod", false); //catégorie equipe
    
    objectStore = DataBaseIndexedDb.createTable("EQUIPE_TYPE_INDIVIDU", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "cei_no", "cei_no", false); //n° equipe type
    DataBaseIndexedDb.createIndex(objectStore, "cl_no", "cl_no", false); //n° club
    DataBaseIndexedDb.createIndex(objectStore, "eq_cod", "eq_cod", false); //catégorie equipe
    DataBaseIndexedDb.createIndex(objectStore, "lc_cod", "lc_cod", false); //code catégorie
    
    objectStore = DataBaseIndexedDb.createTable("FMI_REF", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "ref_typ", "ref_typ", false); //type reference
    DataBaseIndexedDb.createIndex(objectStore, "ref_cod", "ref_cod", false); //code reference
    DataBaseIndexedDb.createIndex(objectStore, "ref_libelle", "ref_libelle", false); //libelle reference
    DataBaseIndexedDb.createIndex(objectStore, "ref_sort", "ref_sort", false); //trie
    
    objectStore = DataBaseIndexedDb.createTable("MATCH", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "ma_no", "ma_no", false); //n° match
    DataBaseIndexedDb.createIndex(objectStore, "cfm_no", "cfm_no", false);
    DataBaseIndexedDb.createIndex(objectStore, "sa_no", "sa_no", false); //saison
    DataBaseIndexedDb.createIndex(objectStore, "cv_eq_cod", "cv_eq_cod", false);
    DataBaseIndexedDb.createIndex(objectStore, "cr_eq_cod", "cr_eq_cod", false);
    DataBaseIndexedDb.createIndex(objectStore, "cv_cl_no", "cv_cl_no", false);
    DataBaseIndexedDb.createIndex(objectStore, "cr_cl_no", "cr_cl_no", false);
    DataBaseIndexedDb.createIndex(objectStore, "ma_demo", "ma_demo", false); //module démonstration
    
    objectStore = DataBaseIndexedDb.createTable("MATCH_FEUILLE", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "cfm_no", "cfm_no", false); //n° feuille de match
    DataBaseIndexedDb.createIndex(objectStore, "ma_no", "ma_no", false); //n° match
    
    objectStore = DataBaseIndexedDb.createTable("MATCH_FEUILLE_COMPO", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "ma_no", "ma_no", false); //n° match
    DataBaseIndexedDb.createIndex(objectStore, "li_no", "li_no", false); //n° licence
    DataBaseIndexedDb.createIndex(objectStore, "cfm_no", "cfm_no", false); //n° feuille de match
    DataBaseIndexedDb.createIndex(objectStore, "cfi_cl_no", "cfi_cl_no", false); //n° club
    DataBaseIndexedDb.createIndex(objectStore, "cfi_capi", "cfi_capi", false); //capitaine
    
    objectStore = DataBaseIndexedDb.createTable("MATCH_FEUILLE_EVENEMENT", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "cfe_no", "cfe_no", false); //n° evènement
    DataBaseIndexedDb.createIndex(objectStore, "ma_no", "ma_no", false); //n° match
    DataBaseIndexedDb.createIndex(objectStore, "li_no", "li_no", false); //n° licence
    DataBaseIndexedDb.createIndex(objectStore, "cfm_no", "cfm_no", false); //n° feuille de matc
    
    objectStore = DataBaseIndexedDb.createTable("MATCH_FEUILLE_LICENCE", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "ma_no", "ma_no", false); //n° match
    DataBaseIndexedDb.createIndex(objectStore, "li_no", "li_no", false); //n° licence
    
    objectStore = DataBaseIndexedDb.createTable("MATCH_FEUILLE_MEMBRE", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "mmf_no", "mmf_no", false); //n° feuille de match membre
    DataBaseIndexedDb.createIndex(objectStore, "ma_no", "ma_no", false); //n° match
    DataBaseIndexedDb.createIndex(objectStore, "cfm_no", "cfm_no", false); //n° feuille de match
    DataBaseIndexedDb.createIndex(objectStore, "cl_no", "cl_no", false); //n° club
    DataBaseIndexedDb.createIndex(objectStore, "mm_no", "mm_no", false); //n° désignation de officiel dans le si fff
    
    objectStore = DataBaseIndexedDb.createTable("MATCH_FEUILLE_RESERVE", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "mfr_no", "mfr_no", false); //n° feuille match reserve
    DataBaseIndexedDb.createIndex(objectStore, "cfm_no", "cfm_no", false); //n° feuille de match
    DataBaseIndexedDb.createIndex(objectStore, "cl_no", "cl_no", false); //n° club
    DataBaseIndexedDb.createIndex(objectStore, "in_no", "in_no", false); //n° individu
    
    objectStore = DataBaseIndexedDb.createTable("SANCTION", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "ma_no", "ma_no", false); //n° match
    DataBaseIndexedDb.createIndex(objectStore, "dd_no", "dd_no", false); //n° décision
    DataBaseIndexedDb.createIndex(objectStore, "in_no", "in_no", false); //n° individu
    DataBaseIndexedDb.createIndex(objectStore, "li_no", "li_no", false); //n° licence
    
    objectStore = DataBaseIndexedDb.createTable("SECURITE_STADE", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "fsi_no", "fsi_no", false); //n° feuille de match sécurité
    DataBaseIndexedDb.createIndex(objectStore, "cfm_no", "cfm_no", false); //n° feuille de match
    
    objectStore = DataBaseIndexedDb.createTable("PARAM", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "ref_typ", "ref_typ", false); //
    DataBaseIndexedDb.createIndex(objectStore, "ref_cod", "ref_cod", false); //
    
    objectStore = DataBaseIndexedDb.createTable("TACTIQUE", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "tq_no", "tq_no", false); //n° tactique
    DataBaseIndexedDb.createIndex(objectStore, "tq_nom", "tq_nom", false); //nom de tactique
    DataBaseIndexedDb.createIndex(objectStore, "tq_cod_affich", "tq_cod_affich", false); //chaine de codage de la tactique
    
    objectStore = DataBaseIndexedDb.createTable("TABLETTE", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "tlb_uuid", "tlb_uuid", false); //uuid de la tablette
    
    objectStore = DataBaseIndexedDb.createTable("UTILISATEUR", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "cl_no", "cl_no", false); //n° club
    DataBaseIndexedDb.createIndex(objectStore, "usr_no", "usr_no", false); //n° utilisateur
    DataBaseIndexedDb.createIndex(objectStore, "usr_nom_conx", "usr_nom_conx", false); //nom utilisateur
    DataBaseIndexedDb.createIndex(objectStore, "usr_ora", "usr_ora", false); //nom affichage utilisateur
    DataBaseIndexedDb.createIndex(objectStore, "usr_password", "usr_password", false); //mot de passe
    
    objectStore = DataBaseIndexedDb.createTable("UTILISATEUR_EQUIPE", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "cl_no", "cl_no", false); //n° club
    DataBaseIndexedDb.createIndex(objectStore, "usr_no", "usr_no", false); //n° utilisateur
    DataBaseIndexedDb.createIndex(objectStore, "eq_no", "eq_no", false); //code equipe
    DataBaseIndexedDb.createIndex(objectStore, "lc_cod", "lc_cod", false); //code catégorie
    DataBaseIndexedDb.createIndex(objectStore, "sa_no", "sa_no", false); //saison
    
    objectStore = DataBaseIndexedDb.createTable("CGU", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "cgu_no", "cgu_no", false);
    DataBaseIndexedDb.createIndex(objectStore, "usr_no", "usr_no", false);
    
    objectStore = DataBaseIndexedDb.createTable("FEUILLE_MATCH_HISTO", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "cfmh_no", "cfmh_no", false);
    DataBaseIndexedDb.createIndex(objectStore, "cfm_no", "cfm_no", false);

    objectStore = DataBaseIndexedDb.createTable("ERROR_LOG", "id", true, transaction);
    DataBaseIndexedDb.createIndex(objectStore, "usr_no", "usr_no", false);
};